
(defun load-db ()
  (interactive)
  (let ((buffer (current-buffer))
	(db (get-buffer-create "*database*"))
	(file (expand-file-name (read-file-name "Load Database: " "~omega/examples/db/nat-numbers.lisp"
						"~omega/examples/db/nat-numbers.lisp" t))))
    (set-buffer db)
    (goto-char (point-max))
    (insert-file-contents file)
    (set-buffer buffer)))


(defun new-conc ()
  (interactive)
  (if (equal (buffer-name (current-buffer)) "*database*")
      (let ((point (point))
	    (start (lisp-defun-begin)))
	(forward-char 1)
	(forward-sexp 2)
	(let ((name (buffer-substring (1+ start) (point)))
	      (end (lisp-defun-end))
	      (db-entry (buffer-substring start (point)))
	      (decl ""))
	  (goto-char (point-max))
	  (while (search-backward "(declarations" (point-min) t)
	    (forward-sexp)
	    (setf decl (concat (buffer-substring (match-end 0) (1- (point)))))
	    (goto-char (match-beginning 0)))
	  (goto-char point)
	  (switch-to-omega)
	  (goto-char (point-max))
					;(insert ";;; Starting new proof for " name "")
	  (process-send-string
	   "*omega*"
	   (concat "new-conc (" decl ") " db-entry "
"))))
    (princ "This is not the database.")))
  
(defun new-hyp ()
  (interactive)
  (if (equal (buffer-name (current-buffer)) "*database*")
      (let ((point (point))
	    (start (lisp-defun-begin)))
	(forward-sexp)
	(let ((db-entry (buffer-substring start (point))))
	  (goto-char point)
	  (switch-to-omega)
	  (process-send-string
	   "*omega*"
	   (concat "new-hyp " db-entry "
"))))
    (princ "This is not the database.")))


(defun find-def ()
  (interactive)
  (let ((point (point))
	(buffer (current-buffer)))
    (backward-sexp)
    (let ((start (point)))
      (forward-sexp)
      (let* ((symbol (buffer-substring start (point)))
	     (name (read-input "Find definition: " symbol))
	     (db-entry (concat "definition " name)))
	(goto-char point)
	(set-buffer "*database*")
	(goto-char (point-max))
	(if (search-backward db-entry (point-min) t)
	    (switch-to-buffer-other-window "*database*")
	  (progn (set-buffer buffer)
		 (princ (format "No definition for %s found in database." name))))))))

(global-set-key [?\M-o] '(keymap))
(global-set-key [?\M-o ?p] 'display-proof)
(global-set-key [?\M-o ?d] 'switch-to-db)
(global-set-key [?\M-o ?o] 'switch-to-omega)
(global-set-key [?\M-o ?c] 'new-conc)
(global-set-key [?\M-o ?h] 'new-hyp)
(global-set-key [?\M-o ?f] 'find-def)
