;;; -*-Emacs-Lisp-*-
;;; Rcs_Info: ilisp-keim.el  
;;; by richts@cantor.informatik.rwth-aachen.de  at Mon Sep 12 18:17:45 1994
;;;
;;; ILISP Keim Common Lisp dialect definition
;;;



;;;%%%Keim
(defvar ilisp-keim-init-file "keim.lisp")




;;;
(defdialect keim41 "Keim Common LISP"
  lucid
  ;(ilisp-load-init 'keim ilisp-keim-init-file)
  )

(defdialect keim "Keim Common LISP"
  lucid
  ;(ilisp-load-init 'keim ilisp-keim-init-file)
  )

(if (not keim-program) (setq keim-program "keim"))



(put ':method 'lisp-indent-function 1)  
(put 'flet 'lisp-indent-function 1)
(put 'labels 'lisp-indent-function 1)
(put 'dolist 'lisp-indent-function 1)
(put 'dotimes 'lisp-indent-function 1)
(put 'when 'lisp-indent-function 1)
(put 'unless 'lisp-indent-function 1)
(put 'multiple-value-call 'lisp-indent-function 1)
(put 'multiple-value-prog1 'lisp-indent-function 1)
(put 'multiple-value-bind 'lisp-indent-function '2)
(put 'with-slots 'lisp-indent-function '2)
(put 'if 'lisp-indent-function nil)


(put 'do 'lisp-indent-function 'lisp-indent-doform)
(put 'do* 'lisp-indent-function 'lisp-indent-doform)

(put 'eval-when 'lisp-indent-function '(lambda (a b) 1))

(put 'with-drawing-options 'lisp-indent-function 1)
(put 'with-room-for-graphics 'lisp-indent-function 1)
(put 'vertically 'lisp-indent-function 1)
(put 'horizontally 'lisp-indent-function 1)
(put 'scrolling 'lisp-indent-function 1)

(put 'formatting-table 'lisp-indent-function 1)
(put 'formatting-row 'lisp-indent-function 1)
(put 'formatting-column 'lisp-indent-function 1)
(put 'formatting-cell 'lisp-indent-function 1)

(defun lisp-indent-doform (state indent-point)
  (goto-char (car (cdr state)))
  (let ((do-column (current-column))
	(i 0)
	do-end)
    (forward-char 1)
    (forward-sexp 1)
    (setq do-end (point))
    (goto-char indent-point)
    (while (< do-end (point))
      (backward-sexp 1)
      (setq i (1+ i)))
    (cond ((= i 0) 0)
	  ((= i 1) (list (+ do-column (* 2 lisp-body-indent))))
	  ((= i 2) 
	   (goto-char (car (cdr (cdr state))))
	   (current-column))
	  ((> i 2)
	   (+ do-column lisp-body-indent)))))

(defun reindent-file ()
  (interactive)
  (goto-char (point-min))
  (while (search-forward "(def" nil 1)
    (reindent-lisp)))

;;; the above was a good idea but it's much easier since a cl-indent is allready defined:

(setq lisp-indent-function 'common-lisp-indent-function)
