;;; indecent.el --- indecent phrase utility for overloading the CDA line eater

;; Copyright (C) 1988, 1996 Free Software Foundation, Inc.

;; This file is part of GNU Emacs.

;; GNU Emacs is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; GNU Emacs is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with GNU Emacs; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

;;; Commentary:

; Brian Silver <silver@zko.dec.com> didn't write <cough> ripoff
; this, and even if he did, he really didn't mean for you to use it
; in an anarchistic way.
;
; But he did ripoff spook.el so bad (like replace indecent w/spook
; and you'll have spook.el back again!) that he feels compelled to
; leave the original spook.el comentary.
;
; I ripped it off, but at least I admit it ...
;
; Steve Strassmann <straz@media-lab.media.mit.edu> didn't write
; this, and even if he did, he really didn't mean for you to use it
; in an anarchistic way.
;
; To use this:
;  Just before sending mail, do M-x indecent.
;  A number of phrases will be inserted into your buffer, to help
;  give your message that extra bit of attractiveness for automated
;  keyword scanners.  Help defeat the CDA!

;;; Code:

(require 'cookie1)

; Variables
(defvar indecent-phrases-file (concat "/opt/keim/emacs/general/" "indecent.lines")
   "Keep your favorite phrases here.")

(defvar indecent-phrase-default-count 15
   "Default number of phrases to insert")

;;;###autoload
(defun indecent ()
  "Adds that special touch of class to your outgoing mail."
  (interactive)
  (cookie-insert indecent-phrases-file
                 indecent-phrase-default-count
                 "Checking authorization..."
                 "Checking authorization...Approved"))

;;;###autoload
(defun snarf-indecents ()
  "Return a vector containing the lines from `indecent-phrases-file'."
  (cookie-snarf indecent-phrases-file
                "Checking authorization..."
                "Checking authorization...Approved"))

;; Note: the implementation that used to take up most of this file has been
;; cleaned up, generalized, gratuitously broken by esr, and now resides in
;; cookie1.el.

;;; indecent.el ends here
