
  
(setq appt-disp-window-function 'mappt-disp-window)
  
(setq appt-delete-window-function 'mappt-delete-window)


(defvar mappt-action-flag nil)

(defvar mappt-id nil)

(defun mappt-disp-window (min-to-app new-time appt-msg)
  (require 'electric)
  (let ((current-id (cons (calendar-current-date) appt-msg)))
    (if (not (equal mappt-id current-id))
	(progn (setq mappt-id current-id
		     mappt-action-flag nil))))
  (if (not (eql 0 mappt-action-flag))
      (save-window-excursion
	(save-excursion
	  (let* ((this-buffer (current-buffer))
		 (this-window (selected-window)) 
		 (appt-disp-buf (get-buffer-create appt-buffer-name)))

	    (set-buffer appt-disp-buf)
	    (setq buffer-read-only nil)
	    (mappt-mode)
	    (erase-buffer)
	    (setq mode-line-format 
		  (concat "------ Appointment in "
			  min-to-app " minutes. " new-time " %-"))
	    (insert-string appt-msg)
	    (set-buffer-modified-p nil)
	    (setq buffer-read-only t)
	    (display-buffer appt-disp-buf)
	    (select-frame (window-frame (get-buffer-window appt-disp-buf t)))
	    (message "Type q to stop beeping.  s to not popup.  k to kill notification")
	    (raise-frame (window-frame (get-buffer-window appt-disp-buf t)))))))
  (if (and appt-audible (null mappt-action-flag))
      (beep 1))
  )

(defun mappt-delete-window ()
  "Function called to undisplay appointment messages.
Usually just deletes the appointment buffer."
  nil)


;;;
;;; Appointment Mode
;;;

(defvar mappt-mode-map nil
  "Keymap for Appointment mode.")

(if mappt-mode-map
    ()
  (setq mappt-mode-map (make-sparse-keymap))
  (define-key mappt-mode-map "q" 'mappt-quiet)
  (define-key mappt-mode-map "s" 'mappt-stop)
  (define-key mappt-mode-map "k" 'mappt-kill))


(defun mappt-mode ()
  "Major mode for showing Appoinments.
Special commands:
\\{mappt-mode-map}
Turning on Appointment mode calls the value of the variable `mappt-mode-hook',
if that value is non-nil."
  (interactive)
  (kill-all-local-variables)
  (use-local-map mappt-mode-map)
  (setq mode-name "Appt")
  (setq major-mode 'mappt-mode)
  (run-hooks 'mappt-mode-hook))

(defun mappt-quiet ()
  (interactive)
  (setq mappt-action-flag 1))

(defun mappt-stop ()
  (interactive)
  (setq mappt-action-flag 0))

(defun mappt-kill ()
  (interactive)
  (kill-buffer appt-buffer-name)
  (setq mappt-action-flag 0))
