(global-set-key [S-mouse-2] 'netscape-follow-url)
(global-set-key [S-mouse-3] 'netscape-follow-exact-url)
(global-set-key [A-mouse-2] 'netscape-follow-news-id)
(if (featurep 'gnus)
    (require 'gnus-netscape)
  (setq gnus-startup-hook '(lambda () (require 'gnus-netscape))))

(defun netscape-follow-url (event)
  (interactive "e")
  (let ((curwin (current-window-configuration)) url)
    (mouse-set-point event)
    (save-excursion
      ;; find url-at-point
      (setq url (netscape-find-url))
      )
    (set-window-configuration curwin)
    (if url
        (progn
          (message "Open URL %s" url)
          (call-process "netscape" nil 0 nil "-remote"
                        (concat "openURL(" url ")")))
      (message "No URL found at point"))))

(defun netscape-follow-exact-url (event)
  (interactive "e")
  (let ((p (point))
	(curwin (current-window-configuration)) url)
    (save-excursion
      (mouse-set-point event)
      ;; find url-at-point
      (setq url (buffer-substring p (point))))
    (set-window-configuration curwin)
    (if url
        (progn
          (message "Open URL %s" url)
          (call-process "netscape" nil 0 nil "-remote"
                        (concat "openURL(" url ")")))
      (message "No URL found at point"))))

;(call-process "/opt/rbi/x11/bin/netscape-v11N-export" nil 0 nil "-remote" (concat "openURL(http://www.informatik.rwth-aachen.de/)"))


(defun netscape-find-url ()
  (let ((p (point))
	(back (skip-chars-backward "^ ,;\"'`(){}[]
"))
	(for (skip-chars-forward "^ ,;\"'`(){}[]
")))
    (buffer-substring (+ p back) (+ p back for))))


(defun netscape-follow-news-id (event)
  (interactive "e")
  (let ((curwin (current-window-configuration)) url)
    (save-excursion
      (mouse-set-point event)
      ;; find url-at-point
      (setq url (concat "news:" (netscape-find-id))))
    (set-window-configuration curwin)
    (if url
        (progn
          (message "Open URL %s" url)
          (call-process "netscape" nil 0 nil "-remote"
                        (concat "openURL(" url ")")))
      (message "No message id found at point"))))


(defun netscape-find-id ()
  (let (;(article (gnus-summary-article-number))
	;(group gnus-newsgroup-name)
	(p (point))
	(back (skip-chars-backward "^<"))
	(for (skip-chars-forward "^>")))
    (buffer-substring (+ p back) (+ p back for))))



