;;;
;;; This file contains values that may vary from user to user
;;;
;;; It could be simply inserted into the ~/.emacs file or loaded from there.
;;;

;;; This file is setup to work without modifications ONLY if you are
;;; looking at the file, and use the command  M-x eval-current-buffer.
;;;
;;; If you want to LOAD this file, you must make a copy, modify the 
;;; following expression, and load the modified file
;;; Pathname MUST end in a "/".
(setq lep-directory "/usr/local/lisp/lucid-4.2/lep/")

;;;
;;; Keep the following if you want LEP loaded and started automatically 
;;; when Lisp is started up with l-commom-lisp (C-c l).

;; Need to use :: notation on lep-setup-server because the expression
;; may be read when the symbol is not yet exported.

(setq l-common-lisp-startup-string
  ;; The expression in the resulting string is passed to the Lisp 
  ;; sub-process started up by the l-common-lisp command.
  (format
   "(progn (terpri)
      (require \"LEP\" \"%sload-lucid-lep\")
      (lcl::lep-setup-server %%s :debug nil %%s)
      (values))"
   lep-directory))


;;; Some commonly changed variables
;(setq l-common-lisp-buffer-name "*common-lisp*")
;(setq l-common-lisp-directory nil)
;(setq l-common-lisp-image-name "lisp")
;(setq l-common-lisp-image-arguments nil)
;(setq l-common-lisp-host "localhost")
;(setq l-emacs-to-lisp-transaction-directory "/tmp")
;(setq l-lisp-evals-always-compile nil)
;(setq l-default-input-ring-max 50)

;;; Load the works
(load (format "%ssite-init" lep-directory))

