(in-package "OMEGA")

(setf env (env~create))


(post~read-object-list
 '((type-constants o i)
   (type-variables aa bb)
   (constants
    (= (o aa aa))
    (false o)
    (true o)
    (and (o o o))
    (or (o o o))
    (implies (o o o))
    (equiv (o o o))
    (not (o o))
    (forall (o (o aa)))
    (exists (o (o aa)))
    (subset (o (o aa) (o aa)))
    (superset (o (o aa) (o aa)))
    (union ((o aa) (o aa) (o aa)))
    (intersection ((o aa) (o aa) (o aa)))
    (image ((o aa) (o bb) (aa bb)))
    (defn (o aa aa))))
 env)


(post~read-object-list
 '((constants (P o) (Q o) (R o) (S o)
	      (P1 (o i)) (Q1 (o i)) (R1 (o i))
	      (P2 (o i i)) (Q2 (o i i)) (R2 (o i i))
	      (f2 (o i i)) (F o i)
	      (skolem (i o)) (c1 i) (c2 i)))
 env)


;; 18

(setf formula18 (term~read '(equiv (implies (and p (implies q r))
					    s)
				   (and (or (not p) (or q s))
					(or (not p) (or (not r) s))))
			   env))


(setf nnf18 (otap~nnf formula18 env t))


;; 23

(setf formula23 (term~read '(equiv (forall (lam (x i) (or P (F x))))
				   (or P (forall (lam (x i) (F x)))))
			   env))


(setf nnf23 (otap~nnf formula23 env t))


;; 38
#|
((all x p(a) and
          (p(x) impl (ex y p(y) and r(x y)))
	impl (ex z,w p(z) and r(x w) and r(w z)))
 eqv
 (all x (not p(a) or p(x) or  (ex z,w p(z) and r(x w) and r(w z)))
      and
        (not p(a) or not(ex y p(y) and r(x y)) or (ex z,w p(z) and r(x w) and r(w z)))))
|#

(setf formula38 (term~read '(equiv (forall (lam (x i)
				     (implies (and (p1  c1)
						   (implies (p1  x) (exists (lam (y i)
								     (and (p1  y) (r2 x y))))))
					      (exists (lam (z i) (exists (lam (w i)
						 (and (p1  z) (and (r2 x w) (r2 w z))))))))))
				    (forall (lam (x i)
				      (and (or (or (not (p1  c1)) (p1  x))
					       (exists (lam (z i) (exists (lam (w i)
						 (and (p1  z) (and (r2 x w) (r2 w z))))))))
					   (or (not (p1  c1))
					       (or (not (exists (lam (y i)
						          (and (p1  y) (r2 x y)))))
						   (exists (lam (z i) (exists (lam (w i)
						     (and (p1  z) (and (r2 x w) (r2 w z)))))))))))))
			   env))


(setf nnf38 (otap~nnf formula38 env t))


;; 43


(setf formula43 (term~read '(implies (forall (lam (x i) (forall (lam (y i)
					(equiv (q2 x y)
					       (forall (lam (z i)
						 (equiv (f2 z x) (f2 z y)))))))))
				     (forall (lam (x i) (forall (lam (y i)
				        (equiv (q2 x y) (q2 y x)))))))
			   env))

(setf assertions43 (post~read-object-list
		    '((assumption ass (forall (lam (x i) (forall (lam (y i)
				        (equiv (q2 x y)
					       (forall (lam (z i)
					         (equiv (f2 z x) (f2 z y))))))))))
		      (conclusion conc43 (forall (lam (x i) (forall (lam (y i)
				           (equiv (q2 x y) (q2 y x))))))))
		    env))

(setf nnf43 (otap~nnf formula43 env t))

;;; test

(setf f (term~read '(equiv P (or Q (not Q)))
		   env))

;;;

(setf f (term~read '(implies (forall (lam (x i) (or (P1 x) (Q1 x))))
			     (or (P1 c1) (Q1 c1)))
		   env))

(setf nnf (tap~nnf f env t))

(print (tap~prove nnf))   ; T


;;;

(setf f (term~read '(implies (forall (lam (x i) (or (P1 x) (Q1 x))))
			     (or (P1 c1) (P1 c2)))
		   env))

(setf nnf (tap~nnf f env t))

(print (tap~prove nnf))   ; nil


;;;

(setf f (term~read '(implies (forall (lam (x i) (or (P1 x) (Q1 x))))
			     (or (P1 c1) (Q1 c2)))
		   env))

(setf nnf (tap~nnf f env t))

(print (tap~prove nnf))   ; nil


;;;

(setf f (term~read '(implies (forall (lam (x i) (or (and (P1 x) (Q1 x)) (Q1 x))))
			     (or (P1 c1) (Q1 c2)))
		   env))

(setf nnf (tap~nnf f env t))

(print (tap~prove nnf))   ; T


;;;

(setf f (term~read '(implies (forall (lam (x i) (forall (lam (y i) (or (and (Q1 x) (Q1 y)) (P1 y))))))
			     (or (Q1 c1) (P1 c2)))
		   env))

(setf nnf (tap~nnf f env t))

(print (tap~prove nnf))   ; T



(setf formula38 (term~read '(equiv (forall (lam (x i)
				     (imp1 lies (and (p1  c1)
						   (imp1 lies (p1  x) (exists (lam (y i)
								     (and (p1  y) (r2 x y))))))
					      (exists (lam (z i) (exists (lam (w i)
						 (and (p1  z) (and (r2 x w) (r2 w z))))))))))
				    (forall (lam (x i)
				      (and (or (or (not (p1  c1)) (p1  x))
					       (exists (lam (z i) (exists (lam (w i)
						 (and (p1  z) (and (r2 x w) (r2 w z))))))))
					   (or (not (p1  c1))
					       (or (not (exists (lam (y i)
						          (and (p1  y) (r2 x y)))))
						   (exists (lam (z i) (exists (lam (w i)
						     (and (p1  z) (and (r2 x w) (r2 w z)))))))))))))
			   env))

