(in-package "KEIM")

(setf tap*env (env~create))

(post~read-object-list '((type-constants o i) (type-variables aa bb)
			 (constants (= (o aa aa)) (false o) (TrueUe o)
				    (and (o o o)) (or (o o o)) (implies (o o o)) (equiv (o o o)) (not (o o))
				    (forall (o (o aa))) (exists (o (o aa))))
			 (constants (Day (o i)) (TrueL (o i)) (TrueU (o i)) (LiesL (o i)) (LiesU (o i))
				    (Mo (o i)) (Tu (o i)) (We (o i)) (Th (o i)) (Fr (o i)) (Sa (o i)) (Su (o i))
				    (Creature (o i)))
			 (subsorts (Creature)
				   (Mo LiesL TrueU Day) (Tu LiesL) (We LiesL)
				   (Th LiesU TrueL Day) (Fr LiesU) (Sa LiesU)
				   (Su TrueL) (Su TrueU))
			 (constants (Lies-at (o Day Day Creature)) (Lion Creature) (Unicorn Creature)
				    (yesterday (Day Day))
				    (yesterday (Mo Tu)) (yesterday (Tu We)) (yesterday (We Th)) (yesterday (Th Fr))
				    (yesterday (Fr Sa)) (yesterday (Sa Su)) (yesterday (Su Mo))))
		       tap*env)

#|
Sort Hierarchy:

              Day                Creatures
             /   \
            /     \ 
         TrueL   TrueU
        /    \   /    \
     LiesU    \ /    LiesL
    /  |  \    |    /  |  \ 
   Th  Fr  Sa  Su  Mo  Tu  We

|#

(setf lion-unicorn
      (cons 17 (term~read '(not (implies (and (forall (lam (x TrueL) (forall (lam (y LiesL)
						(Lies-at Lion x y)))))
					(and (forall (lam (x LiesL) (forall (lam (y TrueL)
						(Lies-at Lion x y)))))
					(and (forall (lam (x LiesL) (forall (lam (y LiesL)
						(not (Lies-at Lion x y))))))
					(and (forall (lam (x TrueL) (forall (lam (y TrueL)
						(not (Lies-at Lion x y))))))
					(and (forall (lam (x LiesU) (forall (lam (y TrueU)
						(Lies-at Unicorn x y)))))
					(and (forall (lam (x TrueU) (forall (lam (y LiesU)
						(Lies-at Unicorn x y)))))
					(and (forall (lam (x LiesU) (forall (lam (y LiesU)
						(not (Lies-at Unicorn x y))))))
					     (forall (lam (x TrueU) (forall (lam (y TrueU)
						(not (Lies-at Unicorn x y))))))
					     )))))))
					(exists (lam (x Day) (and (Lies-at Lion (yesterday x) x)
								  (Lies-at Unicorn (yesterday x) (yesterday (yesterday x))))))))
			 tap*env)))

(setf lion-unicorn1
      (cons 17 (term~read '(not (or (exists (lam (x Day) (and (Lies-at Lion x (yesterday x))
							      (Lies-at Unicorn x (yesterday x)))))
				    (not (and (forall (lam (x TrueL) (forall (lam (y LiesL)
						(Lies-at Lion x y)))))
					(and (forall (lam (x LiesL) (forall (lam (y TrueL)
						(Lies-at Lion x y)))))
					(and (forall (lam (x LiesL) (forall (lam (y LiesL)
						(not (Lies-at Lion x y))))))
					(and (forall (lam (x TrueL) (forall (lam (y TrueL)
						(not (Lies-at Lion x y))))))
					(and (forall (lam (x LiesU) (forall (lam (y TrueU)
						(Lies-at Unicorn x y)))))
					(and (forall (lam (x TrueU) (forall (lam (y LiesU)
						(Lies-at Unicorn x y)))))
					(and (forall (lam (x LiesU) (forall (lam (y LiesU)
						(not (Lies-at Unicorn x y))))))
					     (forall (lam (x TrueU) (forall (lam (y TrueU)
						(not (Lies-at Unicorn x y))))))
					     ))))))))))
			 tap*env)))

;;; unsorted

(setf tap*env (env~create))

(post~read-object-list '((type-constants o i) (type-variables aa bb)
			 (constants (= (o aa aa)) (false o) (TrueUe o)
				    (and (o o o)) (or (o o o)) (implies (o o o)) (equiv (o o o)) (not (o o))
				    (forall (o (o aa))) (exists (o (o aa))))
			 (constants (Day (o i)) (TrueL (o i)) (TrueU (o i)) (LiesL (o i)) (LiesU (o i))
				    (Mo (o i)) (Tu (o i)) (We (o i)) (Th (o i)) (Fr (o i)) (Sa (o i)) (Su (o i))
				    (Creature (o i)))
			 (constants (Lies-at (o i i i)) (Lion i) (Unicorn i)
				    (yesterday (i i))))
		       tap*env)


(setf lion-unicorn-us
      (cons 17 (term~read '(not (implies (and (exists (lam (x i)
						(Th x)))
					(and (forall (lam (x i) (forall (lam (y i)
						(implies (and (not (LiesL x)) (LiesL y))
							 (Lies-at Lion x y))))))
					(and (forall (lam (x i) (forall (lam (y i)
						(implies (and (LiesL x) (not (LiesL y)))
							 (Lies-at Lion x y))))))
					(and (forall (lam (x i) (forall (lam (y i)
						(implies (and (LiesL x) (LiesL y))
							 (not (Lies-at Lion x y)))))))
					(and (forall (lam (x i) (forall (lam (y i)
						(implies (and (not (LiesL x)) (not (LiesL y)))
							 (not (Lies-at Lion x y)))))))
					(and (forall (lam (x i) (forall (lam (y i)
						(implies (and (LiesU x) (not (LiesU y)))
							 (Lies-at Unicorn x y))))))
					(and (forall (lam (x i) (forall (lam (y i)
						(implies (and (not (LiesU x)) (LiesU y))
							 (Lies-at Unicorn x y))))))
					(and (forall (lam (x i) (forall (lam (y i)
						(implies (and (LiesU x) (LiesU y))
							 (not (Lies-at Unicorn x y)))))))
					(and (forall (lam (x i) (forall (lam (y i)
						(implies (and (not (LiesU x)) (not (LiesU y)))
							 (not (Lies-at Unicorn x y)))))))
					(and (forall (lam (x i)
						(equiv (or (Mo x) (or (Tu x) (We x)))
							 (LiesL x))))
					(and (forall (lam (x i)
						(equiv (or (Th x) (or (Fr x) (Sa x)))
							 (LiesU x))))
					(and (forall (lam (x i)
						(implies (Mo x) (Su (yesterday x)))))
					(and (forall (lam (x i)
						(implies (Tu x) (Mo (yesterday x)))))
					(and (forall (lam (x i)
						(implies (We x) (Tu (yesterday x)))))
					(and (forall (lam (x i)
						(implies (Th x) (We (yesterday x)))))
					(and (forall (lam (x i)
						(implies (Fr x) (Th (yesterday x)))))
					(and (forall (lam (x i)
						(implies (Sa x) (Fr (yesterday x)))))
					     (forall (lam (x i)
						(implies (Su x) (Sa (yesterday x)))))
					     )))))))))))))))))
					(exists (lam (x i) (and (Lies-at Lion x (yesterday x))
								  (Lies-at Unicorn x (yesterday x)))))))
			 tap*env)))


(setf lion-unicorn-us1
      (cons 17 (term~read '(not (implies (and (exists (lam (x i)
						(Th x)))
					(and (forall (lam (x i) (forall (lam (y i)
						(implies (and (not (LiesL x)) (LiesL y))
							 (Lies-at Lion x y))))))
					(and (forall (lam (x i) (forall (lam (y i)
						(implies (and (LiesU x) (not (LiesU y)))
							 (Lies-at Unicorn x y))))))
					(and (forall (lam (x i)
						(implies (We x) (LiesL x))))
					(and (forall (lam (x i)
						(implies (Th x) (not (LiesL x)))))
					(and (forall (lam (x i)
						(implies (Th x) (LiesU x))))
					(and (forall (lam (x i)
						(implies (We x) (not (LiesU x)))))
					     (forall (lam (x i)
						(implies (Th x) (We (yesterday x)))))
					     )))))))
					(exists (lam (x i) (and (Lies-at Lion x (yesterday x))
								  (Lies-at Unicorn x (yesterday x)))))))
			 tap*env)))


(setf lion-unicorn-us2
      (cons 10 (term~read '(not (implies (and (exists (lam (x i)
						(Th x)))
					(and (forall (lam (x i)
						(implies (Th x) (not (LiesL x)))))
					(and (forall (lam (x i)
						(implies (Th x) (LiesU x))))
					(and (forall (lam (x i)
						(implies (Th x) (We (yesterday x)))))
					(and (forall (lam (x i)
						(implies (We x) (LiesL x))))
					(and (forall (lam (x i)
						(implies (We x) (not (LiesU x)))))
					(and (forall (lam (x i) (forall (lam (y i)
						(implies (and (not (LiesL x)) (LiesL y))
							 (Lies-at Lion x y))))))
					     (forall (lam (x i) (forall (lam (y i)
						(implies (and (LiesU x) (not (LiesU y)))
							 (Lies-at Unicorn x y))))))
					     )))))))
					(exists (lam (x i) (and (Lies-at Lion x (yesterday x))
								  (Lies-at Unicorn x (yesterday x)))))))
			 tap*env)))
