(in-package "KEIM")

(defun pl~print (term)
  (let ((term1 (first (fo~arguments term)))
	(term2 (second (fo~arguments term))))
    (cond ((termc~negation-p term)
	   (format nil "(-~A)" (pl~print term1)))
	  ((termc~disjunction-p term)
	   (format nil "(~A v ~A)" (pl~print term1) (pl~print term2)))
	  ((termc~conjunction-p term)
	   (format nil "(~A & ~A)" (pl~print term1) (pl~print term2)))
	  ((termc~implication-p term)
	   (format nil "(~A => ~A)" (pl~print term1) (pl~print term2)))
	  ((termc~equivalence-p term)
	   (format nil "(~A <=> ~A)" (pl~print term1) (pl~print term2)))
	  ((termc~universal-quantification-p term)
	   (format nil "all(~A, ~A)" (pl~print (termc~quantification-bound-variable term)) (pl~print term1)))
	  ((termc~existential-quantification-p term)
	   (format nil "ex(~A, ~A)" (pl~print (termc~quantification-bound-variable term)) (pl~print term1)))
	  ((appl~p term)
	   (format nil "~A(~A~{,~A~})" (pl~print (appl~function term)) (pl~print term1)
		   (mapcar #'(lambda (subterm) (pl~print subterm)) (rest (fo~arguments term)))))
	  ((sym~variable-p term)
	   (string-upcase (keim~name term)))
	  (t
	   (string-downcase (keim~name term))))))

(defun pl~print-nnf (term)
  (let ((term1 (first (fo~arguments term)))
	(term2 (second (fo~arguments term))))
    (cond ((termc~negation-p term)
	   (format nil "(-~A)" (pl~print-nnf term1)))
	  ((termc~disjunction-p term)
	   (format nil "(~A,~A)" (pl~print-nnf term1) (pl~print-nnf term2)))
	  ((termc~conjunction-p term)
	   (format nil "(~A;~A)" (pl~print-nnf term1) (pl~print-nnf term2)))
	  ((termc~universal-quantification-p term)
	   (format nil "all(~A, ~A)" (keim~name (termc~quantification-bound-variable term)) (pl~print-nnf term1)))
	  ((appl~p term)
	   (format nil "~A(~A~{,~A~})" (appl~function term) (pl~print-nnf term1)
		   (mapcar #'(lambda (subterm) (pl~print-nnf subterm)) (rest (fo~arguments term)))))
	  ((sym~variable-p term)
	   (string-upcase (keim~name term)))
	  (t
	   (string-downcase (keim~name term))))))
