(in-package "KEIM")


(defun tap~prove-formula (limit-formula-pair)
  (let* ((nnf (nnf~nnormalize (cdr limit-formula-pair) tap*env))
	 (proof (time (tap~prove nnf (car limit-formula-pair)))))
    (if proof
	(format t "~% proved with VAR-LIMIT ~A." (car limit-formula-pair))
      (format t "~% Prove not found with VAR-LIMIT ~A." (car limit-formula-pair)))
    proof))

(defun tap~prove-all-formulas (&optional (formula-list tap*formula-list))
  (cond ((symbolp (first formula-list))
	 (format t "~% Proving ~A" (first formula-list))
	 (tap~prove-formula (eval (first formula-list))))
	(t (tap~prove-formula (first formula-list))))
  (tap~prove-all-formulas (rest formula-list)))

(defun tap~s-prove-formula (limit-formula-pair)
  (let* ((nnf (nnf~nnormalize (cdr limit-formula-pair) tap*env))
	 (proof (time (tap~s-prove nnf (car limit-formula-pair)))))
    (if proof
	(format t "~% proved with VAR-LIMIT ~A." (car limit-formula-pair))
      (format t "~% Prove not found with VAR-LIMIT ~A." (car limit-formula-pair)))
    proof))



(setf tap*env (env~create))
(setf rep*env tap*env)

(post~read-object-list '((type-constants o i) (type-variables aa bb)
			 (constants (= (o aa aa)) (false o) (true o)
				    (and (o o o)) (or (o o o)) (implies (o o o)) (equiv (o o o)) (not (o o))
				    (forall (o (o aa))) (exists (o (o aa))))
			 (constants (a i) (b i) (c i) (w i)
				    (p o) (q o) (r o) (s o)
				    (f1 (o i)) (g1 (o i)) (h1 (o i)) (i1 (o i)) (j1 (o i)) (k1 (o i)) (l1 (o i)) 
				    (p1 (o i)) (q1 (o i)) (r1 (o i)) (s1 (o i))
				    (f2 (o i i)) (g2 (o i i)) (h2 (o i i)) (i2 (o i i)) (j2 (o i i)) 
				    (p2 (o i i)) (q2 (o i i)) (r2 (o i i)) (s2 (o i i)))

  )
		       tap*env)



(setf pel1 (cons 0 (term~read (quote (not (equiv (implies p q) (implies (not q) (not p))))) tap*env)))
(setf pel2 (cons 0 (term~read (quote (not (equiv (not (not p)) p))) tap*env)))
(setf pel3 (cons 0 (term~read (quote (not (implies (not (implies p q)) (implies q p)))) tap*env)))
(setf pel4 (cons 0 (term~read (quote (not (equiv (implies (not p) q) (implies (not q) p)))) tap*env)))
(setf pel5 (cons 0 (term~read (quote (not (implies (implies (or p q) (or p r)) (or p (implies q r))))) tap*env)))
(setf pel6 (cons 0 (term~read (quote (not (or p (not p)))) tap*env)))
(setf pel7 (cons 0 (term~read (quote (not (or p (not (not (not p)))))) tap*env)))
(setf pel8 (cons 0 (term~read (quote (not (implies (implies (implies p q) p) p))) tap*env)))
(setf pel9 (cons 0 (term~read (quote (not (implies (and (and (or p q) (or (not p) q)) (or p (not q))) (not (or (not p) (not q)))))) tap*env)))
(setf pel10 (cons 0 (term~read (quote (and (not (equiv p q)) (and (implies q r) (and (implies r (and p q)) (implies p (or q r)))))) tap*env)))
(setf pel11 (cons 0 (term~read (quote (not (equiv p p))) tap*env)))
(setf pel12 (cons 0 (term~read (quote (not (equiv (equiv (equiv p q) r) (equiv p (equiv q r))))) tap*env)))
(setf pel13 (cons 0 (term~read (quote (not (equiv (or p (and q r)) (and (or p q) (or p r))))) tap*env)))
(setf pel14 (cons 0 (term~read (quote (not (equiv (equiv p q) (and (or q (not p)) (or (not q) p))))) tap*env)))
(setf pel15 (cons 0 (term~read (quote (not (equiv (implies p q) (or (not p) q)))) tap*env)))
(setf pel16 (cons 0 (term~read (quote (not (or (implies p q) (implies q p)))) tap*env)))
(setf pel17 (cons 0 (term~read (quote (not (equiv (implies (and p (implies q r)) s) (and (or (or (not p) q) s) (or (or (not p) (not r)) s))))) tap*env)))

(setf pel18 (cons 2 (term~read (quote (not (exists (lam (x_112 i) (forall (lam (x_115 i) (implies (f1 x_112) (f1 x_115)))))))) tap*env)))
(setf pel19 (cons 2 (term~read (quote (not (exists (lam (x_112 i) (forall (lam (x_115 i) (forall (lam (x_118 i) (implies (implies (p1 x_115) (q1 x_118)) (implies (p1 x_112) (q1 x_112))))))))))) tap*env)))
(setf pel20 (cons 6 (term~read (quote (not (implies (forall (lam (x_115 i) (forall (lam (x_118 i) (exists (lam (x_121 i) (forall (lam (xw i) (implies (and (p1 x_115) (q1 x_118)) (and (r1 x_121) (s1 w))))))))))) (exists (lam (x_144 i) (exists (lam (x_147 i) (implies (and (p1 x_144) (q1 x_147)) (exists (lam (x_160 i) (r1 x_160))))))))))) tap*env)))
(setf pel21 (cons 2 (term~read (quote (and (not (exists (lam (x_115 i) (equiv p (f1 x_115))))) (and (exists (lam (x_126 i) (implies p (f1 x_126)))) (exists (lam (x_134 i) (implies (f1 x_134) p)))))) tap*env)))
(setf pel22 (cons 2 (term~read (quote (not (implies (forall (lam (x_115 i) (equiv p (f1 x_115)))) (equiv p (forall (lam (x_126 i) (f1 x_126))))))) tap*env)))
(setf pel23 (cons 1 (term~read (quote (not (equiv (forall (lam (x_115 i) (or p (f1 x_115)))) (or p (forall (lam (x_126 i) (f1 x_126))))))) tap*env)))
(setf pel24 (cons 6 (term~read (quote (and (not (exists (lam (x_115 i) (and (p1 x_115) (r1 x_115))))) (and (not (exists (lam (x_130 i) (and (s1 x_130) (q1 x_130))))) (and (forall (lam (x_143 i) (implies (p1 x_143) (or (q1 x_143) (r1 x_143))))) (and (implies (not (exists (lam (x_166 i) (p1 x_166)))) (exists (lam (x_171 i) (q1 x_171)))) (forall (lam (x_176 i) (implies (or (q1 x_176) (r1 x_176)) (s1 x_176))))))))) tap*env)))
(setf pel25 (cons 3 (term~read (quote (and (not (exists (lam (x_115 i) (and (q1 x_115) (p1 x_115))))) (and (exists (lam (x_128 i) (p1 x_128))) (and (forall (lam (x_136 i) (implies (f1 x_136) (and (not (g1 x_136)) (r1 x_136))))) (and (forall (lam (x_156 i) (implies (p1 x_156) (and (g1 x_156) (f1 x_156))))) (or (forall (lam (x_174 i) (implies (p1 x_174) (q1 x_174)))) (exists (lam (x_184 i) (and (p1 x_184) (r1 x_184)))))))))) tap*env)))
(setf pel26 (cons 3 (term~read (quote (and (not (equiv (forall (lam (x_118 i) (implies (p1 x_118) (r1 x_118)))) (forall (lam (x_128 i) (implies (q1 x_128) (s1 x_128)))))) (and (equiv (exists (lam (x_144 i) (p1 x_144))) (exists (lam (x_149 i) (q1 x_149)))) (forall (lam (x_154 i) (forall (lam (x_157 i) (implies (and (p1 x_154) (q1 x_157)) (equiv (r1 x_154) (s1 x_157)))))))))) tap*env)))
(setf pel27 (cons 4 (term~read (quote (and (not (forall (lam (x_115 i) (implies (j1 x_115) (not (i1 x_115)))))) (and (exists (lam (x_130 i) (and (f1 x_130) (not (g1 x_130))))) (and (forall (lam (x_145 i) (implies (f1 x_145) (h1 x_145)))) (and (forall (lam (x_158 i) (implies (and (j1 x_158) (i1 x_158)) (f1 x_158)))) (implies (exists (lam (x_176 i) (and (h1 x_176) (not (g1 x_176))))) (forall (lam (x_188 i) (implies (i1 x_188) (not (h1 x_188))))))))))) tap*env)))
(setf pel28 (cons 3 (term~read (quote (and (not (forall (lam (x_115 i) (implies (and (p1 x_115) (f1 x_115)) (g1 x_115))))) (and (forall (lam (x_133 i) (implies (p1 x_133) (forall (lam (x_141 i) (q1 x_141)))))) (and (implies (forall (lam (x_152 i) (or (q1 x_152) (r1 x_152)))) (exists (lam (x_162 i) (and (q1 x_162) (s1 x_162))))) (implies (exists (lam (x_175 i) (s1 x_175))) (forall (lam (x_180 i) (implies (f1 x_180) (g1 x_180))))))))) tap*env)))
(setf pel29 (cons 2 (term~read (quote (and (not (equiv (and (forall (lam (x_121 i) (implies (f1 x_121) (h1 x_121)))) (forall (lam (x_131 i) (implies (g1 x_131) (j1 x_131))))) (forall (lam (x_141 i) (forall (lam (x_144 i) (implies (and (f1 x_141) (g1 x_144)) (and (h1 x_141) (j1 x_144))))))))) (and (exists (lam (x_167 i) (f1 x_167))) (exists (lam (x_172 i) (g1 x_172)))))) tap*env)))
(setf pel30 (cons 2 (term~read (quote (and (not (forall (lam (x_115 i) (i1 x_115)))) (and (forall (lam (x_123 i) (implies (or (f1 x_123) (g1 x_123)) (not (h1 x_123))))) (forall (lam (x_140 i) (implies (implies (g1 x_140) (not (i1 x_140))) (and (f1 x_140) (h1 x_140)))))))) tap*env)))
(setf pel31 (cons 3 (term~read (quote (and (not (exists (lam (x_115 i) (and (i1 x_115) (j1 x_115))))) (and (not (exists (lam (x_130 i) (and (f1 x_130) (or (g1 x_130) (h1 x_130)))))) (and (exists (lam (x_148 i) (and (i1 x_148) (f1 x_148)))) (forall (lam (x_158 i) (implies (not (h1 x_158)) (j1 x_158)))))))) tap*env)))
(setf pel32 (cons 3 (term~read (quote (and (not (forall (lam (x_115 i) (implies (and (f1 x_115) (k1 x_115)) (j1 x_115))))) (and (forall (lam (x_133 i) (implies (and (f1 x_133) (or (g1 x_133) (h1 x_133))) (i1 x_133)))) (and (forall (lam (x_156 i) (implies (and (i1 x_156) (h1 x_156)) (j1 x_156)))) (forall (lam (x_171 i) (implies (k1 x_171) (h1 x_171)))))))) tap*env)))
(setf pel33 (cons 1 (term~read (quote (not (equiv (forall (lam (x_115 i) (implies (and (p1 a) (implies (p1 x_115) (p1 b))) (p1 c)))) (forall (lam (x_135 i) (and (or (not (p1 a)) (or (p1 x_135) (p1 c))) (or (not (p1 a)) (or (not (p1 b)) (p1 c))))))))) tap*env)))
(setf pel35 (cons 4 (term~read (quote (not (exists (lam (x_112 i) (exists (lam (x_115 i) (implies (p2 x_112 x_115) (forall (lam (x_124 i) (forall (lam (x_127 i) (p2 x_124 x_127)))))))))))) tap*env)))
(setf pel36 (cons 6 (term~read (quote (and (not (forall (lam (x_115 i) (exists (lam (x_118 i) (h2 x_115 x_118)))))) (and (forall (lam (x_127 i) (exists (lam (x_130 i) (f2 x_127 x_130))))) (and (forall (lam (x_139 i) (exists (lam (x_142 i) (g2 x_139 x_142))))) (forall (lam (x_148 i) (forall (lam (x_151 i) (implies (or (f2 x_148 x_151) (g2 x_148 x_151)) (forall (lam (x_166 i) (implies (or (f2 x_151 x_166) (g2 x_151 x_166)) (h2 x_148 x_166))))))))))))) tap*env)))
(setf pel37 (cons 7 (term~read (quote (and (not (forall (lam (x_115 i) (exists (lam (x_118 i) (r2 x_115 x_118)))))) (and (forall (lam (x_127 i) (exists (lam (x_130 i) (forall (lam (x_133 i) (exists (lam (x_136 i) (implies (p2 x_133 x_127) (and (and (p2 x_136 x_130) (p2 x_136 x_127)) (implies (p2 x_136 x_130) (exists (lam (x_163 i) (q2 x_163 x_130)))))))))))))) (and (forall (lam (x_172 i) (forall (lam (x_175 i) (implies (not (p2 x_172 x_175)) (exists (lam (x_186 i) (q2 x_186 x_175)))))))) (implies (exists (lam (x_195 i) (exists (lam (x_198 i) (q2 x_195 x_198))))) (forall (lam (x_204 i) (r2 x_204 x_204)))))))) tap*env)))
(setf pel38 (cons 4 (term~read (quote (not (equiv (forall (lam (x_115 i) (implies (and (p1 a) (implies (p1 x_115) (exists (lam (x_131 i) (and (p1 x_131) (r2 x_115 x_131)))))) (exists (lam (x_142 i) (exists (lam (x_145 i) (and (and (p1 x_142) (r2 x_115 x_145)) (r2 x_145 x_142))))))))) (forall (lam (x_162 i) (and (or (or (not (p1 a)) (p1 x_162)) (exists (lam (x_180 i) (exists (lam (x_183 i) (and (and (p1 x_180) (r2 x_162 x_183)) (r2 x_183 x_180))))))) (or (or (not (p1 a)) (not (exists (lam (x_212 i) (and (p1 x_212) (r2 x_162 x_212)))))) (exists (lam (x_223 i) (exists (lam (x_226 i) (and (and (p1 x_223) (r2 x_162 x_226)) (r2 x_226 x_223))))))))))))) tap*env)))
(setf pel39 (cons 1 (term~read (quote (exists (lam (x_110 i) (forall (lam (x_113 i) (equiv (f2 x_113 x_110) (not (f2 x_113 x_113)))))))) tap*env)))
(setf pel40 (cons 3 (term~read (quote (not (implies (exists (lam (x_115 i) (forall (lam (x_118 i) (equiv (f2 x_118 x_115) (f2 x_118 x_118)))))) (not (forall (lam (x_132 i) (exists (lam (x_135 i) (forall (lam (x_138 i) (equiv (f2 x_138 x_135) (not (f2 x_138 x_132))))))))))))) tap*env)))
(setf pel41 (cons 3 (term~read (quote (and (exists (lam (x_113 i) (forall (lam (x_116 i) (f2 x_116 x_113))))) (forall (lam (x_122 i) (exists (lam (x_125 i) (forall (lam (x_128 i) (equiv (f2 x_128 x_125) (and (f2 x_128 x_122) (not (f2 x_128 x_128)))))))))))) tap*env)))
(setf pel42 (cons 3 (term~read (quote (exists (lam (x_110 i) (forall (lam (x_113 i) (equiv (f2 x_113 x_110) (not (exists (lam (x_124 i) (and (f2 x_113 x_124) (f2 x_124 x_113))))))))))) tap*env)))
(setf pel43 (cons 5 (term~read (quote (and (not (forall (lam (x_115 i) (forall (lam (x_118 i) (and (implies (q2 x_115 x_118) (q2 x_118 x_115)) (implies (q2 x_118 x_115) (q2 x_115 x_118)))))))) (and (forall (lam (x_145 i) (forall (lam (x_148 i) (implies (q2 x_145 x_148) (forall (lam (x_157 i) (and (implies (f2 x_157 x_145) (f2 x_157 x_148)) (implies (f2 x_157 x_148) (f2 x_157 x_145)))))))))) (forall (lam (x_181 i) (forall (lam (x_184 i) (implies (forall (lam (x_190 i) (and (implies (f2 x_190 x_181) (f2 x_190 x_184)) (implies (f2 x_190 x_184) (f2 x_190 x_181))))) (q2 x_181 x_184))))))))) tap*env)))
(setf pel44 (cons 3 (term~read (quote (and (not (exists (lam (x_115 i) (and (j1 x_115) (not (f1 x_115)))))) (and (forall (lam (x_130 i) (implies (f1 x_130) (and (exists (lam (x_141 i) (and (g1 x_141) (h2 x_130 x_141)))) (exists (lam (x_152 i) (and (g1 x_152) (not (h2 x_130 x_152))))))))) (exists (lam (x_165 i) (and (j1 x_165) (forall (lam (x_173 i) (implies (g1 x_173) (h2 x_165 x_173)))))))))) tap*env)))
(setf pel45 (cons 5 (term~read (quote (and (not (exists (lam (x_115 i) (and (f1 x_115) (not (exists (lam (x_125 i) (and (g1 x_125) (h2 x_115 x_125))))))))) (and (forall (lam (x_139 i) (implies (and (f1 x_139) (forall (lam (x_125 i) (implies (and (g1 x_125) (h2 x_139 x_125)) (j2 x_139 x_125))))) (forall (lam (x_167 i) (and (and (g1 x_167) (h2 x_139 x_167)) (k1 x_167))))))) (and (not (exists (lam (x_188 i) (and (l1 x_188) (k1 x_188))))) (exists (lam (x_198 i) (and (and (f1 x_198) (forall (lam (x_209 i) (implies (h2 x_198 x_209) (l1 x_209))))) (forall (lam (x_220 i) (implies (and (g1 x_220) (h2 x_198 x_220)) (j2 x_198 x_220))))))))))) tap*env)))
(setf pel46 (cons 5 (term~read (quote (and (not (forall (lam (x_115 i) (implies (f1 x_115) (g1 x_115))))) (and (forall (lam (x_128 i) (forall (lam (x_131 i) (implies (and (f1 x_128) (implies (and (f1 x_131) (h2 x_131 x_128)) (g1 x_131))) (g1 x_128)))))) (and (implies (exists (lam (x_163 i) (and (f1 x_163) (not (g1 x_163))))) (exists (lam (x_175 i) (and (and (f1 x_175) (not (g1 x_175))) (forall (lam (x_190 i) (implies (and (f1 x_190) (not (g1 x_190))) (j2 x_175 x_190)))))))) (forall (lam (x_208 i) (forall (lam (x_211 i) (implies (and (f1 x_208) (and (f1 x_211) (h2 x_208 x_211))) (not (j2 x_211 x_208))))))))))) tap*env)))
