
(in-package :keim)

;Unifikationsalgoritmus
;Dem Unifikationsalgoritmus wird zwei Terme b.z.w
;Atome und der Algoritmus entscheidet, ob die
;Terme b.z.w Atome unifizierbar sind, falls
;sie unifizierbar sind, dann wird einen
;allgemeinsten Unifikator ausgegeben, sonst
;nil.


(defun uni~unify-sort (term1 term2)
 
  (declare (edited  "03-AUG-1993 14:36")
	   (authors ABOZKURT)
	   (input  "zwei Terme" )
	   (effect  "none")
	   (value   "falls die Terme unifizierbar sind, dann liefert sie einen
		    allgemeinsten Unifikator, sonst nil"))
  
  (setq term-s term1)
  (setq term-t term2)
  (uni=list-unify (list (list term1 term2)) (subst~create nil nil)))
  

(defun uni=list-unify (eq-pair-list subst)
  (declare (edited  "03-AUG-1993 14:40")
	   (authors ABOZKURT)
	   (input  "eine Liste von Termpaaren und eine leere Substitution" )
	   (effect  "none")
	   (value   "falls die Terme unifizierbar, dann liefer sie
		    einen allgemeinsten Unifikator, sonst nil"))

  ;(format t "UNIFICATION: eq-pair-list = ~A  subst = ~A ~%" eq-pair-list subst)
  
  (cond ((null eq-pair-list) subst)
	((null (sort~gc-subsort (sort~sort (uni=term-left (car eq-pair-list)))
				(sort~sort (uni=term-right (car eq-pair-list)))))
	 nil)

	((uni=var-reversable   (car eq-pair-list))
	 (uni=list-unify (cons (uni=var-reverse (car eq-pair-list))
			       (cdr eq-pair-list)) subst))
	((uni=var-weekenable   (car eq-pair-list))
	 (uni=list-unify (append (uni=var-weeken (car eq-pair-list))
				 (cdr eq-pair-list)) subst))
	((uni=term-weekenable  (car eq-pair-list))  ; eine Liste von UnifiKatoren...subst-->subst-list
	 (uni=list-unify (cons (uni=term-weeken (car eq-pair-list))
			       (cdr eq-pair-list)) subst))

	
	((uni=xf-not-weekenable (car eq-pair-list)) nil)



	((uni=clash-p (car eq-pair-list)) nil)                            
        ((uni=dec-p (car eq-pair-list))                                   
	 (uni=list-unify (append (uni=dec (car eq-pair-list))
				 (cdr eq-pair-list)) subst))
	((uni=tautology-p (car eq-pair-list))                            
	 (uni=list-unify (cdr eq-pair-list) subst))
	((uni=orientation-p (car eq-pair-list))                          
	 (uni=list-unify (cons (uni=orientation (car eq-pair-list))
			       (cdr eq-pair-list)) subst))
	((uni=occur-check-p (car eq-pair-list)) nil)                     
	((uni=binding-p (car eq-pair-list )) ;anwendbar
	 (uni=list-unify (uni=subst (car eq-pair-list) (cdr eq-pair-list))
			 (uni=compose (car eq-pair-list) subst)))
	(t (format t "~% ERROR: No fiering rule!"))))

;**************************************************************************
(defun uni=var-reversable (eq-pair)

  (declare (edited   "JAN-1994")
	   (authors  HARAKETI)
	   (input    "a pair of terms as a list, such '(t1 t2)")
	   (effect   "none")
	   (value    "BOOLEAN: true if t1 and t2 reversable, else nil"))
 
  ;(format t "uni=var-reversable: eq-pair = ~A   ~%" eq-pair)
  

  (if (and (sym~variable-p (term~top (uni=term-left  eq-pair)))
	   (sym~variable-p (term~top (uni=term-right eq-pair)))
	   (or (uni=subsort-strict  (uni=term-left  eq-pair)
				    (uni=term-right  eq-pair))
	       (and (uni=sort-equal (uni=term-left  eq-pair)
				   (uni=term-right  eq-pair))
		    (not (uni=var-belongs (uni=term-left  eq-pair)
					  term-s  term-t))
		    (uni=var-belongs (uni=term-right  eq-pair)
				      term-s  term-t))))
      t
    nil))

;---------------------------------------------------------------------------
(defun uni=var-reverse (eq-pair)
  (declare (edited   "JAN-1994")
	   (authors  HARAKETI)
	   (input    "a pair of terms as a list, such '(t1 t2")
	   (effect   "none" )
	   (value    "the reversed pair: '(t2 t1)"))

  ;(format t "uni=var-reverse: eq-pair-list = ~A   ~%" eq-pair)

  (list (uni=term-right eq-pair)
	(uni=term-left  eq-pair)))

;**************************************************************************
(defun uni=var-overable (eq-pair)
 (declare (edited   "JAN-1994")
	   (authors  HARAKETI)
	   (input    "a pair of terms as a list, such '(t1 t2)")
	   (effect   "none")
	   (value    "BOOLEAN: true if t1 and t2 overable, else nil"))
  
 ;(format t "uni=var-overable: eq-pair = ~A   ~%" eq-pair)

 (if (and (sym~variable-p (term~top (uni=term-left  eq-pair)))
	  (sym~variable-p (term~top (uni=term-right eq-pair)))
	  (not (uni=subsort-p  (uni=term-left   eq-pair)
			       (uni=term-right  eq-pair)))
	  (not (uni=subsort-p  (uni=term-right  eq-pair)
			       (uni=term-left   eq-pair))))
     t
   nil))
;---------------------------------------------------------------------------
(defun uni=var-over (eq-pair)
  (declare (edited   "JAN-1994")
	   (authors  HARAKETI)
	   (input    "a pair of terms as a list, such '(t1 t2)")
	   (effect   "none" )
	   (value    ""))
 ;(format t "uni=var-over: eq-pair = ~A   ~%" eq-pair)

  (list (uni=cst-create 'x (uni=subsort-gc (uni=term-left  eq-pair)
					(uni=term-left  eq-pair)))
	(uni=cst-create 'x (uni=subsort-gc (uni=term-right eq-pair)
					(uni=term-right eq-pair)))))



;****************************************************************************
(defun uni=var-weekenable (eq-pair)
  (declare (edited   "JAN-1994")
	   (authors  HARAKETI)
	   (input    "a pair of terms as a list, such '(t1 t2)")
	   (effect   "none")
	   (value    "BOOLEAN: true if t1 and t2 weekeneable, else nil"))

  ;(format t "uni=var-weekenable: eq-pair = ~A   ~%" eq-pair)

  (if (and (sym~variable-p (term~top (uni=term-left  eq-pair)))
	   (sym~variable-p (term~top (uni=term-right eq-pair)))
	   (not (uni=subsort-p (uni=term-left  eq-pair) (uni=term-right eq-pair)))
	   (not (uni=subsort-p (uni=term-right eq-pair) (uni=term-left  eq-pair)))
	   (uni=subsort-gc     (uni=term-left  eq-pair) (uni=term-right eq-pair)))

      t
    nil))

;-------------------------------------------------------------------------------
(defun uni=var-weeken (eq-pair)
  (declare (edited   "JAN-1994")
	   (authors  HARAKETI)
	   (input    "a pair of terms as a list, such '(t1 t2) ")
	   (effect   "none" )
	   (value    "two pirs of list: '((t1 tz) (t2 tz)) "))

  ;(format t "uni=var-weeken: eq-pair = ~A   ~%" eq-pair)

  (let ((var-deklaration (uni=var-create (uni=subsort-gc (uni=term-left  eq-pair)
						     (uni=term-right eq-pair)))))
       
       (list (list (uni=term-left   eq-pair)    var-deklaration)
	     (list (uni=term-right  eq-pair)    var-deklaration))))
	      
  
;******************************************************************************
(defun uni=term-weekenable (eq-pair)
  (declare (edited   "JAN-1994")
	   (authors  HARAKETI)
	   (input    "a pair of terms as a list, such '(t1 t2)")
	   (effect   "none")
	   (value    "BOOLEAN: true if t2 weekeneable, else nil"))

  ;(format t "uni=term-weekenable: eq-pair = ~A   ~%" eq-pair)

  (if (and (sym~variable-p (term~top (uni=term-left  eq-pair)) )
	   (appl~p (term~top (uni=term-right eq-pair)))
	   (not (uni=var-belongs  (uni=term-left  eq-pair)
				  (uni=term-right eq-pair) nil))
	   (not (uni=subsort-exclusiv (uni=term-left eq-pair)
				     (uni=term-right eq-pair))))
      
      t
    nil))

;------------------------------------------------------------------------------
(defun uni=term-weeken (eq-pair)
  (declare (edited   "JAN-1994")
	   (authors  HARAKETI)
	   (input    "a pair of terms as a list, such '(t1 t2) ")
	   (effect   "none" )
	   (value    "two pirs of list: '((t1 t2') (s1 arg1)...(sn argn))"))
  
  ;(format t "uni=term-weeken: eq-pair = ~A   ~%" eq-pair)

  (let ((term-deklaration (uni=cst-create (uni=term-left  eq-pair)
					  (uni=subsort-gc (uni=term-left  eq-pair)
							  (uni=term-right eq-pair)))))
       
    (list (list (uni=term-left   eq-pair) term-deklaration)
	  (list (uni=term-right  eq-pair) term-deklaration))))
       
	     
;*******************************************************************************
(defun uni=subsort-strict (term1 term2)
  (declare (edited   "JAN-1994")
	   (authors  HARAKETI)
	   (input    "two terms")
	   (effect   "none" )
	   (value    "the strict subsort of both terms"))

  ;(format t "uni=subsort-strict: term1 = ~A  term2 = ~A  ~%" term1 term2)

  (if (sort~equal (sort~sort term1) (sort~sort term2))
      nil
    (sort~subsort-p (sort~sort term1) (sort~sort term2))))

;*******************************************************************************
(defun uni=subsort-p (term1 term2)
  (declare (edited   "JAN-1994")
	   (authors  HARAKETI)
	   (input    "two terms")
	   (effect   "none" )
	   (value    ""))

  ;(format t " uni=subsort-p: term1 = ~A  term2 = ~A ~%" term1 term2)
  (sort~subsort-p (sort~sort term1) (sort~sort term2)))

;*******************************************************************************
(defun uni=subsort-equal (term1 term2)
  (declare (edited   "JAN-1994")
	   (authors  HARAKETI)
	   (input    "two terms")
	   (effect   "none" )
	   (value    "the strict subsort of both terms"))

  ;(format t "uni=subsort-equal: term1 = ~A  term2 = ~A  ~%" term1 term2)
  
  (if (sort~equal (sort~sort term1) (sort~sort term2))
      t
    nil))

;*******************************************************************************
(defun uni=subsort-gc (term1 term2)
  (declare (edited   "JAN-1994")
	   (authors  HARAKETI)
	   (input    "two terms")
	   (effect   "none" )
	   (value    "g.c subsort of both terms"))

  ;(format t "uni=subsort-gc: term1 = ~A  term2 = ~A  ~%" term1 term2)
  (sort~gc-subsort (sort~sort term1) (sort~sort term2)))

;*******************************************************************************
(defun uni=subsort-exklusiv (term1 term2)
  (declare (edited   "JAN-1994")
	   (authors  HARAKETI)
	   (input    "two terms")
	   (effect   "none" )
	   (value    "BOOLEAN: if each A in sort term2 "
		     "do not belongs to the sort of term2 true, else nil"))
  ;(format t "uni=subsort-exklusiv: term1 = ~A  term2 = ~A  ~%" term1 term2)

  (if (sort~subsorts (sort~gc-subsort (sort~sort term1) (sort~sort term2)))
      nil
    t))

;*******************************************************************************
(defun uni=var-create (sort)
  (declare (edited   "JAN-1994")
	   (authors  HARAKETI)
	   (input    "a sort")
	   (effect   "none" )
	   (value    "creates a new variable of sort <sort> "
		     "in the env and returns it"))

  ;(format t ": sort = ~A   ~%" sort)
  (sym~variable-create  (gentemp "x-") sort))
  
;******************************************************************************
(defun uni=cst-create (term sort)
  (declare (edited   "JAN-1994")
	   (authors  HARAKETI)
	   (input    "a sort")
	   (effect   "none" )
	   (value    "creates a new term of sort <sort> "
		     "in the env and returns it"))
  
  ;(format t "uni=cst-create: term = ~A   sort = ~A ~%" term sort)
  (sym~constant-create  (term~top term) sort))

;******************************************************************************
(defun uni=var-belongs (var term1 term2)
  
  (declare (edited   "JAN-1994")
	   (authors  HARAKETI)
	   (input    "a var and a list of arguments")
	   (effect   "none" )
	   (value    "BOOLEAN: true if var belongs to list"))
  
  ;(format t "uni=var-belongs: var = ~A  term1 = ~A  term2 = ~A ~%"
	;  var term1 term2)
  
  (or (uni=term-occur-check-p var term1)
      (uni=term-occur-check-p var term2)))


;(uni=var-belongs (car (fo~arguments tz)) tz)

;******************************************************************************
(defun uni=xy-not-weekenable (eq-pair)
  (declare (edited   "JAN-1994")
	   (authors  HARAKETI)
	   (input    "a pair of terms as a list, such '(t1 t2)")
	   (effect   "none")
	   (value    "BOOLEAN: nil if t1 and t2 weekeneable, else true"))

  ;(format t "uni=xy-not-weekenable: left = ~A  right = ~A ~%"
	;  (uni=term-left  eq-pair) (uni=term-right  eq-pair))
	  
  (if (and (sym~variable-p (term~top (uni=term-left  eq-pair)))
	   (sym~variable-p (term~top (uni=term-right eq-pair)))
	   (not (uni=var-weekenable eq-pair))
	   (not (uni=var-overable   eq-pair)))
      
      t
    nil))

;******************************************************************************
(defun uni=xf-not-weekenable (eq-pair)
  (declare (edited   "JAN-1994")
	   (authors  HARAKETI)
	   (input    "a pair of terms as a list, such '(t1 t2)")
	   (effect   "none")
	   (value    "BOOLEAN: nil if t1 t2 weekeneable, else ture"))
  
  ;(format t "uni=xf-not-weekenable: left = ~A  right = ~A ~%"
	;  (uni=term-left  eq-pair) (uni=term-right  eq-pair))
  
  (if (and (sym~variable-p (term~top (uni=term-left  eq-pair)))
	   (appl~p (term~top (uni=term-right eq-pair)))
	   (uni=term-weekenable eq-pair)
	   (not (uni=subsort-gc (uni=term-left  eq-pair)
			       (uni=term-right eq-pair))))
      t
    nil))

;************************************************************************  

(defun uni=sort-equal (sort1 sort2)
  (declare (edited   "JAN-1994")
	   (authors  HARAKETI)
	   (input    "")
	   (effect   "none")
	   (value    "BOOLEAN: nil if sort1 = sort2, else ture"))
  
  ;(format t "uni=sort-equal: sort1 = ~A  sort2 = ~A ~%"  sort1 sort2)
  (sort~equal sort1 sort2))


;************************************************************************  
(defun uni=clash-p (eq-pair)
  (declare (edited  "03-AUG-1993 14:42")
	   (authors ABOZKURT)
	   (input   "ein Termpaar als Liste, also  '(t1 t2)")
	   (effect  "none")
	   (value   "BOOLEAN: falls clash, dann t, sonst nil" ))

  ;(format t "uni=clash-p: left = ~A  right = ~A ~%"
	;  (uni=term-left  eq-pair) (uni=term-right  eq-pair))

  (let ((fn-left (term~top (uni=term-left eq-pair)))
	(fn-right (term~top (uni=term-right eq-pair)))
	(fn-left-p (appl~p (uni=term-left eq-pair)))  
	(fn-right-p (appl~p (uni=term-right eq-pair))))
    (if (and fn-left-p
	     fn-right-p
	     (not (term~equal fn-left fn-right)))
	t
      nil)))



(defun uni=term-left (eq-pair)
  (declare (edited  "03-AUG-1993 14:45")
	   (authors ABOZKURT)
	   (input   "ein Termpaar als Liste, also '(t1 t2)")
	   (effect  "none")
	   (value   "liefert den linken Term, also t1" ))

  (first eq-pair))

(defun uni=term-right (eq-pair)
  (declare (edited  "03-AUG-1993 14:47")
	   (authors ABOZKURT)
	   (input   " ein Termpaar als Liste, also '(t1 t2)")
	   (effect  "none")
	   (value   "liefert den rechten Term, also t2 "))

  (first (rest eq-pair)))



  
;----------------------------------------------------------------------------------------------------
(defun uni=dec-p (eq-pair)
  (declare (edited  "03-AUG-1993 14:48")
	   (authors HARAKETI)
	   (input   "ein Termpaar als Liste, also '(t1 t2)")
	   (effect  "none")
	   (value   " BOOLEAN :t falls t1 und t2 dekomponierbar, sonst nil"))

  ;(format t "uni=dec-p: left = ~A  right = ~A ~%"
	;  (uni=term-left  eq-pair) (uni=term-right  eq-pair))

  (let ((fn-left     (term~top (uni=term-left eq-pair)))
	(fn-right    (term~top (uni=term-right eq-pair)))
	(fn-left-p   (fo~application-p (uni=term-left eq-pair)))
	(fn-right-p  (fo~application-p (uni=term-right eq-pair))))

    (if (and (term~equal fn-left fn-right)
	     fn-left-p
	     fn-right-p)
        t
      nil)))

(defun uni=dec-p0 (eq-pair)
  (declare (edited  "03-AUG-1993 14:48")
	   (authors ABOZKURT)
	   (input   "ein Termpaar als Liste, also '(t1 t2)")
	   (effect  "none")
	   (value   " BOOLEAN :t falls t1 und t2 dekomponierbar, sonst nil"))

  ;(format t "uni=dec-p: left = ~A  right = ~A ~%"
	;  (uni=term-left  eq-pair) (uni=term-right  eq-pair))

  (let ((fn-left     (term~top (uni=term-left eq-pair)))
	(fn-right    (term~top (uni=term-right eq-pair)))
	(fn-left-p   (fo~function-p (term~top (uni=term-left eq-pair))))
	(fn-right-p  (fo~function-p (term~top (uni=term-right eq-pair)))))

    (if (and (term~equal fn-left fn-right)
	     fn-left-p
	     fn-right-p)
        t
      nil)))
;----------------------------------------------------------------------------------------------------

(defun uni=dec (eq-pair)
  (declare (edited  "03-AUG-1993 14:50")
	   (authors ABOZKURT)
	   (input   " ein Termpaar als Liste, also '(t1 t2)")
	   (effect  "none")
	   (value   "eine liste von Termpaaren, also '((t1` t2`) (t1`` t2``)...)"))
  
  ;(format t "uni=dec: left = ~A  right = ~A ~%"
	;  (uni=term-left  eq-pair) (uni=term-right  eq-pair))

 (uni=dec-1 (fo~arguments (uni=term-left eq-pair))
	     (fo~arguments (uni=term-right eq-pair))))

(defun uni=dec-1 (args-left args-right)

  ;(format t "uni=dec-1: right = ~A  left = ~A ~%" args-left args-right)

  (cond ((null args-left) nil)
	(t (cons (list (car args-left) (car args-right))
		 (uni=dec-1 (cdr args-left) (cdr args-right))))))

;-----------------------------------------------------------------------------------------------------------------

(defun uni=tautology-p (eq-pair)
  (declare (edited  "03-AUG-1993 14:55")
	   (authors ABOZKURT)
	   (input   " ein Termpaar als Liste, also '(t1 t2)")
	   (effect  "none" )
	   (value   "BOOLEAN: t falls t1 und t2 tautologisch sind, sonst nil "))

  ;(format t "uni=tautology-p: left = ~A  right = ~A ~%"
	;  (uni=term-left  eq-pair) (uni=term-right  eq-pair))
  
  (if (term~equal (uni=term-right eq-pair)
		  (uni=term-left eq-pair))
      t
    nil))


;------------------------------------------------------------------------------------

(defun uni=binding-p (eq-pair)
  (declare (edited  "03-AUG-1993 14:56")
	   (authors ABOZKURT)
	   (input   "eq-pair: ein Termpaar als Liste, also '(t1 t2)")
	   (effect  "none")
	   (value   "BOOLEAN: t falls t1 nicht in t2 vorkommt, sonnst nil"))

  ;(format t "uni=binding-p: left = ~A  right = ~A ~%"
	;  (uni=term-left  eq-pair) (uni=term-right  eq-pair))
  
  (let ((left-var   (term~top (uni=term-left eq-pair)))
	(right-term (uni=term-right eq-pair)))
    (cond ((and (sym~variable-p left-var)
		(not (uni=term-occur-check-p left-var right-term)))
	   t)
	  (t nil))))


;------------------------------------------------------------------------------------
(defun uni=subst (eq-pair eq-pair-list)
  (declare (edited  "03-AUG-1993 15:02")
	   (authors ABOZKURT)
	   (input  " eq-pair: ein Termpaar als Liste, also '(t1 t2)
		    eq-pair-list: eine Liste von Termpaaren" )	          
	   (effect  "none")
	   (value  " eine Liste von Termpaaren: in der eq-pair-list
		    vorkommenden variablen t1 werden durch Term t2 ersetzt"))

  ;(format t "uni=subst: eq-pair = ~A  eq-pair-list = ~A ~%"
	;  eq-pair eq-pair-list)

  (let ((var (uni=term-left eq-pair))
	(term (uni=term-right eq-pair))
	(left-term (uni=term-left (car eq-pair-list)))
	(right-term (uni=term-right (car eq-pair-list))))
    (if (null (car eq-pair-list))
	nil
      (cons (list (top~replace-free-variables left-term (list var) (list term))
		  (top~replace-free-variables right-term (list var) (list term)))
	    (uni=subst eq-pair (cdr eq-pair-list))))))

;----------------------------------------------------------------------------------
(defun uni=compose (eq-pair substitution)
  (declare (edited  "03-AUG-1993 15:07")
	   (authors ABOZKURT)
	   (input   " eq-pair: ein Termpaar als Liste, also '(t1 t2)
		     subtitution: Eine Substitution")
	   (effect  "none")
	   (value  " Eine neue Subsitution: in der "substitution" vorkommenden
		    variablen t1 werden durch den Term t2 ersetzt"))
  ;(format t "uni=compose: eq-pair = ~A  subst = ~A ~%"
	;  eq-pair substitution)
  
  (let ((var (uni=term-left eq-pair))
	(term (uni=term-right eq-pair)))
    (subst~insert-component var term
			    (subst~create (subst~domain substitution)
						   (uni=subst-replace var term
								      (subst~codomain substitution))))))


(defun uni=subst-replace (var term codomain)

  ;(format t "uni=subst-replace: var = ~A  term = ~A codomain = ~A ~%" var term codomain)

  (if (null codomain)
      nil
      (cons (top~replace-free-variables (first codomain) (list var) (list term))
            (uni=subst-replace var term (rest codomain)))))


;----------------------------------------------------------------------------------
(defun uni=orientation-p (eq-pair)
  (declare (edited  "03-AUG-1993 15:11")
	   (authors ABOZKURT)
	   (input    "ein Termpaar als Liste, also '(t1 t2)")
	   (effect   "none")
	   (value    "BOOLEAN: t falls, t1 und t2 orientierbar ist, sonst nil"))

  ;(format t "uni=orientation-p: eq-pair = ~A ~%" eq-pair)

  (if (and (not (sym~variable-p (term~top (uni=term-left eq-pair))))
	   (sym~variable-p (term~top (uni=term-right eq-pair))))
      t
    nil))
;---------------------------------------------------------------------------------

(defun uni=orientation (eq-pair)
  (declare (edited  "03-AUG-1993 15:12")
	   (authors ABOZKURT)
	   (input  " ein Termpaar als Liste, also '(t1 t2) ")
	   (effect  "none" )
	   (value   "eine Termpaar als Liste, also '(t2 t1)"))

  (list (uni=term-right eq-pair)
	(uni=term-left eq-pair)))

;--------------------------------------------------------------------------------
  
;occur-check 

(defun uni=occur-check-p (eq-pair)
  (declare (edited  "03-AUG-1993 15:14")
	   (authors ABOZKURT)
	   (input   "ein Termpaar als Liste, also '(t1 t2)")
	   (effect  "none")
	   (value   "BOOLEAN: t falls t1 in t2 vorkommt, sonst nil"))

  ;(format t "uni=occur-check-p: eq-pair = ~A ~%"  eq-pair)
  
  (let ((var (term~top (uni=term-left eq-pair)))
	(term (uni=term-right eq-pair)))
    (uni=term-occur-check-p var term)))


(defun uni=term-occur-check-p (var term)
  (declare (edited  "03-AUG-1993 15:15")
	   (authors ABOZKURT)
	   (input  " eine Variable und ein Term")
	   (effect  "none")
	   (value   "BOOLEAN: t fall Variable "var" in Term "term"
		    vorkommt, sonst nil"))
 ;(format t "uni=term-occur-check-p: var = ~A  term = ~A ~%"var term)

 (cond ((null term) t)
       ((term~equal var term) t)
       ((symbolp term) nil)                        
       (t (uni=term-list-occur-check var (fo~arguments term)))))

(defun uni=term-list-occur-check (var arg-list)
  (cond ((null arg-list) nil)
	((uni=term-occur-check-p var (car arg-list)) t)
	(t (uni=term-list-occur-check var (cdr arg-list)))))


;***********************************************************************


#|
(load "~/fopra/sort/sort-unification.lisp")

(load "~/fopra/sort/sort-unify.lisp")


(uni~unify-sort t1 t2)

(term~top (car (fo~arguments tz)))
(sym~variable-p (term~top (car (fo~arguments tz))))

subst~

134.96.236.4	js-sfbslc02.cs.uni-sb.de js-sfbslc02		
134.96.236.5	js-sfbslc03.cs.uni-sb.de js-sfbslc03		
134.96.236.6	js-sfbslc04.cs.uni-sb.de js-sfbslc04		
134.96.236.7	js-sfbslc06.cs.uni-sb.de js-sfbslc06		
134.96.236.8	js-sfbslc07.cs.uni-sb.de js-sfbslc07		
134.96.236.9	js-sfbslc08.cs.uni-sb.de js-sfbslc08		
134.96.236.10	js-sfbslc10.cs.uni-sb.de js-sfbslc10		
134.96.236.11   js-sfbslc12.cs.uni-sb.de js-sfbslc12

|#
