(in-package :resprover)

;;; Return T if any clause in VEC subsumes CLAUSE. 
(defun forward-subsumption-p (clause vec)
  (let ((parents (if (res~factoring-p clause) (parent-clauses clause))))
    (dotimes (i (fill-pointer vec))
      (let ((val (aref vec i)))
	(when (and val
		   (not (eq val clause)) ; don't check with itself
		   (not (new-clause-ignore val)) 
		   (not (member val parents)) ; don't redo factors
		   (subs~subsumes-p val clause))
	  (return-from forward-subsumption-p t))))))

(defun do-backward-subsumption (clause vec)
  (dotimes (i (fill-pointer vec))
    (let ((val (aref vec i)))
      (when (and val
		 (not (eq val clause))
		 (not (new-clause-ignore val))
		 (subs~subsumes-p clause val))
	(setf (new-clause-ignore val) t)))))

(defun parent-clauses (clause)
  (cond ((res~resolution-p clause) (res~resolution-clauses clause))
	((res~initial-p clause) nil)
	((res~factoring-p clause)
	 (list (res~factoring-clause clause)))
	(t nil)))



