;;; -*- syntax: common-lisp; package: keim; base: 10; mode: lisp -*-


(IN-PACKAGE "KEIM")


#|
(defmethod print-object ((var sym+var) stream)
  (format stream "~A:~A" (keim~name var) (sort~sort var)))
|#



(setf test*env (env~create))


(post~read-object-list '((type-constants i o num)
			 (constants (R (o num)) (Z (o num)) (N0+ (o num)) (N0- (o num))
				    (N+ (o num)) (N- (o num)) (Zero (o num)))
			 (subsorts (N- N0- Z R) (N+ N0+ Z) (Zero N0+) (Zero N0-))
			 (constants (+ (R R R)) (+ (N0+ N0+ N0+)) (+ (N0- N0- N0-)) (null Zero))
			 (Variables (z1 Z) (z2 Z) (z3 Z) (x1 N0+) (x2 N0+) (x3 N0+)
				    (y1 N0-) (y2 N0-) (y3 N0-) (u1 Zero) (u2 Zero) (u3 Zero)
				    (v1 N+) (v2 N+) (v3 N+) (w1 N-) (w2 N-) (w3 N-)))
		       test*env)

(post~read-object-list '((constants (+ (Zero Zero Zero))))
		       test*env)

(post~read-object-list '((constants (+ (n0- Zero Zero)) (+ (Zero n0- Zero))))
		       test*env)

(setf r (env~lookup-object 'r test*env))
(setf z (env~lookup-object 'z test*env))
(setf n0+ (env~lookup-object 'n0+ test*env))
(setf n0- (env~lookup-object 'n0- test*env))
(setf n+ (env~lookup-object 'n+ test*env))
(setf n- (env~lookup-object 'n- test*env))
(setf zero (env~lookup-object 'zero test*env))

(setf tzero (term~read '(+ u1 u2) test*env))
(setf tz (term~read '(+ z1 z2) test*env))
(setf tn0- (term~read '(+ y1 y2) test*env))
(setf tn- (term~read '(+ w1 w2) test*env))

#|(defgeneric sort=sort-rel (sort)
  (declare (edited  "03-JAN-1994 17:27")
	   (authors RICHTS)
	   (input   "A sort.")
	   (effect  "None.")
	   (value   "A assoc. list. The keys are sorts and the values are the greatest common subsorts"
		    "of this sorts and SORT.")
	   (remark  "A method for SORT+SHAREDSORT is defined in its class definition."))
  (:method ((sort sym+sym))
     (sort=sort-rel (sym~shared-symbol sort))))|#




(setf test*env (env~create))


(post~read-object-list '((type-constants i o)
			 (constants (D (o i)) (C (o i)))
			 (subsorts (C D))
			 (constants (f (d d d)) (f (c c d)) (f (c d c)))
			 (Variables (z1 D) (z2 D) (z3 D) (z4 D) (x1 C) (x2 C) (x3 C)))
		       test*env)

(setf t1 (term~read 'x1 test*env))
(setf s1 (term~read '(f z1 z2) test*env))

(uni~unify-sort t1 s1)


(setf t2 (term~read 'x2 test*env))
(setf s2 (term~read '(f z2 z1) test*env))

(uni~unify-sort t2 s2)


(setf m1 (list (list (term~read '(f z1 z2) test*env)
		     (term~read '(f z3 z4) test*env)
		     (term~read 'x1 test*env))))

(uni~unify-sort-list m1)


(setf m2 (list (list (term~read '(f z1 z2) test*env)
		     (term~read '(f z1 z4) test*env)
		     (term~read 'x1 test*env))))

(uni~unify-sort-list m2)


(setf l1 (list (term~read '(f z1 z2) test*env) (term~read '(f z3 z4) test*env)))
(setf k1 (list (term~read 'x1 test*env) (term~read 'x2 test*env)))

(uni~unify-sort-list l1 k1)


(setf l2 (list (term~read '(f z1 z2) test*env) (term~read '(f z3 z4) test*env)))
(setf k2 (list (term~read 'x1 test*env) (term~read 'x1 test*env)))

(uni~unify-sort-list l2 k2)


(setf l3 (list (term~read '(f z1 z2) test*env) (term~read '(f z3 z4) test*env)))
(setf k3 (list (term~read 'x1 test*env) (term~read 'z1 test*env)))

(uni~unify-sort-list l3 k3)





(setf test*env (env~create))

(post~read-object-list '((type-constants i o)
			 (constants (A (o i)) (B (o i)) (C (o i)) (D (o i)) (E (o i)))
			 (subsorts (D C A) (D B A) (D E))
			 (constants (f (a a a)) (f (d b c)) (f (d c b))
				    (g (a a a)) (g (d b c)))
			 (Variables (z1 A) (z2 A) (z3 A) (z4 A) (x1 D) (x2 D) (x3 D) (y1 E) (y2 E)))
		       test*env)
#|
   A
  / \
  B  C  E
   \ | /
     D
|#



(setf l11 (list (term~read '(f z1 z2) test*env)))
(setf k11 (list (term~read 'y1 test*env)))

(uni~unify-sort-list l11 k11)



(setf l12 (list (term~read '(f z1 z2) test*env) (term~read 'z1 test*env)))
(setf k12 (list (term~read 'y1 test*env) (term~read 'z2 test*env)))

(uni~unify-sort-list l12 k12)



(setf l13 (list (term~read 'z1 test*env) (term~read '(f z1 z2) test*env)))
(setf k13 (list (term~read 'z2 test*env) (term~read 'y1 test*env)))

(uni~unify-sort-list l13 k13)


(setf l14 (list (term~read '(f z1 z2) test*env) (term~read '(g z1 z2) test*env)))
(setf k14 (list (term~read 'y1 test*env) (term~read 'y2 test*env)))

(uni~unify-sort-list l14 k14)




(setf test*env (env~create))

(post~read-object-list '((type-constants i o)
			 (constants (C (o i)) (D (o i)))
			 (subsorts (D C))
			 (constants (f (c c c)) (f (c c d)) (a c))
			 (Variables (x1 c) (x2 c) (x3 c) (y1 d) (y2 d)))
		       test*env)


(setf t1 (term~read '(f x1 x1) test*env))
(setf s1 (term~read '(f y1 a) test*env))

(uni~unify-sort t1 s1)
