;;;****************************************************************************
;;;* Test                                                                     *
;;;****************************************************************************

(in-package :keim)

;;;+--------------------------------------------------------------------------+
;;;| universe                                                                 |
;;;+--------------------------------------------------------------------------+

(defvar env)      ; universe
(defvar a)        ; constants 
(defvar b)
(defvar c) 
(defvar d)
(defvar u)          ; variables
(defvar v)
(defvar w)
(defvar x)
(defvar y)
(defvar z)

(defvar x1)
(defvar x2)
(defvar x3)
(defvar x4)


(defvar ab)            ; applications
(defvar abc)
(defvar abz)
(defvar ax)
(defvar axb)
(defvar axy)
(defvar ayxz)
(defvar az)
(defvar bc)
(defvar by)
(defvar cd)
(defvar uv)
(defvar uva)
(defvar uvcd)
(defvar vx)
(defvar vzu)
(defvar xay)
(defvar xuv)
(defvar xy)
(defvar xyab)
(defvar xyb)
(defvar xz)
(defvar yuac)
(defvar yy)
(defvar zxv)
(defvar tterm)
(defvar fxx)
(defvar fxy)
(defvar xab)
(defvar xabx)
(defvar ycd)
(defvar ycdx)
(defvar yxy)
(defvar yxz)
(defvar abx)
(defvar cdy)
(defvar xcdy)
(defvar yzy)
(defvar zab)
(defvar xx)
(defvar xaa) (defvar aax)
(defvar xax)
(defvar ybb) (defvar bby)   
(defvar yxb)

(defvar xa)
(defvar x1x1)
(defvar x2x2)
(defvar x3x3)
(defvar x4x4)
(defvar aab)
(defvar bba)
(defvar axbzx)
(defvar zczyyy)

(defun a~univ-create ()
  (declare (special env))

  (setf env (env~create))
  (post~read-object-list '((type-constants i o)
			   (constants (f (i i i))
				      (a i) (b i) (c i) (d i))
			   (variables (u i) (v i) (x i) (y i) (z i)
				      (w i)
			              (x1 i) (x2 i) (x3 i) (x4 i))
			   (signatures (a (+ (i i i))) (a (* (i i i)))))
			 env)
                               ; universe filled with individuals
  (setf a (term~read 'a env))          ; constants 
  (setf b (term~read 'b env))
  (setf c (term~read 'c env)) 
  (setf d (term~read 'd env))
  (setf u (term~read 'u env))          ; variables
  (setf v (term~read 'v env))
  (setf w (term~read 'w env))
  (setf x (term~read 'x env))
  (setf y (term~read 'y env))
  (setf z (term~read 'z env))

  (setf ab (term~read '(f a b) env))            ; applications
  (setf xx (term~read '(f x x) env))
  (setf uv (term~read '(f u v) env))
  (setf xab (term~read '(f x (f a b)) env))
  (setf xabx (term~read '(f (f x a) (f b x)) env))
  (setf zab (term~read '(f (f z a) b) env))
  (setf yzy (term~read '(f y (f z y)) env))
  (setf yxy (term~read '(f (f y x) y) env))
  (setf yxz (term~read '(f (f y x) z) env))
  (setf ycd (term~read '(f (f y c) d) env))
  (setf ycdx (term~read '(f (f y (f c d)) x) env))
  (setf fxx (term~read '(f x x) env))
  (setf fxy (term~read '(f x y) env))
  (setf abc (term~read '(f a (f b c)) env))
  (setf abz (term~read '(f a (f b z)) env))
  (setf ax (term~read '(f a x) env))
  (setf axb (term~read '(f a (f x b)) env))
  (setf axy (term~read '(f a (f x y)) env))
  (setf ayxz (term~read '(f (f a y) (f x z)) env))
  (setf az (term~read '(f a z) env))
  (setf bc (term~read '(f b c) env))
  (setf by (term~read '(f b y) env))
  (setf cd (term~read '(f c d) env))
  (setf uva (term~read '(f u (f v a)) env))
  (setf uvcd (term~read '(f (f u v) (f c d)) env))
  (setf vx (term~read '(f v x) env))
  (setf vzu (term~read '(f v (f z u)) env))
  (setf xay (term~read '(f x (f a y)) env))
  (setf xuv (term~read '(f x (f u v)) env))
  (setf xy (term~read '(f x y) env))
  (setf xyab (term~read '(f (f x y) (f a b)) env))
  (setf xyb (term~read '(f x (f y b)) env))
  (setf xz (term~read '(f x z) env))
  (setf yuac (term~read '(f (f y u) (f a c)) env))
  (setf yy (term~read '(f y y) env))
  (setf zxv (term~read '(f z (f x v)) env))
;;; 14
  (setf xaa (term~read '(f (f x a) a) env))
  (setf xax (term~read '(f x (f x a)) env))
  (setf ybb (term~read '(f y (f b b)) env))	
  (setf aax (term~read '(f (f a a) x) env))
  (setf bby (term~read '(f (f b b) y) env))
  (setf yxb (term~read '(f (f y x) b) env))
  
  (setf tterm (term~read '(+ a b) env))

  (setf abx (term~read '(f (f a b) x) env))
  (setf cdy (term~read '(f c (f d y)) env))
  (setf xcdy (term~read '(f (f x c) (f d y)) env))

  (setf xa (term~read '(f x a) env))
;;;  (setf x  (term~read 'x env))
  (setf x1 (term~read 'x1 env))
  (setf x2 (term~read 'x2 env))
  (setf x3 (term~read 'x3 env))
  (setf x4 (term~read 'x4 env))
  (setf x1x1 (term~read '(f x1 x1) env))
  (setf x2x2 (term~read '(f x2 x2) env))
  (setf x3x3 (term~read '(f x3 x3) env))
  (setf x4x4 (term~read '(f x4 x4) env))
  (setf aab (term~read '(f (f a a) b) env))
  (setf bba (term~read '(f (f b b) a) env))
  (setf axbzx (term~read '(f (f a x) (f b (f z x))) env))
  (setf zczyyy (term~read '(f (f z (f c (f z y))) (f y y)) env)))

(defun a~theo-init (lhs rhs restr)
  (let*
      ((variables (fo~arguments (append lhs rhs)))
       (vars-as-consts (a~collect-consts variables nil))
       (theory (th~term-theory tterm)))
    (a~unify theory lhs rhs restr vars-as-consts)))
       
(defun a~collect-consts (list akku)
  (if (null list)
      akku
      (if (fo~constant-p (car list))
	  (a~collect-consts (cdr list) (cons (car list) akku))
	  (a~collect-consts (cdr list) akku))))

(defun a~collect-symbols 

(defun a~test (key)
  (a~univ-create)
  (case key
;;;   ((1) (cpa~theo-init
;;;	 (list (list x) (list y)) nil nil nil nil))
    ((1) (a~theo-init (list aab) (list bba) nil))
    ((2) (a~theo-init (list axbzx) (list zczyyy) nil))))
;;; (cpcb~decide-unify (list (term~read '(L (L a x) (L b (L z x))) cpcb*env))
;;;		      (list (term~read '(L (L z (L c (L z y))) (L y y)) cpcb*env)))














