
(in-package "KEIM")

(export '(a*env))

(setf a*env (env~create))

(post~read-object-list '((type-constants i)
			 (constants (a i) (b i) (c i) (d i)
				    (a0 i) (b0 i)
				    (a1 i) (b1 i)
				    (a_0 i) (a_A i) (a_B i) (a_1 i)
				    (f (i i)) (f1 (i i)) (f2 (i i))
			            (g (i i i)) (h (i i i)) (- (i i)))
			 (variables (x i) (y i) (z i) (u i) (v i) (w i)
				    (x1 i) (x2 i) (x3 i) (x4 i) (x5 i) (x6 i)
				    (y1 i) (y2 i) (y3 i) (y4 i) (y5 i) (y6 i) (y99 i)
			            (z1 i) (z2 i)
			            (v_0 i) (v_1 i) (v_2 i) (v_3 i))
			 (signatures (a (L (i i i)))
				     ))
		       a*env)

(defmacro unif==test (list1 list2 result)
  `(let ((arg1 ,list1)
	 (arg2 ,list2))
    (format t "~%~A: ~A ~A ~A   " (incf counter) arg1 arg2 ,result)
    (let ((res (cpcb~decide-unify arg1 arg2)))
      (cond ((eq (null ,result) (null res))
	     (format t "OK"))
	    (t (format t "*** result is ~A ***" res))))))

(setf counter 0)

(defun cpat~read (term &optional (env a*env))
  (term~read (cpat=word-to-term (first term) (rest term)) env))

(defun cpat=word-to-term (function word)
  (cond ((rest (rest word))
	 (list function (first word) (cpat=word-to-term function (rest word))))
	((rest word)
	 (cons function word))
	(t (error "KEIM (A): word ~A must have at least two symbols" word))))



(unif==test
  (list (term~read 'x a*env))
  (list (term~read '(L a (L b c)) a*env))
  t)

(unif==test
  (list (term~read '(L x y) a*env))
  (list (term~read '(L y x) a*env))
  t)

(unif==test
  (list (term~read '(L (L a x) (L b (L z x))) a*env))
  (list (term~read '(L (L (L z c) (L z y)) (L y y)) a*env))
  nil)

(unif==test
  (list (term~read '(L x (L a b)) a*env) (term~read 'x a*env))
  (list (term~read '(L (L x y) x) a*env) (term~read 'z a*env))
  t)

(unif==test
  (list (term~read '(L a (L a x)) a*env) (term~read '(L (L x a) x) a*env))
  (list (term~read '(L b (L b y)) a*env) (term~read '(L (L a x) b) a*env)) 
  nil)

(unif==test
  (list (term~read '(L a (L b x)) a*env))
  (list (term~read '(L (L x c) (L d y)) a*env))
  nil)

(unif==test
  (list (term~read '(L y (L x b)) a*env))
  (list (term~read '(L x (L a a)) a*env))
  nil)

(unif==test
  (list (term~read '(L (L b b) y) a*env) (term~read '(L x x) a*env))
  (list (term~read 'x a*env) (term~read '(L a (L x b)) a*env))
  nil)

(unif==test
  (list (term~read '(L (L b b) y) a*env) (term~read '(L x x) a*env))
  (list (term~read 'x a*env) (term~read '(L a (L b b)) a*env))
  nil)

(unif==test
 (list (term~read '(L (L b b) y) a*env) (term~read '(L x x) a*env))
 (list (term~read 'x a*env) (term~read '(L b (L b b)) a*env))
 nil)

(unif==test
  (list (term~read '(L x (L y z)) a*env))
  (list (term~read '(L (L x y) z) a*env))
  t)

(unif==test
  (list (term~read '(L (g x y) (L y z)) a*env))
  (list (term~read '(L (L (g x y) y) z) a*env))
  t)

(unif==test
  (list (term~read '(L (L a x) (L b (L z x))) a*env))
  (list (term~read '(L (L z (L c (L z y))) (L y y)) a*env))
  nil)

(unif==test
  (list (term~read '(L (L x x) (L (L a y) (L b y))) a*env))
  (list (term~read '(L (L c (L a (L y v))) (L (L a b) d)) a*env))
  nil)

(unif==test
 (list (term~read '(L a x) a*env)
       (term~read 'x a*env)
       (term~read 'x1 a*env)
       (term~read 'x2 a*env)
       (term~read 'x3 a*env)
       (term~read 'x4 a*env))
 (list (term~read '(L x a) a*env)
       (term~read '(L x1 x1) a*env)
       (term~read '(L x2 x2) a*env)
       (term~read '(L x3 x3) a*env)
       (term~read '(L x4 x4) a*env)
       (term~read '(L y y) a*env))
 t)

(unif==test
 (list (term~read '(L a x) a*env)
       (term~read 'x a*env)
       (term~read 'x1 a*env))
 (list (term~read '(L x a) a*env)
       (term~read '(L x1 x1) a*env)
       (term~read '(L x x) a*env))
 nil)

(unif==test
  (list (term~read '(L a (L a b)) a*env))
  (list (term~read '(L (L b b) b) a*env))
  nil)

(unif==test
  (list (term~read '(L a x) a*env))
  (list (term~read '(L x a) a*env))
  t)

(unif==test
  (list (term~read '(L a x) a*env))
  (list (term~read '(L x b) a*env))
  nil)

(unif==test
  (list (term~read '(L (L a x) x) a*env))
  (list (term~read '(L x (L x b)) a*env))
  nil)
