
(in-package "KEIM")

(export '(cpa*env))

(setf cpa*env (env~create))

(post~read-object-list '((type-constants i)
			 (constants (a i) (b i) (c i) (d i)
				    (a0 i) (b0 i)
				    (a1 i) (b1 i)
				    (a_0 i) (a_A i) (a_B i) (a_1 i)
				    (f (i i)) (f1 (i i)) (f2 (i i))
			            (g (i i i)) (h (i i i)) (- (i i)))
			 (variables (x i) (y i) (z i) (u i) (v i) (w i)
				    (x1 i) (x2 i) (x3 i) (x4 i) (x5 i) (x6 i)
				    (y1 i) (y2 i) (y3 i) (y4 i) (y5 i) (y6 i) (y99 i)
			            (z1 i) (z2 i)
			            (v_0 i) (v_1 i) (v_2 i) (v_3 i))
			 (signatures (aci (&& (i i i))) (aci (& (i i i))) (aci (! (i i i)))
				     (ac (++ (i i i))) (ac (+ (i i i)))
			             (ac (** (i i i))) (ac (* (i i i)))
			             (a (L (i i i))) (a (L3 (i i i)))
				     ))
		       cpa*env)

(defun cpat~read (term &optional (env cpa*env))
  (term~read (cpat=word-to-term (first term) (rest term)) env))

(defun cpat=word-to-term (function word)
  (cond ((rest (rest word))
	 (list function (first word) (cpat=word-to-term function (rest word))))
	((rest word)
	 (cons function word))
	(t (error "KEIM (A): word ~A must have at least two symbols" word))))

(setf t1 (term~read '(g (* (+ x a) (* b y)) (f (& (* y (f y)) (& a b))))
		    cpa*env))

(setf t2 (term~read '(g a b)
		    cpa*env))

(setf t3 (term~read '(* a) 
		    cpa*env))

(setf x (term~read 'x
		    cpa*env))
(setf y (term~read 'y
		    cpa*env))

(setf a (term~read 'a
		    cpa*env))
(setf b (term~read 'b
		    cpa*env))
(setf c (term~read 'c
		    cpa*env))

(setf tl1 (list (term~read '(g u v) cpa*env)
		(term~read '(& (f x) (& y2 (f a))) cpa*env)
		(term~read '(& x1 (! x2 x3)) cpa*env)
		(term~read '(* x1 (+ x2 x3)) cpa*env)
		))

(setf tl2 (list (term~read '(g x (f z)) cpa*env)
		(term~read '(& (& y1 y2) y3) cpa*env)
		(term~read '(& (! x1 x2) (! x1 x3)) cpa*env)
		(term~read '(& (* x1 x2) (+ x1 x3)) cpa*env)
		))




;;; My own examples for a-unif
(format t "Beispiel1 ~% ++++++++++  ~% ~%")
(cpcb~decide-unify (list (term~read '(x) cpa*env))
		   (list (term~read '(L a (L b c)) cpa*env)))
;;; t


(format t "Beispiel2 ~% ++++++++++  ~% ~%")
(cpcb~decide-unify (list (term~read '(L x y) cpa*env))
		   (list (term~read '(L y x) cpa*env)))
;;; t


(format t "Beispiel3 ~% ++++++++++  ~% ~%")
(cpcb~decide-unify (list (term~read '(L (+ x y) (* x1 x2)) cpa*env))
		   (list (term~read '(x2) cpa*env)))
;;; nil


(format t "Beispiel4 ~% ++++++++++  ~% ~%")
(cpcb~decide-unify (list (term~read '(L (L a x) (L b (L z x))) cpa*env))
		   (list (term~read '(L (L (L z c) (L z y)) (L y y)) cpa*env)))
;;; nil

(format t "Beispiel5 ~% ++++++++++  ~% ~%")
(cpcb~decide-unify (list (term~read '(+ (L a (L x y)) z) cpa*env))
		   (list (term~read '(L (L a b) (L x y)) cpa*env)))
;;; nil


(format t "Beispiel6 ~% ++++++++++  ~% ~%")
(cpcb~decide-unify (list (term~read '(L x (L a b)) cpa*env) (term~read '(x) cpa*env))
		   (list (term~read '(L (L x y) x) cpa*env) (term~read '(z) cpa*env)))

;;; t


(format t "Beispiel7 ~% ++++++++++  ~% ~%")
(cpcb~decide-unify (list (term~read '(L a (L a x)) cpa*env) (term~read '(L (L x a) x) cpa*env))
		   (list (term~read '(L b (L b y)) cpa*env) (term~read '(L (L a x) b) cpa*env))) 

(format t "Beispiel8 ~% ++++++++++  ~% ~%");;; nil
(cpcb~decide-unify (list (term~read '(L a (L b x)) cpa*env))
		   (list (term~read '(L (L x c) (L d y)) cpa*env)))
;;; nil

(format t "Beispiel9 ~% ++++++++++  ~% ~%")
(cpcb~decide-unify (list (term~read '(L y (L x b)) cpa*env))
		   (list (term~read '(L x (L a a)) cpa*env)))
;;; nil

(format t "Beispiel10 ~% ++++++++++  ~% ~%")
(cpcb~decide-unify (list (term~read '(L (L b b) y) cpa*env) (term~read '(L x x) cpa*env))
		   (list (term~read '(x) cpa*env) (term~read '(L a (L x b)) cpa*env)))
;;; nil

(format t "Beispiel11 ~% ++++++++++  ~% ~%")
(cpcb~decide-unify (list (term~read '(L (L b b) y) cpa*env) (term~read '(L x x) cpa*env))
		   (list (term~read '(x) cpa*env) (term~read '(L a (L b b)) cpa*env)))
;;; nil

(format t "Beispiel12 ~% ++++++++++  ~% ~%")
(cpcb~decide-unify (list (term~read '(L (L b b) y) cpa*env) (term~read '(L x x) cpa*env))
		   (list (term~read '(x) cpa*env) (term~read '(L b (L b b)) cpa*env)))
(format t "Beispiel13 ~% ++++++++++  ~% ~%")
(cpcb~decide-unify (list (term~read '(L x (L y z)) cpa*env))
		   (list (term~read '(L (L x y) z) cpa*env)))
;;; t

(format t "Beispiel14 ~% ++++++++++  ~% ~%")
(cpcb~decide-unify (list (term~read '(L (g x y) (L y z)) cpa*env))
		      (list (term~read '(L (L (g x y) y) z) cpa*env)))
;;; t

(format t "Beispiel15 ~% ++++++++++  ~% ~%")
(cpcb~decide-unify (list (term~read '(L (L a x) (L b (L z x))) cpa*env))
		   (list (term~read '(L (L z (L c (L z y))) (L y y)) cpa*env)))
;;; nil, aber: x = cabaca, y = baca, z = a


#|
(a~decide-unify *cpa-th*
                (list terml)       ;;; lhs 
		(list termr)       ;;; rhs
                nil                ;;; restriction
		(list a b c)) ;;; vars as consts
|#	       

(format t "Beispiel16 ~% ++++++++++  ~% ~%")
(cpcb~decide-unify (list (term~read '(L (L x x) (L (L a y) (L b y))) cpa*env))
		   (list (term~read '(L (L c (L a (L y v))) (L (L a b) d)) cpa*env)))
;;; nil, aber: xxayby =?= cayvabd

(format t "Beispiel17 ~% ++++++++++  ~% ~%")
(cpcb~decide-unify (list (term~read '(L a x) cpa*env)
			 (term~read 'x cpa*env)
			 (term~read 'x1 cpa*env)
			 (term~read 'x2 cpa*env)
			 (term~read 'x3 cpa*env)
			 (term~read 'x4 cpa*env))
		   (list (term~read '(L x a) cpa*env)
			 (term~read '(L x1 x1) cpa*env)
			 (term~read '(L x x) cpa*env)
			 (term~read '(L x3 x3) cpa*env)
			 (term~read '(L x4 x4) cpa*env)
			 (term~read '(L y y) cpa*env)))
;;; t

(format t "Beispiel18 ~% ++++++++++  ~% ~%")
(cpcb~decide-unify (list (term~read '(L a x) cpa*env)
			 (term~read 'x cpa*env)
			 (term~read 'x1 cpa*env))
		   (list (term~read '(L x a) cpa*env)
			 (term~read '(L x1 x1) cpa*env)
			 (term~read '(L x x) cpa*env)))
;;; t

(format t "Beispiel19 ~% ++++++++++  ~% ~%")
(cpcb~decide-unify (list (term~read '(+ (L x1 (L x2 x3)) (L x1 (L x2 x3))) cpa*env))
		   (list (term~read '(+ (L (L x1 x2) x3) (L (L x1 x2) x3)) cpa*env)))
;;; t

(format t "Beispiel20 ~% ++++++++++  ~% ~%")
(cpcb~decide-unify (list (term~read '(L a (L a b)) cpa*env))
		   (list (term~read '(L (L b b) b) cpa*env)))
;;; nil

(format t "Beispiel21 ~% ++++++++++  ~% ~%")
(cpcb~decide-unify (list (term~read '(L a x) cpa*env))
		   (list (term~read '(L x a) cpa*env)))
;;; t

(format t "Beispie22 ~% ++++++++++  ~% ~%")
(cpcb~decide-unify (list (term~read '(& (+ (L a x) (L x b)) (L x y)) cpa*env))
		   (list (term~read '(& (L x y) (+ (L a b) (L x x))) cpa*env)))
;;; t

(format t "Beispiel23 ~% ++++++++++  ~% ~%")
(cpcb~decide-unify (list (term~read '(L a x) cpa*env))
		   (list (term~read '(L x b) cpa*env)))
;;; nil

(format t "Beispiel24 ~% ++++++++++  ~% ~%")
(cpcb~decide-unify (list (term~read '(L (L a x) x) cpa*env))
		   (list (term~read '(L x (L x b)) cpa*env)))
;;; nil

(format t "Beispiel25 ~% ++++++++++  ~% ~%")
(cpcb~decide-unify (list (term~read '(+ (L a x) (L a x)) cpa*env))
		   (list (term~read '(+ (L x a) (L x a)) cpa*env)))
;;; t

(format t "Beispiel26 ~% ++++++++++  ~% ~%")
(cpcb~decide-unify (list (term~read '(+ x1 x2) cpa*env))
		   (list (term~read '(+ x3 x4) cpa*env)))
;;; t

#|
(format t "Beispiel27 ~% ++++++++++  ~% ~%")
(cpcb~decide-unify (list (term~read '(L (h x) y) cpa*env))
		   (list (term~read '(L y (h (L z1 z2))) cpa*env)))
;;; L (h ...) kann nicht ausgewertet werden
|#

(format t "Beispiel28 ~% ++++++++++  ~% ~%")
(cpcb~decide-unify (list (term~read '(L (+ x y) a) cpa*env))
		   (list (term~read '(L x (+ y a)) cpa*env)))
;;; nil

(format t "Beispiel29 ~% ++++++++++  ~% ~%")
(cpcb~decide-unify (list (term~read '(+ (L (L x y) z) a) cpa*env))
		   (list (term~read '(+ (L x (L y z)) a) cpa*env)))
;;; t

(format t "Beispiel30 ~% ++++++++++  ~% ~%")
(cpcb~decide-unify (list (term~read '(+ (L (L x y) z) b) cpa*env))
		   (list (term~read '(+ (L x (L y z)) a) cpa*env)))
;;; nil

(format t "Beispiel31 ~% ++++++++++  ~% ~%")
(cpcb~decide-unify (list (term~read '(+ (L (L x y) z) (+ x y)) cpa*env))
		   (list (term~read '(+ (L x (L y z)) (+ y x)) cpa*env)))
;;; t





#| Joern's examples

(cpcb~decide-unify (list (cpat~read '(L a x b z x)))
		   (list (cpat~read '(L z c z y y y))))

axbzx =?= zczyyy
    x = cabaca, y = baca, z = a

acabacabzcabaca =?=
zczbacabacabaca

|#
