(in-package "KEIM")

(setf ac*env (env~create))

(post~read-object-list '((type-constants i)
			 (constants (a i) (b i)
				    (a0 i) (b0 i)
				    (a1 i) (b1 i)
				    (l (i i)))
			 (variables (x i) (y i) (z i) (u i) (v i) (w i)
				    (x1 i) (x2 i) (x3 i)
				    (y1 i) (y2 i) (y3 i)
				    (z1 i) (z2 i) (z3 i))
			 (signatures (ac (+ (i i i))) (ac (* (i i i)))))
		       ac*env)

(defun ac==read (term)
  (term~copy (term~read term ac*env)))

(defun ac==unif (tl1 tl2 cr vc &optional (val nil s))
  (let* ((termlist1 (mapcar #'ac==read tl1))
	 (termlist2 (mapcar #'ac==read tl2))
	 (const-restr (mapcar (function (lambda (l)
				  (mapcar #'ac==read l)))
			      cr))
	 (var-const (mapcar #'ac==read vc))
	 (result (ac~unify termlist1 termlist2 const-restr var-const))
	 (result2 nil);((evac~lpsolve termlist1 termlist2 const-restr var-const))
	 )
    (when s
      (format t "~%~A: ~A ~A ~A ~A   " (incf counter) tl1 tl2 cr vc)
      (cond ((eq (null result) (null val))
	     (format t "OK  "))
	    (t
	     (format t "*** must be ~A ***  " val)))
      (cond ((eq (null result2) (null val))
	     (format t "OK"))
	    (t
	     (format t "*** must be ~A ***" val))))
    (values result result2)))

(defmacro ac==unify (tl1 tl2 cr vc &optional (val nil s))
  (if s
      `(ac==unif ',tl1 ',tl2 ',cr ',vc ',val)
    `(ac==unif ',tl1 ',tl2 ',cr ',vc)))


(setf counter 0)


(ac==unify ((+ x y))
	   ((+ x y))
	   nil nil t)

(ac==unify ((+ x y))
	   ((+ x y))
	   nil nil t)

(ac==unify ((+ x y))
	   ((+ x y))
	   nil (x y) t)

(ac==unify ((+ x y))
	   ((+ x (+ z z)))
	   ((x)) (x) t)

(ac==unify ((+ x y))
	   ((+ u (+ z z)))
	   ((x)) (u x) t)

(ac==unify ((+ x y))
	   ((+ u (+ z z)))
	   ((u y))
	   (u x) nil)

(ac==unify ((+ a y))
	   ((+ b (+ z z)))
	   nil nil t)

(ac==unify ((+ x y))
	   ((+ u v))
	   nil (x) t)

(ac==unify ((+ x y))
	   ((+ u v))
	   nil nil t)

(ac==unify ((+ x y))
	   ((+ u v))
	   ((x v))
	   (x) t)

(ac==unify ((+ x (+ x (+ x y))))
	   ((+ (+ u u) (+ v v)))
	   () () t)


(ac==unify ((+ x (+ x x)))
	   ((+ u (+ v w)))
	   () () t)

;(ac~unify (X38) ((G W X1)) ((X38)) (X38))

(ac==unify (x)
	   ((+ v w))
	   () (x) t)

(ac==unify ((+ x (+ x (+ x y))) (+ x1 (+ x1 (+ x1 y))) (+ x2 (+ y2 u)))
	   ((+ (+ u u) (+ v v)) (+ x2 (+ x3 x3)) (+ y1 (+ y2 y3)))
	   () () t)

(ac==unify ((+ x (+ x (+ x y))) (+ x1 (+ x1 (+ x1 y))) (+ x2 (+ x2 (+ x2 u))))
	   ((+ (+ u u) (+ v v)) (+ x2 (+ x3 x3)) (+ y1 (+ y2 y3)))
	   () () t)


