(in-package "KEIM")

(export '(ac*env))

(setf ac*env (env~create))

(post~read-object-list '((type-constants i)
			 (constants (a i) (b i) (c i) (d i)
				    (a0 i) (b0 i)
				    (a1 i) (b1 i)
				    (a_0 i) (a_A i) (a_B i) (a_1 i)
				    (f (i i)) (f1 (i i)) (f2 (i i))
			            (g (i i i)) (h (i i i)) (- (i i)))
			 (variables (x i) (y i) (z i) (u i) (v i) (w i)
				    (x1 i) (x2 i) (x3 i) (x4 i) (x5 i) (x6 i)
				    (y1 i) (y2 i) (y3 i) (y4 i) (y5 i) (y6 i) (y99 i)
				    (v_0 i) (v_1 i) (v_2 i) (v_3 i))
			 (signatures (ac (++ (i i i))) (ac (+ (i i i)))
			             (ac (** (i i i))) (ac (* (i i i)))
				     ))
		       ac*env)


(defmacro unif==test (list1 list2 result)
  `(let ((arg1 ,list1)
	 (arg2 ,list2))
    (format t "~%~A: ~A ~A ~A   " (incf counter) arg1 arg2 ,result)
    (let ((res (cpcb~decide-unify arg1 arg2)))
      (cond ((eq (null ,result) (null res))
	     (format t "OK"))
	    (t (format t "*** result is ~A ***" res))))))

(setf counter 0)



(unif==test (list (term~read '(+ x x) ac*env))
	    (list (term~read '(+ y y) ac*env))
	    t)

(unif==test (list (term~read '(+ a x) ac*env))
	    (list (term~read '(+ a y) ac*env))
	    t)

(unif==test (list (term~read '(+ x (f x)) ac*env))
	    (list (term~read '(+ y (f y)) ac*env))
	    t)

(unif==test (list (term~read '(+ x x) ac*env))
	    (list (term~read '(+ (f y) (f z)) ac*env))
	    t)

(unif==test (list (term~read '(+ x x) ac*env))
	    (list (term~read '(+ a b) ac*env))
	    nil)

(unif==test (list (term~read '(g y x) ac*env))
	    (list (term~read '(g a (+ y (+ (f y) (g y y)))) ac*env))
	    t)

(unif==test (list (term~read '(f x) ac*env))
	    (list (term~read '(f (+ b (+ a a))) ac*env))
	    t)

(unif==test (list (term~read '(f (+ x1 x2)) ac*env))
	    (list (term~read '(f (+ y1 y2)) ac*env))
	    t)

(unif==test (list (term~read '(+ x1 x2) ac*env))
	    (list (term~read '(+ (+ y1 y2) (f y1)) ac*env))
	    t)

(unif==test (list (term~read '(g x v) ac*env)
		  (term~read '(+ x (+ (f u) (- u))) ac*env))
	    (list (term~read '(g x v) ac*env)
		  (term~read '(+ u v) ac*env))
	    t)

(unif==test (list (term~read '(+  (* a x1) (* a x2)) ac*env)
		  (term~read '(++ (** a y1) (** a y2)) ac*env))
	    (list (term~read '(+  (* c d) (* c x)) ac*env)
		  (term~read '(++ (** c d) (** c x)) ac*env))
	    nil)

(unif==test (list (term~read '(+  (* a b) (* a b)) ac*env)
		  (term~read '(++ (** a b) (** a b)) ac*env))
	    (list (term~read '(+  (* c d) (* c x)) ac*env)
		  (term~read '(++ (** c d) (** c x)) ac*env))
	    nil)

(unif==test (list (term~read '(f (* x x)) ac*env)
		  (term~read '(+ a (++ u u)) ac*env))
	    (list (term~read '(f (* a y)) ac*env)
		  (term~read '(+ a (++ a v)) ac*env))
	    t)

(unif==test (list (term~read '(g u v) ac*env)
		  (term~read '(+ x (+ (f u) (- u))) ac*env))
	    (list (term~read '(g z w) ac*env)
		  (term~read '(+ u v) ac*env))
	    t)

(unif==test (list (term~read '(+ x a) ac*env))
	    (list (term~read '(+ (+ y1 y2) (f y1)) ac*env))
	    t)

(unif==test (list (term~read '(+ x1 a) ac*env))
	    (list (term~read '(+ (+ y1 y2) (f (+ y2 y3))) ac*env))
	    t)

(unif==test (list (term~read '(+ (g X1 X2) (g (f X1) X2)) ac*env))
	    (list (term~read '(+ (g y1 y2) (g (f y1) y2)) ac*env))
	    t)

(unif==test (list (term~read '(+ x1 a) ac*env))
	    (list (term~read '(+ (+ y3 (g y1 y2)) (g (f y1) y2)) ac*env))
	    t)


(unif==test (list (term~read '(* (* x1 x2) (+ x3 x4)) ac*env))
	    (list (term~read '(* y1 (f y1)) ac*env))
	    t)

(unif==test (list (term~read '(* (+ x1 x2) (+ x1 (f x2))) ac*env))
	    (list (term~read '(* (+ y1 y2) (+ y1 (f y2))) ac*env))
	    t)

(unif==test (list (term~read '(* (* x3 (g x1 x2)) (g x1 (f x2))) ac*env))
	    (list (term~read '(* (g x1 x2) (g x1 (f x2))) ac*env))
	    nil)

(unif==test (list (term~read '(+ a x) ac*env))
	    (list (term~read '(+ (+ (* y1 y2) y3) (* y1 (f y2))) ac*env))
	    t)

(unif==test (list (term~read 'x1 ac*env)
		  (term~read 'x2 ac*env)
		  (term~read '(+ (+ (f b) x1) x1) ac*env))
	    (list (term~read '(* (* a a) b) ac*env)
		  (term~read '(* (* a a) b) ac*env)
		  (term~read '(+ (+ (f b) x2) x2) ac*env))
	    t)


;; negative examples:

(unif==test (list (term~read '(f a) ac*env))
	    (list (term~read '(f (+ x y)) ac*env))
	    nil)

(unif==test (list (term~read '(+ x (f x)) ac*env))
	    (list (term~read '(+ y y) ac*env))
	    nil)

(unif==test (list (term~read '(+ x (f x)) ac*env))
	    (list (term~read '(+ y (+ y y)) ac*env))
	    nil)

(unif==test (list (term~read '(+ x (f x)) ac*env))
	    (list (term~read '(+ (+ (f a) y) y) ac*env))
	    nil)

(unif==test (list (term~read '(+ x (f x)) ac*env))
	    (list (term~read '(+ y (f (+ y z))) ac*env))
	    nil)

(unif==test (list (term~read '(+ (+ x x) a) ac*env))
	    (list (term~read '(+ (+ y y) (+ z z)) ac*env))
	    nil)

(unif==test (list (term~read '(+ x1 (+ (f1 x2) (f x3))) ac*env))
	    (list(term~read '(+ y1 (+ (f2 x1) (f y3))) ac*env))
	    nil)

(unif==test (list (term~read '(+ (+ x b) (+ a a)) ac*env))
	    (list (term~read '(+ b (+ a a)) ac*env))
	    nil)

(unif==test (list (term~read 'x ac*env)
		  (term~read '(+ a1 x1) ac*env))
	    (list (term~read '(* (* a a) b) ac*env)
		  (term~read '(+ (+ (f b) x) x) ac*env))
	    nil)

(unif==test (list (term~read '(* x y) ac*env)
		  (term~read '(+ x (+ y z)) ac*env))
	    (list (term~read '(* u v) ac*env)
		  (term~read '(+ u v) ac*env))
	    nil)

(unif==test (list (term~read '(+ z (+ (* x1 x2) (* x1 (f x2)))) ac*env))
	    (list (term~read '(+ (* y1 y2) (* y1 (f y2))) ac*env))
	    nil)

(unif==test (list (term~read '(+ (+ x3 (* x1 x2)) (* x1 (f x2))) ac*env))
	    (list (term~read '(+ (* y1 y2) (* y1 (f y2))) ac*env))
	    nil)

(unif==test (list (term~read 'x1 ac*env)
		  (term~read 'x2 ac*env)
		  (term~read '(+ y1 (+ x1 x1)) ac*env))
	    (list (term~read '(* (* a a) b) ac*env)
		  (term~read '(* a a) ac*env)
		  (term~read '(+ (+ x2 x2) (+ y2 (f (* b b)))) ac*env))
	    t)

