(setf env (env~create))
(post~read-object-list '((type-constants i)
			 (constants (a i) (b i)
				    (a0 i) (b0 i)
				    (a1 i) (b1 i)
				    (l (i i)))
			 (variables (x i) (y i) (z i) (u i) (v i) (w i)
				    (x1 i) (x2 i) (x3 i))
			 (signatures (aci (f (i i i))) (aci (h (i i)))
				     (ac (+ (i i i))) (ac (* (i i i)))
			             (ac (g (i i i)))))
		       env)

#| (setf eqs (list (list (term~read '(g x y) env)
		      (term~read '(g (k y z) w) env))))
 |#

(evac~lpsolve (list (term~read 'x env))
	      (list (term~read '(g w b) env))
	      (list (list (term~read 'x env)))
	      (list (term~read 'x env)
		    (term~read 'b env)))

(evac~lpsolve (list (term~read '(+ (+ x x) v) env))
	      (list (term~read '(+ (+ (+ y y) z) z) env))
	      (list (list (term~read 'v env)))
	      (list (term~read 'v env)))

(evac~lpsolve (list (term~read '(+ x v) env))
	      (list (term~read '(+ y z) env))
	      (list (list (term~read 'v env)))
	      (list (term~read 'x env) (term~read 'y env) (term~read 'z env) (term~read 'v env)))

(evac~lpsolve (list (term~read '(+ x x) env))
	      (list (term~read '(+ y (+ z z)) env))
	      (list (list (term~read 'y env)))
	      (list (term~read 'y env)))

(evac~lpsolve (list (term~read '(+ x y) env))
	      (list (term~read '(+ y x) env))
	      (list (list (term~read 'y env) (term~read 'x env)))
	      (list (term~read 'y env)))

(evac~lpsolve (list (term~read '(+ x y) env))
	      (list (term~read '(+ y x) env))
	      (list)
	      (list (term~read 'y env) (term~read 'x env)))

#|
(defun evac~lpsolve (tl1 tl2 &optional (crestr NIL) (var_as_const NIL))
  (declare (edited  "21-APR-1995")
	   (authors Neskakis)
	   (input   "2 lists of terms, optional list of restricted constants")
	   (effect  "calls lpsolve")
	   (value   "returns a substitution if the unification-problem is solvable, else NIL"))
  (let ((lp-solve (run-program "/usr/local/keim/bin/lp_solve"
			       :input :stream
			       :output :stream
			       :error-output :output
			       :wait nil))
	(lines nil) (var nil) (const nil))
    (unwind-protect
	(progn
	  (unwind-protect
	      (multiple-value-setq (var const) (evac~baueingabe tl1 tl2 crestr var_as_const t)) ;((lp-solve))
	    (evac~baueingabe tl1 tl2 crestr var_as_const lp-solve)
	    (close (underlying-stream lp-solve :output)))
	   (do ((line (read-line lp-solve nil lp-solve) (read-line lp-solve nil lp-solve)))
	       ((eq line lp-solve) (setf lines (nreverse lines)))
	       (push line lines))
           (evac~eval lines var const (ac=give-fsym tl1 tl2)))
      (close (underlying-stream lp-solve :input)))))

(defun evac~lpsolve (tl1 tl2 &optional (crestr NIL) (var_as_const NIL))
  (declare (edited  "21-APR-1995")
	   (authors Neskakis)
	   (input   "2 lists of terms, optional list of restricted constants")
	   (effect  "calls lpsolve")
	   (value   "returns a substitution if the unification-problem is solvable, else NIL"))
  (let ((lp-solve (run-program "/usr/local/keim/bin/lp_solve"
			       :input :stream
			       :output :stream
			       :error-output :output
			       :wait nil))
	(lines nil) (var nil) (const nil))
    (unwind-protect
	(progn
	  (unwind-protect
	      (progn (multiple-value-setq (var const)
		        (evac~baueingabe tl1 tl2 crestr var_as_const t))
		     (evac~baueingabe tl1 tl2 crestr var_as_const lp-solve))
	    (close (underlying-stream lp-solve :output)))
	  (if (and (null var) (null const))  ; evac~baueingabe detected that 
	      nil                            ; the problem is unsolvable
	    (progn
	      (do ((line (read-line lp-solve nil lp-solve)
			 (read-line lp-solve nil lp-solve)))
		  ((eq line lp-solve) (setf lines (nreverse lines)))
		  (push line lines)
		  (print line))
	      (evac~eval lines var const (ac=give-fsym tl1 tl2)))))
      (close (underlying-stream lp-solve :input)))))


(defun evac~eval (lines varliste constliste fsym)
  (if (endp lines)
      (error " KEIM(evac) : Unknown output of lp-solve ")
      (if (or (string-equal "(M)ILP problem has no solution, problem is infeasible" (car lines))
	      (search "contradicts earlier bounds, exiting" (car lines))
	      (search "variables must always be non-negative" (car lines)))
	  NIL
	  (if (string-equal "Value of objective function:" (car lines) :end2 (min 28 (length (car lines))))
	      (unwind-protect
		  (evac~buildsub (cddr lines) varliste constliste fsym)
		(ac~labels-reset! varliste))
	      (evac~eval (cdr lines) varliste constliste fsym)))))

(defun evac=baugleichung (vec varstelle varwert stream)
  (do ((i (1- (length vec)) (1- i)))
      ((< i 0) (format stream " = ~A;~%" varwert))
      (let*  ((wert    (elt vec i))
	      (zeichen (evac=plus-minus wert))
	      (abswert (abs wert)))
	(case abswert
	      (0 (format stream " ~A ~A x_~A_~A" zeichen abswert i varstelle)) 
	      (1 (format stream " ~A x_~A_~A" zeichen i varstelle))
	      (t (format stream " ~A ~A x_~A_~A" zeichen abswert i varstelle))))))
|#
