(in-package "KEIM")

(setf abel*env (env~create))

(post~read-object-list '((type-constants i)
			 (constants (a i) (b i) (a0 i) (b0 i) (a1 i) (b1 i)
			            (a_q i) (a_k i) (a_l i) (a_e i) (a_f i)
			            (a_A i) (a_B i) (a_0 i) (a_1 i)
			            (inv (i i)) (n (i i)) (p (i i))
			            (s (i i i)) (dot (i i i)))
			 (variables (x i) (y i) (z i) (u i) (v i) (w i)
				    (x1 i) (x2 i) (x3 i) (x4 i) (x5 i) (x6 i)
				    (y1 i) (y2 i) (y3 i) (y4 i) (y5 i) (y6 i)
				    (v_0 i) (v_1 i) (v_2 i) (v_3 i))
			 (signatures (aci (+ (i i i))) (aci (* (i i i)))))
		       abel*env)

(defun cb==test (&rest args)
  (let* ((stream *standard-output*)
	 ;(*standard-output* my-stream)
	 )
    (format stream "~%~A: ~A   " (incf counter) args)
    (let ((result
	   (do* ((arg-tail args (rest (rest arg-tail)))
		 (term1 (term~copy (term~read (first arg-tail) abel*env))
			(term~copy (term~read (first arg-tail) abel*env)))
		 (term2 (term~copy (term~read (second arg-tail) abel*env))
			(term~copy (term~read (second arg-tail) abel*env)))
		 (tl1 (list term1) (cons term1 tl1))
		 (tl2 (list term2) (cons term2 tl2)))
		((null (rest (rest (rest arg-tail))))
		 (#+weg mcb~decide-unify cpcb~decide-unify #+weg cb~decide-unify
				   tl1 tl2
				   ;(mapcar #'list tl1 tl2)
				   ))))
	  (wwert (first (last args))))
      (declare (special *standard-output*))
      ;(get-output-stream-string my-stream)
      (cond ((eq (null result) (null wwert))
	     (format stream "OK"))
	    (t (format stream "*** must be ~A ***" wwert))))))

(setf counter 0)
(setf my-stream (make-string-output-stream))

(time (progn
(cb==test  (QUOTE (+ a_0 x1)) (QUOTE  (+ a_0 y1))  T ) 
(cb==test  (QUOTE (+ a_0 x1)) (QUOTE  (+ y1 (inv y1)))  T ) 
(cb==test  (QUOTE (+ a_0 x1)) (QUOTE  (+ (+ y1 y2) (inv y1)))  T ) 
(cb==test  (QUOTE (+ x1 (inv x1))) (QUOTE  (+ y1 (inv y1)))  T ) 
(cb==test  (QUOTE (+ (+ x1 x2) (inv x1))) (QUOTE  (+ y1 (inv y1)))  T ) 
(cb==test  (QUOTE (+ x1 (inv x1))) (QUOTE  (+ (+ y1 y2) (inv y1)))  T ) 
(cb==test  (QUOTE (+ (+ x1 x2) (inv x1))) (QUOTE  (+ (+ y1 y2) (inv y1)))  T ) 
(cb==test  (QUOTE (+ x1 (inv x1))) (QUOTE  (+ a_0 y1))  T ) 
(cb==test  (QUOTE (+ (+ x1 x2) (inv x1))) (QUOTE  (+ a_0 y1))  T ) 
(cb==test  (QUOTE (+ a_0 x1)) (QUOTE  (+ y2 (inv (+ y1 y2))))  T ) 
(cb==test  (QUOTE (+ a_0 x1)) (QUOTE  (+ (+ y2 y3) (inv (+ y1 y2))))  T ) 
(cb==test  (QUOTE (+ x1 (inv x1))) (QUOTE  (+ y2 (inv (+ y1 y2))))  NIL ) 
(cb==test  (QUOTE (+ (+ x1 x2) (inv x1))) (QUOTE  (+ y2 (inv (+ y1 y2))))  T ) 
(cb==test  (QUOTE (+ x1 (inv x1))) (QUOTE  (+ (+ y2 y3) (inv (+ y1 y2))))  T ) 
(cb==test  (QUOTE (+ (+ x1 x2) (inv x1))) (QUOTE  (+ (+ y2 y3) (inv (+ y1 y2))))  T ) 
(cb==test  (QUOTE (+ x2 (inv (+ x1 x2)))) (QUOTE  (+ y2 (inv (+ y1 y2))))  T ) 
(cb==test  (QUOTE (+ x1 x2)) (QUOTE  (+ y2 (inv (+ y1 y2))))  T ) 
(cb==test  (QUOTE (+ (+ x2 x3) (inv (+ x1 x2)))) (QUOTE  (+ y2 (inv (+ y1 y2))))  T ) 
(cb==test  (QUOTE (+ x2 (inv (+ x1 x2)))) (QUOTE  (+ (+ y2 y3) (inv (+ y1 y2))))  T ) 
(cb==test  (QUOTE (+ x1 x2)) (QUOTE  (+ (+ y2 y3) (inv (+ y1 y2))))  T ) 
(cb==test  (QUOTE (+ (+ x2 x3) (inv (+ x1 x2)))) (QUOTE  (+ (+ y2 y3) (inv (+ y1 y2))))  T ) 
(cb==test  (QUOTE (inv x1)) (QUOTE  (inv (+ y1 y2)))  T ) 
(cb==test  (QUOTE (inv a_0)) (QUOTE  (inv (+ y1 y2)))  NIL ) 
(cb==test  (QUOTE (inv (inv x1))) (QUOTE  (inv (+ y1 y2)))  NIL ) 
(cb==test  (QUOTE (inv x1)) (QUOTE  (inv (+ y1 y2)))  T ) 
(cb==test  (QUOTE (inv (+ x1 x2))) (QUOTE  (inv (+ y1 y2)))  T ) 
(cb==test  (QUOTE (+ x1 x2)) (QUOTE  (+ a_0 y1))  T ) 
(cb==test  (QUOTE (+ x1 x2)) (QUOTE  (+ y1 (inv y1)))  T ) 
(cb==test  (QUOTE (+ x1 x2)) (QUOTE  (+ (+ y1 y2) (inv y1)))  T )
))
