(in-package "KEIM")

(export '(aci*env))

(setf aci*env (env~create))

(post~read-object-list '((type-constants i)
			 (constants (a i) (b i) (c i) (d i)
				    (a0 i) (b0 i)
				    (a1 i) (b1 i)
				    (a_0 i) (a_A i) (a_B i) (a_1 i)
				    (f (i i)) (f1 (i i)) (f2 (i i))
			            (g (i i i)) (h (i i i)) (- (i i)))
			 (variables (x i) (y i) (z i) (u i) (v i) (w i)
				    (x1 i) (x2 i) (x3 i) (x4 i) (x5 i) (x6 i)
				    (y1 i) (y2 i) (y3 i) (y4 i) (y5 i) (y6 i) (y99 i)
				    (v_0 i) (v_1 i) (v_2 i) (v_3 i))
			 (signatures (aci (&& (i i i))) (aci (& (i i i))) (aci (! (i i i)))
				     ))
		       aci*env)


(defmacro unif==test (list1 list2 result)
  `(let ((arg1 ,list1)
	 (arg2 ,list2))
    (format t "~%~A: ~A ~A ~A   " (incf counter) arg1 arg2 ,result)
    (let ((res (cpcb~decide-unify arg1 arg2)))
      (cond ((eq (null ,result) (null res))
	     (format t "OK"))
	    (t (format t "*** result is ~A ***" res))))))

(setf counter 0)



(unif==test (list (term~read '(& x y) aci*env))
	    (list (term~read '(& z (f y)) aci*env))
	    t)

(unif==test (list (term~read '(& y a) aci*env))
	    (list (term~read '(! x b) aci*env))
	    nil)

(unif==test (list (term~read '(! (! (& x1 x2) (& x1 x3)) (& x1 (f (! x2 x3)))) aci*env)
		  (term~read '(& a_1 x1) aci*env))
	    (list (term~read '(! (f (& y1 y2)) (f (& y3 (f y2)))) aci*env)
		  (term~read '(f a_0) aci*env))
	    nil)

(unif==test (list (term~read '(! x1 (f x1)) aci*env))
	    (list (term~read '(! (& y1 y2) (& y1 (f y2))) aci*env))
	    nil)

(unif==test (list (term~read '(g u v) aci*env)
		  (term~read '(& (f x) (f a)) aci*env))
	    (list (term~read '(g x (f z)) aci*env)
		  (term~read '(& y a) aci*env))
	    nil)

(unif==test (list (term~read 'x1 aci*env)
		  (term~read '(& (! x1 x1) (! x1 x2)) aci*env))
	    (list (term~read '(& (f y1) (f y2)) aci*env)
		  (term~read '(f (! y1 y2)) aci*env))
	    t)

