;(in-package "CLIM-USER")
(in-package "KEIM")


(export '(bool*env))

(setf bool*env (env~create))

(post~read-object-list '((type-constants i)
			 (constants (f1 (i i))
			            (a i) (b i) (c i) (d i)
			            (a1 i) (a2 i) (a3 i)
			            (b1 i) (b2 i) (b3 i)
			            (null i) (eins i)
				    (+ (i i i)) (* (i i i)))
			 (variables (x i) (y i) (z i)
			            (x-1 i) (x-2 i) (x-3 i) (x-4 i) (x-5 i)
			            (y-1 i) (y-2 i) (y-3 i)
			            (z-1 i) (z-2 i) (z-3 i)
			            (u i) (v i) (w i))
			 (signatures (br (+ (i i i)) (* (i i i)) (null i) (eins i))))
		       bool*env)


;;; examples are of the form (bool~unify tx) or (bool~unify (list txa))

(setf a (term~read 'a bool*env))
(setf b (term~read 'b bool*env))
(setf c (term~read 'c bool*env))
(setf x (term~read 'x bool*env))
(setf y (term~read 'y bool*env))


(setf t1a (term~read '(+ x y) bool*env))
(setf t1b (term~read '(+ (* x y) a) bool*env))
(setf t1 (append (list t1a) (list t1b)))
    ;;; {(X --> (+ (* X (* Y A)) (+ (* Y A) A))) (Y --> (* Y A))}


(setf t2a (term~read 'x bool*env))
(setf t2b (term~read '(+ x eins) bool*env))
(setf t2 (append (list t2a) (list t2b)))
    ;;; NIL


(setf t3a (term~read 'x bool*env))
(setf t3b (term~read '(* a x) bool*env))
(setf t3 (append (list t3a) (list t3b)))
    ;;; {(X --> (* X A))}


(setf t4a (term~read '(* x y) bool*env))
(setf t4b (term~read 'null bool*env))
(setf t4 (append (list t4a) (list t4b)))
    ;;; {(X --> (+ (* X Y) X))}


(setf t5a (term~read '(+ x a) bool*env))
(setf t5b (term~read 'null bool*env))
(setf t5 (append (list t5a) (list t5b)))
    ;;; {(X --> A)}


(setf t6a (term~read '(+ (* a x) y) bool*env))
(setf t6b (term~read 'null bool*env))
(setf t6 (append (list t6a) (list t6b)))
    ;;; {(X --> (+ (* X A) (+ X (* Y A)))) (Y --> (* Y A))}


(setf t7a (term~read '(* (* (+ a b) (+ (+ b x) (* y b))) z) bool*env))
(setf t7b (term~read 'null bool*env))
(setf t7 (append (list t7a) (list t7b)))
    ;;; {(Z --> (+ (* Z (* A B)) (+ (* Z (* A X)) (+ (* Z (* A (* Y B))) (+ (* Z B)
    ;;;                                  (+ (* Z (* B X)) (+ (* Z (* B Y)) Z)))))))}


(setf t8a (term~read '(* b x) bool*env))
(setf t8b (term~read '(* a y) bool*env))
(setf t8 (append (list t8a) (list t8b)))
    ;;; {(X --> (+ (* X B) (+ X (* A (* Y B))))) (Y --> (+ (* Y (* A B)) (+ (* Y A) Y)))}


(setf t9a (term~read '(+ (* a x) (* b y)) bool*env))
(setf t9b (term~read '(+ (+ z (* x c)) a) bool*env))
(setf t9 (append (list t9a) (list t9b)))
    ;;; {(X --> (+ (* X A) (+ (* X C) (+ X (+ (* B (* Y C)) (+ (* B (* Y A))
    ;;;                          (+ (* Z C) (+ (* Z A) (+ (* A C) A)))))))))
    ;;;  (Z --> (+ (* Z B) (+ (* Z (* C B)) (+ (* Z C) (+ (* Z (* A B))
    ;;;            (+ (* Z A) (+ (* A (* C B)) (* A C))))))))
    ;;;  (Y --> (+ (* Y B) (+ (* Y (* B C)) (+ (* Y (* A B)) (+ Y (+ (* Z B)
    ;;;               (+ (* Z (* C B)) (+ (* A (* Z B)) (* A (* C B))))))))))}

    ;;; new results by using a heuristic for the decision, which variable to bw
    ;;; eliminated next:
    ;;; {(Y --> (+ (* Y B) (+ Y (+ (* Z B) (+ (* A (* X B)) (+ (* X (* C B)) (* A B)))))))
    ;;;  (Z --> (+ (* Z B) (+ (* A (* X B)) (+ (* X (* C B)) (+ (* X C)
    ;;;                                  (+ (* A X) (+ (* A B) A)))))))}


(setf t10a (term~read '(+ a (* x b)) bool*env))
(setf t10b (term~read 'eins bool*env))
(setf t10 (append (list t10a) (list t10b)))
    ;;; NIL


    ;;; examples for a list of equations

(setf tt1a (term~read 'x-1 bool*env))
(setf tt1b (term~read '(* a x-1) bool*env))
(setf tt1c (term~read '(* x-2 y-2) bool*env))
(setf tt1d (term~read 'null bool*env))
(setf tt1e (term~read '(+ x-3 a) bool*env))
(setf tt1f (term~read 'null bool*env))

(setf tt1 (append (append (append (list tt1a) (list tt1b)) (append (list tt1c) (list tt1d)))
		  (append (list tt1e) (list tt1f))))
    ;;; {(X-3 --> A) (X-1 --> (* X-1 A)) (X-2 --> (+ (* X-2 Y-2) X-2))}




(setf tt2a (term~read 'x bool*env))
(setf tt2b (term~read '(* a x) bool*env))
(setf tt2c (term~read '(* x y) bool*env))
(setf tt2d (term~read 'null bool*env))
(setf tt2e (term~read '(+ x a) bool*env))
(setf tt2f (term~read 'null bool*env))

(setf tt2 (append (append (append (list tt2a) (list tt2b)) (append (list tt2c) (list tt2d)))
		  (append (list tt2e) (list tt2f))))
    ;;; {(Y --> (+ (* Y A) Y)) (X --> A)}




(setf tt3a (term~read '(+ (* a x) (* b y)) bool*env))
(setf tt3b (term~read '(+ (+ z (* x c)) a) bool*env))
(setf tt3c (term~read '(* (* (+ a b) (+ (+ b x) (* y b))) z) bool*env))
(setf tt3d (term~read 'null bool*env))
(setf tt3e (term~read '(* b x) bool*env))
(setf tt3f (term~read '(* a y) bool*env))

(setf tt3 (append (append (append (list tt3a) (list tt3b)) (append (list tt3c) (list tt3d)))
		  (append (list tt3e) (list tt3f))))
    ;;; {(Z --> (+ (* A X) (+ (* B Y) (+ (* X C) (+ A (+ (* B (* Y A))
    ;;;         (+ (* B (* X A)) (+ (* X (* C B)) (* X (* C (* A B)))))))))))
    ;;;  (X --> (+ (* X (* A C)) (+ (* X (* B A)) (+ (* X B) (+ (* X (* C (* B A))) X)))))
    ;;;  (Y --> (+ (* Y A) (+ Y (* B (* X A)))))}


(setf tt4a (term~read 'x bool*env))
(setf tt4b (term~read '(* a x) bool*env))
(setf tt4c (term~read '(+ z a) bool*env))
(setf tt4d (term~read 'null bool*env))
(setf tt4e (term~read '(* x y) bool*env))
(setf tt4f (term~read 'null bool*env))

(setf tt4 (append (append (append (list tt4a) (list tt4b)) (append (list tt4c) (list tt4d)))
		  (append (list tt4e) (list tt4f))))
    ;;; {(Z --> A) (X --> (* X A)) (Y --> (+ (* Y (* X A)) Y))}



;;; BR.FREE

(setf multi1 (list (list (term~read 'x-1 bool*env) (term~read '(f1 (+ x-2 x-3)) bool*env))
		  (list (term~read 'x-3 bool*env) (term~read '(f1 (+ (+ x-4 a1) a2)) bool*env))
		  (list (term~read 'x-4 bool*env) (term~read '(f1 (+ x-5 b1)) bool*env))
		  (list (term~read 'x-5 bool*env) (term~read '(f1 x-1) bool*env))))

(setf multi (list (list (term~read 'a bool*env) (term~read '(+ x-1 x-3) bool*env))
		  (list (term~read '(f1  x-1) bool*env) (term~read '(f1 (f1 x-2)) bool*env))))

(setf multi3 (list (list (term~read 'a3 bool*env) (term~read '(+ (+ x-1 x-2) a1) bool*env))
		  (list (term~read 'x-2 bool*env) (term~read '(f1 y-3) bool*env))
		  (list (term~read 'x-2 bool*env) (term~read '(+ y-2 b2) bool*env))
		  (list (term~read 'x-1 bool*env) (term~read '(f1 b1) bool*env))
		  (list (term~read 'x-1 bool*env) (term~read '(+ y-1 b1) bool*env))))

(setf multi4 (list (list (term~read 'x-1 bool*env)  (term~read '(f1 a1) bool*env))
		   (list (term~read 'x-1 bool*env)  (term~read '(+ (+ x-2 y-1) (f1 a1)) bool*env))
		   (list (term~read 'y-1 bool*env)  (term~read '(f1 b1) bool*env))
		   (list (term~read 'y-1 bool*env)  (term~read '(+ (+ y-2 x-1) (f1 b1)) bool*env))))


(setf multi5 (list (list (term~read 'x bool*env) (term~read '(+ y a) bool*env))
		   (list (term~read 'x bool*env) (term~read '(f1 z) bool*env))))

(setf multi6 (list (list (term~read 'x bool*env) (term~read '(+ y a) bool*env))
		   (list (term~read 'y bool*env) (term~read '(f1 x) bool*env))))

(setf multi7 (list (list (term~read 'x bool*env) (term~read '(+ y a) bool*env))
		   (list (term~read 'y bool*env) (term~read '(f1 z) bool*env))
		   (list (term~read 'z bool*env) (term~read '(* u b) bool*env))))


#|

(bool~unify (list (term~read '(+ (* a x) (+ (* b y) a)) bool*env)
		  (term~read 'null bool*env))
	    () ())

(bool~unify (list (term~read '(+ (* a x) (+ (* b y) (* a b))) bool*env)
		  (term~read 'null bool*env))
	    () ())

(bool~unify (list (term~read '(+ (* a x) (+ (* b y) (+ a b))) bool*env)
		  (term~read 'null bool*env))
	    () ())

(bool~unify (list (term~read '(+ (* a (* x y)) (+ (* a x) (+ (* b (* x y)) a))) bool*env)
		  (term~read 'null bool*env))
	    () ())

(bool~unify (list (term~read '(+ (* a (* x y)) (+ (* a x) (+ (* b (* x y)) a))) bool*env)
		  (term~read 'null bool*env))
	    ()
	    (list (list (term~read 'b bool*env) (term~read 'x bool*env))))

     {(X --> (+ (* X2 A) (+ X2 A))) (Y --> (+ (* Y (* B (* X2 A)))
	     (+ (* Y (* B X2)) (+ (* Y (* B A)) (+ (* Y A) Y)))))}


|#
