(in-package "KEIM")

(export '(cpcb*env))

(setf cpcb*env (env~create))

(post~read-object-list '((type-constants i)
			 (constants (a i) (b i) (c i) (d i)
				    (a0 i) (b0 i)
				    (a1 i) (b1 i)
				    (a_0 i) (a_A i) (a_B i) (a_1 i)
				    (f (i i)) (f1 (i i)) (f2 (i i))
			            (g (i i i)) (h (i i i)) (- (i i)))
			 (variables (x i) (y i) (z i) (u i) (v i) (w i)
				    (x1 i) (x2 i) (x3 i) (x4 i) (x5 i) (x6 i)
				    (y1 i) (y2 i) (y3 i) (y4 i) (y5 i) (y6 i) (y99 i)
				    (v_0 i) (v_1 i) (v_2 i) (v_3 i))
			 (signatures (aci (&& (i i i))) (aci (& (i i i))) (aci (! (i i i)))
				     (ac (++ (i i i))) (ac (+ (i i i)))
			             (ac (** (i i i))) (ac (* (i i i)))
			             (a (list i i i))
				     ))
		       cpcb*env)

#|


;; A

(unif==test
  (list (term~read '(+ (L (L x y) z) a) a*env))
  (list (term~read '(+ (L x (L y z)) a) a*env))
  t)

(unif==test
  (list (term~read '(+ (L (L x y) z) b) a*env))
  (list (term~read '(+ (L x (L y z)) a) a*env))
  nil)

(unif==test
  (list (term~read '(+ (L (L x y) z) (+ x y)) a*env))
  (list (term~read '(+ (L x (L y z)) (+ y x)) a*env))
  t)

(unif==test
  (list (term~read '(+ (L a x) (L a x)) a*env))
  (list (term~read '(+ (L x a) (L x a)) a*env))
  t)

(unif==test
  (list (term~read '(+ x1 x2) a*env))
  (list (term~read '(+ x3 x4) a*env))
  t)

(unif==test
  (list (term~read '(L (+ x y) a) a*env))
  (list (term~read '(L x (+ y a)) a*env))
  nil)

(unif==test
  (list (term~read '(& (+ (L a x) (L x b)) (L x y)) a*env))
  (list (term~read '(& (L x y) (+ (L a b) (L x x))) a*env))
  t)

(unif==test
  (list (term~read '(L (+ x y) (* x1 x2)) a*env))
  (list (term~read '(x2) a*env))
  nil)

(unif==test
  (list (term~read '(+ (L a (L x y)) z) a*env))
  (list (term~read '(L (L a b) (L x y)) a*env))
  nil)

(unif==test
  (list (term~read '(+ (L x1 (L x2 x3)) (L x1 (L x2 x3))) a*env))
  (list (term~read '(+ (L (L x1 x2) x3) (L (L x1 x2) x3)) a*env))
  t)



;; AC

(cpcb~decide-unify (list (term~read '(+ x x) cpcb*env))
		   (list (term~read '(+ y y) cpcb*env)))

(cpcb~decide-unify (list (term~read '(+ a x) cpcb*env))
		   (list (term~read '(+ a y) cpcb*env)))

(cpcb~decide-unify (list (term~read '(+ x (f x)) cpcb*env))
		   (list (term~read '(+ y (f y)) cpcb*env)))

(cpcb~decide-unify (list (term~read '(+ x x) cpcb*env))
		   (list (term~read '(+ (f y) (f z)) cpcb*env)))

(cpcb~decide-unify (list (term~read '(+ x x) cpcb*env))
		   (list (term~read '(+ a b) cpcb*env)))

(cpcb~decide-unify (list (term~read '(g y x) cpcb*env))
		   (list (term~read '(g a (+ y (+ (f y) (g y y)))) cpcb*env)))

(cpcb~decide-unify (list (term~read '(f x) cpcb*env))
		   (list (term~read '(f (+ b (+ a a))) cpcb*env)))

(cpcb~decide-unify (list (term~read '(f (+ x1 x2)) cpcb*env))
		   (list (term~read '(f (+ y1 y2)) cpcb*env)))

(cpcb~decide-unify (list (term~read '(+ x1 x2) cpcb*env))
		   (list (term~read '(+ (+ y1 y2) (f y1)) cpcb*env)))

(cpcb~decide-unify (list (term~read '(g x v) cpcb*env)
			 (term~read '(+ x (+ (f u) (- u))) cpcb*env))
		   (list (term~read '(g x v) cpcb*env)
			 (term~read '(+ u v) cpcb*env)))

(cpcb~decide-unify (list (term~read '(+  (* a x1) (* a x2)) cpcb*env)
			 (term~read '(++ (** a y1) (** a y2)) cpcb*env))
		   (list (term~read '(+  (* c d) (* c x)) cpcb*env)
			 (term~read '(++ (** c d) (** c x)) cpcb*env)))

(cpcb~decide-unify (list (term~read '(+  (* a b) (* a b)) cpcb*env)
			 (term~read '(++ (** a b) (** a b)) cpcb*env))
		   (list (term~read '(+  (* c d) (* c x)) cpcb*env)
			 (term~read '(++ (** c d) (** c x)) cpcb*env)))

(cpcb~decide-unify (list (term~read '(f (* x x)) cpcb*env)
			 (term~read '(+ a (++ u u)) cpcb*env))
		   (list (term~read '(f (* a y)) cpcb*env)
			 (term~read '(+ a (++ a v)) cpcb*env)))

(cpcb~decide-unify (list (term~read '(g u v) cpcb*env)
			 (term~read '(+ x (+ (f u) (- u))) cpcb*env))
		   (list (term~read '(g z w) cpcb*env)
			 (term~read '(+ u v) cpcb*env)))

(cpcb~decide-unify (list (term~read '(+ x a) cpcb*env))
		   (list (term~read '(+ (+ y1 y2) (f y1)) cpcb*env)))

(cpcb~decide-unify (list (term~read '(+ x1 a) cpcb*env))
		   (list (term~read '(+ (+ y1 y2) (f (+ y2 y3))) cpcb*env)))

(cpcb~decide-unify (list (term~read '(+ (g X1 X2) (g (f X1) X2)) cpcb*env))
		   (list (term~read '(+ (g y1 y2) (g (f y1) y2)) cpcb*env)))

(cpcb~decide-unify (list (term~read '(+ x1 a) cpcb*env))
		   (list (term~read '(+ (+ y3 (g y1 y2)) (g (f y1) y2)) cpcb*env)))


(cpcb~decide-unify (list (term~read '(* (* x1 x2) (+ x3 x4)) cpcb*env))
		   (list (term~read '(* y1 (f y1)) cpcb*env)))

(cpcb~decide-unify (list (term~read '(* (+ x1 x2) (+ x1 (f x2))) cpcb*env))
		   (list (term~read '(* (+ y1 y2) (+ y1 (f y2))) cpcb*env)))

(cpcb~decide-unify (list (term~read '(* (* x3 (g x1 x2)) (g x1 (f x2))) cpcb*env))
		   (list (term~read '(* (g x1 x2) (g x1 (f x2))) cpcb*env)))

(cpcb~decide-unify (list (term~read '(+ a x) cpcb*env))
		   (list (term~read '(+ (+ (* y1 y2) y3) (* y1 (f y2))) cpcb*env)))

(cpcb~decide-unify (list (term~read 'x1 cpcb*env)
			 (term~read 'x2 cpcb*env)
			 (term~read '(+ (+ (f b) x1) x1) cpcb*env))
		   (list (term~read '(* (* a a) b) cpcb*env)
			 (term~read '(* (* a a) b) cpcb*env)
			 (term~read '(+ (+ (f b) x2) x2) cpcb*env)))

(ac=test (list (term~read '(+ x1 a) cpcb*env))
	 (list (term~read '(+ (+ y1 y2) (f (+ y2 y3))) cpcb*env)))


;; negative examples:

(cpcb~decide-unify (list (term~read '(f a) cpcb*env))
		   (list (term~read '(f (+ x y)) cpcb*env)))

(cpcb~decide-unify (list (term~read '(+ x (f x)) cpcb*env))
		   (list (term~read '(+ y y) cpcb*env)))

(cpcb~decide-unify (list (term~read '(+ x (f x)) cpcb*env))
		   (list (term~read '(+ y (+ y y)) cpcb*env)))

(cpcb~decide-unify (list (term~read '(+ x (f x)) cpcb*env))
		   (list (term~read '(+ (+ (f a) y) y) cpcb*env)))

(cpcb~decide-unify (list (term~read '(+ x (f x)) cpcb*env))
		   (list (term~read '(+ y (f (+ y z))) cpcb*env)))

(cpcb~decide-unify (list (term~read '(+ (+ x x) a) cpcb*env))
		   (list (term~read '(+ (+ y y) (+ z z)) cpcb*env)))

(cpcb~decide-unify (list (term~read '(+ x1 (+ (f1 x2) (f x3))) cpcb*env))
		   (list(term~read '(+ y1 (+ (f2 x1) (f y3))) cpcb*env)))


(cpcb~decide-unify (list (term~read '(+ (+ x b) (+ a a)) cpcb*env))
		   (list (term~read '(+ b (+ a a)) cpcb*env)))

(cpcb~decide-unify (list (term~read 'x cpcb*env)
			 (term~read '(+ a1 x1) cpcb*env))
		   (list (term~read '(* (* a a) b) cpcb*env)
			 (term~read '(+ (+ (f b) x) x) cpcb*env)))

(cpcb~decide-unify (list (term~read '(* x y) cpcb*env)
			 (term~read '(+ x (+ y z)) cpcb*env))
		   (list (term~read '(* u v) cpcb*env)
			 (term~read '(+ u v) cpcb*env)))

(cpcb~decide-unify (list (term~read '(+ z (+ (* x1 x2) (* x1 (f x2)))) cpcb*env))
		   (list (term~read '(+ (* y1 y2) (* y1 (f y2))) cpcb*env)))

(cpcb~decide-unify (list (term~read '(+ (+ x3 (* x1 x2)) (* x1 (f x2))) cpcb*env))
		   (list (term~read '(+ (* y1 y2) (* y1 (f y2))) cpcb*env)))

(cpcb~decide-unify (list (term~read 'x1 cpcb*env)
			 (term~read 'x2 cpcb*env)
			 (term~read '(+ y1 (+ x1 x1)) cpcb*env))
		   (list (term~read '(* (* a a) b) cpcb*env)
			 (term~read '(* a a) cpcb*env)
			 (term~read '(+ (+ x2 x2) (+ y2 (f (* b b)))) cpcb*env)))


;;; ACI

(cpcb~decide-unify (list (term~read '(! (! (& x1 x2) (& x1 x3)) (& x1 (f (! x2 x3)))) cpcb*env)
			 (term~read '(& a_1 x1) cpcb*env))
		   (list (term~read '(! (f (& y1 y2)) (f (& y3 (f y2)))) cpcb*env)
			 (term~read '(f a_0) cpcb*env)))

(cpcb~decide-unify (list (term~read '(& y a) cpcb*env))
		   (list (term~read '(! x b) cpcb*env)))

(cpcb~decide-unify (list (term~read '(! x1 (f x1)) cpcb*env))
		   (list (term~read '(! (& y1 y2) (& y1 (f y2))) cpcb*env)))

(cpcb~decide-unify (list (term~read '(g u v) cpcb*env)
			 (term~read '(& (f x) (f a)) cpcb*env))
		   (list (term~read '(g x (f z)) cpcb*env)
			 (term~read '(& y a) cpcb*env)))

(cpcb~decide-unify (list (term~read '(& x y) cpcb*env))
		   (list (term~read '(& z (f y)) cpcb*env)))


(cpcb~decide-unify (list (term~read 'x1 cpcb*env)
			 (term~read '(& (! x1 x1) (! x1 x2)) cpcb*env))
		   (list (term~read '(& (f y1) (f y2)) cpcb*env)
			 (term~read '(f (! y1 y2)) cpcb*env)))


;;; AC, ACI

(cpcb~decide-unify (list (term~read '(&& (& y1 a) (+ y2 y3)) cpcb*env))
		   (list (term~read '(&& x1 (! x2 b)) cpcb*env)))

(cpcb~decide-unify (list (term~read '(+ (& y1 a) (* b y2)) cpcb*env))
		   (list (term~read '(+ (! (& x1 x2) c) x3) cpcb*env)))

(cpcb~decide-unify (list (term~read '(+ (& x a) (* a1 y)) cpcb*env))
		   (list (term~read '(+ (! (& x2 x3) b) z) cpcb*env)))

(cpcb~decide-unify (list (term~read '(* (&& (& y1 a) (+ y2 y3)) (++ a1 y4)) cpcb*env))
		   (list (term~read '(* (&& x1 (! x2 b)) (! x3 x4)) cpcb*env)))

|#
