;(in-package "CLIM-USER")
(in-package "KEIM")

(export '(feat*env))

(setf feat*env (env~create))

(post~read-object-list '((type-constants i o)
			 (constants (a i) (b i) (c i) (d i)
				    (a0 i) (b0 i) (a1 i) (b1 i)
				    (a_0 i) (a_A i) (a_B i) (a_1 i)
				    (f (i i)) (f1 (i i)) (f2 (i i))
			            (g (i i i)) (h (i i i)) (- (i i))
			            (= (o i i)))
			 (variables (x i) (y i) (z i) (u i) (v i) (w i)
				    (x1 i) (x2 i) (x3 i) (x4 i) (x5 i) (x6 i)
				    (y1 i) (y2 i) (y3 i) (y4 i) (y5 i) (y6 i) (y99 i)
				    (v_0 i) (v_1 i) (v_2 i) (v_3 i))
			 (signatures (feat (p (o i)) (s1 (o i)) (s2 (o i)) (s3 (o i)) (s4 (o i))
				      (tops (o i)) (s5 (o i)) (s6 (o i)) (s7 (o i)) (s8 (o i))
				      (q (o i i)) (r (o i i ))
				      (sort-hierarchy (tops p s1) (p s2 s3) (s1 s4 s5)
						      (s2 s6) (s3 s6) (s6 s7 s8) (s8 s4)))
			             (rat-tree (k (i i)) (l (i i i)))
				     ))
		       feat*env)


(defmacro unif==test-pred (constraint-list result)
  `(let ((arg ,constraint-list))
    (format t "~%~A: ~A ~A   " (incf counter) arg ,result)
    (let ((res (cpcb~decide-unify-pred arg)))
      (cond ((eq (null ,result) (null res))
	     (format t "OK"))
	    (t (format t "*** result is ~A ***" res))))))

(setf counter 0)



(unif==test-pred (mapcar #'(lambda (term) (term~read term feat*env))
			 '((s1 x1) (s2 (f a)) (s3 (k x2))
			   (r x1 (f a)) (q x1 (k x2))))
		 t)

(unif==test-pred (mapcar #'(lambda (term) (term~read term feat*env))
			 '((s1 x1) (s2 x2) (r x1 x2)
			   (= x2 (g (f a1) (k x2)))))
		 nil)

(unif==test-pred (mapcar #'(lambda (term) (term~read term feat*env))
			 '((s1 x1) (s2 (f x2)) (s3 (f x3))
			   (r x1 (f x2)) (r x1 (f x3))
			   (r x2 x4) (r x3 x5)
			   (p x2) (p x3) (s1 x4) (s3 x5)))
		 t)








