;******************************************************************************
;* cpfree - test                                                              *
;******************************************************************************

(in-package "KEIM")

;+----------------------------------------------------------------------------+
;| universe                                                                   |
;+----------------------------------------------------------------------------+

(defvar env)
(defvar a)          ; constants 
(defvar b)
(defvar c) 
(defvar c1)
(defvar c2)
(defvar d)
(defvar u)          ; variables
(defvar v)
(defvar v0)
(defvar v1)
(defvar v2)
(defvar v3)
(defvar v4)
(defvar v5)
(defvar v6)
(defvar v7)
(defvar v8)
(defvar v9)
(defvar v10)
(defvar v11)
(defvar x)
(defvar y)
(defvar z)


(defun cpfree~test-init ()

  (setf env (env~create))      ; universe

  (post~read-object-list '((type-constants i o)
			   (constants (f (i i i))
				      (g (i i i))
				      (h (i i))
				      (l (i i))
				      (a i) (b i) (c i) (d i)
				      (c1 i) (c2 i))
			   (variables (u i) (v i) (x i) (y i) (z i)
				      (v0 i) (v1 i) (v2 i) (v3 i)
				      (v4 i) (v5 i) (v6 i) (v7 i)
				      (v8 i) (v9 i) (v10 i) (v11 i)))
			 env)
			       ; universe filled with individuals


  (setf a (term~read 'a env))          ; constants 
  (setf b (term~read 'b env))
  (setf c (term~read 'c env)) 
  (setf c1 (term~read 'c1 env))
  (setf c2 (term~read 'c2 env))
  (setf d (term~read 'd env))
  (setf u (term~read 'u env))          ; variables
  (setf v (term~read 'v env))
  (setf v0 (term~read 'v1 env))
  (setf v1 (term~read 'v2 env))
  (setf v2 (term~read 'v2 env))
  (setf v3 (term~read 'v2 env))
  (setf v4 (term~read 'v2 env))
  (setf v5 (term~read 'v2 env))
  (setf v6 (term~read 'v2 env))
  (setf v7 (term~read 'v2 env))
  (setf v8 (term~read 'v2 env))
  (setf v9 (term~read 'v2 env))
  (setf v10 (term~read 'v2 env))
  (setf v11 (term~read 'v2 env))
  (setf x (term~read 'x env))
  (setf y (term~read 'y env))
  (setf z (term~read 'z env)))
  
;+----------------------------------------------------------------------------+
;| test - functions                                                           |
;+----------------------------------------------------------------------------+

(defun cpfree~theo-init (equations)
  (let*
      ((gup (unicp~general-up-create equations))
       (theory (th~term-theory a)))
    (unicp~theo-init theory gup equations nil nil nil nil)))

(defun cpfree~new-constr (up identified)
  (unicp~new-constr up identified nil nil nil))


(defun cpfree~test (key)
  (cpfree~test-init)
  (case key
	((1) (cpfree~theo-init (list (list (term~read '(f (f y c) x) env))
				     (list (term~read '(f z (f b c)) env)))))
	((2) (cpfree~theo-init (list (list x y)
				     (list a b))))
	((3) (cpfree~theo-init (list (list (term~read '(f (f y c) x) env))
				     (list (term~read '(f z (f v c)) env)))))
	((4) (cpfree~theo-init (list
				(list (term~copy (term~read 'x env))
				      (term~copy (term~read 'y env))
				      (term~copy (term~read 'x env)))
				(list (term~copy (term~read '(h x) env))
				      (term~copy (term~read '(h y) env))
				      (term~copy (term~read 'y env))))))
	((5) (cpfree~theo-init (list (list (term~read 'y env))
				     (list (term~read '(h a) env)))))
	((6) (cpfree~theo-init (list (list (term~read 'x env))
				     (list (term~read '(h y) env)))))
	((7) (cpfree~theo-init (list (list (term~read '(h x) env))
				     (list (term~read '(h y) env)))))
	((8) (cpfree~theo-init (list (list (term~read '(f x x) env))
				     (list (term~read '(f y a) env)))))
	((9) (cpfree~theo-init (list (list (term~read '(f y a) env))
				     (list (term~read '(f x x) env)))))
	((10) (cpfree~theo-init (list (list (term~read '(f x x) env))
				      (list (term~read '(f a y) env)))))
	((11) (cpfree~theo-init (list (list (term~read '(f a y) env))
				      (list (term~read '(f x x) env)))))
	((12) (cpfree~theo-init (list
				 (list (term~read '(f x y) env))
				 (list (term~read '(f (h a) (l a)) env)))))
	((13) (cpfree~theo-init (list
				 (list (term~read '(f x y) env))
				 (list (term~read '(f a b) env)))))
	((14) (cpfree~theo-init (list
				 (list (term~read '(f x y) env))
				 (list (term~read '(f (f a b) (g a x)) env)))))
	((15) (cpfree~theo-init (list
				 (list
				  (term~read 'x env)
				  (term~read 'u env)
				  (term~read 'v env))
				 (list
				  (term~read 'y env)
				  (term~read '(h x) env)
				  (term~read '(h y) env))
				 )))
	((16) (cpfree~theo-init (list
				 (list
				  (term~copy (term~read 'x env))
				  (term~copy (term~read 'u env))
				  (term~copy (term~read 'v env)))
				 (list
				  (term~copy (term~read 'y env))
				  (term~copy (term~read '(h x) env))
				  (term~copy (term~read '(h y) env)))
				 )))
	))
  

(defun cpfree~test-constr (key)
  (cpfree~test-init)
  (case key
	((1) (cpfree~new-constr (cpfree~test 1) (list (list x y))))
	((2) (cpfree~new-constr (cpfree~test 2) (list (list x y))))
	((3) (cpfree~new-constr (cpfree~test 3) (list (list x z))))
	((4) (cpfree~new-constr (cpfree~test 9) (list (list x y))))
	))











