;******************************************************************************
;* free - test                                                                *
;******************************************************************************

(in-package :keim)

;+----------------------------------------------------------------------------+
;| universe                                                                   |
;+----------------------------------------------------------------------------+

(defvar env)

(setf env (env~create))      ; universe

(post~read-object-list '((type-constants i o)
			 (constants (f (i i i))
				    (g (i i i))
				    (h (i i))
				    (l (i i))
				    (a i) (b i) (c i) (d i)
				    (c1 i) (c2 i))
			 (variables (u i) (v i) (x i) (y i) (z i)
				    (v0 i) (v1 i) (v2 i) (v3 i)
				    (v4 i) (v5 i) (v6 i) (v7 i)
				    (v8 i) (v9 i) (v10 i) (v11 i)))
		       env)
                               ; universe filled with individuals

(defun free~init ()
  (setf env (env~create))      ; universe

  (post~read-object-list '((type-constants i o)
	        		 (constants
				  (f (i i i))
				  (g (i i i))
				  (h (i i))
				  (l (i i))
				  (a i) (b i) (c i) (d i)
				  (c1 i) (c2 i))
			   (variables
			    (u i) (v i) (x i) (y i) (z i)
			    (v0 i) (v1 i) (v2 i) (v3 i)
			    (v4 i) (v5 i) (v6 i) (v7 i)
			    (v8 i) (v9 i) (v10 i) (v11 i)))
			 env)
                               ; universe filled with individuals


  )

;+----------------------------------------------------------------------------+
;| variables                                                                  |
;+----------------------------------------------------------------------------+

(setf a (term~read 'a env))          ; constants 
(setf b (term~read 'b env))
(setf c (term~read 'c env)) 
(setf c1 (term~read 'c1 env))
(setf c2 (term~read 'c2 env))
(setf d (term~read 'd env))
(setf u (term~read 'u env))          ; variables
(setf v (term~read 'v env))
(setf v0 (term~read 'v1 env))
(setf v1 (term~read 'v2 env))
(setf v2 (term~read 'v2 env))
(setf v3 (term~read 'v2 env))
(setf v4 (term~read 'v2 env))
(setf v5 (term~read 'v2 env))
(setf v6 (term~read 'v2 env))
(setf v7 (term~read 'v2 env))
(setf v8 (term~read 'v2 env))
(setf v9 (term~read 'v2 env))
(setf v10 (term~read 'v2 env))
(setf v11 (term~read 'v2 env))
(setf x (term~read 'x env))
(setf y (term~read 'y env))
(setf z (term~read 'z env))

(setf ffycx (term~read '(f (f y c) x) env))
(setf fzfbz (term~read '(f z (f b c)) env))
;+----------------------------------------------------------------------------+
;| test - functions                                                           |
;+----------------------------------------------------------------------------+

(defun free~test (key)
  (case key
    ((1) (free~decide (list (term~read '(f (f y c) x) env)) 
		      (list (term~read '(f z (f b c)) env))
		      nil
		      nil))
    ((2) (free~unif (list (term~read '(f (f y c) x) env)) 
		    (list (term~read '(f z (f b c)) env))
		    (list (list (term~read 'c env) (term~read 'x env)))
		    nil))
    ((3) (free~unif
	  (list
	   (term~read
	    '(f (g v0 v0)
	      (f (g v1 v1)
	       (f (g v2 v2)
		(f (g v3 v3)
		   (f (g v4 v4)
		      (f (g v5 v5)
			 (f (g v6 v6)
			    (f (g v7 v7)
			       (f (g v8 v8)
				  (f (g v9 v9)
				     (g v10 v10))))))))))) env)) 
	  (list
	   (term~read
	    '(f v1
	      (f v2
	       (f v3
		(f v4
		   (f v5
		      (f v6
			 (f v7
			    (f v8
			       (f v9
				  (f v10 v11)))))))))) env))
	  nil
	  nil))
    ((4) (free~decide
	  (list
	   (term~read
	    '(f (g v0 v0) (f (g v1 v1) (f (g v2 v2) (f (g v3 v3) (f (g v4 v4)
	     (f (g v5 v5) (f (g v6 v6) (f (g v7 v7) (f (g v8 v8) (f (g v9 v9)
	     (g v10 v10))))))))))) env)) 
	  (list
	   (term~read
	    '(f v1 (f v2 (f v3 (f v4 (f v5 (f v6 (f v7 (f v8 (f v9
	     (f v10 v11)))))))))) env))
	  nil
	  nil))
    ((5) (free~unif
	  (list (term~read '(f x (f y z)) env)) 
	  (list (term~read '(f a (f a b)) env))
	  (list (list (term~read 'a env) (term~read 'z env))
		(list (term~read 'b env) (term~read 'y env))
		(list (term~read 'b env) (term~read 'z env)))
	  nil))
    ((6) (free~unif (list (term~read 'a env))
		    (list (term~read 'b env))
		    nil
		    nil))
    ((7) (free~unif (list (term~read 'x env))
		    (list (term~read 'b env))
		    nil
		    nil))
    ((8) (free~unif (list (term~read 'x env))
		    (list (term~read 'y env))
		    nil
		    nil))
    ((9) (free~unif (list (term~read '(g a x) env)) ; wrong input
		    (list (term~read '(g v b) env))
		    (list (term~read 'x env))
		    nil))
    ((10) (free~unif (list (term~read '(g a x) env))
		     (list (term~read '(g v b) env))
		     nil
		     (list (term~read 'x env))))
    ((11) (free~unif (list (term~read 'x env) (term~read 'x env))
		     (list (term~read '(h y) env) (term~read '(h a) env))
		     nil
		     nil))
    ((12) (free~unif (list (term~read 'x env) (term~read 'x env))
		     (list (term~read '(h y) env) (term~read '(h a) env))
		     nil
		     (list (term~read 'y env))))
    ((13) (free~unif (list (term~read 'x env) (term~read 'x env))
		     (list (term~read 'b env) (term~read '(h a) env))
		     nil
		     nil))
    ((14) (free~unif (list (term~read '(h a) env))
		     (list (term~read '(l y) env))
		     nil
		     (list (term~read 'y env))))
    ((15) (free~unif (list  (term~read 'y env))
		     (list  (term~read '(h z) env))
		     nil
		     (list  (term~read 'z env))))
    ((16) (free~unif (list (term~read 'x env) (term~read 'x env))
		     (term~copy (list (term~read 'b env) (term~read 'b env)))
		     nil
		     nil))
    ((17) (free~unif (list (term~read 'x env) (term~read 'x env))
		     (list (term~read '(h a) env) (term~read '(h a) env))
		     nil
		     nil))
    ((18) (free~unif (list (term~read 'x env) (term~read 'x env))
		     (term~copy (list (term~read 'x env) (term~read 'x env)))
		     nil
		     nil))
    ((19) (free~unif (list (term~read 'x env) (term~read 'y env))
		     (list (term~read 'a env) (term~copy (term~read 'a env)))
		     (list (list (term~read 'a env)
				 (term~read 'y env))) 
		     nil))
    ((20) (free~unif (list (term~read 'x env)
			   (term~read 'y env)
			   (term~read 'x env))
		     (list (term~read '(h x) env)
			   (term~read '(h y) env)
			   (term~read 'y env))
		     nil 
		     nil))
    ((21) (free~unif (list (term~copy (term~read 'x env))
			   (term~copy (term~read 'y env))
			   (term~copy (term~read 'x env)))
		     (list (term~copy (term~read '(h x) env))
			   (term~copy (term~read '(h y) env))
			   (term~copy (term~read 'y env)))
		     nil 
		     nil))
    ((22) (free~unif (list (term~read 'x env)
			   (term~read 'x env)
			   (term~read 'x env)
			   (term~read '(h y) env))
		     (list (term~read 'a env)
			   (term~read 'a env)
			   (term~read 'b env)
			   (term~read '(h z) env))
		     (list (list (term~read 'z env) (term~read 'x env)))
		     (list (term~read 'z env))))
    ((23) (free~unif (term~copy (list (term~read 'x env)
				      (term~read 'x env)
				      (term~read 'x env)
				      (term~read '(h y) env)))
		     (term~copy (list (term~read 'a env)
				      (term~read 'a env)
				      (term~read 'b env)
				      (term~read '(h z) env)))
		     (term~copy (list (list (term~read 'z env)
					    (term~read 'x env))))
		     (term~copy (list (term~read 'z env)))))
    ((24) (free~unif (list (term~read 'x env)
			   (term~read 'x env)
			   (term~read 'x env))
		     (term~copy (list (term~read 'a env)
				      (term~read 'a env)
				      (term~read 'b env)))
		     nil
		     nil))
    ((25) (uni~unify-list (list (term~read '(f (f y c) x) env)) 
			  (list (term~read '(f z (f b c)) env))))
    ((26) (uni~unify-list
	   (list
	    (term~read
	     '(f (g v0 v0) (f (g v1 v1) (f (g v2 v2) (f (g v3 v3) (f (g v4 v4)
	      (f (g v5 v5) (f (g v6 v6) (f (g v7 v7) (f (g v8 v8) (f (g v9 v9)
	      (g v10 v10))))))))))) env)) 
	   (list
	    (term~read
	     '(f v1 (f v2 (f v3 (f v4 (f v5 (f v6 (f v7 (f v8 (f v9
	      (f v10 v11)))))))))) env))))
    ((27) (uni~unify-list
	   (list (term~read '(f x (f y z)) env)) 
	   (list (term~read '(f a (f a b)) env))))
    ((28) (uni~unify-list (list (term~read 'a env))
			  (list (term~read 'b env))))
    ((29) (uni~unify-list (list (term~read 'x env))
			  (list (term~read 'b env))))
    ((30) (uni~unify-list (list (term~read 'x env))
			  (list (term~read 'y env))))
    ((31) (uni~unify-list (list (term~read '(g a x) env))
			  (list (term~read '(g v b) env))))
    ((32) (uni~unify-list (list (term~read 'x env)
				(term~read 'x env))
			  (list (term~read '(h y) env)
				(term~read '(h a) env))))
    ((33) (uni~unify-list (list (term~read 'x env) (term~read 'x env))
			  (list (term~read 'b env) (term~read '(h a) env))))
    ((34) (uni~unify-list (list (term~read '(h a) env))
			  (list (term~read '(l y) env))))
    ((35) (uni~unify-list (list  (term~read 'y env))
			  (list  (term~read '(h z) env))))
    ((36) (uni~unify-list (list (term~read 'x env)
				(term~read 'x env))
			  (term~copy
			   (list (term~read 'b env)
				 (term~read 'b env)))))
    ((37) (uni~unify-list (list (term~read 'x env)
				(term~read 'x env))
			  (list (term~read '(h a) env)
				(term~read '(h a) env))))
    ((38) (uni~unify-list (list (term~read 'x env)
				(term~read 'x env))
			  (term~copy
			   (list (term~read 'x env)
				 (term~read 'x env)))))
    ((39) (uni~unify-list (list (term~read 'x env)
				(term~read 'y env))
			  (list (term~read 'a env)
				(term~copy (term~read 'a env)))))
    ((40) (uni~unify-list (list (term~read 'x env)
				(term~read 'y env)
				(term~read 'x env))
			  (list (term~read '(h x) env)
				(term~read '(h y) env)
				(term~read 'y env))))
    ((41) (uni~unify-list (list (term~copy (term~read 'x env))
				(term~copy (term~read 'y env))
				(term~copy (term~read 'x env)))
			  (list (term~copy (term~read '(h x) env))
				(term~copy (term~read '(h y) env))
				(term~copy (term~read 'y env)))))
    ((42) (uni~unify-list (list (term~read 'x env)
				(term~read 'x env)
				(term~read 'x env)
				(term~read '(h y) env))
			  (list (term~read 'a env)
				(term~read 'a env)
				(term~read 'b env)
				(term~read '(h z) env))))
    ((43) (uni~unify-list (list (term~read 'x env)
				(term~read 'x env)
				(term~read 'x env))
			  (term~copy (list (term~read 'a env)
					   (term~read 'a env)
					   (term~read 'b env)))))
    ((44) (uni~unify-list (list (term~read '(f x x) env))
			  (list (term~read '(f y a) env))))
    ((45) (uni~unify-list (list (term~read '(f y a) env))
			  (list (term~read '(f x x) env))))
    ((46) (uni~unify-list (list (term~read '(f x x) env))
			  (list (term~read '(f a y) env))))
    ((47) (uni~unify-list (list (term~read '(f a y) env))
			  (list (term~read '(f x x) env))))
    ((48)
     (setf uni*permanent-bindings T)
     (uni~unify-list (list (term~read '(f b y) env))
		     (list (term~read '(f x x) env)))
     (uni~unify-list (list (term~read 'a env))
		     (list (term~read 'x env))))
    ))

(defun free~time-test (key n)
  (let*
      ((problem1 (free=problem-create 1 n))
       (term11 (first problem1))
       (term12 (second problem1))
       (problem2 (free=problem-create 2 n))
       (terms21 (first problem2))
       (terms22 (second problem2))
       (restrs2  (third problem2))
       (problem3 (free=problem-create 3 n))
       (terms31 (first problem3))
       (terms32 (second problem3))
       (restrs3  (third problem3))
       )
  (case key
    ((1) (time (free~unif (list term11) (list term12))))
    ((2) (time (free~decide terms21 terms22 restrs2)))
    ((3) (time (free~decide terms31 terms32 restrs3)))
    )
  nil))

(defun free=problem-create (key n)
  (let ((term1 nil)
	(term2 nil)
	(restr1 nil)
	(var1 (fo~variable-create))
	(var2 (fo~variable-create))
	(const1 (fo~constant-create))
	;(const2 (fo~constant-create))
	(f (fo~function-create (term~read 'f env) 2))
	(g (fo~function-create (term~read 'g env) 2)))
    (case key
      ((1)
       (setf term1 (fo~application-create g (list var2 var2)))
       (setf term2 (fo~application-create f (list var2 var1)))
       (loop for i from 1 to (- n 2) do
	     (let ((var-new (fo~variable-create)))
	       (setf term1 (fo~application-create
			    f
			    (list (fo~application-create
				   g
				   (list var-new var-new))
				  term1)))
	       (setf term2 (fo~application-create f (list var-new term2)))))
       (let ((var-new (fo~variable-create)))
	 (setf term1 (fo~application-create
		      f
		      (list (fo~application-create g (list var-new var-new))
		      term1))))
       (list term1 term2))
      ((2)
       (setf term1 (fo~application-create g (list var2 var2)))
       (setf term2 (fo~application-create f (list var2 var1)))
       (setf restr1 (list var2 var1))
       (loop for i from 1 to (- n 2) do
	     (let ((var-new (fo~variable-create)))
	       (setf term1 (fo~application-create
			    f
			    (list (fo~application-create
				   g
				   (list var-new var-new))
				  term1)))
	       (setf term2 (fo~application-create f (list var-new term2)))
	       (push var-new restr1)
	       ))
       (push const1 restr1)
       (let ((var-new (fo~variable-create)))
	 (setf term1 (fo~application-create
		      f
		      (list (fo~application-create g (list var-new var-new))
			    term1)))
	 (list (list term1 var-new) (list term2 const1) (list restr1))))
      ((3)
       (setf term1 (fo~application-create g (list var2 var2)))
       (setf term2 (fo~application-create f (list var2 var1)))
       (setf restr1 (list var2 var1))
       (loop for i from 1 to (- n 2) do
	     (let ((var-new (fo~variable-create)))
	       (setf term1 (fo~application-create
			    f
			    (list (fo~application-create
				   g
				   (list var-new var-new))
				  term1)))
	       (setf term2 (fo~application-create f (list var-new term2)))
	       (push var-new restr1)
	       ))
       (push const1 restr1)
       (let ((var-new (fo~variable-create)))
	 (setf term1 (fo~application-create
		      f
		      (list (fo~application-create g (list var-new var-new))
			    term1)))
	 (list (list term1 (fo~variable-create))
	       (list term2 const1)
	       (list restr1))))
      )))

		     
#|		   
(uni~unify-list
	   (list
	    (term~read
	     '(f (g v0 v0) (f (g v1 v1) (f (g v2 v2) (f (g v3 v3) (f (g v4 v4)
	      (f (g v5 v5) (f (g v6 v6) (f (g v7 v7) (f (g v8 v8) (f (g v9 v9)
	      (g v10 v10))))))))))) env)) 
	   (list
	    (term~read
	     '(f v1 (f v2 (f v3 (f v4 (f v5 (f v6 (f v7 (f v8 (f v9
	      (f v10 v11)))))))))) env)))

|#
