;;; -*- Package: HADES; Syntax: Common-lisp; Mode: LISP -*-


(in-package 'hades)




(term-reset)
(reset-grouped-array :memory)
(term=cth.reset :loaded)

(term=cth.configure)

(setf ac-ac1*ac nil)

;(do-new.environment
(uds-instantiate 'th-AC.AC1.CONSTRAINTS '(tham1 am-one1)
		 :constants '(a1 a2 a3 a4 b1 b2 b3 b4)
		 :variables '(x x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 y1 y2 y3 y4))
(uds-instantiate 'th-AC.AC1.CONSTRAINTS '(tham2 am-one2))
(uds-instantiate 'th-AC.AC1.CONSTRAINTS '(tham3 am-one3))
(setf f1 (uds-function.create 'f1 1))
(setf f2 (uds-function.create 'f2 2))
(setf f3 (uds-function.create 'f3 3))
(setf v_1 'v_1 v_2 'v_2 v_3 'v_3 v_4 'v_4)

;(time (progn


;;; AC1
;;;;;;;;;

(setf ac-ac1-ac nil)

;AC1.PURE

    
(setf term1 (uds-create '(tham1 x1 x2)))
(setf term2 (uds-create '(tham1 y1 y2)))
(setf multi (list (list term1 term2)))
(test= 1
       (tu.test-unifiers multi) 
       (((x1 (tham1 v_1 v_2)) (x2 (tham1 v_3 v_4)) (y1 (tham1 v_1 v_3)) (y2 (tham1 v_2 v_4))))
       tu.test-subst.test)

(setf term1 (uds-create 'x4))
(setf term2 (uds-create '(tham1 x1 x2)))
(setf multi (list (list x term1) (list x term2)))
(test= 2
       (tu.test-unifiers multi)
       (((x4 (tham1 x1 x2)) (x (tham1 x1 x2))))
       tu.test-subst.test)

(setf term1 (uds-create 'am-one1))
(setf term2 (uds-create 'am-one1))
(setf multi (list (list x term1) (list x term2)))
(test= 3
       (tu.test-unifiers multi)
       (((x am-one1)))
       tu.test-subst.test)

(setf term1 (uds-create 'am-one1))
(setf term2 (uds-create '(tham1 x1 x2)))
(setf multi (list (list x term1) (list x term2)))
(test= 4
       (tu.test-unifiers multi)
       (((x1 am-one1) (x2 am-one1) (x  am-one1)))
       tu.test-subst.test)

(setf term1 (uds-create '(tham1 x1 x2 x3)))
(setf term2 (uds-create '(tham1 x1 x2)))
(setf multi (list (list x term1) (list x term2)))
(test= 5
       (tu.test-unifiers multi)
       (((x3 am-one1) (x (tham1 x1 x2))))
       tu.test-subst.test)

(setf term1 (uds-create '(tham1 x1 x1 x1)))
(setf term2 (uds-create '(tham1 y1 y1 y1 y1)))
(setf multi (list (list x term1) (list x term2)))
(test= 6
       (tu.test-unifiers multi)
       (((x1 (tham1 v_1 v_1 v_1 v_1)) (y1 (tham1 v_1 v_1 v_1))
	 (x (tham1 v_1 v_1 v_1 v_1 v_1 v_1 v_1 v_1 v_1 v_1 v_1 v_1))))
       tu.test-subst.test)

(setf term1 (uds-create '(tham1 x1 x1 x2)))
(setf term2 (uds-create '(tham1 y1 y1 y2 y3)))
(setf multi (list (list x term1) (list x term2)))
(test= 7
       (tu.test-unifiers multi)
        (((X  (THAM1 V_1 V_1 V_2 V_2 V_3 V_3 V_4 V_4 V_5 V_5 V_6 V_7))
	  (X1 (THAM1 V_2 V_3 V_4 V_5)) (X2 (THAM1 V_1 V_1 V_6 V_7))
	  (Y2 (THAM1 V_2 V_2 V_3 V_6)) (Y3 (THAM1 V_3 V_4 V_4 V_7))
	  (Y1 (THAM1 V_1 V_5))))
       tu.test-subst.test)


;AC1.CONST

(setf term1 a1)
(setf term2 (uds-create '(tham1 y1 y1)))
(setf multi (list (list x term1) (list x term2)))
(test= 8
       (tu.test-unifiers multi)
       NIL
       tu.test-subst.test)

(setf term1 a1)
(setf term2 (uds-create '(tham1 x1 x2)))
(setf multi (list (list x term1) (list x term2)))
(test= 9
       (tu.test-unifiers multi)
       (((x1 am-one1) (x2 a1) (x a1))
	((x1 a1) (x2 am-one1) (x a1)))
       tu.test-subst.test)

(setf term1 (uds-create '(tham1 a1 a2 a3)))
(setf term2 (uds-create '(tham1 y1 a1)))
(setf multi (list (list x term1) (list x term2)))
(test= 10
       (tu.test-unifiers multi)
       (((y1 (tham1 a2 a3)) (x (tham1 a1 a2 a3))))
       tu.test-subst.test)

(setf term1 (uds-create '(tham1 a1 (tham1 a2 a3))))
(setf term2 (uds-create '(tham1 a1 (tham1 a3 (tham1 am-one1 a2)))))
(setf multi (list (list term1 term2)))
(test= 11
       (tu.test-unifiers multi)
       (())
       tu.test-subst.test)

(setf term1 (uds-create '(tham1 a1 (tham1 a2 a3))))
(setf term2 (uds-create '(tham1 a1 (tham1 a3 (tham1 am-one1 x1)))))
(setf multi (list (list term1 term2)))
(test= 12
       (tu.test-unifiers multi)
       (((x1 a2)))
       tu.test-subst.test)


;AC1.FREE

(setf term1 (uds-create '(f2 x3 x4)))
(setf term2 (uds-create '(tham1 x1 x2 x2)))
(setf multi (list (list x term1) (list x term2)))
(test= 13
       (tu.test-unifiers multi)
       (((x1 (f2 x3 x4)) (x2 am-one1) (x (f2 x3 x4))))
       tu.test-subst.test)

(setf term1 (uds-create '(tham1 x1 x2 x3)))
(setf term2 (uds-create '(f3 x1 x2 x3)))
(setf multi (list (list x term1) (list x term2)))
(test= 14
       (tu.test-unifiers multi)
       NIL
       tu.test-subst.test)

(setf term1 (uds-create '(tham1 x1 x2 x3)))
(setf term2 (uds-create '(f2 x1 y1)))
(setf multi (list (list x term1) (list x term2)))
(test= 15
       (tu.test-unifiers multi)
       (((x1 am-one1) (x2 (f2 am-one1 y1)) (x3 am-one1) (x (f2 am-one1 y1)))
	((x1 am-one1) (x2 am-one1) (x3 (f2 am-one1 y1)) (x (f2 am-one1 y1))))
       tu.test-subst.test)

(setf multi (list (list (uds-create '(tham1 a1 (tham1 (f2 a1 a2) a3)))
			(uds-create '(tham1 a1 (tham1 a3 (tham1 am-one1 x1)))))))
(test= 16
       (tu.test-unifiers multi)
       (((x1 (f2 a1 a2))))
       tu.test-subst.test)

(setf multi (list (list (uds-create '(tham1 a1 (tham1 (f2 a1 a2) a3)))
			(uds-create '(tham1 a1 (tham1 a3 (tham1 am-one1 (f2 x1 a2))))))))
(test= 17
       (tu.test-unifiers multi)
       (((x1 a1)))
       tu.test-subst.test)
#|
(setf multi (list (list (uds-create '(tham1 y1 y2 (f1 (tham1 y1 y3 (f1 (tham1 y4 y3))))))
			(uds-create '(tham1 x1 x1 (f1 (tham1 x1 x3 (f1 (tham1 x4 x3)))))))))
(test= 18
       (tu.test-unifiers multi)
       5
       tu.test-subst.test)
|#


(setf multi (list (list (uds-create '(f1 (tham1 y1 y3 (f1 (tham1 y4 y3)))))
			(uds-create '(f1 (tham1 x1 x3 (f1 (tham1 x4 x3))))))))
(test= 19
       (tu.test-unifiers multi) 
       4
       tu.test-subst.test)


(setf multi (list (list x (uds-create '(tham1 x1 (f1 x1) x2)))
		  (list x (uds-create '(tham1 y1 (f1 y1) y2)))))
(test= 20
       (tu.test-unifiers multi) 
       (((X (THAM1 v_1 v_3 v_2 v_2 (F1 (THAM1 v_3 v_2))))
	 (X1 (THAM1 v_3 v_2))  (X2 (THAM1 v_1 v_2))
	 (Y1 (THAM1 v_3 v_2))  (Y2 (THAM1 v_1 v_2)))
	((X (THAM1 v_1 v_2 v_3 v_4 (F1 (THAM1 v_2 v_4)) (F1 (THAM1 v_3 v_4))))
	 (X1 (THAM1 v_2 v_4))  (X2 (THAM1 v_1 v_3 (F1 (THAM1 v_3 v_4))))
	 (Y1 (THAM1 v_3 v_4))  (Y2 (THAM1 v_1 v_2 (F1 (THAM1 v_2 v_4)))))
	((X (THAM1 v_1 v_2 v_3 v_4 (F1 (THAM1 v_2 v_4))
		   (F1 (THAM1 v_3 v_4 (F1 (THAM1 v_2 v_4))))))
	 (X1 (THAM1 v_2 v_4))  (X2 (THAM1 v_1 v_3 (F1 (THAM1 v_3 v_4 (F1 (THAM1 v_2 v_4))))))
	 (Y1 (THAM1 v_3 v_4 (F1 (THAM1 v_2 v_4))))  (Y2 (THAM1 v_1 v_2)))
	((X (THAM1 v_1 v_2 v_3 v_4 (F1 (THAM1 v_2 v_4 (F1 (THAM1 v_3 v_4))))
		   (F1 (THAM1 v_3 v_4))))
	 (X1 (THAM1 v_2 v_4 (F1 (THAM1 v_3 v_4)))) (X2 (THAM1 v_1 v_3))
	 (Y1 (THAM1 v_3 v_4)) 
	 (Y2 (THAM1 v_1 v_2 (F1 (THAM1 v_2 v_4 (F1 (THAM1 v_3 v_4))))))))
       tu.test-subst.test)


(setf multi (list (list (uds-create '(tham1 x1 (f2    x1  (f1 x3))))
			(uds-create '(tham1 x2 (f2 (f1 a1)   x2  ))))))
(test= 20.1
       (tu.test-unifiers multi)
       (((x1 (f1 a1)) (x2 (f1 a1)) (x3 a1)))
       tu.test-subst.test)

(setf multi (list (list (uds-create '(tham1 x1 (f1 x4) (f2    x1       (f1 x3))))
			(uds-create '(tham1 x2    x3   (f2 (f1 (f1 a1))   x2  ))))))
(test= 20.2
       (tu.test-unifiers multi)
       (((x1 (f1 (f1 a1))) (x2 (f1 (f1 a1))) (x3 (f1 a1)) (x4 a1))
	((x1 (f1 (f1 a1))) (x2 (f1 (f1 (f1 a1)))) (x3 (f1 (f1 a1))) (x4 (f1 (f1  a1)))))
       tu.test-subst.test)


(setf multi (list (list (uds-create '(tham1 x1 (f1 x1)))
			(uds-create '(tham1 x2 (f1 am-one1))))))
(test= 20.3
       (tu.test-unifiers multi)
       (((x1 am-one1) (x2 am-one1))
	((x1 (tham1 v_1 (f1 am-one1))) (x2 (tham1 v_1 (f1 (tham1 v_1 (f1 am-one1)))))))
       tu.test-subst.test)


(setf multi (list (list (uds-create '(tham1 x1 (f1 x1)))
			(uds-create '(tham1 (f2 y1 y2) (f1 (tham1 y1 (f2 y3 a1))))))))
(test= 20.4
       (tu.test-unifiers multi)
       (((y1 am-one1) (y2 a1) (y3 am-one1) (x1 (f2 am-one1 a1))))
       tu.test-subst.test)


(setf multi (list (list (uds-create '(tham1 x1 (f1 a1)  (f1 (tham1 x2 (f1 a1)))))
			(uds-create '(tham1    (f1 y1)  (f1 (tham1 x2 (f1 a1))))))))
(test= 20.5
       (tu.test-unifiers multi)
       (((x1 am-one1) (y1 a1)))
       tu.test-subst.test)


(setf multi (list (list (uds-create '(tham1 x1 (f1 x1)))
			(uds-create '(tham1 (f1 y1) (f1 (tham1 x2 (f1 a1))))))))
(test= 20.6
       (tu.test-unifiers multi)
       (((x1 (f1 a1)) (x2 am-one1) (y1 a1))
	((x1 (f1 (tham1 x2 (f1 a1)))) (y1 (f1 (tham1 x2 (f1 a1))))))
       tu.test-subst.test)


(setf multi (list (list (uds-create '(tham1 x1 x1 (f1 x2) (f2 (f1 a1) y1)))
			(uds-create '(tham1 y1 y2         (f2 y2 (tham1 (f1 a1) (f1 a1))))))))
(test= 20.7
       (tu.test-unifiers multi)
       (((y1 (tham1 (f1 a1) (f1 a1))) (y2 (f1 a1)) (x1 (f1 a1)) (x2 a1)))
       tu.test-subst.test)



;AC1*.FREE

(setf multi (list (list x (uds-create 'am-one1))
		  (list x (uds-create 'am-one2))))
(test= 21
       (tu.test-unifiers multi)
       NIL
       tu.test-subst.test)

(setf multi (list (list x (uds-create '(tham1 x1 x2 x3)))
		  (list x (uds-create 'am-one2))))
(test= 22
       (tu.test-unifiers multi)
       (((x1 am-one2) (x2 am-one1) (x3 am-one1) (x am-one2))
	((x1 am-one1) (x2 am-one2) (x3 am-one1) (x am-one2))
	((x1 am-one1) (x2 am-one1) (x3 am-one2) (x am-one2)))
       tu.test-subst.test)

(setf multi (list (list y1 (uds-create '(tham1 x1 x2)))
		  (list x1 (uds-create '(tham2 y1 y2)))))
(test= 23
       (tu.test-unifiers multi)
       (((x1 y1) (x2 am-one1) (y2 am-one2))
	((x1 am-one1) (x2 am-one2) (y1 am-one2) (y2 am-one1)))
       tu.test-subst.test "Beide Loesungen kommen doppelt vor.")

(setf multi (list (list x (uds-create '(tham1 x1 x2 x3)))
		  (list x (uds-create '(tham2 x1 x2 x3)))))
(test= 24
       (tu.test-unifiers multi)
       NIL
       tu.test-subst.test)

(setf multi (list (list x (uds-create '(tham1 x1 x2 x3)))
		  (list x (uds-create '(tham2 x1 x2 y3)))))
(test= 25
       (tu.test-unifiers multi)
       (((X1 AM-ONE1) (X2 AM-ONE1) (X3 (THAM2 Y3 AM-ONE1 AM-ONE1)) (X (THAM2 Y3 AM-ONE1 AM-ONE1)))
	((X1 AM-ONE2) (X2 AM-ONE2) (Y3 (THAM1 X3 AM-ONE2 AM-ONE2)) (X (THAM1 X3 AM-ONE2 AM-ONE2))))
       tu.test-subst.test)

(setf multi (list (list (uds-create '(f1 x))
			(uds-create '(tham1 x (f1 (tham1 x x)))))))
(test= 26
       (tu.test-unifiers multi)
       (((x am-one1)))
       tu.test-subst.test)

(setf multi (list (list (uds-create '(f1 (tham1 a1 a2))) (uds-create '(tham1 x1 (tham1 (f1 x2) x2))))
		  (list x1 (uds-create '(tham1 (f1 a1) (f1 a2))))))
(test= 27
       (tu.test-unifiers multi)
       nil
       tu.test-subst.test)


(setf multi (list (list x2 (uds-create '(tham1 x1  x2)))
		  (list x1 (uds-create '(tham1 (f1 y1) y2)) (uds-create '(f1 a1)))))
(test= 28
       (tu.test-unifiers multi)
       nil
       tu.test-subst.test)




;;; AC
;;;;;;;;

(setf ac-ac1-ac t)


;AC.PURE

(setf term1 (uds-create '(tham1 x1 x2)))
(setf term2 (uds-create '(tham1 y1 y2)))
(setf multi (list (list term1 term2)))
(test= 1
       (tu.test-unifiers multi)
       (((x1 y1) (x2 y2))
	((x1 y2) (x2 y1))
	((x1 (tham1 v_1 v_3)) (x2 v_2) (y2 v_1) (y1 (tham1 v_2 v_3)))
	((x1 (tham1 v_1 v_3)) (x2 v_2) (y2 (tham1 v_1 v_2)) (y1 v_3))
	((x1 v_1) (x2 (tham1 v_2 v_3)) (y1 v_2) (y2 (tham1 v_1 v_3)))
	((x1 v_1) (x2 (tham1 v_2 v_3)) (y1 (tham1 v_2 v_1)) (y2 v_3))
	((x1 (tham1 v_1 v_2)) (x2 (tham1 v_3 v_4)) (y1 (tham1 v_3 v_2)) (y2 (tham1 v_1 v_4))))
       tu.test-subst.test)

(setf term1 (uds-create '(tham1 x1 x1)))
(setf term2 (uds-create '(tham1 y1 y1)))
(setf multi (list  (list x term1) (list x term2)))
(test= 2
       (tu.test-unifiers multi)
       (((x (tham1 x1 x1)) (y1 x1)))
       tu.test-subst.test)


;AC.CONST

(setf term1 (uds-create '(tham1 a1 a1)))
(setf term2 (uds-create '(tham1 b1 b1)))
(setf multi (list  (list x term1) (list x term2)))
(test= 3
       (tu.test-unifiers multi)
       NIL
       tu.test-subst.test)

(setf term1 (uds-create '(tham1 a1 a2)))
(setf term2 (uds-create '(tham1 a1 a2)))
(setf multi (list  (list x term1) (list x term2)))
(test= 4
       (tu.test-unifiers multi)
       (((x (tham1 a1 a2))))
       tu.test-subst.test)

(setf term1 (uds-create '(tham1 a1 a2 a3)))
(setf term2 (uds-create '(tham1 a1 a2)))
(setf multi (list  (list x term1) (list x term2)))
(test= 5
       (tu.test-unifiers multi)
       NIL
       tu.test-subst.test)

(setf term1 (uds-create '(tham1 x1 a1 a2)))
(setf term2 (uds-create '(tham1 x1 a1 a2)))
(setf multi (list  (list x term1) (list x term2)))
(test= 6
       (tu.test-unifiers multi)
       (((x (tham1 x1 a1 a2))))
       tu.test-subst.test)

(setf term1 (uds-create '(tham1 a1 a2 a3)))
(setf term2 (uds-create '(tham1 y1 a1)))
(setf multi (list  (list x term1) (list x term2)))
(test= 7
       (tu.test-unifiers multi)
       (((y1 (tham1 a2 a3)) (x (tham1 a1 a2 a3))))
       tu.test-subst.test)


(setf term1 (uds-create '(tham1 a1 (tham1 a2 a3))))
(setf term2 (uds-create '(tham1 y1 a1)))
(setf multi (list (list term1 term2)))
(test= 7.1
       (tu.test-unifiers multi)
       (((y1 (tham1 a2 a3))))
       tu.test-subst.test)

(setf term1 (uds-create '(tham1 x1 a1 a2)))
(setf term2 (uds-create '(tham1 y1 b1 b2 b3)))
(setf multi (list (list x term1) (list x term2)))
(test= 8
       (tu.test-unifiers multi)
       (((x1 (tham1 v_1 b1 b2 b3)) (y1 (tham1 v_1 a1 a2)) (x (tham1 v_1 a1 a2 b1 b2 b3)))
	((x1 (tham1 b1 b2 b3)) (y1 (tham1 a1 a2)) (x (tham1 a1 a2 b1 b2 b3))))
       tu.test-subst.test)

(setf term1 (uds-create '(tham1 x1 a1 a1)))
(setf term2 (uds-create '(tham1 y1 y1 y1 b1)))
(setf multi (list (list x term1) (list x term2)))
(test= 9
       (tu.test-unifiers multi)
       (((X (THAM1 A1 A1 A1 B1)) (X1 (THAM1 A1 B1)) (Y1 A1))
	((X (THAM1 v_1 v_1 v_1 A1 A1 A1 B1)) (X1 (THAM1 v_1 v_1 v_1 A1 B1)) (Y1 (THAM1 v_1 A1))))
       tu.test-subst.test)

(setf term1 (uds-create '(f2 x1 a1)))
(setf term2 (uds-create '(f2 y1 a1)))
(setf multi (list (list term1 term2)))
(test= 10
       (tu.test-unifiers multi)
       (((y1 x1)))
       tu.test-subst.test)

;AC*

(setf term1 (uds-create '(tham2 a1 (tham3 a2 a3))))
(setf term2 (uds-create '(tham2 y1 a1)))
(setf multi (list (list x term1) (list x term2)))
(test= 11
       (tu.test-unifiers multi)
       (((y1 (tham3 a2 a3)) (x (tham2 a1 (tham3 a2 a3)))))
       tu.test-subst.test)

(setf term1 (uds-create '(tham2 x1 (tham3 x1 (tham2 x2 x3)))))
(setf term2 (uds-create '(tham2 y1 y1)))
(setf multi (list (list x term1) (list x term2)))
(test= 12
       (tu.test-unifiers multi)
       NIL
       tu.test-subst.test)

(setf term1 (uds-create '(tham2 x1 a1 (tham3 (tham2 x2 x3) (tham2 x1 a1)))))
(setf term2 (uds-create '(tham2 x1 (tham3 y2 (tham2 x2 x3)))))
(setf multi (list  (list x term1) (list x term2)))
(test= 13
       (tu.test-unifiers multi)
       NIL
       tu.test-subst.test)

(setf term1 (uds-create '(tham2 x1 (tham3 x1 (tham2 x2 x3)))))
(setf term2 (uds-create '(tham2 y1 (tham3 y2 (tham2 x2 x3)))))
(setf multi (list (list x term1) (list x term2)))
(test= 14
       (tu.test-unifiers multi)
       (((x (tham2 y2 (tham3 y2 (tham2 x2 x3)))) (y1 y2) (x1 y2))
	((x (tham2 (tham3 y2 (tham2 x2 x3)) (tham3 y2 (tham2 x2 x3) (tham2 x2 x3))))
	 (x1 (tham3 y2 (tham2 x2 x3)))  (y1 (tham3 y2 (tham2 x2 x3) (tham2 x2 x3))))
	((x (tham2 v_1 (tham3 y2 (tham2 x2 x3)) (tham3 (tham2 x2 x3) (tham2 v_1 (tham3 y2 (tham2 x2 x3))))))
	 (x1 (tham2 v_1 (tham3 y2 (tham2 x2 x3))))
	 (y1 (tham2 v_1 (tham3 (tham2 x2 x3) (tham2 v_1 (tham3 y2 (tham2 x2 x3))))))))
       tu.test-subst.test)


;AC.FREE


(setf multi (list (list (uds-create '(tham1 x1 x2 (f2 x1 a1) (f1 (tham1 x3 a2)) (f1 (tham1 x1 x2))))
			(uds-create '(tham1 a1 a2 (f2 x5 x4) (f1 (tham1 x5 a1)) (f1 (tham1 a1 a2)))))))
(test= 14.1
       (tu.test-unifiers multi)
       (((X1 A2) (X2 A1) (X3 A1) (X4 A1) (X5 A2)))
       tu.test-subst.test "Loesung doppelt")

(setf multi (list (list x2 (uds-create '(tham1 x1  x2)))
		  (list x1 (uds-create '(tham1 (f1 y1) y2)) (uds-create '(f1 a1)))))
(test= 14.2
       (tu.test-unifiers multi)
       nil
       tu.test-subst.test)

(setf term1 (uds-create '(tham1 x1 (f1 (tham1 x1 x2)))))
(setf term2 (uds-create '(tham1 a2 (f1 (tham1 a1 a2)))))
(setf multi (list (list term1 term2)))
(test= 15
       (tu.test-unifiers multi)
       (((x1 a2) (x2 a1)))
       tu.test-subst.test)


(setf multi (list (list (uds-create '(tham1 x1 (f2 (tham1 x1 a2))))
			(uds-create '(tham1 a1 (f2 (tham1 a1 a2)))))))
(test= 16
       (tu.test-unifiers multi)
       (((x1 a1)))
       tu.test-subst.test)


(setf multi (list (list (uds-create '(tham1 x1 (f2 (tham1 x1 a2))))
			(uds-create '(tham1 x1 (f2 (tham1 a1 a2)))))))
(test= 18
       (tu.test-unifiers multi)
       (((x1 a1)))
       tu.test-subst.test)


(setf multi (list (list (uds-create '(tham1 a1 (f2 (tham1 x1 x1))))
			(uds-create '(tham1 x2 (f2 (tham1 x2 a1)))))))
(test= 19
       (tu.test-unifiers multi)
       (((x1 a1) (x2 a1)))
       tu.test-subst.test)


(setf multi (list (list (uds-create '(tham1 (f1 x1) (f2 (tham1 x1 x2))))
			(uds-create '(tham1 (f1 a1) (f2 (tham1 y1 a2)))))))
(test= 20
       (tu.test-unifiers multi)
       (((x1 a1) (x2 a2) (y1 a1)) ((x1 a1) (x2 (tham1 v_1 a2)) (y1 (tham1 v_1 a1))))
       tu.test-subst.test)


(setf multi (list (list (uds-create '(tham1 (f1 x1) (f2 (tham1 x1 x2))))
			(uds-create '(tham1 (f1 a4) (f2 (tham1 a1 a2 a3 a4)))))))
(test= 21
       (tu.test-unifiers multi)
       (((x1 a4) (x2 (tham1 a1 a2 a3))))
       tu.test-subst.test)


(setf multi (list (list (uds-create '(tham1 (f2 (tham1 a1 a3)    x1)         (f1 (tham1 x1 x2))))
			(uds-create '(tham1 (f2 (tham1 y1 y2) (tham1 y1 a2)) (f1 (tham1 a1 a2 a3 a4)))))))
(test= 22
       (tu.test-unifiers multi)
       (((x1 (tham1 a1 a2)) (x2 (tham1 a3 a4)) (y1 a1) (y2 a3))
	((x1 (tham1 a2 a3)) (x2 (tham1 a1 a4)) (y1 a3) (y2 a1)))
       tu.test-subst.test)


(setf multi (list  (list x (uds-create '(tham1 x1 x1 x2 (f2 x1 x3))))
		   (list x (uds-create '(tham1 y1 (f2 b1 b2) (f2 b1 b2))))))
(test= 23
       (tu.test-unifiers multi) 
       (((x1 b1)  (x3 b2)  (x2 (f2 b1 b2))  (y1 (tham1 b1 b1))
	 (x (tham1 b1 b1 (f2 b1 b2) (f2 b1 b2))))
	((x1 b1)  (x3 b2)  (x2 (tham1 v_1 (f2 b1 b2)))  (y1 (tham1 v_1 b1 b1))
	 (x (tham1 v_1 b1 b1 (f2 b1 b2) (f2 b1 b2))))
	((x2 (tham1 (f2 b1 b2) (f2 b1 b2)))  (y1 (tham1 x1 x1 (f2 x1 x3)))
	 (x (tham1 x1 x1 (f2 x1 x3) (f2 b1 b2) (f2 b1 b2))))
	((x2 (tham1 v_1 (f2 b1 b2) (f2 b1 b2)))  (y1 (tham1 x1 x1 v_1 (f2 x1 x3)))
	 (x (tham1 x1 x1 v_1 (f2 x1 x3) (f2 b1 b2) (f2 b1 b2))))
	((x1 (f2 b1 b2))  (y1 (tham1 x2 (f2 (f2 b1 b2) x3)))
	 (x (tham1 x2 (f2 b1 b2) (f2 b1 b2) (f2 (f2 b1 b2) x3))))
	((x1 (tham1 v_1 (f2 b1 b2)))  (y1 (tham1 v_1 v_1 x2 (f2 (tham1 v_1 (f2 b1 b2)) x3)))
	 (x (tham1 v_1 v_1 x2 (f2 b1 b2) (f2 b1 b2) (f2 (tham1 v_1 (f2 b1 b2)) x3)))))
       tu.test-subst.test)


(setf multi (list  (list x (uds-create '(tham1 x1 (f1 x1) x2)))
		   (list x (uds-create '(tham1 y1 (f1 y1) y2)))))
(test= 24 
       (tu.test-unifiers multi) 
       35
       tu.test-subst.test)


(setf multi (list (list (uds-create '(tham1 x1 (f2    x1  (f1 x3))))
			(uds-create '(tham1 x2 (f2 (f1 a1)   x2  ))))))
(test= 25
       (tu.test-unifiers multi)
       (((x1 (f1 a1)) (x2 (f1 a1)) (x3 a1)))
       tu.test-subst.test)

(setf multi (list (list (uds-create '(tham1 x1 (f1 x4) (f2    x1       (f1 x3))))
			(uds-create '(tham1 x2    x3   (f2 (f1 (f1 a1))   x2  ))))))
(test= 26
       (tu.test-unifiers multi)
       (((x1 (f1 (f1 a1))) (x2 (f1 (f1 a1))) (x3 (f1 a1)) (x4 a1))
	((x1 (f1 (f1 a1))) (x2 (f1 (f1 (f1 a1)))) (x3 (f1 (f1 a1))) (x4 (f1 (f1  a1)))))
       tu.test-subst.test)


(setf multi (list (list (uds-create '(tham1 x1 a1 (f1 x1) (f2 x1 x1)))
			(uds-create '(tham1 y1 b1 (f1 b1) (f2 b1 x1))))))
(test= 26.1
       (tu.test-unifiers multi)
       (((x1 b1) (y1 a1)))
       tu.test-subst.test)


(setf multi (list (list (uds-create '(tham1 x1    (f1 x1) (f2 x1 x1)))
			(uds-create '(tham1 y1 b1 (f1 b1) (f2 b1 x1))))))
(test= 26.2
       (tu.test-unifiers multi)
       nil
       tu.test-subst.test)


(setf multi (list (list (uds-create '(tham1 x1    (f1 x1)))
			(uds-create '(tham1 b1 b1 (f1 b1))))))
(test= 26.3
       (tu.test-unifiers multi)
       nil
       tu.test-subst.test)


(setf multi (list (list (uds-create '(tham1 x1 (f1 x1)))
			(uds-create '(tham1 (f2 y1 y2) (f2 y3 y4) (f1 (tham1 x2 (f2 a1 x3))))))))
(test= 28
       (tu.test-unifiers multi)
       (((x1 (tham1 (f2 y1 y2) (f2 a1 x3))) (x2 (f2 y1 y2)) (y3 a1) (y4 x3))
	((x1 (tham1 (f2 y3 y4) (f2 a1 x3))) (x2 (f2 y3 y4)) (y1 a1) (y2 x3)))
       tu.test-subst.test)


(setf multi (list (list (uds-create '(tham1 x1 x1 (f1 x2) (f2 (f1 a1) y1)))
			(uds-create '(tham1 y1 y2         (f2 y2 (tham1 (f1 a1) (f1 a1))))))))
(test= 29
       (tu.test-unifiers multi)
       (((y1 (tham1 (f1 a1) (f1 a1))) (y2 (f1 a1)) (x1 (f1 a1)) (x2 a1)))
       tu.test-subst.test "Loesung doppelt")

(setf multi (list (list (uds-create '(tham1 (f1 (tham1 x1 x2)) (f1 (tham1 x3 x4))))
			(uds-create '(tham1 (f1 (tham1 y1 y2)) (f1 (tham1 y3 y4)))))))
(test= 30
       (tu.test-unifiers multi)
       98
       tu.test-subst.test)


(setf multi (list (list (uds-create '(tham1 x1    (f1 x1)))
			(uds-create '(tham1 a2 a1 (f1 (tham1 y1 y2)))))))
(test= 31
       (tu.test-unifiers multi)
       (((y1 a1) (y2 a2) (x1 (tham1 a1 a2))) ((y1 a2) (y2 a1) (x1 (tham1 a1 a2))))
       tu.test-subst.test)


(setf multi (list (list (uds-create '(tham1 x1 x2   (f1 x1) (f2 a2 x2)))
			(uds-create '(tham1 y1 a2 a1 (f1 y1) (f2 y3 b1))))))
(test= 31
       (tu.test-unifiers multi)
       (((y1 a1) (y2 a2) (x1 (tham1 a1 a2))) ((y1 a2) (y2 a1) (x1 (tham1 a1 a2))))
       tu.test-subst.test)

;))
;)
