;;; -*- Package: HADES; Syntax: Common-lisp; Mode: LISP -*-

;Statistics:
;
;(06-Sep-1991)     29 sec       (38 examples; test-function t)


(in-package 'hades)

(term-reset)
(reset-grouped-array :memory)
(term=cth.reset :loaded)

(term=cth.configure)


;(do-new.environment

(uds-instantiate 'th-abelian.semigroup
		 '(thas1))
(uds-instantiate 'th-abelian.semigroup '(thas2))
(uds-instantiate 'th-abelian.semigroup '(thas3)
		 :constants '(a1 a2 a3 a4 b1 b2 b3 b4)
		 :variables '(x x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 y1 y2 y3 y4))
(setf f1 (uds-function.create 'f1 1))
(setf f2 (uds-function.create 'f2 2))
(setf f3 (uds-function.create 'f3 3))
(setf v_1 'v_1 v_2 'v_2 v_3 'v_3 v_4 'v_4 v_5 'v_5 v_6 'v_6)


;(time (progn


;AC.PURE

(setf term1 (uds-create '(thas1 x1 x2)))
(setf term2 (uds-create '(thas1 y1 y2)))
(setf multi (list (list term1 term2)))
(test= 1
       (tu.test-unifiers multi)
       (((x1 y1) (x2 y2))
	((x1 y2) (x2 y1))
	((x1 (thas1 v_1 v_3)) (x2 v_2) (y2 v_1) (y1 (thas1 v_2 v_3)))
	((x1 (thas1 v_1 v_3)) (x2 v_2) (y2 (thas1 v_1 v_2)) (y1 v_3))
	((x1 v_1) (x2 (thas1 v_2 v_3)) (y1 v_2) (y2 (thas1 v_1 v_3)))
	((x1 v_1) (x2 (thas1 v_2 v_3)) (y1 (thas1 v_2 v_1)) (y2 v_3))
	((x1 (thas1 v_1 v_2)) (x2 (thas1 v_3 v_4)) (y1 (thas1 v_3 v_2)) (y2 (thas1 v_1 v_4))))
       tu.test-subst.test)

(setf term1 (uds-create '(thas1 x1 x1)))
(setf term2 (uds-create '(thas1 y1 y1)))
(setf multi (list  (list x term1) (list x term2)))
(test= 2
       (tu.test-unifiers multi)
       (((x (thas1 x1 x1)) (y1 x1)))
       tu.test-subst.test)

(setf multi (list  (list (uds-create '(thas1 x1 x1 x2))
			 (uds-create '(thas1 y1 y2 y3)))))
(test= 2.1
       (tu.test-unifiers multi)
       381
       tu.test-subst.test)


;AC.CONST

(setf term1 (uds-create '(thas1 a1 a1)))
(setf term2 (uds-create '(thas1 b1 b1)))
(setf multi (list  (list x term1) (list x term2)))
(test= 3
       (tu.test-unifiers multi)
       NIL
       tu.test-subst.test)

(setf term1 (uds-create '(thas1 a1 a2)))
(setf term2 (uds-create '(thas1 a1 a2)))
(setf multi (list  (list x term1) (list x term2)))
(test= 4
       (tu.test-unifiers multi)
       (((x (thas1 a1 a2))))
       tu.test-subst.test)

(setf term1 (uds-create '(thas1 a1 a2 a3)))
(setf term2 (uds-create '(thas1 a1 a2)))
(setf multi (list  (list x term1) (list x term2)))
(test= 5
       (tu.test-unifiers multi)
       NIL
       tu.test-subst.test)

(setf term1 (uds-create '(thas1 x1 a1 a2)))
(setf term2 (uds-create '(thas1 x1 a1 a2)))
(setf multi (list  (list x term1) (list x term2)))
(test= 6
       (tu.test-unifiers multi)
       (((x (thas1 x1 a1 a2))))
       tu.test-subst.test)

(setf term1 (uds-create '(thas1 a1 a2 a3)))
(setf term2 (uds-create '(thas1 y1 a1)))
(setf multi (list  (list x term1) (list x term2)))
(test= 7
       (tu.test-unifiers multi)
       (((y1 (thas1 a2 a3)) (x (thas1 a1 a2 a3))))
       tu.test-subst.test)

(setf term1 (uds-create '(thas1 a1 (thas1 a2 a3))))
(setf term2 (uds-create '(thas1 y1 a1)))
(setf multi (list (list term1 term2)))
(test= 8
       (tu.test-unifiers multi)
       (((y1 (thas1 a2 a3))))
       tu.test-subst.test)

(setf term1 (uds-create '(thas1 x1 a1 a2)))
(setf term2 (uds-create '(thas1 y1 b1 b2 b3)))
(setf multi (list (list x term1) (list x term2)))
(test= 9
       (tu.test-unifiers multi)
       (((x1 (thas1 v_1 b1 b2 b3)) (y1 (thas1 v_1 a1 a2)) (x (thas1 v_1 a1 a2 b1 b2 b3)))
	((x1 (thas1 b1 b2 b3)) (y1 (thas1 a1 a2)) (x (thas1 a1 a2 b1 b2 b3))))
       tu.test-subst.test)

(setf term1 (uds-create '(thas1 x1 a1 a1)))
(setf term2 (uds-create '(thas1 y1 y1 y1 b1)))
(setf multi (list (list x term1) (list x term2)))
(test= 10
       (tu.test-unifiers multi)
       (((X (THAS1 A1 A1 A1 B1)) (X1 (THAS1 A1 B1)) (Y1 A1))
	((X (THAS1 v_1 v_1 v_1 A1 A1 A1 B1)) (X1 (THAS1 v_1 v_1 v_1 A1 B1)) (Y1 (THAS1 v_1 A1))))
       tu.test-subst.test)


;AC.FREE

(setf term1 (uds-create '(f2 x1 a1)))
(setf term2 (uds-create '(f2 y1 a1)))
(setf multi (list (list term1 term2)))
(test= 11
       (tu.test-unifiers multi)
       (((y1 x1)))
       tu.test-subst.test)

(setf term1 (uds-create '(thas1 x1 (f1 (thas1 x1 x2)))))
(setf term2 (uds-create '(thas1 a2 (f1 (thas1 a1 a2)))))
(setf multi (list (list term1 term2)))
(test= 12
       (tu.test-unifiers multi)
       (((x1 a2) (x2 a1)))
       tu.test-subst.test)

(setf multi (list (list (uds-create '(thas1 x1 (f2 (thas1 x1 a2))))
			(uds-create '(thas1 a1 (f2 (thas1 a1 a2)))))))
(test= 13
       (tu.test-unifiers multi)
       (((x1 a1)))
       tu.test-subst.test)

(setf multi (list (list (uds-create '(thas1 x1 (f2 (thas1 x1 a2))))
			(uds-create '(thas1 x1 (f2 (thas1 a1 a2)))))))
(test= 14
       (tu.test-unifiers multi)
       (((x1 a1)))
       tu.test-subst.test)

(setf multi (list (list (uds-create '(thas1 a1 (f2 (thas1 x1 x1))))
			(uds-create '(thas1 x2 (f2 (thas1 x2 a1)))))))
(test= 15
       (tu.test-unifiers multi)
       (((x1 a1) (x2 a1)))
       tu.test-subst.test)

(setf multi (list (list (uds-create '(thas1 (f1 x1) (f2 (thas1 x1 x2))))
			(uds-create '(thas1 (f1 a1) (f2 (thas1 y1 a2)))))))
(test= 16
       (tu.test-unifiers multi)
       (((x1 a1) (x2 a2) (y1 a1)) ((x1 a1) (x2 (thas1 v_1 a2)) (y1 (thas1 v_1 a1))))
       tu.test-subst.test)

(setf multi (list (list (uds-create '(thas1 (f1 x1) (f2 (thas1 x1 x2))))
			(uds-create '(thas1 (f1 a4) (f2 (thas1 a1 a2 a3 a4)))))))
(test= 17
       (tu.test-unifiers multi)
       (((x1 a4) (x2 (thas1 a1 a2 a3))))
       tu.test-subst.test)

(setf multi (list (list (uds-create '(thas1 (f2 (thas1 a1 a3)    x1)         (f1 (thas1 x1 x2))))
			(uds-create '(thas1 (f2 (thas1 y1 y2) (thas1 y1 a2)) (f1 (thas1 a1 a2 a3 a4)))))))
(test= 18
       (tu.test-unifiers multi)
       (((x1 (thas1 a1 a2)) (x2 (thas1 a3 a4)) (y1 a1) (y2 a3))
	((x1 (thas1 a2 a3)) (x2 (thas1 a1 a4)) (y1 a3) (y2 a1)))
       tu.test-subst.test)

(setf multi (list (list (uds-create '(thas1 x1 x2 (f2 x1 a1) (f1 (thas1 x3 a2)) (f1 (thas1 x1 x2))))
			(uds-create '(thas1 a1 a2 (f2 x5 x4) (f1 (thas1 x5 a1)) (f1 (thas1 a1 a2)))))))
(test= 19
       (tu.test-unifiers multi)
       (((X1 A2) (X2 A1) (X3 A1) (X4 A1) (X5 A2)))
       tu.test-subst.test)

(setf multi (list (list x2 (uds-create '(thas1 x1  x2)))
		  (list x1 (uds-create '(thas1 (f1 y1) y2)) (uds-create '(f1 a1)))))
(test= 20
       (tu.test-unifiers multi)
       nil
       tu.test-subst.test)

(setf multi (list  (list x (uds-create '(thas1 x1 x1 x2 (f2 x1 x3))))
		   (list x (uds-create '(thas1 y1 (f2 b1 b2) (f2 b1 b2))))))
(test= 21
       (tu.test-unifiers multi) 
       (((x1 b1)  (x3 b2)  (x2 (f2 b1 b2))  (y1 (thas1 b1 b1))
	 (x (thas1 b1 b1 (f2 b1 b2) (f2 b1 b2))))
	((x1 b1)  (x3 b2)  (x2 (thas1 v_1 (f2 b1 b2)))  (y1 (thas1 v_1 b1 b1))
	 (x (thas1 v_1 b1 b1 (f2 b1 b2) (f2 b1 b2))))
	((x2 (thas1 (f2 b1 b2) (f2 b1 b2)))  (y1 (thas1 x1 x1 (f2 x1 x3)))
	 (x (thas1 x1 x1 (f2 x1 x3) (f2 b1 b2) (f2 b1 b2))))
	((x2 (thas1 v_1 (f2 b1 b2) (f2 b1 b2)))  (y1 (thas1 x1 x1 v_1 (f2 x1 x3)))
	 (x (thas1 x1 x1 v_1 (f2 x1 x3) (f2 b1 b2) (f2 b1 b2))))
	((x1 (f2 b1 b2))  (y1 (thas1 x2 (f2 (f2 b1 b2) x3)))
	 (x (thas1 x2 (f2 b1 b2) (f2 b1 b2) (f2 (f2 b1 b2) x3))))
	((x1 (thas1 v_1 (f2 b1 b2)))  (y1 (thas1 v_1 v_1 x2 (f2 (thas1 v_1 (f2 b1 b2)) x3)))
	 (x (thas1 v_1 v_1 x2 (f2 b1 b2) (f2 b1 b2) (f2 (thas1 v_1 (f2 b1 b2)) x3)))))
       tu.test-subst.test)

#|
 (((X --> (THAS1 B1 B1 (F2 B1 B2) (F2 B1 B2))) (X2 --> (F2 B1 B2)) (X3 --> B2) (X1 --> B1) (Y1 --> (THAS1 B1 B1)))
  ((X --> (THAS1 V-2604 V-2604 (F2 V-2604 X3) (F2 B1 B2) (F2 B1 B2))) (X2 --> (THAS1 (F2 B1 B2) (F2 B1 B2))) (X1 --> V-2604)
   (Y1 --> (THAS1 V-2604 V-2604 (F2 V-2604 X3))))
  ((X --> (THAS1 V-2604 V-2604 V-2778 (F2 V-2604 X3) (F2 B1 B2) (F2 B1 B2))) (X2 --> (THAS1 V-2778 (F2 B1 B2) (F2 B1 B2)))
   (X1 --> V-2604) (Y1 --> (THAS1 V-2604 V-2604 V-2778 (F2 V-2604 X3))))
  ((X --> (THAS1 V-2778 B1 B1 (F2 B1 B2) (F2 B1 B2))) (X2 --> (THAS1 V-2778 (F2 B1 B2))) (X3 --> B2) (X1 --> B1)
   (Y1 --> (THAS1 V-2778 B1 B1)))
  ((X --> (THAS1 V-2604 V-2604 V-2778 (F2 B1 B2) (F2 B1 B2) (F2 (THAS1 V-2604 (F2 B1 B2)) X3))) (X2 --> V-2778)
   (X1 --> (THAS1 V-2604 (F2 B1 B2))) (Y1 --> (THAS1 V-2604 V-2604 V-2778 (F2 (THAS1 V-2604 (F2 B1 B2)) X3))))
  ((X --> (THAS1 V-2778 (F2 B1 B2) (F2 B1 B2) (F2 (F2 B1 B2) X3))) (X2 --> V-2778) (X1 --> (F2 B1 B2))
   (Y1 --> (THAS1 V-2778 (F2 (F2 B1 B2) X3)))))
|#

(setf multi (list  (list x (uds-create '(thas1 x1 (f1 x1) x2)))
		   (list x (uds-create '(thas1 y1 (f1 y1) y2)))))
(test= 22
       (tu.test-unifiers multi) 
       35
       tu.test-subst.test)

(setf multi (list (list (uds-create '(thas1 x1 (f2    x1  (f1 x3))))
			(uds-create '(thas1 x2 (f2 (f1 a1)   x2  ))))))
(test= 23
       (tu.test-unifiers multi)
       (((x1 (f1 a1)) (x2 (f1 a1)) (x3 a1)))
       tu.test-subst.test)

(setf multi (list (list (uds-create '(thas1 x1 (f1 x4) (f2    x1       (f1 x3))))
			(uds-create '(thas1 x2    x3   (f2 (f1 (f1 a1))   x2  ))))))
(test= 24
       (tu.test-unifiers multi)
       (((x1 (f1 (f1 a1))) (x2 (f1 (f1 a1))) (x3 (f1 a1)) (x4 a1))
	((x1 (f1 (f1 a1))) (x2 (f1 (f1 (f1 a1)))) (x3 (f1 (f1 a1))) (x4 (f1 (f1  a1)))))
       tu.test-subst.test)

(setf multi (list (list (uds-create '(thas1 x1 a1 (f1 x1) (f2 x1 x1)))
			(uds-create '(thas1 y1 b1 (f1 b1) (f2 b1 x1))))))
(test= 25
       (tu.test-unifiers multi)
       (((x1 b1) (y1 a1)))
       tu.test-subst.test)

(setf multi (list (list (uds-create '(thas1 x1    (f1 x1) (f2 x1 x1)))
			(uds-create '(thas1 y1 b1 (f1 b1) (f2 b1 x1))))))
(test= 26
       (tu.test-unifiers multi)
       nil
       tu.test-subst.test)

(setf multi (list (list (uds-create '(thas1 x1    (f1 x1)))
			(uds-create '(thas1 b1 b1 (f1 b1))))))
(test= 27
       (tu.test-unifiers multi)
       nil
       tu.test-subst.test)

(setf multi (list (list (uds-create '(thas1 x1 (f1 x1)))
			(uds-create '(thas1 (f2 y1 y2) (f2 y3 y4) (f1 (thas1 x2 (f2 a1 x3))))))))
(test= 28
       (tu.test-unifiers multi)
       (((x1 (thas1 (f2 y1 y2) (f2 a1 x3))) (x2 (f2 y1 y2)) (y3 a1) (y4 x3))
	((x1 (thas1 (f2 y3 y4) (f2 a1 x3))) (x2 (f2 y3 y4)) (y1 a1) (y2 x3)))
       tu.test-subst.test)

(setf multi (list (list (uds-create '(thas1 x1 x1 (f1 x2) (f2 (f1 a1) y1)))
			(uds-create '(thas1 y1 y2         (f2 y2 (thas1 (f1 a1) (f1 a1))))))))
(test= 29
       (tu.test-unifiers multi)
       (((y1 (thas1 (f1 a1) (f1 a1))) (y2 (f1 a1)) (x1 (f1 a1)) (x2 a1)))
       tu.test-subst.test)

(setf multi (list (list (uds-create '(thas1 (f1 (thas1 x1 x2)) (f1 (thas1 x3 x4))))
			(uds-create '(thas1 (f1 (thas1 y1 y2)) (f1 (thas1 y3 y4)))))))
(test= 30
       (tu.test-unifiers multi)
       t
       tu.test-subst.test)

(setf multi (list (list (uds-create '(thas1 x1    (f1 x1)))
			(uds-create '(thas1 a2 a1 (f1 (thas1 y1 y2)))))))
(test= 31
       (tu.test-unifiers multi)
       (((y1 a1) (y2 a2) (x1 (thas1 a1 a2))) ((y1 a2) (y2 a1) (x1 (thas1 a1 a2))))
       tu.test-subst.test)

(setf multi (list (list (uds-create '(thas1 x1 x2   (f1 x1) (f2 a2 x2)))
			(uds-create '(thas1 y1 a2 a1 (f1 y1) (f2 y3 b1))))))
(test= 32
       (tu.test-unifiers multi)
       nil
       tu.test-subst.test)

(setf multi (list (list (uds-create '(thas1 x1 x1))
			(uds-create '(thas1 (f1 a1) (f1 y1))))))
(test= 33
       (tu.test-unifiers multi)
       (((x1 (f1 a1)) (y1 a1)))
       tu.test-subst.test)

(setf multi (list (list (uds-create '(thas1 x1 x1 x2))
			(uds-create '(thas1 (f2 a1 y2) (f2 a1 a2) (f2 y1 a2))))))
(test= 34
       (tu.test-unifiers multi)
       (((x1 (f2 a1 a2)) (x2 (f2 y1 a2)) (y2 a2))
	((x1 (f2 a1 a2)) (x2 (f2 a1 y2)) (y1 a1))
	((x1 (f2 a1 a2)) (x2 (f2 a1 a2)) (y1 a1) (y2 a2)))  ;Diese Loesung Instanz der ersten beiden
       tu.test-subst.test "erste Loesung redundant")


;AC*

(setf term1 (uds-create '(thas2 x1 (thas3 x1 (thas2 x2 x3)))))
(setf term2 (uds-create '(thas2 y1 y1)))
(setf multi (list (list x term1) (list x term2)))
(test= 35
       (tu.test-unifiers multi)
       NIL
       tu.test-subst.test)

(setf term1 (uds-create '(thas2 x1 (thas3 x1 (thas2 x2 x3)))))
(setf term2 (uds-create '(thas2 y1 (thas3 y2 (thas2 x2 x3)))))
(setf multi (list (list x term1) (list x term2)))
(test= 36
       (tu.test-unifiers multi)
       (((x (thas2 y2 (thas3 y2 (thas2 x2 x3)))) (y1 y2) (x1 y2))
	((x (thas2 (thas3 y2 (thas2 x2 x3)) (thas3 y2 (thas2 x2 x3) (thas2 x2 x3))))
	 (x1 (thas3 y2 (thas2 x2 x3)))
	 (y1 (thas3 y2 (thas2 x2 x3) (thas2 x2 x3))))
	((x (thas2 v_1 (thas3 y2 (thas2 x2 x3)) (thas3 (thas2 x2 x3) (thas2 v_1 (thas3 y2 (thas2 x2 x3))))))
	 (x1 (thas2 v_1 (thas3 y2 (thas2 x2 x3))))
	 (y1 (thas2 v_1 (thas3 (thas2 x2 x3) (thas2 v_1 (thas3 y2 (thas2 x2 x3))))))))
       tu.test-subst.test)

#|acab:
(((X (THAS2 V-44821 (THAS3 V-44821 (THAS2 X2 X3))))
  (X1 V-44821) (Y1 V-44821) (Y2 V-44821))
 ((X (THAS2 (THAS3 V-44821 (THAS2 X2 X3)) (THAS3 V-44821 (THAS2 X2 X3) (THAS2 X2 X3))))     ;instanz der ersten
  (X1 (THAS3 V-44821 (THAS2 X2 X3)))
  (Y1 (THAS3 V-44821 (THAS2 X2 X3)))
  (Y2 (THAS3 V-44821 (THAS2 X2 X3))))
 ((X (THAS2 X2 X3 (THAS3 (THAS2 X2 X3) (THAS2 X2 X3))))  ;instanz der ersten
  (X1 (THAS2 X2 X3)) (Y1 (THAS2 X2 X3)) (Y2 (THAS2 X2 X3)))
 ((X (THAS2 (THAS3 Y2 (THAS2 X2 X3)) (THAS3 Y2 (THAS2 X2 X3) (THAS2 X2 X3)))) 
  (X1 (THAS3 Y2 (THAS2 X2 X3)))
  (Y1 (THAS3 Y2 (THAS2 X2 X3) (THAS2 X2 X3))))
 ((X (THAS2 V-44569 (THAS3 Y2 (THAS2 X2 X3)) (THAS3 (THAS2 X2 X3) (THAS2 V-44569 (THAS3 Y2 (THAS2 X2 X3))))))
  (X1 (THAS2 V-44569 (THAS3 Y2 (THAS2 X2 X3))))
  (Y1 (THAS2 V-44569 (THAS3 (THAS2 X2 X3) (THAS2 V-44569 (THAS3 Y2 (THAS2 X2 X3))))))))
|#

;AC*.CONST

(setf term1 (uds-create '(thas2 x1 a1 (thas3 (thas2 x2 x3) (thas2 x1 a1)))))
(setf term2 (uds-create '(thas2 x1 (thas3 y2 (thas2 x2 x3)))))
(setf multi (list  (list x term1) (list x term2)))
(test= 37
       (tu.test-unifiers multi)
       NIL
       tu.test-subst.test)

(setf term1 (uds-create '(thas2 a1 (thas3 a2 a3))))
(setf term2 (uds-create '(thas2 y1 a1)))
(setf multi (list (list x term1) (list x term2)))
(test= 38
       (tu.test-unifiers multi)
       (((y1 (thas3 a2 a3)) (x (thas2 a1 (thas3 a2 a3)))))
       tu.test-subst.test)


;))
;)


#| Sehr lange Rechenzeit:

(setf multi (list (list (uds-create '(thas1 (thas2 x1 x1) (thas2 x1 x2)))
			(uds-create '(thas1 (thas2 y1 y1) (thas2 y1 y2))))))
(test= 100
       (tu.test-unifiers multi)
       ()
       tu.test-subst.test)

;;; Loesungen mit Konstantenabstraktion(31):

 (((Y1 --> X1) (X2 --> V_1) (Y2 --> V_1) (X --> (THAS1 X1 V_1 (F1 X1))))
  ((Y2 --> (THAS1 V-1211 V-5016)) (Y1 --> (THAS1 V-1748 V-5026 (F1 (THAS1 V-5016 V-5026))))
   (X2 --> (THAS1 V-1211 V-1748 (F1 (THAS1 V-1748 V-5026 (F1 (THAS1 V-5016 V-5026)))))) (X1 --> (THAS1 V-5016 V-5026))
   (X --> (THAS1 V-1211 V-1748 V-5016 V-5026 (F1 (THAS1 V-1748 V-5026 (F1 (THAS1 V-5016 V-5026)))) (F1 (THAS1 V-5016 V-5026)))))
  ((Y2 --> (THAS1 V-1211 V-5016 (F1 (THAS1 V-5016 V-5026 (F1 (THAS1 V-1748 V-5026)))))) (Y1 --> (THAS1 V-1748 V-5026))
   (X2 --> (THAS1 V-1211 V-1748)) (X1 --> (THAS1 V-5016 V-5026 (F1 (THAS1 V-1748 V-5026))))
   (X --> (THAS1 V-1211 V-1748 V-5016 V-5026 (F1 (THAS1 V-1748 V-5026)) (F1 (THAS1 V-5016 V-5026 (F1 (THAS1 V-1748 V-5026)))))))
  ((Y2 --> (THAS1 V-1211 V-5016 (F1 (THAS1 V-5016 V-5026)))) (Y1 --> (THAS1 V-1748 V-5026))
   (X2 --> (THAS1 V-1211 V-1748 (F1 (THAS1 V-1748 V-5026)))) (X1 --> (THAS1 V-5016 V-5026))
   (X --> (THAS1 V-1211 V-1748 V-5016 V-5026 (F1 (THAS1 V-1748 V-5026)) (F1 (THAS1 V-5016 V-5026)))))
  ((Y2 --> (THAS1 V-1211 V-5016)) (Y1 --> (THAS1 V-1748 (F1 V-5016))) (X2 --> (THAS1 V-1211 V-1748 (F1 (THAS1 V-1748 (F1 V-5016)))))
   (X1 --> V-5016) (X --> (THAS1 V-1211 V-1748 V-5016 (F1 V-5016) (F1 (THAS1 V-1748 (F1 V-5016))))))
  ((Y2 --> (THAS1 V-1211 V-5016 (F1 (THAS1 V-5016 (F1 V-1748))))) (Y1 --> V-1748) (X2 --> (THAS1 V-1211 V-1748))
   (X1 --> (THAS1 V-5016 (F1 V-1748))) (X --> (THAS1 V-1211 V-1748 V-5016 (F1 V-1748) (F1 (THAS1 V-5016 (F1 V-1748))))))
  ((Y2 --> (THAS1 V-1211 V-5016 (F1 V-5016))) (Y1 --> V-1748) (X2 --> (THAS1 V-1211 V-1748 (F1 V-1748))) (X1 --> V-5016)
   (X --> (THAS1 V-1211 V-1748 V-5016 (F1 V-1748) (F1 V-5016))))
  ((Y2 --> V-1211) (Y1 --> (THAS1 V-1748 V-5026 (F1 V-5026))) (X2 --> (THAS1 V-1211 V-1748 (F1 (THAS1 V-1748 V-5026 (F1 V-5026)))))
   (X1 --> V-5026) (X --> (THAS1 V-1211 V-1748 V-5026 (F1 V-5026) (F1 (THAS1 V-1748 V-5026 (F1 V-5026))))))
  ((Y2 --> (THAS1 V-1211 (F1 (THAS1 V-5026 (F1 (THAS1 V-1748 V-5026)))))) (Y1 --> (THAS1 V-1748 V-5026)) (X2 --> (THAS1 V-1211 V-1748))
   (X1 --> (THAS1 V-5026 (F1 (THAS1 V-1748 V-5026))))
   (X --> (THAS1 V-1211 V-1748 V-5026 (F1 (THAS1 V-1748 V-5026)) (F1 (THAS1 V-5026 (F1 (THAS1 V-1748 V-5026)))))))
  ((Y2 --> (THAS1 V-1211 (F1 V-5026))) (Y1 --> (THAS1 V-1748 V-5026)) (X2 --> (THAS1 V-1211 V-1748 (F1 (THAS1 V-1748 V-5026))))
   (X1 --> V-5026) (X --> (THAS1 V-1211 V-1748 V-5026 (F1 V-5026) (F1 (THAS1 V-1748 V-5026)))))
  ((Y2 --> (THAS1 V-1211 (F1 (F1 V-1748)))) (Y1 --> V-1748) (X2 --> (THAS1 V-1211 V-1748)) (X1 --> (F1 V-1748))
   (X --> (THAS1 V-1211 V-1748 (F1 V-1748) (F1 (F1 V-1748)))))
  ((Y2 --> (THAS1 V-1211 V-5016)) (Y1 --> (THAS1 V-5026 (F1 (THAS1 V-5016 V-5026))))
   (X2 --> (THAS1 V-1211 (F1 (THAS1 V-5026 (F1 (THAS1 V-5016 V-5026)))))) (X1 --> (THAS1 V-5016 V-5026))
   (X --> (THAS1 V-1211 V-5016 V-5026 (F1 (THAS1 V-5016 V-5026)) (F1 (THAS1 V-5026 (F1 (THAS1 V-5016 V-5026)))))))
  ((Y2 --> (THAS1 V-1211 V-5016 (F1 (THAS1 V-5016 V-5026 (F1 V-5026))))) (Y1 --> V-5026) (X2 --> V-1211)
   (X1 --> (THAS1 V-5016 V-5026 (F1 V-5026))) (X --> (THAS1 V-1211 V-5016 V-5026 (F1 V-5026) (F1 (THAS1 V-5016 V-5026 (F1 V-5026))))))
  ((Y2 --> (THAS1 V-1211 V-5016 (F1 (THAS1 V-5016 V-5026)))) (Y1 --> V-5026) (X2 --> (THAS1 V-1211 (F1 V-5026)))
   (X1 --> (THAS1 V-5016 V-5026)) (X --> (THAS1 V-1211 V-5016 V-5026 (F1 V-5026) (F1 (THAS1 V-5016 V-5026)))))
  ((Y2 --> (THAS1 V-1211 V-5016)) (Y1 --> (F1 V-5016)) (X2 --> (THAS1 V-1211 (F1 (F1 V-5016)))) (X1 --> V-5016)
   (X --> (THAS1 V-1211 V-5016 (F1 V-5016) (F1 (F1 V-5016)))))
  ((Y2 --> V-1211) (Y1 --> (THAS1 V-5026 (F1 V-5026))) (X2 --> (THAS1 V-1211 (F1 (THAS1 V-5026 (F1 V-5026))))) (X1 --> V-5026)
   (X --> (THAS1 V-1211 V-5026 (F1 V-5026) (F1 (THAS1 V-5026 (F1 V-5026))))))
  ((Y2 --> (THAS1 V-1211 (F1 (THAS1 V-5026 (F1 V-5026))))) (Y1 --> V-5026) (X2 --> V-1211) (X1 --> (THAS1 V-5026 (F1 V-5026)))
   (X --> (THAS1 V-1211 V-5026 (F1 V-5026) (F1 (THAS1 V-5026 (F1 V-5026))))))
  ((Y2 --> (THAS1 V-1211 (F1 V-5026))) (Y1 --> V-5026) (X2 --> (THAS1 V-1211 (F1 V-5026))) (X1 --> V-5026)
   (X --> (THAS1 V-1211 V-5026 (F1 V-5026) (F1 V-5026))))
  ((Y2 --> V-5016) (Y1 --> (THAS1 V-1748 V-5026 (F1 (THAS1 V-5016 V-5026))))
   (X2 --> (THAS1 V-1748 (F1 (THAS1 V-1748 V-5026 (F1 (THAS1 V-5016 V-5026)))))) (X1 --> (THAS1 V-5016 V-5026))
   (X --> (THAS1 V-1748 V-5016 V-5026 (F1 (THAS1 V-1748 V-5026 (F1 (THAS1 V-5016 V-5026)))) (F1 (THAS1 V-5016 V-5026)))))
  ((Y2 --> (THAS1 V-5016 (F1 (THAS1 V-5016 V-5026 (F1 (THAS1 V-1748 V-5026)))))) (Y1 --> (THAS1 V-1748 V-5026)) (X2 --> V-1748)
   (X1 --> (THAS1 V-5016 V-5026 (F1 (THAS1 V-1748 V-5026))))
   (X --> (THAS1 V-1748 V-5016 V-5026 (F1 (THAS1 V-1748 V-5026)) (F1 (THAS1 V-5016 V-5026 (F1 (THAS1 V-1748 V-5026)))))))
  ((Y2 --> (THAS1 V-5016 (F1 (THAS1 V-5016 V-5026)))) (Y1 --> (THAS1 V-1748 V-5026)) (X2 --> (THAS1 V-1748 (F1 (THAS1 V-1748 V-5026))))
   (X1 --> (THAS1 V-5016 V-5026)) (X --> (THAS1 V-1748 V-5016 V-5026 (F1 (THAS1 V-1748 V-5026)) (F1 (THAS1 V-5016 V-5026)))))
  ((Y2 --> V-5016) (Y1 --> (THAS1 V-1748 (F1 V-5016))) (X2 --> (THAS1 V-1748 (F1 (THAS1 V-1748 (F1 V-5016))))) (X1 --> V-5016)
   (X --> (THAS1 V-1748 V-5016 (F1 V-5016) (F1 (THAS1 V-1748 (F1 V-5016))))))
  ((Y2 --> (THAS1 V-5016 (F1 (THAS1 V-5016 (F1 V-1748))))) (Y1 --> V-1748) (X2 --> V-1748) (X1 --> (THAS1 V-5016 (F1 V-1748)))
   (X --> (THAS1 V-1748 V-5016 (F1 V-1748) (F1 (THAS1 V-5016 (F1 V-1748))))))
  ((Y2 --> (THAS1 V-5016 (F1 V-5016))) (Y1 --> V-1748) (X2 --> (THAS1 V-1748 (F1 V-1748))) (X1 --> V-5016)
   (X --> (THAS1 V-1748 V-5016 (F1 V-1748) (F1 V-5016))))
  ((Y2 --> (F1 (THAS1 V-5026 (F1 (THAS1 V-1748 V-5026))))) (Y1 --> (THAS1 V-1748 V-5026)) (X2 --> V-1748)
   (X1 --> (THAS1 V-5026 (F1 (THAS1 V-1748 V-5026))))
   (X --> (THAS1 V-1748 V-5026 (F1 (THAS1 V-1748 V-5026)) (F1 (THAS1 V-5026 (F1 (THAS1 V-1748 V-5026)))))))
  ((Y2 --> (F1 V-5026)) (Y1 --> (THAS1 V-1748 V-5026)) (X2 --> (THAS1 V-1748 (F1 (THAS1 V-1748 V-5026)))) (X1 --> V-5026)
   (X --> (THAS1 V-1748 V-5026 (F1 V-5026) (F1 (THAS1 V-1748 V-5026)))))
  ((Y2 --> (F1 (F1 V-1748))) (Y1 --> V-1748) (X2 --> V-1748) (X1 --> (F1 V-1748)) (X --> (THAS1 V-1748 (F1 V-1748) (F1 (F1 V-1748)))))
  ((Y2 --> V-5016) (Y1 --> (THAS1 V-5026 (F1 (THAS1 V-5016 V-5026)))) (X2 --> (F1 (THAS1 V-5026 (F1 (THAS1 V-5016 V-5026)))))
   (X1 --> (THAS1 V-5016 V-5026))
   (X --> (THAS1 V-5016 V-5026 (F1 (THAS1 V-5016 V-5026)) (F1 (THAS1 V-5026 (F1 (THAS1 V-5016 V-5026)))))))
  ((Y2 --> (THAS1 V-5016 (F1 (THAS1 V-5016 V-5026)))) (Y1 --> V-5026) (X2 --> (F1 V-5026)) (X1 --> (THAS1 V-5016 V-5026))
   (X --> (THAS1 V-5016 V-5026 (F1 V-5026) (F1 (THAS1 V-5016 V-5026)))))
  ((Y2 --> V-5016) (Y1 --> (F1 V-5016)) (X2 --> (F1 (F1 V-5016))) (X1 --> V-5016) (X --> (THAS1 V-5016 (F1 V-5016) (F1 (F1 V-5016)))))
  ((Y2 --> (F1 V-5026)) (Y1 --> V-5026) (X2 --> (F1 V-5026)) (X1 --> V-5026) (X --> (THAS1 V-5026 (F1 V-5026) (F1 V-5026)))))

;;; Es fehlen :
((Y1 V_2) (Y2 V_2) (X1 V_2) (X2 V_2) (X (THAS1 V_2 V_2 (F1 V_2))))
((Y1 V_2) (Y2 (THAS1 V_2 V_3)) (X1 V_2) (X2 (THAS1 V_2 V_3)) (X (THAS1 V_2 V_2 V_3 (F1 V_2))))
((Y2 (THAS1 V_3 V_5)) (X1 (THAS1 V_4 V_5)) (Y1 (THAS1 V_4 V_5)) (X2 (THAS1 V_3 V_5)) (X (THAS1 V_3 V_4 V_5 V_5 (F1 (THAS1 V_4 V_5)))))
((Y2 V_6) (X1 (THAS1 V_4 V_6)) (Y1 (THAS1 V_4 V_6)) (X2 V_6) (X (THAS1 V_4 V_6 V_6 (F1 (THAS1 V_4 V_6)))))


;;;; Loesungen mit Variablenabstraktion(35):

(((Y1 --> V_1) (Y2 --> (F1 (F1 V_1))) (X1 --> (F1 V_1)) (X2 --> V_1) (X --> (THAS1 V_1 (F1 V_1) (F1 (F1 V_1)))))
  ((Y1 --> V_1) (Y2 --> (THAS1 V_2 (F1 (THAS1 V_2 (F1 V_1))))) (X1 --> (THAS1 V_2 (F1 V_1))) (X2 --> V_1)
   (X --> (THAS1 V_2 V_1 (F1 V_1) (F1 (THAS1 V_2 (F1 V_1))))))
  ((Y1 --> V_2) (Y2 --> V_2) (X1 --> V_2) (X2 --> V_2) (X --> (THAS1 V_2 V_2 (F1 V_2))))
  ((Y1 --> V_1) (Y2 --> (THAS1 V_2 (F1 V_2))) (X1 --> V_2) (X2 --> (THAS1 V_1 (F1 V_1)))
   (X --> (THAS1 V_2 V_1 (F1 V_2) (F1 V_1))))
  ((Y1 --> (THAS1 V_1 (F1 V_2))) (Y2 --> V_2) (X1 --> V_2) (X2 --> (THAS1 V_1 (F1 (THAS1 V_1 (F1 V_2)))))
   (X --> (THAS1 V_2 V_1 (F1 V_2) (F1 (THAS1 V_1 (F1 V_2))))))
  ((Y1 --> (F1 V_2)) (Y2 --> V_2) (X1 --> V_2) (X2 --> (F1 (F1 V_2))) (X --> (THAS1 V_2 (F1 V_2) (F1 (F1 V_2)))))
  ((Y1 --> (F1 V_2)) (Y2 --> (THAS1 V_2 V_3)) (X1 --> V_2) (X2 --> (THAS1 V_3 (F1 (F1 V_2))))
   (X --> (THAS1 V_2 V_3 (F1 V_2) (F1 (F1 V_2)))))
  ((Y1 --> (THAS1 V_1 (F1 V_2))) (Y2 --> (THAS1 V_2 V_3)) (X1 --> V_2)
   (X2 --> (THAS1 V_1 V_3 (F1 (THAS1 V_1 (F1 V_2)))))
   (X --> (THAS1 V_2 V_1 V_3 (F1 V_2) (F1 (THAS1 V_1 (F1 V_2))))))
  ((Y1 --> V_1) (Y2 --> (THAS1 V_2 V_3 (F1 V_2))) (X1 --> V_2) (X2 --> (THAS1 V_1 V_3 (F1 V_1)))
   (X --> (THAS1 V_2 V_1 V_3 (F1 V_2) (F1 V_1))))
  ((Y1 --> V_2) (Y2 --> (THAS1 V_2 V_3)) (X1 --> V_2) (X2 --> (THAS1 V_2 V_3))
   (X --> (THAS1 V_2 V_2 V_3 (F1 V_2))))
  ((Y1 --> V_1) (Y2 --> (THAS1 V_2 V_3 (F1 (THAS1 V_2 (F1 V_1))))) (X1 --> (THAS1 V_2 (F1 V_1)))
   (X2 --> (THAS1 V_1 V_3)) (X --> (THAS1 V_2 V_1 V_3 (F1 V_1) (F1 (THAS1 V_2 (F1 V_1))))))
  ((Y1 --> V_1) (Y2 --> (THAS1 V_3 (F1 (F1 V_1)))) (X1 --> (F1 V_1)) (X2 --> (THAS1 V_1 V_3))
   (X --> (THAS1 V_1 V_3 (F1 V_1) (F1 (F1 V_1)))))
  ((Y1 --> (THAS1 V_1 V_4)) (Y2 --> (THAS1 V_3 (F1 (THAS1 V_4 (F1 (THAS1 V_1 V_4))))))
   (X1 --> (THAS1 V_4 (F1 (THAS1 V_1 V_4)))) (X2 --> (THAS1 V_1 V_3))
   (X --> (THAS1 V_1 V_3 V_4 (F1 (THAS1 V_1 V_4)) (F1 (THAS1 V_4 (F1 (THAS1 V_1 V_4)))))))
  ((Y1 --> (THAS1 V_1 V_4)) (Y2 --> (THAS1 V_2 V_3 (F1 (THAS1 V_2 V_4 (F1 (THAS1 V_1 V_4))))))
   (X1 --> (THAS1 V_2 V_4 (F1 (THAS1 V_1 V_4)))) (X2 --> (THAS1 V_1 V_3))
   (X --> (THAS1 V_2 V_1 V_3 V_4 (F1 (THAS1 V_2 V_4 (F1 (THAS1 V_1 V_4)))) (F1 (THAS1 V_1 V_4)))))
  ((Y2 --> (THAS1 V_3 V_5)) (X1 --> (THAS1 V_4 V_5)) (Y1 --> (THAS1 V_4 V_5)) (X2 --> (THAS1 V_3 V_5))
   (X --> (THAS1 V_3 V_4 V_5 V_5 (F1 (THAS1 V_4 V_5)))))
  ((Y1 --> (THAS1 V_1 V_4)) (Y2 --> (THAS1 V_2 V_3 (F1 (THAS1 V_2 V_4)))) (X1 --> (THAS1 V_2 V_4))
   (X2 --> (THAS1 V_1 V_3 (F1 (THAS1 V_1 V_4))))
   (X --> (THAS1 V_2 V_1 V_3 V_4 (F1 (THAS1 V_2 V_4)) (F1 (THAS1 V_1 V_4)))))
  ((Y1 --> (THAS1 V_1 V_4 (F1 (THAS1 V_2 V_4)))) (Y2 --> (THAS1 V_2 V_3)) (X1 --> (THAS1 V_2 V_4))
   (X2 --> (THAS1 V_1 V_3 (F1 (THAS1 V_1 V_4 (F1 (THAS1 V_2 V_4))))))
   (X --> (THAS1 V_2 V_1 V_3 V_4 (F1 (THAS1 V_2 V_4)) (F1 (THAS1 V_1 V_4 (F1 (THAS1 V_2 V_4)))))))
  ((Y1 --> (THAS1 V_4 (F1 (THAS1 V_2 V_4)))) (Y2 --> (THAS1 V_2 V_3)) (X1 --> (THAS1 V_2 V_4))
   (X2 --> (THAS1 V_3 (F1 (THAS1 V_4 (F1 (THAS1 V_2 V_4))))))
   (X --> (THAS1 V_2 V_3 V_4 (F1 (THAS1 V_2 V_4)) (F1 (THAS1 V_4 (F1 (THAS1 V_2 V_4)))))))
  ((Y1 --> (THAS1 V_4 (F1 (THAS1 V_2 V_4)))) (Y2 --> V_2) (X1 --> (THAS1 V_2 V_4))
   (X2 --> (F1 (THAS1 V_4 (F1 (THAS1 V_2 V_4)))))
   (X --> (THAS1 V_2 V_4 (F1 (THAS1 V_2 V_4)) (F1 (THAS1 V_4 (F1 (THAS1 V_2 V_4)))))))
  ((Y1 --> (THAS1 V_1 V_4 (F1 (THAS1 V_2 V_4)))) (Y2 --> V_2) (X1 --> (THAS1 V_2 V_4))
   (X2 --> (THAS1 V_1 (F1 (THAS1 V_1 V_4 (F1 (THAS1 V_2 V_4))))))
   (X --> (THAS1 V_2 V_1 V_4 (F1 (THAS1 V_2 V_4)) (F1 (THAS1 V_1 V_4 (F1 (THAS1 V_2 V_4)))))))
  ((Y1 --> (THAS1 V_1 V_4)) (Y2 --> (THAS1 V_2 (F1 (THAS1 V_2 V_4)))) (X1 --> (THAS1 V_2 V_4))
   (X2 --> (THAS1 V_1 (F1 (THAS1 V_1 V_4))))
   (X --> (THAS1 V_2 V_1 V_4 (F1 (THAS1 V_2 V_4)) (F1 (THAS1 V_1 V_4)))))
  ((Y2 --> V_6) (X1 --> (THAS1 V_4 V_6)) (Y1 --> (THAS1 V_4 V_6)) (X2 --> V_6)
   (X --> (THAS1 V_4 V_6 V_6 (F1 (THAS1 V_4 V_6)))))
  ((Y1 --> (THAS1 V_1 V_4)) (Y2 --> (THAS1 V_2 (F1 (THAS1 V_2 V_4 (F1 (THAS1 V_1 V_4))))))
   (X1 --> (THAS1 V_2 V_4 (F1 (THAS1 V_1 V_4)))) (X2 --> V_1)
   (X --> (THAS1 V_2 V_1 V_4 (F1 (THAS1 V_2 V_4 (F1 (THAS1 V_1 V_4)))) (F1 (THAS1 V_1 V_4)))))
  ((Y1 --> (THAS1 V_1 V_4)) (Y2 --> (F1 (THAS1 V_4 (F1 (THAS1 V_1 V_4)))))
   (X1 --> (THAS1 V_4 (F1 (THAS1 V_1 V_4)))) (X2 --> V_1)
   (X --> (THAS1 V_1 V_4 (F1 (THAS1 V_1 V_4)) (F1 (THAS1 V_4 (F1 (THAS1 V_1 V_4)))))))
  ((Y1 --> X1) (Y2 --> V_3) (X2 --> V_3) (X --> (THAS1 X1 V_3 (F1 X1))))
  ((Y1 --> V_4) (Y2 --> (THAS1 V_3 (F1 V_4))) (X1 --> V_4) (X2 --> (THAS1 V_3 (F1 V_4)))
   (X --> (THAS1 V_3 V_4 (F1 V_4) (F1 V_4))))
  ((Y1 --> (THAS1 V_4 (F1 V_4))) (Y2 --> V_3) (X1 --> V_4) (X2 --> (THAS1 V_3 (F1 (THAS1 V_4 (F1 V_4)))))
   (X --> (THAS1 V_3 V_4 (F1 V_4) (F1 (THAS1 V_4 (F1 V_4))))))
  ((Y1 --> V_4) (Y2 --> (THAS1 V_3 (F1 (THAS1 V_4 (F1 V_4))))) (X1 --> (THAS1 V_4 (F1 V_4))) (X2 --> V_3)
   (X --> (THAS1 V_3 V_4 (F1 V_4) (F1 (THAS1 V_4 (F1 V_4))))))
  ((Y1 --> (THAS1 V_1 V_4 (F1 V_4))) (Y2 --> V_3) (X1 --> V_4)
   (X2 --> (THAS1 V_1 V_3 (F1 (THAS1 V_1 V_4 (F1 V_4)))))
   (X --> (THAS1 V_1 V_3 V_4 (F1 V_4) (F1 (THAS1 V_1 V_4 (F1 V_4))))))
  ((Y1 --> (THAS1 V_1 V_4)) (Y2 --> (THAS1 V_3 (F1 V_4))) (X1 --> V_4)
   (X2 --> (THAS1 V_1 V_3 (F1 (THAS1 V_1 V_4)))) (X --> (THAS1 V_1 V_3 V_4 (F1 V_4) (F1 (THAS1 V_1 V_4))))
   )
  ((Y1 --> V_4) (Y2 --> (THAS1 V_2 V_3 (F1 (THAS1 V_2 V_4 (F1 V_4))))) (X1 --> (THAS1 V_2 V_4 (F1 V_4)))
   (X2 --> V_3) (X --> (THAS1 V_2 V_3 V_4 (F1 V_4) (F1 (THAS1 V_2 V_4 (F1 V_4))))))
  ((Y1 --> V_4) (Y2 --> (THAS1 V_2 V_3 (F1 (THAS1 V_2 V_4)))) (X1 --> (THAS1 V_2 V_4))
   (X2 --> (THAS1 V_3 (F1 V_4))) (X --> (THAS1 V_2 V_3 V_4 (F1 V_4) (F1 (THAS1 V_2 V_4)))))
  ((Y1 --> V_4) (Y2 --> (THAS1 V_2 (F1 (THAS1 V_2 V_4)))) (X1 --> (THAS1 V_2 V_4)) (X2 --> (F1 V_4))
   (X --> (THAS1 V_2 V_4 (F1 V_4) (F1 (THAS1 V_2 V_4)))))
  ((Y1 --> (THAS1 V_1 V_4)) (Y2 --> (F1 V_4)) (X1 --> V_4) (X2 --> (THAS1 V_1 (F1 (THAS1 V_1 V_4))))
   (X --> (THAS1 V_1 V_4 (F1 V_4) (F1 (THAS1 V_1 V_4)))))
  ((Y1 --> V_4) (Y2 --> (F1 V_4)) (X1 --> V_4) (X2 --> (F1 V_4)) (X --> (THAS1 V_4 (F1 V_4) (F1 V_4)))))

|#

#|
(term-reset)
(reset-grouped-array :memory)
(term=cth.reset :loaded)

(term=cth.configure)

(uds-instantiate 'th-abelian.semigroup
		 '(thas1))
(uds-instantiate 'th-abelian.semigroup '(thas2))
(uds-instantiate 'th-abelian.semigroup '(thas3)
		 :variables '(x1 x2 y1 y2 y3 y4))
(setf v_1 'v_1 v_2 'v_2 v_3 'v_3 v_4 'v_4 v_5 'v_5 v_6 'v_6)

(setf multi (list (list (uds-create '(thas1 (thas2 x1 x1) (thas2 x1 x2)))
			(uds-create '(thas1 (thas2 y1 y1) (thas2 y1 y2))))))
(test= 35
       (tu.test-unifiers multi)
       ()
       tu.test-subst.test)

(setf t1 (uds-create '(thas2 x1 x1))
      t2 (uds-create '(thas2 x1 x2))
      t3 (uds-create '(thas2 y1 y1))
      t4 (uds-create '(thas2 y1 y2)))

(term-names (setf res (uni-substitutions (uni-create.elementary.unification.problem (list t1 t2) (list t3 t4)))))
(term-names (setf res (uni-substitutions (uni-create.elementary.unification.problem (list t2 t1) (list t4 t3)))))

(term-names (setf res (uni-substitutions (uni-create.elementary.unification.problem (list t2 t1) (list t3 t4)))))
(term-names (setf res (uni-substitutions (uni-create.elementary.unification.problem (list t1 t2) (list t4 t3)))))

(term-names (setf res (uni-merge (uni-create.elementary.unification.problem t1 t4)
				 (uni-create.elementary.unification.problem t2 t3))))
|#