;;; -*- Package: HADES; Syntax: Common-lisp; Mode: LISP -*-

;Statistics:
;
;(23-Oct-1990)     46/30/60 sec.   
;(23-Nov-1990)     20 - 22 sec. (Magic)
;(14-Mar-1991)     27 sec.      (Alice , au)
;
;(05-Sep-1991)     41 sec       (53 examples; test-function t)

(in-package 'hades)

(term-reset)
(reset-grouped-array :memory)
(term=cth.reset :loaded)

(term=cth.configure)

;(do-new.environment
(uds-instantiate 'th-abelian.monoid '(tham1 am-one1))
(uds-instantiate 'th-abelian.monoid '(tham2 am-one2)
		 :constants '(a1 a2 a3 a4 b1 b2 b3 b4)
		 :variables '(x x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 y1 y2 y3 y4))
(setf f1 (uds-function.create 'f1 1))
(setf f2 (uds-function.create 'f2 2))
(setf f3 (uds-function.create 'f3 3))
(setf v_1 'v_1 v_2 'v_2 v_3 'v_3 v_4 'v_4 v_5 'v_5 v_6 'v_6 v_7 'v_7 v_8 'v_8 v_9 'v_9 v_10 'v_10
      v_11 'v_11 v_12 'v_12 v_13 'v_13 v_14 'v_14 v_15 'v_15 v_16 'v_16)


;(time (progn

;AC1.PURE

(setf term1 (uds-create '(tham1 x1 x2)))
(setf term2 (uds-create '(tham1 y1 y2)))
(setf multi (list (list term1 term2)))
(test= 1
       (tu.test-unifiers multi) 
       (((x1 (tham1 v_1 v_2)) (x2 (tham1 v_3 v_4)) (y1 (tham1 v_1 v_3)) (y2 (tham1 v_2 v_4))))
       tu.test-subst.test)

(setf term1 (uds-create 'x1))
(setf term2 (uds-create '(tham1 x1 x2)))
(setf multi (list (list x term1) (list x term2)))
(test= 2
       (tu.test-unifiers multi)
       (((x2 am-one1) (x x1)))
       tu.test-subst.test)

(setf term1 (uds-create 'x4))
(setf term2 (uds-create '(tham1 x1 x2)))
(setf multi (list (list x term1) (list x term2)))
(test= 3
       (tu.test-unifiers multi)
       (((x4 (tham1 x1 x2)) (x (tham1 x1 x2))))
       tu.test-subst.test)

(setf term1 (uds-create 'am-one1))
(setf term2 (uds-create 'am-one1))
(setf multi (list (list x term1) (list x term2)))
(test= 4
       (tu.test-unifiers multi)
       (((x am-one1)))
       tu.test-subst.test)

(setf term1 (uds-create 'am-one1))
(setf term2 (uds-create '(tham1 x1 x2)))
(setf multi (list (list x term1) (list x term2)))
(test= 5
       (tu.test-unifiers multi)
       (((x1 am-one1) (x2 am-one1) (x  am-one1)))
       tu.test-subst.test)

(setf term1 (uds-create '(tham1 x1 x2 x3)))
(setf term2 (uds-create '(tham1 x1 x2)))
(setf multi (list (list x term1) (list x term2)))
(test= 6
       (tu.test-unifiers multi)
       (((x3 am-one1) (x (tham1 x1 x2))))
       tu.test-subst.test)

(setf term1 (uds-create '(tham1 x1 x1 x1)))
(setf term2 (uds-create '(tham1 y1 y1 y1 y1)))
(setf multi (list (list x term1) (list x term2)))
(test= 7
       (tu.test-unifiers multi)
       (((x1 (tham1 v_1 v_1 v_1 v_1)) (y1 (tham1 v_1 v_1 v_1))
	 (x (tham1 v_1 v_1 v_1 v_1 v_1 v_1 v_1 v_1 v_1 v_1 v_1 v_1))))
       tu.test-subst.test)

(setf term1 (uds-create '(tham1 x1 x1 x2)))
(setf term2 (uds-create '(tham1 y1 y1 y2 y3)))
(setf multi (list (list x term1) (list x term2)))
(test= 8
       (tu.test-unifiers multi)
        (((X  (THAM1 V_1 V_1 V_2 V_2 V_3 V_3 V_4 V_4 V_5 V_5 V_6 V_7))
	  (X1 (THAM1 V_2 V_3 V_4 V_5)) (X2 (THAM1 V_1 V_1 V_6 V_7))
	  (Y2 (THAM1 V_2 V_2 V_3 V_6)) (Y3 (THAM1 V_3 V_4 V_4 V_7))
	  (Y1 (THAM1 V_1 V_5))))
       tu.test-subst.test)


;AC1.CONST

(setf term1 a1)
(setf term2 (uds-create '(tham1 y1 y1)))
(setf multi (list (list x term1) (list x term2)))
(test= 9
       (tu.test-unifiers multi)
       NIL
       tu.test-subst.test)

(setf term1 a1)
(setf term2 (uds-create '(tham1 x1 x2)))
(setf multi (list (list x term1) (list x term2)))
(test= 10
       (tu.test-unifiers multi)
       (((x1 am-one1) (x2 a1) (x a1))
	((x1 a1) (x2 am-one1) (x a1)))
       tu.test-subst.test)

(setf term1 (uds-create '(tham1 a1 a2 a3)))
(setf term2 (uds-create '(tham1 y1 a1)))
(setf multi (list (list x term1) (list x term2)))
(test= 11
       (tu.test-unifiers multi)
       (((y1 (tham1 a2 a3)) (x (tham1 a1 a2 a3))))
       tu.test-subst.test)

(setf term1 (uds-create '(tham1 a1 (tham1 a2 a3))))
(setf term2 (uds-create '(tham1 a1 (tham1 a3 (tham1 am-one1 a2)))))
(setf multi (list (list term1 term2)))
(test= 12
       (tu.test-unifiers multi)
       (())
       tu.test-subst.test)

(setf term1 (uds-create '(tham1 a1 (tham1 a2 a3))))
(setf term2 (uds-create '(tham1 a1 (tham1 a3 (tham1 am-one1 x1)))))
(setf multi (list (list term1 term2)))
(test= 13
       (tu.test-unifiers multi)
       (((x1 a2)))
       tu.test-subst.test)


;AC1.FREE

(setf term1 (uds-create '(f2 x3 x4)))
(setf term2 (uds-create '(tham1 x1 x2 x2)))
(setf multi (list (list x term1) (list x term2)))
(test= 14
       (tu.test-unifiers multi)
       (((x1 (f2 x3 x4)) (x2 am-one1) (x (f2 x3 x4))))
       tu.test-subst.test)

(setf term1 (uds-create '(tham1 x1 x2 x3)))
(setf term2 (uds-create '(f3 x1 x2 x3)))
(setf multi (list (list x term1) (list x term2)))
(test= 15
       (tu.test-unifiers multi)
       NIL
       tu.test-subst.test)

(setf term1 (uds-create '(tham1 x1 x2 x3)))
(setf term2 (uds-create '(f2 x1 y1)))
(setf multi (list (list x term1) (list x term2)))
(test= 16
       (tu.test-unifiers multi)
       (((x1 am-one1) (x2 (f2 am-one1 y1)) (x3 am-one1) (x (f2 am-one1 y1)))
	((x1 am-one1) (x2 am-one1) (x3 (f2 am-one1 y1)) (x (f2 am-one1 y1))))
       tu.test-subst.test)

(setf multi (list (list (uds-create '(tham1 a1 (tham1 (f2 a1 a2) a3)))
			(uds-create '(tham1 a1 (tham1 a3 (tham1 am-one1 x1)))))))
(test= 17
       (tu.test-unifiers multi)
       (((x1 (f2 a1 a2))))
       tu.test-subst.test)

(setf multi (list (list (uds-create '(tham1 a1 (tham1 (f2 a1 a2) a3)))
			(uds-create '(tham1 a1 (tham1 a3 (tham1 am-one1 (f2 x1 a2))))))))
(test= 18
       (tu.test-unifiers multi)
       (((x1 a1)))
       tu.test-subst.test)

(setf multi (list (list (uds-create '(tham1 y1 y2 (f1 (tham1 y1 y3 (f1 (tham1 y4 y3))))))
			(uds-create '(tham1 x1 x1 (f1 (tham1 x1 x3 (f1 (tham1 x4 x3)))))))))
(test= 19
       (tu.test-unifiers multi)
       9
       tu.test-subst.test)

(setf multi (list (list (uds-create '(f1 (tham1 y1 y3 (f1 (tham1 y4 y3)))))
			(uds-create '(f1 (tham1 x1 x3 (f1 (tham1 x4 x3))))))))
(test= 20
       (tu.test-unifiers multi) 
       4
       tu.test-subst.test)

#|Result:
(((X1 (THAM1 v_5 v_3 v_4)) (Y1 (THAM1 v_5 v_2 v_4))
  (X4 (THAM1 v_1 v_3)) (X3 (THAM1 v_8 v_2 v_4))
  (Y3 (THAM1 v_8 v_3 v_4)) (Y4 (THAM1 v_2 v_1)))
 ((X3 (THAM1 v_6 v_8 (F1 (THAM1 Y4 v_7 v_8)))) (X1 (THAM1 v_5 v_7))
  (Y3 (THAM1 v_7 v_8))
  (Y1 (THAM1 v_5 v_6 (F1 (THAM1 X4 v_6 v_8 (F1 (THAM1 Y4 v_7 v_8)))))))
 ((X1 (THAM1 v_5 v_7 (F1 (THAM1 Y4 v_7 v_8 (F1 (THAM1 X4 v_6 v_8))))))
  (X3 (THAM1 v_6 v_8))
  (Y1 (THAM1 v_5 v_6))
  (Y3 (THAM1 v_7 v_8 (F1 (THAM1 X4 v_6 v_8)))))
 ((X1 (THAM1 v_1 v_2 (F1 (THAM1 Y4 v_2 v_4)))) (X3 (THAM1 v_3 v_4))
  (Y1 (THAM1 v_1 v_3 (F1 (THAM1 X4 v_3 v_4)))) (Y3 (THAM1 v_2 v_4))))
|#


(setf multi (list (list x (uds-create '(tham1 x1 (f1 x1) x2)))
		  (list x (uds-create '(tham1 y1 (f1 y1) y2)))))
(test= 21
       (tu.test-unifiers multi)
       (((X (THAM1 X1 v_1(F1 X1))) (Y1 X1) (X2 v_1) (Y2 v_1))
	((X (THAM1 v_1 v_2 v_3 v_4 (F1 (THAM1 v_1 v_2)) (F1 (THAM1 v_1 v_4 (F1 (THAM1 v_1 v_2))))))
	 (X1 (THAM1 v_1 v_2))  (X2 (THAM1 v_3 v_4 (F1 (THAM1 v_1 v_4 (F1 (THAM1 v_1 v_2))))))
	 (Y2 (THAM1 v_2 v_3))  (Y1 (THAM1 v_1 v_4 (F1 (THAM1 v_1 v_2)))))
	((X (THAM1 v_1 v_2 v_3 v_4 (F1 (THAM1 v_1 v_2 (F1 (THAM1 v_1 v_4)))) (F1 (THAM1 v_1 v_4))))
	 (X2 (THAM1 v_3 v_4)) (X1 (THAM1 v_1 v_2 (F1 (THAM1 v_1 v_4))))
	 (Y1 (THAM1 v_1 v_4)) (Y2 (THAM1 v_2 v_3 (F1 (THAM1 v_1 v_2 (F1 (THAM1 v_1 v_4)))))))
	((X (THAM1 v_1 v_2 v_3 v_4 (F1 (THAM1 v_1 v_2)) (F1 (THAM1 v_1 v_4))))
	 (Y1 (THAM1 v_1 v_4)) (Y2 (THAM1 v_2 v_3 (F1 (THAM1 v_1 v_2))))
	 (X1 (THAM1 v_1 v_2)) (X2 (THAM1 v_3 v_4 (F1 (THAM1 v_1 v_4))))))
       tu.test-subst.test)

#|
((X --> (THAM1 V-28206 x1 (F1 x1) (F1 x1) (F1 (F1 x1))))
 (X1 --> x1)
 (X2 --> (THAM1 V-28206 (F1 x1) (F1 (F1 x1))))
 (Y1 --> (F1 x1))
 (Y2 --> (THAM1 V-28206 x1 (F1 x1))))    ;2

((X --> (THAM1 V-28206 x1 (F1 x1) (F1 (F1 x1))))
 (X1 --> x1)
 (X2 --> (THAM1 V-28206 (F1 (F1 x1))))
 (Y1 --> (F1 x1))
 (Y2 --> (THAM1 V-28206 x1))) ;2

((X --> (THAM1 V-28206 y1 (F1 y1) (F1 y1) (F1 (F1 y1))))
 (X1 --> (F1 y1))
 (X2 --> (THAM1 V-28206 y1 (F1 y1)))
 (Y1 --> y1)
 (Y2 --> (THAM1 V-28206 (F1 y1) (F1 (F1 y1))))) ;2

((X --> (THAM1 V-28206 y1 (F1 y1) (F1 (F1 y1))))
 (X1 --> (F1 y1))
 (X2 --> (THAM1 V-28206 y1))
 (Y1 --> y1)
 (Y2 --> (THAM1 V-28206 (F1 (F1 y1))))) ;2

((X --> (THAM1 V-28206 x1 x1 (F1 x1) (F1 x1)))
 (X1 --> x1)
 (X2 --> (THAM1 V-28206 x1 (F1 x1)))
 (Y1 --> x1)
 (Y2 --> (THAM1 V-28206 x1 (F1 x1))))

((X --> (THAM1 V-28206 x1 x1 (F1 x1)))
 (X1 --> x1)
 (X2 --> (THAM1 V-28206 x1))
 (Y1 --> x1)
 (Y2 --> (THAM1 V-28206 x1)))

((X --> (THAM1 V-28206 x1 (F1 x1) (F1 x1)))
 (X1 --> x1)
 (X2 --> (THAM1 V-28206 (F1 x1)))
 (Y1 --> x1)
 (Y2 --> (THAM1 V-28206 (F1 x1))))

((X --> (THAM1 V-28206 x1 (F1 x1)))
 (X1 --> x1)
 (X2 --> V-28206)
 (Y1 --> x1)
 (Y2 --> V-28206))

((X --> (THAM1 V-27706 V-27706 V-28206 V-28246 (F1 (THAM1 V-27706 V-28246)) (F1 (THAM1 V-27706 V-28246))))
 (X1 --> (THAM1 V-27706 V-28246))
 (X2 --> (THAM1 V-27706 V-28206 (F1 (THAM1 V-27706 V-28246))))
 (Y1 --> (THAM1 V-27706 V-28246))
 (Y2 --> (THAM1 V-27706 V-28206 (F1 (THAM1 V-27706 V-28246)))))

((X --> (THAM1 V-27706 V-27706 V-28206 V-28246 (F1 (THAM1 V-27706 V-28246))))
 (X1 --> (THAM1 V-27706 V-28246))
 (X2 --> (THAM1 V-27706 V-28206))
 (Y1 --> (THAM1 V-27706 V-28246))
 (Y2 --> (THAM1 V-27706 V-28206)))

((X --> (F1 AM-ONE1)) (X1 --> AM-ONE1) (X2 --> AM-ONE1) (Y1 --> AM-ONE1) (Y2 --> AM-ONE1))

((X --> (THAM1 V-28206 y1 x1 (F1 y1) (F1 x1)))
 (X1 --> x1) 
 (X2 --> (THAM1 V-28206 y1 (F1 y1)))
 (Y1 --> y1)
 (Y2 --> (THAM1 V-28206 x1 (F1 x1)))) ;3

((X --> (THAM1 V-28206 V-28236 x1 (F1 x1) (F1 (THAM1 V-28236 x1))))
 (Y1 --> (THAM1 V-28236 x1))
 (Y2 --> (THAM1 V-28206 (F1 x1)))
 (X1 --> x1)
 (X2 --> (THAM1 V-28206 V-28236 (F1 (THAM1 V-28236 x1)))))

((X --> (THAM1 V-28206 V-28236 x1 (F1 x1) (F1 (THAM1 V-28236 (F1 x1)))))
 (Y1 --> (THAM1 V-28236 (F1 x1)))
 (Y2 --> (THAM1 V-28206 x1))
 (X1 --> x1)
 (X2 --> (THAM1 V-28206 V-28236 (F1 (THAM1 V-28236 (F1 x1))))))

((X --> (THAM1 Y2 V-28236 x1 (F1 x1) (F1 (THAM1 V-28236 x1 (F1 x1)))))
 (Y1 --> (THAM1 V-28236 x1 (F1 x1)))
 (Y2 --> Y2)
 (X1 --> x1)
 (X2 --> (THAM1 Y2 V-28236 (F1 (THAM1 V-28236 x1 (F1 x1))))))

((X --> (THAM1 V-28206 x1 y1 (F1 x1) (F1 y1)))
 (Y1 --> y1)
 (Y2 --> (THAM1 V-28206 x1 (F1 x1)))
 (X1 --> x1)
 (X2 --> (THAM1 V-28206 y1 (F1 y1)))) ;weg

((X --> (THAM1 V-28206 V-28216 y1 (F1 y1) (F1 (THAM1 V-28216 y1))))
 (Y1 --> y1)
 (Y2 --> (THAM1 V-28206 V-28216 (F1 (THAM1 V-28216 y1))))
 (X1 --> (THAM1 V-28216 y1))
 (X2 --> (THAM1 V-28206 (F1 y1))))

((X --> (THAM1 V-28206 V-28216 y1 (F1 y1) (F1 (THAM1 V-28216 (F1 y1)))))
 (Y1 --> y1)
 (Y2 --> (THAM1 V-28206 V-28216 (F1 (THAM1 V-28216 (F1 y1)))))
 (X1 --> (THAM1 V-28216 (F1 y1)))
 (X2 --> (THAM1 V-28206 y1)))

((X --> (THAM1 x2 V-28216 y1 (F1 y1) (F1 (THAM1 V-28216 y1 (F1 y1)))))
 (Y1 --> y1)
 (Y2 --> (THAM1 x2 V-28216 (F1 (THAM1 V-28216 y1 (F1 y1)))))
 (X1 --> (THAM1 V-28216 y1 (F1 y1)))
 (X2 --> x2))
|#
#|


(((X --> (THAM1 |v_60893| |v_60892| |v_60890| |v_60889| (F1 (THAM1 |v_60892| |v_60889| (F1 (THAM1 |v_60890| |v_60889|))))
		(F1 (THAM1 |v_60890| |v_60889|))))
  (X1 --> (THAM1 |v_60892| |v_60889| (F1 (THAM1 |v_60890| |v_60889|))))
  (Y1 --> (THAM1 |v_60890| |v_60889|))
  (X2 --> (THAM1 |v_60893| |v_60890|))
  (Y2 --> (THAM1 |v_60893| |v_60892| (F1 (THAM1 |v_60892| |v_60889| (F1 (THAM1 |v_60890| |v_60889|)))))))

 ((X --> (THAM1 |v_60893| |v_60902| |v_60902| |v_60889| (F1 (THAM1 |v_60902| |v_60889|))))
  (X1 --> (THAM1 |v_60902| |v_60889|))
  (X2 --> (THAM1 |v_60893| |v_60902|))
  (Y1 --> (THAM1 |v_60902| |v_60889|))
  (Y2 --> (THAM1 |v_60893| |v_60902|)))
 ((X --> (THAM1 |v_60893| |v_60892| |v_60890| |v_60889| (F1 (THAM1 |v_60892| |v_60889|)) (F1 (THAM1 |v_60890| |v_60889|))))
  (X1 --> (THAM1 |v_60892| |v_60889|))
  (X2 --> (THAM1 |v_60893| |v_60890| (F1 (THAM1 |v_60890| |v_60889|))))
  (Y1 --> (THAM1 |v_60890| |v_60889|))
  (Y2 --> (THAM1 |v_60893| |v_60892| (F1 (THAM1 |v_60892| |v_60889|)))))
 ((X --> (THAM1 |v_60893| |v_60892| |v_60890| |v_60889| (F1 (THAM1 |v_60892| |v_60889|))
		(F1 (THAM1 |v_60890| |v_60889| (F1 (THAM1 |v_60892| |v_60889|))))))
  (X1 --> (THAM1 |v_60892| |v_60889|))
  (X2 --> (THAM1 |v_60893| |v_60890| (F1 (THAM1 |v_60890| |v_60889| (F1 (THAM1 |v_60892| |v_60889|))))))
  (Y1 --> (THAM1 |v_60890| |v_60889| (F1 (THAM1 |v_60892| |v_60889|))))
  (Y2 --> (THAM1 |v_60893| |v_60892|))))

(((X --> (THAM1 |v_8165| |v_8174| |v_8174| |v_8161| (F1 (THAM1 |v_8174| |v_8161|))))
  (X1 --> (THAM1 |v_8174| |v_8161|))
  (X2 --> (THAM1 |v_8165| |v_8174|))
  (Y1 --> (THAM1 |v_8174| |v_8161|))
  (Y2 --> (THAM1 |v_8165| |v_8174|)))
 ((X --> (THAM1 |v_8165| |v_8164| |v_8162| |v_8161| (F1 (THAM1 |v_8164| |v_8161|)) (F1 (THAM1 |v_8162| |v_8161|))))
  (X1 --> (THAM1 |v_8164| |v_8161|))
  (X2 --> (THAM1 |v_8165| |v_8162| (F1 (THAM1 |v_8162| |v_8161|))))
  (Y1 --> (THAM1 |v_8162| |v_8161|))
  (Y2 --> (THAM1 |v_8165| |v_8164| (F1 (THAM1 |v_8164| |v_8161|)))))
 ((X --> (THAM1 |v_8165| |v_8164| |v_8162| |v_8161| (F1 (THAM1 |v_8164| |v_8161|))
		(F1 (THAM1 |v_8162| |v_8161| (F1 (THAM1 |v_8164| |v_8161|))))))
  (X1 --> (THAM1 |v_8164| |v_8161|))
  (X2 --> (THAM1 |v_8165| |v_8162| (F1 (THAM1 |v_8162| |v_8161| (F1 (THAM1 |v_8164| |v_8161|))))))
  (Y1 --> (THAM1 |v_8162| |v_8161| (F1 (THAM1 |v_8164| |v_8161|))))
  (Y2 --> (THAM1 |v_8165| |v_8164|)))

 ((X --> (THAM1 |v_8165| |v_8164| |v_8162| |v_8161| (F1 (THAM1 |v_8164| |v_8161| (F1 (THAM1 |v_8162| |v_8161|))))
		(F1 (THAM1 |v_8162| |v_8161|))))
  (X1 --> (THAM1 |v_8164| |v_8161| (F1 (THAM1 |v_8162| |v_8161|))))
  (X2 --> (THAM1 |v_8165| |v_8162|))
  (Y1 --> (THAM1 |v_8162| |v_8161|))
  (Y2 --> (THAM1 |v_8165| |v_8164| (F1 (THAM1 |v_8164| |v_8161| (F1 (THAM1 |v_8162| |v_8161|))))))))
|#

()
(setf multi (list (list (uds-create '(tham1 x1 (f2    x1  (f1 x3))))
			(uds-create '(tham1 x2 (f2 (f1 a1)   x2  ))))))
(test= 22
       (tu.test-unifiers multi)
       (((x1 (f1 a1)) (x2 (f1 a1)) (x3 a1)))
       tu.test-subst.test)

(setf multi (list (list (uds-create '(tham1 x1 (f1 x4) (f2    x1       (f1 x3))))
			(uds-create '(tham1 x2    x3   (f2 (f1 (f1 a1))   x2  ))))))
(test= 23
       (tu.test-unifiers multi)
       (((x1 (f1 (f1 a1))) (x2 (f1 (f1 a1))) (x3 (f1 a1)) (x4 a1))
	((x1 (f1 (f1 a1))) (x2 (f1 (f1 (f1 a1)))) (x3 (f1 (f1 a1))) (x4 (f1 (f1  a1)))))
       tu.test-subst.test)


(setf multi (list (list (uds-create '(tham1 x1 (f1 x1)))
			(uds-create '(tham1 x2 (f1 am-one1))))))
(test= 24
       (tu.test-unifiers multi)
       (((x1 am-one1) (x2 am-one1))
	((x1 (tham1 v_1 (f1 am-one1))) (x2 (tham1 v_1 (f1 (tham1 v_1 (f1 am-one1)))))))
       tu.test-subst.test)


(setf multi (list (list (uds-create '(tham1 x1 (f1 x1)))
			(uds-create '(tham1 (f2 y1 y2) (f1 (tham1 y1 (f2 y3 a1))))))))
(test= 25
       (tu.test-unifiers multi)
       (((y1 am-one1) (y2 a1) (y3 am-one1) (x1 (f2 am-one1 a1))))
       tu.test-subst.test)


(setf multi (list (list (uds-create '(tham1 x1 (f1 a1)  (f1 (tham1 x2 (f1 a1)))))
			(uds-create '(tham1    (f1 y1)  (f1 (tham1 x2 (f1 a1))))))))
(test= 26
       (tu.test-unifiers multi)
       (((x1 am-one1) (y1 a1)))
       tu.test-subst.test)


(setf multi (list (list (uds-create '(tham1 x1 (f1 x1)))
			(uds-create '(tham1 (f1 y1) (f1 (tham1 x2 (f1 a1))))))))
(test= 27
       (tu.test-unifiers multi)
       (((x1 (f1 a1)) (x2 am-one1) (y1 a1))
	((x1 (f1 (tham1 x2 (f1 a1)))) (y1 (f1 (tham1 x2 (f1 a1))))))
       tu.test-subst.test)


(setf multi (list (list (uds-create '(tham1 x1 x1 (f1 x2) (f2 (f1 a1) y1)))
			(uds-create '(tham1 y1 y2         (f2 y2 (tham1 (f1 a1) (f1 a1))))))))
(test= 28
       (tu.test-unifiers multi)
       (((y1 (tham1 (f1 a1) (f1 a1))) (y2 (f1 a1)) (x1 (f1 a1)) (x2 a1)))
       tu.test-subst.test)


(setf multi (list (list (uds-create '(tham1 x1 x1))
			(uds-create '(tham1 (f1 a1) (f1 y1))))))
(test= 29
       (tu.test-unifiers multi)
       (((x1 (f1 a1)) (y1 a1)))
       tu.test-subst.test)

(setf multi (list (list (uds-create '(tham1 x1 x1 x2))
			(uds-create '(tham1 (f2 a1 y2) (f2 a1 a2) (f2 y1 a2))))))
(test= 30
       (tu.test-unifiers multi)
       (((x1 (f2 a1 a2)) (x2 (f2 y1 a2)) (y2 a2))
	((x1 (f2 a1 a2)) (x2 (f2 a1 y2)) (y1 a1))
	((x1 am-one1) (x2 (tham1 (f2 y1 a2) (f2 a1 y2) (f2 a1 a2))))   ;die folgenden Loesungen sind redundant:
	((X1 (F2 A1 A2)) (X2 (F2 A1 A2)) (Y2 A2) (Y1 A1))
	((X1 AM-ONE1) (X2 (THAM1 (F2 A1 Y2) (F2 A1 A2) (F2 A1 A2))) (Y1 A1))
	((X1 AM-ONE1) (X2 (THAM1 (F2 Y1 A2) (F2 A1 A2) (F2 A1 A2))) (Y2 A2))
	((X1 AM-ONE1) (X2 (THAM1 (F2 A1 A2) (F2 A1 A2) (F2 A1 A2))) (Y2 A2) (Y1 A1)))
       tu.test-subst.test "redundante Loesungen")


(setf multi (list (list (uds-create '(tham1 (f1 x1) (f2 (tham1 x1 x2))))
			(uds-create '(tham1 (f1 a1) (f2 (tham1 y1 a2)))))))
(test= 31
       (tu.test-unifiers multi)
       (((x1 a1) (x2 (tham1 v_1 a2)) (y1 (tham1 v_1 a1))))
       tu.test-subst.test)


(setf multi (list (list (uds-create '(tham1 (f1 (tham1 x1 x2)) (f1 (tham1 x3 x4))))
			(uds-create '(tham1 (f1 (tham1 y1 y2)) (f1 (tham1 y3 y4)))))))
(test= 32
       (tu.test-unifiers multi)
       (((X3 (THAM1 V_3 V_4)) (X4 (THAM1 V_1 V_2)) (Y1 (THAM1 V_1 V_3)) (Y2 (THAM1 V_2 V_4))
	 (Y4 (THAM1 V_6 V_8)) (Y3 (THAM1 V_5 V_7)) (X2 (THAM1 V_7 V_8)) (X1 (THAM1 V_5 V_6)))
	((X1 (THAM1 V_1 V_2)) (X2 (THAM1 V_3 V_4)) (Y1 (THAM1 V_1 V_3)) (Y2 (THAM1 V_2 V_4))
	 (X3 (THAM1 V_5 V_6)) (X4 (THAM1 V_7 V_8)) (Y3 (THAM1 V_5 V_7)) (Y4 (THAM1 V_6 V_8)))
	((Y1 (THAM1 V_1 V_2 V_5 V_6 V_9 V_10 V_13 V_14))      ;diese Loesung redundant
	 (Y2 (THAM1 V_3 V_4 V_7 V_8 V_11 V_12 V_15 V_16))
	 (X4 (THAM1 V_5 V_6 V_7 V_8 V_13 V_14 V_15 V_16))
	 (X3 (THAM1 V_1 V_2 V_3 V_4 V_9 V_10 V_11 V_12))
	 (X2 (THAM1 V_9 V_10 V_11 V_12 V_13 V_14 V_15 V_16))
	 (X1 (THAM1 V_1 V_2 V_3 V_4 V_5 V_6 V_7 V_8))
	 (Y4 (THAM1 V_2 V_4 V_6 V_8 V_10 V_12 V_14 V_16))
	 (Y3 (THAM1 V_1 V_3 V_5 V_7 V_9 V_11 V_13 V_15))))
       tu.test-subst.test "dritte Loesung Instanz der ersten beiden")


(setf multi (list (list (uds-create '(f1 x))
			(uds-create '(tham1 x (f1 (tham1 x x)))))))
(test= 33
       (tu.test-unifiers multi)
       (((x am-one1)))
       tu.test-subst.test)

(setf multi (list (list (uds-create '(f1 (tham1 a1 a2))) (uds-create '(tham1 x1 (tham1 (f1 x2) x2))))
		  (list x1 (uds-create '(tham1 (f1 a1) (f1 a2))))))
(test= 34
       (tu.test-unifiers multi)
       nil
       tu.test-subst.test)


(setf multi (list (list x2 (uds-create '(tham1 x1  x2)))
		  (list x1 (uds-create '(tham1 (f1 y1) y2)) (uds-create '(f1 a1)))))
(test= 35
       (tu.test-unifiers multi)
       nil
       tu.test-subst.test)


;;; AC1*


(setf multi (list (list x (uds-create 'am-one1))
		  (list x (uds-create 'am-one2))))
(test= 36
       (tu.test-unifiers multi)
       NIL
       tu.test-subst.test)

(setf multi (list (list x (uds-create '(tham1 x1 x2 x3)))
		  (list x (uds-create 'am-one2))))
(test= 37
       (tu.test-unifiers multi)
       (((x1 am-one2) (x2 am-one1) (x3 am-one1) (x am-one2))
	((x1 am-one1) (x2 am-one2) (x3 am-one1) (x am-one2))
	((x1 am-one1) (x2 am-one1) (x3 am-one2) (x am-one2)))
       tu.test-subst.test)

(setf multi (list (list (uds-create '(tham1 x1 x2))
			(uds-create '(tham2 y1 y2)))))
(test= 38
       (tu.test-unifiers multi)
       (((x1 am-one1) (x2 (tham2 y1 y2)))
	((x2 am-one1) (x1 (tham2 y1 y2)))
	((y1 am-one2) (y2 (tham1 x1 x2)))
	((y2 am-one2) (y1 (tham1 x1 x2))))
       tu.test-subst.test)

(setf multi (list (list y1 (uds-create '(tham1 x1 x2)))
		  (list x1 (uds-create '(tham2 y1 y2)))))
(test= 39
       (tu.test-unifiers multi)
       (((x1 y1) (x2 am-one1) (y2 am-one2))       ;beide Loesungen doppelt
	((x1 y1) (x2 am-one1) (y2 am-one2))
	((x1 am-one1) (x2 am-one2) (y1 am-one2) (y2 am-one1))
	((x1 am-one1) (x2 am-one2) (y1 am-one2) (y2 am-one1)))
       tu.test-subst.test)

(setf multi (list (list x1 (uds-create '(tham2 (tham1 x1 x2) y2)))))
(test= 40
       (tu.test-unifiers multi)
       (((x2 am-one1) (y2 am-one2))     ;beide Loesungen doppelt
	((x2 am-one1) (y2 am-one2) (x1 v_1))
	((x1 am-one1) (x2 am-one2) (y2 am-one1))
	((x1 am-one1) (x2 am-one2) (y2 am-one1)))
       tu.test-subst.test "Beide Loesungen kommen doppelt vor.")

(setf multi (list (list x1 (uds-create '(tham1 (tham2 x1 x2) (tham2 x3 x4))))))
(test= 41
       (tu.test-unifiers multi)
       (((x2 am-one2) (x3 am-one2) (x4 am-one1))
	((x2 am-one2) (x3 am-one1) (x4 am-one2))
	((x1 am-one2) (x2 am-one1)  (x3 am-one2) (x4 am-one2))   ;die folgenden Losungen sind redundant:
	((X1 AM-ONE2) (X2 AM-ONE1) (X3 AM-ONE2) (X4 AM-ONE2))
	((X2 AM-ONE2) (X3 AM-ONE1) (X4 AM-ONE2) (X1 v_1))
	((X2 AM-ONE2) (X3 AM-ONE2) (X4 AM-ONE1) (X1 v_1)))
       tu.test-subst.test "Loesungen doppelt")

(setf multi (list (list  (uds-create '(tham1 x1 x1))
			 (uds-create '(tham1 y1 (tham2 y1 y2))))))
(test= 42
       (tu.test-unifiers multi)
       (((x1 (tham1 v_1 am-one2)) (y1 am-one2) (y2 (tham1 v_1 v_1 am-one2)))
	((x1 y1) (y2 am-one2))     ;die folgenden Loesungen sind Instanzen der zweiten Loesung:
	((Y2 AM-ONE2) (X1 V_1) (Y1 V_1))
	((Y2 AM-ONE2) (X1 (THAM1 V_1 V_1 V_2)) (Y1 (THAM1 V_1 V_1 V_2))))
       tu.test-subst.test "erste, dritte und vierte Loesung gleich")

(setf multi (list (list  (uds-create '(tham1 x1 x2))
			 (uds-create '(tham1 y1 (tham2 y2 (tham1 y3 y4)))))))
(test= 43
       (tu.test-unifiers multi)
       (((X2  (THAM1 V_1 V_2)) (X1  (THAM1 V_3 V_4))
	 (Y1  (THAM1 V_2 V_4)) (Y2  (THAM1 V_1 V_3)) (Y3  AM-ONE2) (Y4  AM-ONE1))
	((X2  (THAM1 V_1 V_2)) (X1  (THAM1 V_3 V_4))
	 (Y1  (THAM1 V_2 V_4)) (Y2  (THAM1 V_1 V_3)) (Y3  AM-ONE1) (Y4  AM-ONE2))
	((X2  (THAM1 V_3 V_4 V_5)) (X1  (THAM1 V_1 V_2 V_6))
	 (Y1  (THAM1 V_5 V_6)) (Y3  (THAM1 V_2 V_4)) (Y2  AM-ONE2) (Y4  (THAM1 V_1 V_3)))
	((X1 (THAM1 v_1 (THAM2 Y2 (THAM1 Y3 Y4)))) (Y1 (THAM1 x2 v_1)))
	((X2 (THAM1 v_1 (THAM2 Y2 (THAM1 Y3 Y4)))) (Y1 (THAM1 v_1 x1))))
       tu.test-subst.test)

(setf multi (list (list x1 (uds-create '(tham1 (tham2 x1 x2) y1 y2 y3)))))
(test= 44
       (tu.test-unifiers multi)
       (((x2 am-one2) (y1 am-one1) (y2 am-one1) (y3 am-one1))
	((x1 am-one2) (x2 am-one1) (y1 am-one2) (y2 am-one1) (y3 am-one1))
	((x1 am-one2) (x2 am-one1) (y1 am-one1) (y2 am-one2) (y3 am-one1))
	((x1 am-one2) (x2 am-one1) (y1 am-one1) (y2 am-one1) (y3 am-one2))   ;die folgenden Loesungen sind doppelt:
	((X1 v_1)     (X2 AM-ONE2) (Y1 AM-ONE1) (Y2 AM-ONE1) (Y3 AM-ONE1))   
	((X1 AM-ONE2) (X2 AM-ONE1) (Y1 AM-ONE2) (Y2 AM-ONE1) (Y3 AM-ONE1))
	((X1 AM-ONE2) (X2 AM-ONE1) (Y1 AM-ONE1) (Y2 AM-ONE2) (Y3 AM-ONE1))
	((X1 AM-ONE2) (X2 AM-ONE1) (Y1 AM-ONE1) (Y2 AM-ONE1) (Y3 AM-ONE2)))
       tu.test-subst.test "Loesungen doppelt")

(setf multi (list (list x1 (uds-create '(tham1 (tham2 x1 x2) (tham2 x1 x3) x4)))))
(test= 45
       (tu.test-unifiers multi)
       (((x1 am-one1) (x2 am-one2) (x3 am-one2) (x4 am-one1))
	((x1 am-one2) (x2 am-one1) (x3 am-one1) (x4 am-one2))
	((x1 am-one2) (x2 am-one1) (x3 am-one2) (x4 am-one1))
	((x1 am-one2) (x2 am-one2) (x3 am-one1) (x4 am-one1))    ;die folgenden Loesungen sind doppelt:
	((X1 AM-ONE2) (X2 AM-ONE1) (X3 AM-ONE1) (X4 AM-ONE2))
	((X1 AM-ONE2) (X2 AM-ONE1) (X3 AM-ONE2) (X4 AM-ONE1)))
       tu.test-subst.test "Loesungen doppelt")

(setf multi (list (list x (uds-create '(tham1 x1 x2 x3)))
		  (list x (uds-create '(tham2 x1 x2 x3)))))
(test= 46
       (tu.test-unifiers multi)
       NIL
       tu.test-subst.test)

(setf multi (list (list x (uds-create '(tham1 x1 x2 x3)))
		  (list x (uds-create '(tham2 x1 x2 y3)))))
(test= 47
       (tu.test-unifiers multi)
       (((X1 AM-ONE1) (X2 AM-ONE1) (X3 (THAM2 Y3 AM-ONE1 AM-ONE1)) (X (THAM2 Y3 AM-ONE1 AM-ONE1)))
	((X1 AM-ONE2) (X2 AM-ONE2) (Y3 (THAM1 X3 AM-ONE2 AM-ONE2)) (X (THAM1 X3 AM-ONE2 AM-ONE2))))
       tu.test-subst.test)

(setf multi (list (list (uds-create '(tham1 x1 (tham2 x2 x3)))
			(uds-create '(tham2 y1 (tham1 y2 y3))))))
(test= 48
       (tu.test-unifiers multi)
       (((X1 (THAM2 Y1 (THAM1 Y2 Y3))) (X2 AM-ONE1) (X3 AM-ONE2))
	((X1 (THAM2 Y1 (THAM1 Y2 Y3))) (X2 AM-ONE2) (X3 AM-ONE1))
	((Y1 (THAM1 X1 (THAM2 X2 X3))) (Y2 AM-ONE1) (Y3 AM-ONE2))
	((Y1 (THAM1 X1 (THAM2 X2 X3))) (Y2 AM-ONE2) (Y3 AM-ONE1))
	((X1 AM-ONE1) (Y1 (THAM2 v_1 v_2)) (X2 (THAM2 v_2 (THAM1 Y2 Y3))) (X3 v_1))
	((X1 AM-ONE1) (Y1 (THAM2 v_1 v_2)) (X3 (THAM2 v_1 (THAM1 Y2 Y3))) (X2 v_2))
	((Y1 AM-ONE2) (X1 (THAM1 v_1 v_4)) (Y2 (THAM1 v_1 (THAM2 X2 X3))) (Y3 v_4))
	((Y1 AM-ONE2) (X1 (THAM1 v_1 v_4)) (Y3 (THAM1 v_4 (THAM2 X2 X3))) (Y2 v_1))
	((Y1 AM-ONE2) (X2 AM-ONE2) (X1 (THAM1 v_1 v_4)) (X3 (THAM1 v_2 v_3)) (Y2 (THAM1 v_1 v_3)) (Y3 (THAM1 v_2 v_4)))
	((Y1 AM-ONE2) (X3 AM-ONE2) (X1 (THAM1 v_1 v_4)) (X2 (THAM1 v_2 v_3)) (Y2 (THAM1 v_1 v_3)) (Y3 (THAM1 v_2 v_4)))
	((X1 AM-ONE1) (Y3 AM-ONE1) (Y1 (THAM2 V_1 V_4)) (Y2 (THAM2 V_2 V_3)) (X2 (THAM2 V_2 V_4)) (X3 (THAM2 V_1 V_3)))
	((X1 AM-ONE1) (Y2 AM-ONE1) (Y1 (THAM2 V_1 V_4)) (Y3 (THAM2 V_2 V_3)) (X2 (THAM2 V_2 V_4)) (X3 (THAM2 V_1 V_3))))
       tu.test-subst.test)

(setf multi (list (list (uds-create '(tham1 (tham2 x1 x2) (tham2 x3 x4)))
			(uds-create '(tham1 y1 y2)))))
(test= 49
       (tu.test-unifiers multi)
       16
       tu.test-subst.test)

(setf multi (list (list (uds-create '(tham1 x1 (tham2 x2 x3)))
			(uds-create '(tham1 y1 (tham2 y2 y3))))))
(test= 50
       (tu.test-unifiers multi)
       12
       tu.test-subst.test)

#|
;Loesung rule-based:

(((X1 (THAM1 V-5908 (THAM2 Y2 Y3))) (Y1 (THAM1 V-5908 (THAM2 X2 X3))))
 ((X1 y1) (X2 (THAM2 V-3918 V-5728)) (X3 (THAM2 V-5078 V-5772)) (Y2 (THAM2 V-3918 V-5078)) (Y3 (THAM2 V-5728 V-5772)))
 ((X3 AM-ONE2) (X1 (THAM1 V-5908 (THAM2 Y2 Y3))) (Y1 (THAM1 x2 V-5908)))
 ((X3 AM-ONE2) (X2 (THAM1 V-5676 (THAM2 Y2 Y3))) (Y1 (THAM1 x1 V-5676)))
 ((X2 AM-ONE2) (X1 (THAM1 V-5908 (THAM2 Y2 Y3))) (Y1 (THAM1 x3 V-5908)))
 ((X2 AM-ONE2) (X3 (THAM1 V-5676 (THAM2 Y2 Y3))) (Y1 (THAM1 x1 V-5676)))
 ((Y3 AM-ONE2) (Y2 (THAM1 V-3684 (THAM2 X2 X3))) (X1 (THAM1 V-3684 y1)))
 ((Y2 AM-ONE2) (Y3 (THAM1 V-3684 (THAM2 X2 X3))) (X1 (THAM1 V-3684 y1)))
 ((X3 AM-ONE2) (Y3 AM-ONE2)
  (X1 (THAM1 V-3684 V-5908)) (X2 (THAM1 V-5676 V-5992))
  (Y1 (THAM1 V-5676 V-5908)) (Y2 (THAM1 V-3684 V-5992)))
 ((X3 AM-ONE2) (Y2 AM-ONE2)
  (X1 (THAM1 V-3684 V-5908)) (X2 (THAM1 V-5676 V-5992))
  (Y1 (THAM1 V-5676 V-5908)) (Y3 (THAM1 V-3684 V-5992)))
 ((X2 AM-ONE2) (Y3 AM-ONE2)
  (Y1 (THAM1 V-5676 V-5908)) (Y2 (THAM1 V-3684 V-5992))
  (X1 (THAM1 V-3684 V-5908)) (X3 (THAM1 V-5676 V-5992)))
 ((X2 AM-ONE2) (Y2 AM-ONE2)
  (X1 (THAM1 V-3684 V-5908)) (X3 (THAM1 V-5676 V-5992))
  (Y1 (THAM1 V-5676 V-5908)) (Y3 (THAM1 V-3684 V-5992))))

;Loesung sequential:
(((Y1 (THAM1 V-9606 (THAM2 X2 X3))) (X1 (THAM1 V-9606 (THAM2 Y2 Y3))))
 ((X1 y1) (Y3 (THAM2 V-9596 V-9774)) (Y2 (THAM2 V-5058 V-9676)) (X3 (THAM2 V-9596 V-9676)) (X2 (THAM2 V-5058 V-9774)))
 ((X1 (THAM1 V-9606 (THAM2 V-5058 V-9596 V-9676 V-9774))) (Y1 (THAM1 V-9606 (THAM2 V-5058 V-9596 V-9676 V-9774)))
  (Y3 (THAM2 V-9596 V-9774)) (Y2 (THAM2 V-5058 V-9676)) (X3 (THAM2 V-9596 V-9676)) (X2 (THAM2 V-5058 V-9774)))  ;subsum.
 ((X3 AM-ONE2) (X2 (THAM1 V-9586 (THAM2 Y2 Y3))) (Y1 (THAM1 x1 V-9586)))
 ((X3 AM-ONE2) (X1 (THAM1 V-9606 (THAM2 Y2 Y3))) (Y1 (THAM1 x2 V-9606)))
 ((X2 AM-ONE2) (X3 (THAM1 V-9586 (THAM2 Y2 Y3))) (Y1 (THAM1 x1 V-9586)))
 ((X2 AM-ONE2) (X1 (THAM1 V-9606 (THAM2 Y2 Y3))) (Y1 (THAM1 x3 V-9606)))
 ((Y3 AM-ONE2) (Y2 (THAM1 V-9566 (THAM2 X2 X3))) (X1 (THAM1 y1 V-9566)))
 ((Y3 AM-ONE2) (Y1 (THAM1 V-9606 (THAM2 X2 X3))) (X1 (THAM1 y2 V-9606)))
 ((Y2 AM-ONE2) (Y3 (THAM1 V-9566 (THAM2 X2 X3))) (X1 (THAM1 y1 V-9566)))
 ((Y2 AM-ONE2) (Y1 (THAM1 V-9606 (THAM2 X2 X3))) (X1 (THAM1 y3 V-9606)))
 ((X3 AM-ONE2) (Y3 AM-ONE2)
  (Y1 (THAM1 V-9586 V-9606)) (Y2 (THAM1 V-4000 V-9566))
  (X1 (THAM1 V-9566 V-9606)) (X2 (THAM1 V-4000 V-9586)))
 ((X3 AM-ONE2) (Y2 AM-ONE2)
  (Y1 (THAM1 V-9586 V-9606)) (Y3 (THAM1 V-4000 V-9566))
  (X1 (THAM1 V-9566 V-9606)) (X2 (THAM1 V-4000 V-9586)))
 ((Y3 AM-ONE2) (X2 AM-ONE2)
  (Y1 (THAM1 V-9586 V-9606)) (Y2 (THAM1 V-4000 V-9566))
  (X1 (THAM1 V-9566 V-9606)) (X3 (THAM1 V-4000 V-9586)))
 ((Y2 AM-ONE2) (X2 AM-ONE2)
  (Y1 (THAM1 V-9586 V-9606)) (Y3 (THAM1 V-4000 V-9566))
  (X1 (THAM1 V-9566 V-9606)) (X3 (THAM1 V-4000 V-9586)))
 ((X3 AM-ONE2) (Y3 AM-ONE2)
  (X1 (THAM1 V-9576 V-9606)) (X2 (THAM1 V-4000 V-9576))
  (Y1 (THAM1 V-9576 V-9606)) (Y2 (THAM1 V-4000 V-9576)))  ;subsumierbar
 ((X2 AM-ONE2) (Y2 AM-ONE2)
  (X1 (THAM1 V-9576 V-9606)) (X3 (THAM1 V-4000 V-9576))
  (Y1 (THAM1 V-9576 V-9606)) (Y3 (THAM1 V-4000 V-9576)))  ;subsumierbar
 ((X2 AM-ONE2) (Y3 AM-ONE2)
  (X1 (THAM1 V-9576 V-9606)) (X3 (THAM1 V-4000 V-9576))
  (Y1 (THAM1 V-9576 V-9606)) (Y2 (THAM1 V-4000 V-9576)))  ;subsumierbar
 ((Y2 AM-ONE2) (X3 AM-ONE2)
  (Y1 (THAM1 V-9576 V-9606)) (Y3 (THAM1 V-4000 V-9576))
  (X1 (THAM1 V-9576 V-9606)) (X2 (THAM1 V-4000 V-9576)))) ;subsumierbar
 |#

; AC1*.FREE


(setf multi (list (list (uds-create '(tham1 x1 x2 (f2 x2 x3)))
			(uds-create '(tham2 y1 y2 (f2 y3 a1))))))
(test= 51
    (tu.test-unifiers multi)
    (((x1 am-one1) (x2 am-one1) (x3 a1) (y1 am-one2) (y2 am-one2) (y3 am-one1)))
    tu.test-subst.test)

(setf multi (list (list (uds-create '(tham1 x1 x2 (tham2 x4 (f2 x2 x3))))
			(uds-create '(tham2 y1 y2 (f2 y3 a1))))))
(test= 52
    (tu.test-unifiers multi)
    (((x1 am-one1) (x2 am-one1) (x4 (tham2 y1 y2)) (y3 am-one1) (x3 a1))
     ((x1 am-one1) (x2 am-one1) (x4 (tham2 v_2 y1 (f2 y3 a1))) (y2 (tham2 v_2 (f2 am-one1 x3))))
     ((x1 am-one1) (x2 am-one1) (x4 (tham2 y2 v_1 (f2 y3 a1))) (y1 (tham2 v_1 (f2 am-one1 x3)))))
    tu.test-subst.test)

(setf multi (list (list (uds-create '(tham1 (tham2 x1 a1) (tham2 x1 x2)))
			(uds-create '(tham1 y1 y2 (f1 y2))))))
(test= 53
    (tu.test-unifiers multi)
    (((X1 AM-ONE2) (Y1 v_2) (Y2 (THAM1 v_1 A1)) (X2 (THAM1 v_1 v_2 (F1 (THAM1 v_1 A1)))))
     ((X1 AM-ONE2) (Y2 v_1) (Y1 (THAM1 v_2 A1)) (X2 (THAM1 v_1 v_2 (F1 v_1))))
     ((X2 AM-ONE2) (X1 (THAM1 v_1 v_2 (F1 v_1)))
      (Y2 v_1) (Y1 (THAM1 v_2 (THAM2 A1 (THAM1 v_1 v_2 (F1 v_1)))))))
    tu.test-subst.test)

#| Sehr lange Rechenzeit:

(setf multi (list (list (uds-create '(tham1 (tham2 x1 x2) (tham2 x1 (f1 x2)) (tham2 x1 (f1 x3))))
			(uds-create '(tham1 (tham2 y1 y2) (tham2 y1 (f1 y2)) (tham2 y1 (f1 y3)))))))
(test= 100
    (tu.test-unifiers multi)
    ()
    tu.test-subst.test)

(setf multi (list (list x1 (uds-create '(tham1 x3 x4)))
		  (list x3 (uds-create '(tham2 x1 x2)))
		  (list y1 (uds-create '(tham1 y2 (f1 y3))))
		  (list y4 (uds-create '(f1 (tham1 y2 (f1 y3)))))))
(test= 101
    (tu.test-unifiers multi)
    (((X2 AM-ONE2) (X4 AM-ONE1) (X3 X1) (Y1 (THAM1 Y2 (F1 Y3))) (Y4 (F1 (THAM1 Y2 (F1 Y3)))))
     ((X2 AM-ONE2) (X4 AM-ONE1) (X1 X3) (Y1 (THAM1 Y2 (F1 Y3))) (Y4 (F1 (THAM1 Y2 (F1 Y3)))))
     ((X2 AM-ONE1) (X4 AM-ONE2) (X1 AM-ONE2) (X3 AM-ONE1) (Y1 (THAM1 Y2 (F1 Y3))) (Y4 (F1 (THAM1 Y2 (F1 Y3)))))
     ((X2 AM-ONE1) (X4 AM-ONE2) (X1 AM-ONE2) (X3 AM-ONE1) (Y1 (THAM1 Y2 (F1 Y3))) (Y4 (F1 (THAM1 Y2 (F1 Y3))))))
    tu.test-subst.test)

(setf multi (list (list (uds-create '(tham1 (tham2 x1 x2) (tham2 x1 x3) (tham2 x1 (f1 x2)) (tham2 x1 (f1 x3))))
			(uds-create '(tham1 (tham2 y1 y2) (tham2 y1 (f1 y2)))))))
(test= 102
    (tu.test-unifiers multi)
    ()
    tu.test-subst.test)


(setf multi (list (list (uds-create '(tham1 (tham2 x1 x2) (tham2 x1 x3) (tham2 x1 (f1 x2)) (tham2 x1 (f1 x3))))
			(uds-create '(tham1 (tham2 y1 y2) (tham2 y1 (f1 y2)) (tham2 y1 (f1 y3)))))))
(test= 103
    (tu.test-unifiers multi)
    ()
    tu.test-subst.test)

Loesung:

(((X1 AM-ONE2) (X3 AM-ONE1) (X2 (THAM1 v_1 (F1 AM-ONE1)))
  (Y1 AM-ONE2) (Y3 AM-ONE1) (Y2 (THAM1 v_1 (F1 AM-ONE1))))
 ((X1 AM-ONE2) (X2 (THAM1 v_1 (F1 (THAM1 v_1 v_2 (F1 v_2))))) (X3 v_2)
  (Y1 AM-ONE2) (Y3 (THAM1 v_1 (F1 (THAM1 v_1 v_2 (F1 v_2))))) (Y2 (THAM1 v_1 v_2 (F1 v_2))))
 ((X1 AM-ONE2) (X2 AM-ONE1) (X3 (THAM1 v_2 (F1 AM-ONE1)))
  (Y1 AM-ONE2) (Y3 AM-ONE1) (Y2 (THAM1 v_2 (F1 AM-ONE1))))
 ((X1 AM-ONE2) (X2 AM-ONE1) (X3 v_2)
  (Y1 AM-ONE2) (Y3 AM-ONE1) (Y2 v_2))
 ((X1 AM-ONE2) (X2 v_1) (X3 (THAM1 v_2 (F1 (THAM1 v_1 v_2 (F1 v_1)))))
  (Y1 AM-ONE2) (Y2 (THAM1 v_1 v_2 (F1 v_1))) (Y3 (THAM1 v_2 (F1 (THAM1 v_1 v_2 (F1 v_1))))))
 ((X1 AM-ONE2) (X2 v_1) (X3 AM-ONE1)
  (Y1 AM-ONE2) (Y2 v_1) (Y3 AM-ONE1))
 ((X1 AM-ONE1) (X2 (F1 AM-ONE2)) (X3 AM-ONE2)
  (Y1 AM-ONE1) (Y2 (F1 AM-ONE2)) (Y3 AM-ONE2))
 ((X1 AM-ONE1) (X2 (F1 (F1 AM-ONE2))) (X3 AM-ONE2)
  (Y1 AM-ONE1) (Y2 (F1 AM-ONE2)) (Y3 (F1 (F1 AM-ONE2))))
 ((X1 AM-ONE1) (X2 AM-ONE2) (X3 (F1 AM-ONE2))
  (Y1 AM-ONE1) (Y3 AM-ONE2) (Y2 (F1 AM-ONE2)))
 ((X1 AM-ONE1) (X2 AM-ONE2) (X3 AM-ONE2)
  (Y1 AM-ONE1) (Y2 AM-ONE2) (Y3 AM-ONE2)) ((X1 AM-ONE1) (X2 AM-ONE2) (Y2 X3)
  (Y1 AM-ONE1) (Y3 AM-ONE2))
 ((X1 AM-ONE1) (X2 AM-ONE2) (X3 (F1 (F1 AM-ONE2)))
  (Y1 AM-ONE1) (Y2 (F1 AM-ONE2)) (Y3 (F1 (F1 AM-ONE2))))
 ((X1 AM-ONE1) (X3 AM-ONE2) (Y2 X2)
  (Y1 AM-ONE1) (Y3 AM-ONE2))
 ((X1 AM-ONE1) (X2 AM-ONE2) (X3 AM-ONE2)
  (Y1 AM-ONE1) (Y2 AM-ONE2) (Y3 AM-ONE2)))
|#

;))
;)

#|

(with-open-file (file "trace" :direction :output)
 (let ((trace au*trace))
  (setf au*trace file)
  (term-reset)
  (reset-grouped-array :memory)
  (term=cth.reset :loaded)
  (term=cth.configure)
  
  (do-new.environment
   (uds-instantiate 'th-abelian.monoid '(tham1 am-one1)
		    :variables '(x1 x2 y1 y2))
   (uds-instantiate 'th-abelian.monoid '(tham2 am-one2))
   
   (setf multi (list (list y1 (uds-create '(tham1 x1 x2)))
			(list x1 (uds-create '(tham2 y1 y2)))))
   (test= 23
	   (tu.test-unifiers multi)
	   (((x1 y1) (x2 am-one1) (y2 am-one2))
	   ((x1 am-one1) (x2 am-one2) (y1 am-one2) (y2 am-one1)))
	   tu.test-subst.test "Beide Loesungen kommen doppelt vor.")
   )
  (setf au*trace trace)))
|#

#|
()
(progn
 (term-reset)
 (reset-grouped-array :memory)
 (term=cth.reset :loaded)
 (term=cth.configure)
 
 (do-new.environment
  
  (uds-instantiate 'th-abelian.monoid '(tham1 am-one1)
		   :constants '(a1 a2 a3 a4 b1 b2 b3 b4)
		   :variables '(x x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 y1 y2 y3 y4))
  (uds-instantiate 'th-abelian.monoid '(tham2 am-one2))

  (setf f1 (uds-function.create 'f1 1))
  
  (setf term1 (uds-create '(tham1 (tham2 x1 a1) (tham2 x1 x2))))
  (setf term2 (uds-create '(tham1 (tham1 x3 (f1 x4)) x4)))
  (setf multi (list (list x term1) (list x term2)))
  (uni-create.termlists.unification.problem multi)
  (test= 30
	  (tu.test-unifiers multi)
	  (((x1 am-one1) (x2 (f2 am-one1 y1)) (x3 am-one1) (x (f2 am-one1 y1)))
	  ((x1 am-one1) (x2 am-one1) (x3 (f2 am-one1 y1)) (x (f2 am-one1 y1))))
	  tu.test-subst.test)
  ))
|#