;;; -*- Package: HADES; Syntax: Common-lisp; Mode: LISP -*-


(in-package 'hades)


(term-reset)
(reset-grouped-array :memory)
(term=cth.reset :loaded)

(term=cth.configure)


;(do-new.environment

(defvar ag*test.expt.p nil)

(uds-instantiate (if ag*test.expt.p 'th-abelian.group.expt 'th-abelian.group)
		 (if ag*test.expt.p '(ag+ ag- ag0 ag.) '(ag+ ag- ag0)))
(uds-instantiate (if ag*test.expt.p 'th-abelian.group.expt 'th-abelian.group)
		 (if ag*test.expt.p '(ag* ag/ ag1 ag^) '(ag* ag/ ag1))
		 :constants '(a1 a2 a3 a4 b1 b2 b3 b4)
		 :variables '(x x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 y1 y2 y3 y4))
(setf f1 (uds-function.create 'f1 1))
(setf f2 (uds-function.create 'f2 2))
(setf f3 (uds-function.create 'f3 3))
(setf v_1 'v_1 v_2 'v_2 v_3 'v_3 v_4 'v_4)



; AG

(setf multi (list (list (uds-create '(ag+ x1 x2)) (uds-create '(ag+ y1 y2)))))
(test= 1
       (tu.test-unifiers multi)
       (((y1 (ag+ x2 x1 (ag- y2)))))
       tu.test-subst.test)

(setf multi (list (list (uds-create '(ag+ x1 x2)) ag0)))
(test= 2
       (tu.test-unifiers multi)
       (((x2 (ag- x1))))
       tu.test-subst.test)

(setf multi (list (list x1 (uds-create '(ag+ x1 x2 x3 x4)))))
(test= 3
       (tu.test-unifiers multi)
       (((x3 (ag+ (ag- x2) (ag- x4)))))
       tu.test-subst.test)

(setf multi (list (list x1 (uds-create '(ag+ y1 y2 y3)))
		  (list y1 (uds-create '(ag+ x1 x2 x3)))))
(test= 3.1
       (tu.test-unifiers multi)
       (((x2 (ag+ y1 (ag- x1) (ag- x3))) (y3 (ag+ x1 (ag- y2) (ag- y1)))))
       tu.test-subst.test)

(setf multi (list (list x1 (uds-create '(ag+ x2 y1 y2)))
		  (list x2 (uds-create '(ag+ x1 y1 y2)))))
(test= 3.2
       (tu.test-unifiers multi)
       (((x1 x2) (y1 (ag- y2))))
       tu.test-subst.test)

(setf multi (list (list (uds-create '(ag+ x1 x2 x3)) (uds-create '(ag- x1)))))
(test= 4
       (tu.test-unifiers multi)
       (((x3 (ag+ (ag- x2) (ag- x1) (ag- x1)))))
       tu.test-subst.test)

(setf multi (list (list (uds-create '(ag+ x1 x2)) (uds-create '(ag+ x1 x2 x3)))))
(test= 5
       (tu.test-unifiers multi)
       (((x3 ag0)))
       tu.test-subst.test)

(setf multi (list (list (uds-create '(ag+ x1 x1 x1)) (uds-create '(ag+ y1 y1)))))
(test= 6
       (tu.test-unifiers multi)
       (((x1 (ag+ v_1 v_1)) (y1 (ag+ v_1 v_1 v_1))))
       tu.test-subst.test)

(setf multi (list (list (uds-create '(ag+ x1 x1 x1)) (uds-create '(ag+ y1 y1)))
		  (list (uds-create '(ag+ x1 x1)) (uds-create '(ag+ y2 y2 y2)))))
(test= 6.1
       (tu.test-unifiers multi)
       (((x1 (ag+ v_1 v_1 v_1 v_1 v_1 v_1))
	 (y1 (ag+ v_1 v_1 v_1 v_1 v_1 v_1 v_1 v_1 v_1))
	 (y2 (ag+ v_1 v_1 v_1 v_1))))
       tu.test-subst.test)

; AG.CONST

(setf multi (list (list (uds-create '(ag+ x1 x2)) (uds-create '(ag+ a1 a2)))))
(test= 7
       (tu.test-unifiers multi)
       (((x2 (ag+ a1 a2 (ag- x1)))))
       tu.test-subst.test)

(setf multi (list (list (uds-create '(ag+ (ag- x1) (ag- x2))) (uds-create '(ag- (ag+ x1 x2))))))
(test= 8
       (tu.test-unifiers multi)
       (())
       tu.test-subst.test)

(setf multi (list (list (uds-create '(ag+ x1 x2)) (uds-create '(ag+ x1 x2 a1 a2)))))
(test= 9
       (tu.test-unifiers multi)
       NIL
       tu.test-subst.test)

(setf multi (list (list (uds-create '(ag+ x1 a1 a2)) (uds-create '(ag+ y1 b1 b2 b3)))))
(test= 10
       (tu.test-unifiers multi)
       (((x1 (ag+ y1 b1 b2 b3 (ag- a1) (ag- a2)))))
       tu.test-subst.test)

(setf multi (list (list x1 (uds-create '(ag+ x2 a1)))
		  (list x2 (uds-create '(ag+ x1 y1)))))
(test= 11
       (tu.test-unifiers multi)
       (((x1 (ag+ x2 a1)) (y1 (ag- a1))))
       tu.test-subst.test)

#| Bei Test 12 tritt ein Fehler auf: Versuch durch Null tu teilen.
(setf multi (list (list x1 (uds-create '(ag+ x2 a1)))
		  (list x2 (uds-create '(ag+ x1 y1)))
		  (list (uds-create '(ag+ x1 x1)) (uds-create '(ag+ y2 y2 y2)))
		  (list (uds-create '(ag+ x2 x2)) (uds-create '(ag+ y3 y3 y3)))))
(test= 12
       (tu.test-unifiers multi)
       (((x1 (ag+ x2 a1)) (y1 (ag- a1))))
       tu.test-subst.test)
|#

(setf multi (list (list (uds-create '(ag+ x2 x3 (ag- a1) a2)) (uds-create '(ag+ x1 x1 a2 a3)))
		  (list (uds-create '(ag+ x1 x2 x3 a1)) (uds-create '(ag+ x1 x2 a1 (ag- a2) (ag- a2))))))
(test= 13
       (tu.test-unifiers multi)
       (((x3 (ag+ (ag- a2) (ag- a2))) (x1 (ag+ v_1 (ag- a2))) (x2 (ag+ v_1 v_1 a1 a3))))
       tu.test-subst.test)


; AG.FREE

(setf multi (list (list (uds-create '(f2 x1 a1)) (uds-create '(ag+ x4 a1 a2)))))
(test= 20
       (tu.test-unifiers multi)
       (((x4 (ag+ (ag- a1) (ag- a2) (f2 x1 a1)))))
       tu.test-subst.test)

(setf multi (list (list (uds-create '(ag+ (f2 x1 x2) (f2 x3 x2))) (uds-create '(ag+ (f2 y2 y1) (f2 y2 y3))))))
(test= 21
       (tu.test-unifiers multi)
       (((x1 y2) (x3 y2) (y1 x2) (y3 x2))   ; 8 mal
	((x1 y2) (x3 y2) (y1 x2) (y3 x2))
	((x1 y2) (x3 y2) (y1 x2) (y3 x2))
	((x1 y2) (x3 y2) (y1 x2) (y3 x2))
	((x1 y2) (x3 y2) (y1 x2) (y3 x2))
	((x1 y2) (x3 y2) (y1 x2) (y3 x2))
	((x1 y2) (x3 y2) (y1 x2) (y3 x2))
	((x1 y2) (x3 y2) (y1 x2) (y3 x2)))
       tu.test-subst.test)


; AG*.FREE
;)