;;; -*- Package: HADES; Syntax: Common-lisp; Mode: LISP -*-

(in-package 'hades)

#|
(defun tu.test=unify.multi (multi)
  (declare (special sg-plus1 sg-exp1))
  (let ((up (sg-solve.string.unification.problem.exp multi sg-plus1 sg-exp1)))
    (do ((i 10 (1- i))
	 (subst (do-send up :next-solution) (do-send up :next-solution))
	 (res nil (cons subst res)))
	((or (null subst) (zerop i)) (subst-l.create res)))))


(defun my-print (object &optional (stream t))
  (if (equal stream t)
      (format t "~%~A" (my=print object))
      (format stream "~A" (my=print object))))

(defun my=print (object)
  (cond ((vectorp object) (format nil "[~{~A ~}]" (map 'list #'(lambda (object) (my=print object)) object)))
	((listp object) (mapcar #'(lambda (object) (my=print object)) object))
	(t object)))

|#


(term-reset)
(reset-grouped-array :memory)
(term=cth.reset :loaded)

(term=cth.configure)

;(do-new.environment

(uds-instantiate 'th-semigroup.with.exponent '(sg-plus1 sg-exp1)
		 :constants '(a1 a2 a3 a4 b1 b2 b3 b4)
		 :variables '(x x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 y1 y2 y3 y4))
(setf v_1 'v_1 v_2 'v_2 v_3 'v_3 v_4 'v_4)


(setf multi (list (list (uds-create '(sg-plus1 x1 x2)) (uds-create '(sg-plus1 x2 x1)))))
(test= 1
       (tu.test-unifiers multi 10)
       ()
       tu.test-subst.test)

(setf multi (list (list (uds-create '(sg-plus1 x1 x2)) (uds-create '(sg-plus1 x2 x1)))
		  (list (uds-create '(sg-plus1 x3 a1)) (uds-create '(sg-plus1 a1 x3)))))
(test= 1.1
       (tu.test-unifiers multi 10)
       ()
       tu.test-subst.test)

(setf multi (list (list (uds-create '(sg-plus1 a1 x1)) (uds-create '(sg-plus1 x1 a1)))))
(test= 1.2
       (tu.test-unifiers multi)
       (((X1 (SG-EXP1 A1 10))) ((X1 (SG-EXP1 A1 9))) ((X1 (SG-EXP1 A1 8))) ((X1 (SG-EXP1 A1 7)))
	((X1 (SG-EXP1 A1 6))) ((X1 (SG-EXP1 A1 5))) ((X1 (SG-EXP1 A1 4))) ((X1 (SG-EXP1 A1 3)))
	((X1 (SG-EXP1 A1 2))) ((X1 A1)))
       tu.test-subst.test)

(setf multi (list (list (uds-create '(sg-plus1 a1 a1 a1)) (uds-create '(sg-plus1 x1 x2)))))
(test= 2
       (tu.test-unifiers multi)
       (((x1 a1) (x2 (sg-exp1 a1 2))) ((x1 (sg-exp1 a1 2)) (x2 a1)))
       tu.test-subst.test)

(setf multi (list (list (uds-create '(sg-plus1 a1 a2 a1)) (uds-create '(sg-plus1 x1 x2)))))
(test= 3
       (tu.test-unifiers multi)
       (((x1 a1) (x2 (sg-plus1 a2 a1))) ((x1 (sg-plus1 a1 a2)) (x2 a1)))
       tu.test-subst.test)

(setf multi (list (list (uds-create '(sg-plus1 (sg-plus1 a1 a2) a3)) (uds-create '(sg-plus1 a1 (sg-plus1 a2 a3))))
		  (list x1 x1)))
(test= 4
       (tu.test-unifiers multi)
       (())
       tu.test-subst.test)
;)