;;; -*- Package: HADES; Mode: LISP; Base: 10 -*-


(term-reset)
(reset-grouped-array :memory)
(term=cth.reset :loaded)

(term=cth.configure)


(instantiate 'th-semigroup.with.exponent
	     '(f-ass exp)
	     :variables '(v1 v2 v3 v4 v5 v6)
	     :constants '(c1 c2 c3 c4 c5 c6))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                                                                                                              ;;
;;                                         1. Beispiel:                                                         ;;
;;                                                                                                              ;;
;;                                   c1 + v1  =  v1 + c1                                                        ;;
;;                                                                                                              ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



;(setf multi-1 (interface.with.unification.algorithms (list c1 c2 c3 c4 c5 c6) (list v1 v2 v3 v4 v5 v6) nil
;						     "F:>farid>assoc>beispiel.1.2" :add f-ass :exponential exp))
;    [ { c1+v1 = v1+c1 } ]

(setf multi (list (list (uds-create '(sg-plus1 c1 v1)) (uds-create '(sg-plus1 v1 c1)))))

(print (term-names multi))

(setf Objekt1 (sg-solve.string.unification.problem.exp multi f-ass exp))

(setf Objekt1a (do-send Objekt1 :restrict (list v1 v2 v3 v4) t))

(setf Objekt1b (do-send Objekt1 :replace-terms (list c1) (list v4) t))

(setf Objekt1c (do-send Objekt1a :replace-terms (list c1) (list v4) t))

(setf Sigma1 (do-send Objekt1 :next-solution))

(print (term-names Sigma1))

(setf Sigma1a (do-send Objekt1a :next-solution))

(print (term-names Sigma1a))

(setf Sigma1b (do-send Objekt1b :next-solution))

(print (term-names Sigma1b))

(setf Sigma1c (do-send Objekt1c :next-solution))

(print (term-names Sigma1c))

(do-send Objekt1 :names)

(do-send Objekt1a :names)

(do-send Objekt1b :names)

(do-send Objekt1c :names)

(do-send Objekt1 :solvable?)

(do-send Objekt1a :solvable?)

(do-send Objekt1b :solvable?)

(do-send Objekt1c :solvable?)



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                                                                                                              ;;
;;                                         2. Beispiel:                                                         ;;
;;                                                                                                              ;;
;;                                   c1 + v2  =  v1 + c2                                                        ;;
;;                                                                                                              ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



;(setf multi-2 (interface.with.unification.algorithms (list c1 c2 c3 c4 c5 c6) (list v1 v2 v3 v4 v5 v6) nil
;						     "F:>farid>assoc>beispiel.2.2" :add f-ass :exponential exp))
;      [ { c1+v2 = v1+c2 } ]

(setf multi (list (list (uds-create '(sg-plus1 c1 v2)) (uds-create '(sg-plus1 v1 c2)))))

(print (term-names multi))

(setf Objekt2 (sg-solve.string.unification.problem.exp multi f-ass exp))

(setf Objekt2a (do-send Objekt2 :restrict (list v1)))

(setf Sigma2 (do-send Objekt2 :next-solution))

(print (term-names Sigma2))

(setf Sigma2a (do-send Objekt2a :next-solution))

(print (term-names Sigma2a))

(do-send Objekt2 :names)

(do-send Objekt2a :names)

(do-send Objekt2 :solvable?)

(do-send Objekt2a :solvable?)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                                                                                                              ;;
;;                                         3. Beispiel:                                                         ;;
;;                                                                                                              ;;
;;                                   v1 + v2  =  v2 + v1                                                        ;;
;;                                                                                                              ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;




;(setf multi-3 (interface.with.unification.algorithms (list c1 c2 c3 c4 c5 c6) (list v1 v2 v3 v4 v5 v6) nil
;						     "F:>farid>assoc>beispiel.3.2" :add f-ass :exponential exp))
;      [ { v1+v2 = v2+v1 } ]

(setf multi (list (list (uds-create '(sg-plus1 v1 v2)) (uds-create '(sg-plus1 v2 v1)))))

(print (term-names multi))

(setf Objekt3 (sg-solve.string.unification.problem.exp multi f-ass exp))

(setf Sigma3 (do-send Objekt3 :next-solution))

(print (term-names Sigma3))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                                                                                                              ;;
;;                                         4. Beispiel:                                                         ;;
;;                                                                                                              ;;
;;                                   v1 + c1  =  c2 + v1                                                        ;;
;;                                                                                                              ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



;(setf multi-4 (interface.with.unification.algorithms (list c1 c2 c3 c4 c5 c6) (list v1 v2 v3 v4 v5 v6) nil
;						     "F:>farid>assoc>beispiel.4.2" :add f-ass :exponential exp))
;          [ { v1+c1 = c2+v1 } ]

(setf multi (list (list (uds-create '(sg-plus1 v1 c1)) (uds-create '(sg-plus1 c2 v1)))))

(print (term-names multi))

(setf Objekt4 (sg-solve.string.unification.problem.exp multi f-ass exp))

(setf Sigma4 (do-send Objekt4 :next-solution))

(print (term-names Sigma4))



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                                                                                                              ;;
;;                                         5. Beispiel:                                                         ;;
;;                                                                                                              ;;
;;                                   v1 + v2  =  c1 + v1 + c2                                                   ;;
;;                                                                                                              ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;




;(setf multi-5 (interface.with.unification.algorithms (list c1 c2 c3 c4 c5 c6) (list v1 v2 v3 v4 v5 v6) nil
;						     "F:>farid>assoc>beispiel.5.2" :add f-ass :exponential exp))
;        [ { v1+v2 = c1+v1+c2 } ]

(setf multi (list (list (uds-create '(sg-plus1 v1 v2)) (uds-create '(sg-plus1 c1 v1 c2)))))

(print (term-names multi))

(setf Objekt5 (sg-solve.string.unification.problem.exp multi f-ass exp))

(setf Sigma5 (do-send Objekt5 :next-solution))

(print (term-names Sigma5))



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                                                                                                              ;;
;;                                         6. Beispiel:                                                         ;;
;;                                                                                                              ;;
;;                                   v1 + c1  =  c1 + v1                                                        ;;
;;                                                                                                              ;;
;;                              v1 + c1 + v2  =  v2 + c1 + v1                                                   ;;
;;                                                                                                              ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;




;(setf multi-6 (interface.with.unification.algorithms (list c1 c2 c3 c4 c5 c6) (list v1 v2 v3 v4 v5 v6) nil
;						     "F:>farid>assoc>beispiel.6.2" :add f-ass :exponential exp))
;        [ {   v1+c1 = c1+v1   }
;          { v1+c1+v2 = v2+c1+v1 } ]

(setf multi (list (list (uds-create '(sg-plus1 v1 c1)) (uds-create '(sg-plus1 c1 v1)))
		  (list (uds-create '(sg-plus1 v1 c1 v2)) (uds-create '(sg-plus1 v2 c1 v1)))))

(print (term-names multi))

(setf Objekt6 (sg-solve.string.unification.problem.exp multi f-ass exp))

(setf Objekt6a (do-send Objekt6 :restrict (list v1 v2 v3 v4)))

(setf Objekt6b (do-send Objekt6 :replace-terms (list c1) (list v4)))

(setf Objekt6c (do-send Objekt6a :replace-terms (list c1) (list v4)))

(setf Sigma6 (do-send Objekt6 :next-solution))

(print (term-names Sigma6))

(setf Sigma6a (do-send Objekt6a :next-solution))

(print (term-names Sigma6a))

(setf Sigma6b (do-send Objekt6b :next-solution))

(print (term-names Sigma6b))

(setf Sigma6c (do-send Objekt6c :next-solution))

(print (term-names Sigma6c))

(do-send Objekt6 :names)

(do-send Objekt6a :names)

(do-send Objekt6b :names)

(do-send Objekt6c :names)

(do-send Objekt6 :solvable?)

(do-send Objekt6a :solvable?)

(do-send Objekt6b :solvable?)

(do-send Objekt6c :solvable?)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                                                                                                              ;;
;;                                         7. Beispiel:                                                         ;;
;;                                                                                                              ;;
;;                              v1 + c1 + v2  =  v2 + c2 + v1                                                   ;;
;;                                                                                                              ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



;(setf multi-7 (interface.with.unification.algorithms (list c1 c2 c3 c4 c5 c6) (list v1 v2 v3 v4 v5 v6) nil
;						     "F:>farid>assoc>beispiel.7.2" :add f-ass :exponential exp))
;         [ { v1+c1+v2 = v2+c2+v1 } ]

(setf multi (list (list (uds-create '(sg-plus1 v1 c1 v2)) (uds-create '(sg-plus1 v2 c2 v1)))))

(print (term-names multi))

(setf Objekt7 (sg-solve.string.unification.problem.exp multi f-ass exp))

(setf Sigma7 (do-send Objekt7 :next-solution))

(print (term-names Sigma7))



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                                                                                                              ;;
;;                                         8. Beispiel:                                                         ;;
;;                                                                                                              ;;
;;                              c1 + v2 + c2  =  v2 + v1                                                        ;;
;;                                                                                                              ;;
;;                              v1 + v2 + v3  =  c3 + v2 + c1 + v3 + c4 + v5 + c2                               ;;
;;                                                                                                              ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



;(setf multi-8 (interface.with.unification.algorithms (list c1 c2 c3 c4 c5 c6) (list v1 v2 v3 v4 v5 v6) nil
;						     "F:>farid>assoc>beispiel.8.2" :add f-ass :exponential exp))
;      [ { c1+v2+c2   =  v2+v1                }
;        { v1+v2+v3   =  c3+v2+c1+v3+c4+v5+c2 } ]

(setf multi (list (list (uds-create '(sg-plus1 c1 v2 c2)) (uds-create '(sg-plus1 v2 v1)))
		  (list (uds-create '(sg-plus1 v1 v2 v3)) (uds-create '(sg-plus1 c3 v2 c1 v3 c4 v5 c2)))))

(print (term-names multi))

(setf Objekt8 (sg-solve.string.unification.problem.exp multi f-ass exp))

(setf Sigma8 (do-send Objekt8 :next-solution))

(print (term-names Sigma8))