;;; -*- Package: HADES; Syntax: Common-lisp; Mode: LISP -*-

;Statistics:
;
;(32-Nov-1990)     23 sec. (Magic)


(in-package 'hades)

(term-reset)
(reset-grouped-array :memory)
(term=cth.reset :loaded)

(term=cth.configure)

;(do-new.environment

(uds-instantiate 'th-boolean.ring '(br-xor1 br-not1 br-zero1 br-and1 br-one1))
(uds-instantiate 'th-boolean.ring '(br-xor2 br-not2 br-zero2 br-and2 br-one2)
		 :constants '(a1 a2 a3 a4 b1 b2 b3 b4)
		 :variables '(x x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 y1 y2 y3 y4))
(setf f1 (uds-function.create 'f1 1))
(setf f2 (uds-function.create 'f2 2))
(setf f3 (uds-function.create 'f3 3))
(setf v_1 'v_1 v_2 'v_2 v_3 'v_3 v_4 'v_4)


;BR.CONST

;(time (progn

(setf term1 x1)
(setf term2 (uds-create '(br-and1 x1 a1)))
(setf multi (list (list x term1) (list x term2)))
(test= 1
       (tu.test-unifiers multi)
       (((x (br-and1 v_1 a1)) (x1 (br-and1 v_1 a1))))
       tu.test-subst.test)

(setf multi (list (list x (uds-create '(br-and1 x1 x2)))
		  (list x  br-zero1)))
(test= 2
       (tu.test-unifiers multi)
       (((X BR-ZERO1) (X2 (BR-XOR1 V_1 (BR-AND1 V_1 V_2))) (X1 V_2)))
       tu.test-subst.test)

(setf multi (list (list x (uds-create '(br-xor1 x1 x2)))
		  (list x br-zero1)))
(test= 3
       (tu.test-unifiers multi)
       (((X BR-ZERO1) (X1 X2)))
       tu.test-subst.test)

(setf multi (list (list x (uds-create '(br-xor1 x1 a1)))
		  (list x br-zero1)))
(test= 4
       (tu.test-unifiers multi)
       (((X BR-ZERO1) (X1 A1)))
       tu.test-subst.test)

(setf multi (list (list x (uds-create '(br-xor1  (br-and1 a1 x1) x2)))
		  (list x br-zero1)))
(test= 5
       (tu.test-unifiers multi)
       (((X BR-ZERO1) (X2 (BR-AND1 X1 A1))))
       tu.test-subst.test)

(setf multi (list (list x (uds-create '(br-and1 (br-xor1  a1 a2) (br-xor1 a2 x1 (br-and1 x2 a2)) x3)))
		  (list x br-zero1)))
(test= 6
       (tu.test-unifiers multi)
       (((X BR-ZERO1)  (X1 v_1)  (X2 v_2)
	 (X3 (BR-XOR1 v_3 (BR-AND1 v_1 v_3 A1) (BR-AND1 v_1 v_3 A2) (BR-AND1 v_2 v_3 A1 A2)
		      (BR-AND1 v_2 v_3 A2) (BR-AND1 v_3 A1 A2) (BR-AND1 v_3 A2)))))
       tu.test-subst.test)

(setf multi (list (list x (uds-create '(br-xor1 (br-and1 a2 x1))))
		  (list x (uds-create '(br-xor1 (br-and1 a1 x2))))))
(test= 7
       (tu.test-unifiers multi)
       (((X (BR-AND1 v_2 A1 A2))
	 (X1 (BR-XOR1 v_1 (BR-AND1 v_2 A1 A2) (BR-AND1 v_1 A2)))
	 (X2 (BR-XOR1 v_2 (BR-AND1 v_2 A1) (BR-AND1 v_2 A1 A2)))))
       tu.test-subst.test)

(setf multi (list (list x (uds-create '(br-xor1 (br-and1 a1 x1) (br-and1 x2 a2)))) 
		  (list x (uds-create '(br-xor1 y1 (br-and1 x1 b1) a1)))))
(test= 8
       (tu.test-unifiers multi)
       (((X (BR-XOR1 (BR-AND1 V_1 A1) (BR-AND1 V_2 A2))) 
	 (Y1 (BR-XOR1 A1 (BR-AND1 V_1 A1) (BR-AND1 V_1 B1) (BR-AND1 V_2 A2)))
	 (X1 V_1)   (X2 V_2)))
       tu.test-subst.test)


;BR.FREE

(setf multi (list (list x1 (uds-create '(f1 (br-xor1 x2 x3))))
		  (list x3 (uds-create '(f1 (br-xor1 x1 x4 a1))))
		  (list x4 (uds-create '(f1 (br-xor1 x2 x5 b1))))))
;(format t "Test 9 laeuft (unendlich ??) lange. 17.09.90")
#|
(test= 9
       (tu.test-unifiers multi)
       26  ;...
       tu.test-subst.test)
(test= 9 
       (uni-substitutions (uni-create.termlists.unification.problem multi))
       3
       tu.test-subst.test)
|#
#|
;Loesung am 18.01.91:

(((X3 --> (F1 A1)) (X5 --> (BR-XOR1 B1 (F1 A1))) (X1 --> (F1 (BR-XOR1 X2 (F1 A1))))
  (X4 --> (F1 (BR-XOR1 X2 (F1 A1)))))
 ((X5 --> (BR-XOR1 B1 (F1 A1))) (X1 --> (F1 |v-31329|)) (X4 --> (F1 |v-31329|)) (X3 --> (F1 A1))
  (X2 --> (BR-XOR1 |v-31329| (F1 A1))))
 ((X1 --> (F1 |v-31197|)) (X5 --> (BR-XOR1 B1 (F1 A1))) (X3 --> (F1 A1)) (X2 --> (BR-XOR1 |v-31197| (F1 A1)))
  (X4 --> (F1 |v-31197|)))
 ((X1 --> (F1 |v-31329|)) (X4 --> (F1 |v-31197|))
  (X5 --> (BR-XOR1 |v-31197| |v-31329| B1 (F1 (BR-XOR1 A1 (F1 |v-31197|) (F1 |v-31329|)))))
  (X3 --> (F1 (BR-XOR1 A1 (F1 |v-31197|) (F1 |v-31329|))))
  (X2 --> (BR-XOR1 |v-31329| (F1 (BR-XOR1 A1 (F1 |v-31197|) (F1 |v-31329|))))))
 ((X5 --> (BR-XOR1 B1 (F1 A1))) (X4 --> (F1 |v-31329|)) (X1 --> (F1 |v-31329|)) (X3 --> (F1 A1))
  (X2 --> (BR-XOR1 |v-31329| (F1 A1))))
 ((X1 --> (F1 (F1 A1))) (X4 --> (F1 (F1 A1))) (X2 --> BR-ZERO1) (X3 --> (F1 A1)) (X5 --> (BR-XOR1 B1 (F1 A1))))
 ((X4 --> (F1 (F1 A1))) (X2 --> BR-ZERO1) (X3 --> (F1 A1)) (X5 --> (BR-XOR1 B1 (F1 A1))) (X1 --> (F1 (F1 A1))))
 ((X4 --> (F1 NIL)) (X1 --> (F1 B1)) (X2 --> (BR-XOR1 B1 (F1 (BR-XOR1 A1 (F1 NIL) (F1 B1)))))
  (X3 --> (F1 (BR-XOR1 A1 (F1 NIL) (F1 B1)))) (X5 --> (BR-XOR1 NIL (F1 (BR-XOR1 A1 (F1 NIL) (F1 B1))))))
 ((X1 --> (F1 (F1 A1))) (X4 --> (F1 (F1 A1))) (X2 --> BR-ZERO1) (X3 --> (F1 A1)) (X5 --> (BR-XOR1 B1 (F1 A1))))
 ((X4 --> (F1 (F1 A1))) (X2 --> BR-ZERO1) (X3 --> (F1 A1)) (X5 --> (BR-XOR1 B1 (F1 A1))) (X1 --> (F1 (F1 A1))))
 ((X4 --> (F1 (BR-XOR1 |v-31329| NIL B1))) (X1 --> (F1 |v-31329|))
  (X5 --> (BR-XOR1 NIL (F1 (BR-XOR1 A1 (F1 |v-31329|) (F1 (BR-XOR1 |v-31329| NIL B1))))))
  (X3 --> (F1 (BR-XOR1 A1 (F1 |v-31329|) (F1 (BR-XOR1 |v-31329| NIL B1)))))
  (X2 --> (BR-XOR1 |v-31329| (F1 (BR-XOR1 A1 (F1 |v-31329|) (F1 (BR-XOR1 |v-31329| NIL B1)))))))
 ((X3 --> (F1 A1)) (X5 --> (BR-XOR1 B1 (F1 A1))) (X1 --> (F1 (BR-XOR1 X2 (F1 A1))))
  (X4 --> (F1 (BR-XOR1 X2 (F1 A1)))))
 ((X3 --> (F1 A1)) (X5 --> (BR-XOR1 B1 (F1 A1))) (X1 --> (F1 NIL)) (X4 --> (F1 NIL)) (X2 --> (BR-XOR1 NIL (F1 A1))))
 ((X3 --> (F1 A1)) (X5 --> (BR-XOR1 B1 (F1 A1))) (X2 --> BR-ZERO1) (X4 --> (F1 (F1 A1))) (X1 --> (F1 (F1 A1))))
 ((X4 --> (F1 (F1 A1))) (X3 --> (F1 A1)) (X5 --> (BR-XOR1 B1 (F1 A1))) (X2 --> BR-ZERO1) (X1 --> (F1 (F1 A1))))
 ((X3 --> (F1 (BR-XOR1 A1 (F1 |v-31197|) (F1 NIL)))) (X1 --> (F1 NIL)) (X4 --> (F1 |v-31197|))
  (X5 --> (BR-XOR1 |v-31197| NIL B1 (F1 (BR-XOR1 A1 (F1 |v-31197|) (F1 NIL)))))
  (X2 --> (BR-XOR1 NIL (F1 (BR-XOR1 A1 (F1 |v-31197|) (F1 NIL))))))
 ((X2 --> (BR-XOR1 A1 (F1 A1))) (X1 --> (F1 A1)) (X3 --> (F1 A1)) (X5 --> (BR-XOR1 B1 (F1 A1))) (X4 --> (F1 A1)))
 ((X3 --> (F1 A1)) (X5 --> (BR-XOR1 B1 (F1 A1))) (X4 --> (F1 NIL)) (X1 --> (F1 NIL)) (X2 --> (BR-XOR1 NIL (F1 A1))))
 ((X3 --> (F1 (BR-XOR1 A1 (F1 NIL) (F1 (BR-XOR1 NIL NIL B1))))) (X4 --> (F1 (BR-XOR1 NIL NIL B1))) (X1 --> (F1 NIL))
  (X5 --> (BR-XOR1 NIL (F1 (BR-XOR1 A1 (F1 NIL) (F1 (BR-XOR1 NIL NIL B1))))))	;
  (X2 --> (BR-XOR1 NIL (F1 (BR-XOR1 A1 (F1 NIL) (F1 (BR-XOR1 NIL NIL B1))))))))

;Loesung am 04.03.91 (nach dem Aendern von au=collapsing.soundso):

(((X3 --> (F1 A1)) (X5 --> (BR-XOR1 B1 (F1 A1))) (X1 --> (F1 (BR-XOR1 X2 (F1 A1)))) (X4 --> (F1 (BR-XOR1 X2 (F1 A1)))))
 ((X3 --> (F1 A1)) (X5 --> (BR-XOR1 B1 (F1 A1))) (X4 --> (F1 (BR-XOR1 X2 (F1 A1)))) (X1 --> (F1 (BR-XOR1 X2 (F1 A1)))))
 ((X5 --> (BR-XOR1 B1 (F1 A1))) (X1 --> (F1 |v-15645|)) (X4 --> (F1 |v-15645|)) (X3 --> (F1 A1))
  (X2 --> (BR-XOR1 |v-15645| (F1 A1))))
 ((X5 --> (BR-XOR1 B1 (F1 A1))) (X2 --> (BR-XOR1 |v-15645| (F1 A1))) (X3 --> (F1 A1)) (X4 --> (F1 |v-15645|))
  (X1 --> (F1 |v-15645|)))
 ((X1 --> (F1 |v-15561|)) (X5 --> (BR-XOR1 B1 (F1 A1))) (X3 --> (F1 A1)) (X2 --> (BR-XOR1 |v-15561| (F1 A1)))
  (X4 --> (F1 |v-15561|)))
 ((X1 --> (F1 |v-15645|)) (X4 --> (F1 |v-15561|))
  (X5 --> (BR-XOR1 |v-15561| |v-15645| B1 (F1 (BR-XOR1 A1 (F1 |v-15561|) (F1 |v-15645|)))))
  (X3 --> (F1 (BR-XOR1 A1 (F1 |v-15561|) (F1 |v-15645|))))
  (X2 --> (BR-XOR1 |v-15645| (F1 (BR-XOR1 A1 (F1 |v-15561|) (F1 |v-15645|))))))
 ((X5 --> (BR-XOR1 B1 (F1 A1))) (X4 --> (F1 |v-15645|)) (X1 --> (F1 |v-15645|)) (X3 --> (F1 A1))
  (X2 --> (BR-XOR1 |v-15645| (F1 A1))))
 ((X1 --> (F1 (F1 A1))) (X4 --> (F1 (F1 A1))) (X2 --> BR-ZERO1) (X3 --> (F1 A1)) (X5 --> (BR-XOR1 B1 (F1 A1))))
 ((X5 --> (BR-XOR1 B1 (F1 A1))) (X3 --> (F1 A1)) (X2 --> BR-ZERO1) (X4 --> (F1 (F1 A1))) (X1 --> (F1 (F1 A1))))
 ((X4 --> (F1 (F1 A1))) (X2 --> BR-ZERO1) (X3 --> (F1 A1)) (X5 --> (BR-XOR1 B1 (F1 A1))) (X1 --> (F1 (F1 A1))))
 ((X4 --> (F1 NIL)) (X1 --> (F1 B1)) (X2 --> (BR-XOR1 B1 (F1 (BR-XOR1 A1 (F1 NIL) (F1 B1)))))
  (X3 --> (F1 (BR-XOR1 A1 (F1 NIL) (F1 B1)))) (X5 --> (BR-XOR1 NIL (F1 (BR-XOR1 A1 (F1 NIL) (F1 B1))))))
 ((X1 --> (F1 (F1 A1))) (X4 --> (F1 (F1 A1))) (X2 --> BR-ZERO1) (X3 --> (F1 A1)) (X5 --> (BR-XOR1 B1 (F1 A1))))
 ((X5 --> (BR-XOR1 B1 (F1 A1))) (X3 --> (F1 A1)) (X2 --> BR-ZERO1) (X4 --> (F1 (F1 A1))) (X1 --> (F1 (F1 A1))))
 ((X4 --> (F1 (F1 A1))) (X2 --> BR-ZERO1) (X3 --> (F1 A1)) (X5 --> (BR-XOR1 B1 (F1 A1))) (X1 --> (F1 (F1 A1))))
 ((X4 --> (F1 (BR-XOR1 |v-15645| NIL B1))) (X1 --> (F1 |v-15645|))
  (X5 --> (BR-XOR1 NIL (F1 (BR-XOR1 A1 (F1 |v-15645|) (F1 (BR-XOR1 |v-15645| NIL B1))))))
  (X3 --> (F1 (BR-XOR1 A1 (F1 |v-15645|) (F1 (BR-XOR1 |v-15645| NIL B1)))))
  (X2 --> (BR-XOR1 |v-15645| (F1 (BR-XOR1 A1 (F1 |v-15645|) (F1 (BR-XOR1 |v-15645| NIL B1)))))))
 ((X3 --> (F1 A1)) (X5 --> (BR-XOR1 B1 (F1 A1))) (X1 --> (F1 (BR-XOR1 X2 (F1 A1)))) (X4 --> (F1 (BR-XOR1 X2 (F1 A1)))))
 ((X3 --> (F1 A1)) (X5 --> (BR-XOR1 B1 (F1 A1))) (X1 --> (F1 NIL)) (X4 --> (F1 NIL)) (X2 --> (BR-XOR1 NIL (F1 A1))))
 ((X3 --> (F1 A1)) (X5 --> (BR-XOR1 B1 (F1 A1))) (X2 --> (BR-XOR1 NIL (F1 A1))) (X4 --> (F1 NIL)) (X1 --> (F1 NIL)))
 ((X3 --> (F1 A1)) (X5 --> (BR-XOR1 B1 (F1 A1))) (X2 --> BR-ZERO1) (X4 --> (F1 (F1 A1))) (X1 --> (F1 (F1 A1))))
 ((X1 --> (F1 (F1 A1))) (X4 --> (F1 (F1 A1))) (X2 --> BR-ZERO1) (X5 --> (BR-XOR1 B1 (F1 A1))) (X3 --> (F1 A1)))
 ((X4 --> (F1 (F1 A1))) (X3 --> (F1 A1)) (X5 --> (BR-XOR1 B1 (F1 A1))) (X2 --> BR-ZERO1) (X1 --> (F1 (F1 A1))))
 ((X3 --> (F1 (BR-XOR1 A1 (F1 |v-15561|) (F1 NIL)))) (X1 --> (F1 NIL)) (X4 --> (F1 |v-15561|))
  (X5 --> (BR-XOR1 |v-15561| NIL B1 (F1 (BR-XOR1 A1 (F1 |v-15561|) (F1 NIL)))))
  (X2 --> (BR-XOR1 NIL (F1 (BR-XOR1 A1 (F1 |v-15561|) (F1 NIL))))))
 ((X2 --> (BR-XOR1 A1 (F1 A1))) (X1 --> (F1 A1)) (X3 --> (F1 A1)) (X5 --> (BR-XOR1 B1 (F1 A1))) (X4 --> (F1 A1)))
 ((X4 --> (F1 A1)) (X5 --> (BR-XOR1 B1 (F1 A1))) (X3 --> (F1 A1)) (X1 --> (F1 A1)) (X2 --> (BR-XOR1 A1 (F1 A1))))
 ((X1 --> (F1 NIL)) (X2 --> (BR-XOR1 NIL (F1 A1))) (X3 --> (F1 A1)) (X4 --> (F1 NIL)) (X5 --> (BR-XOR1 B1 (F1 A1))))
 ((X3 --> (F1 (BR-XOR1 A1 (F1 NIL) (F1 (BR-XOR1 NIL NIL B1))))) (X4 --> (F1 (BR-XOR1 NIL NIL B1))) (X1 --> (F1 NIL))
  (X5 --> (BR-XOR1 NIL (F1 (BR-XOR1 A1 (F1 NIL) (F1 (BR-XOR1 NIL NIL B1))))))
  (X2 --> (BR-XOR1 NIL (F1 (BR-XOR1 A1 (F1 NIL) (F1 (BR-XOR1 NIL NIL B1))))))))

; Loesung des BR.FREE-Algorithmus:

(((X1 --> (F1 A1))   (X2 --> (BR-XOR1 A1 (F1 A1)))   (X3 --> (F1 A1))   (X4 --> (F1 A1))   (X5 --> (BR-XOR1 B1 (F1 A1))))
 ((X1 --> (F1 (BR-XOR1 X2 (F1 A1)))) (X3 --> (F1 A1))   (X4 --> (F1 (BR-XOR1 X2 (F1 A1))))   (X5 --> (BR-XOR1 B1 (F1 A1))))
 ((X1 --> (F1 NIL))   (X2 --> (BR-XOR1 NIL (F1 (BR-XOR1 A1 (F1 NIL) (F1 (BR-XOR1 NIL NIL B1))))))
  (X3 --> (F1 (BR-XOR1 A1 (F1 NIL) (F1 (BR-XOR1 NIL NIL B1)))))
  (X4 --> (F1 (BR-XOR1 NIL NIL B1)))
  (X5 --> (BR-XOR1 NIL (F1 (BR-XOR1 A1 (F1 NIL) (F1 (BR-XOR1 NIL NIL B1))))))))
|#

(setf multi (list (list x1 (uds-create '(f1 a1)) (uds-create '(f1 (br-xor1 x1 x2))))
		  (list x3 (uds-create '(f1 (br-xor1 x1 x4 a1))))
		  (list x4 (uds-create '(f1 (br-xor1 x2 x5 b1))))))
(test= 10
       (tu.test-unifiers multi)
        (((X1 (F1 A1))
	  (X2 (BR-XOR1 A1 (F1 A1)))
	  (X3 (F1 (BR-XOR1 A1 (F1 A1) (F1 (BR-XOR1 X5 A1 B1 (F1 A1))))))
	  (X4 (F1 (BR-XOR1 X5 A1 B1 (F1 A1))))))
       tu.test-subst.test)

(setf multi (list (list x1 (uds-create '(f1 (br-xor1 x2 x3))))
		  (list x3 (uds-create '(f1 (br-xor1 x4 a1 a2))))
		  (list x4 (uds-create '(f1 (br-xor1 x5 b1))))
		  (list x5 (uds-create '(f1 x1)))))
(test= 11
       (tu.test-unifiers multi)
       (((X1 (F1 v_1)) 
	 (X2 (BR-XOR1 v_1 (F1 (BR-XOR1 A1 A2 (F1 (BR-XOR1 B1 (F1 (F1 v_1)))))))) 
	 (X3 (F1 (BR-XOR1 A1 A2 (F1 (BR-XOR1 B1 (F1 (F1 v_1)))))))
	 (X4 (F1 (BR-XOR1 B1 (F1 (F1 v_1)))))
	 (X5 (F1 (F1 v_1)))))
	#|((X1 (F1 NIL)) 
	 (X3 (F1 (BR-XOR1 A1 A2 (F1 (BR-XOR1 B1 (F1 (F1 NIL))))))) 
	 (X2 (BR-XOR1 NIL (F1 (BR-XOR1 A1 A2 (F1 (BR-XOR1 B1 (F1 (F1 NIL))))))))
	 (X4 (F1 (BR-XOR1 B1 (F1 (F1 NIL)))))
	 (X5 (F1 (F1 NIL)))))|#
       tu.test-subst.test "Beide Loesungen aeqivalent: v_1 entspricht NIL !?!")


(setf multi (list (list a1 (uds-create '(br-xor1 x1 x3)))
		  (list (uds-create '(f1 x1)) (uds-create '(f1 (f1 x2))))))
(test= 12
       (tu.test-unifiers multi)
       (((X3 (BR-XOR1 A1 (F1 X2))) (X1 (F1 X2))))
       tu.test-subst.test)


(setf multi (list (list a2 (uds-create '(br-xor1 x3 x4)))
		  (list a1 (uds-create '(br-xor1 x1 x2 x3)))
		  (list (uds-create '(f1 y3)) x2 (uds-create '(br-xor1 y2 b2)))
		  (list (uds-create '(f1 b1)) x1 (uds-create '(br-xor1 y1 b1)))))
(test= 13
       (tu.test-unifiers multi)
       (((X2 (F1 B1)) (Y3 B1) (X3 A1) (Y1 (BR-XOR1 B1 (F1 B1))) (Y2 (BR-XOR1 B2 (F1 B1))) (X4 (BR-XOR1 A1 A2))
	 (X1 (F1 B1)))
	((X2 (F1 Y3)) (X1 (F1 B1)) (X4 (BR-XOR1 A1 A2 (F1 Y3) (F1 B1))) (Y2 (BR-XOR1 B2 (F1 Y3)))
	 (Y1 (BR-XOR1 B1 (F1 B1))) (X3 (BR-XOR1 A1 (F1 Y3) (F1 B1)))))
       tu.test-subst.test "Die ersten beiden Loesungen gleich.")


(setf multi (list (list a1 (uds-create '(br-xor1 x1 x2 a1)))
		  (list (uds-create '(f1 y3)) x2 (uds-create '(br-xor1 y2 b2)))
		  (list (uds-create '(f1 b1)) x1 (uds-create '(br-xor1 y1 b1)))))
(test= 14
       (tu.test-unifiers multi)
       (((X2 (F1 B1)) (X1 (F1 B1)) (Y3 B1) (Y2 (BR-XOR1 B2 (F1 B1))) (Y1 (BR-XOR1 B1 (F1 B1)))))
       tu.test-subst.test)


;Beispiel 15 laeuft in eine Endlositeration (07.03.91).          Loesung am 30.05.91

(setf multi (list (list x2 (uds-create '(f1 (br-xor1 x x1 x2))))
		  (list x1 (uds-create '(f1 y2)))
		  (list x  (uds-create '(f1 b1)) (uds-create '(br-xor1 y1 b1)))))
(test= 15
       (tu.test-unifiers multi)
       (((X (F1 B1)) (X1 (F1 (F1 B1))) (X2 (F1 (F1 B1))) (Y1 (BR-XOR1 B1 (F1 B1))) (Y2 (F1 B1))))
       tu.test-subst.test "Alle vier Loesungen gleich")

#|
(test= 15
       (uni-substitutions (uni-create.termlists.unification.problem multi))
       (((X (F1 B1)) (X1 (F1 (F1 B1))) (X2 (F1 (F1 B1))) (Y1 (BR-XOR1 B1 (F1 B1))) (Y2 (F1 B1))))
       tu.test-subst.test)
(test= 15
       (let ((substitutions-object (gu-general.unification.termlists multi)))
	 (when substitutions-object
	   (uds-substitutions substitutions-object)))
       (((X (F1 B1)) (X1 (F1 (F1 B1))) (X2 (F1 (F1 B1))) (Y1 (BR-XOR1 B1 (F1 B1))) (Y2 (F1 B1))))
       tu.test-subst.test)
|#

;Beispiel 16 liefert manchmal eine und manchmal zwei oder drei (nicht mininmale) Loesungen!?!

(setf multi (list (list    (uds-create '(f1 (f1 y3))) (uds-create '(f1 (br-xor1 x x1 x2))))
		  (list x1 (uds-create '(f1 y2)))
		  (list x  (uds-create '(f1 b1)) (uds-create '(br-xor1 y1 b1)))))
(test= 16
       (tu.test-unifiers multi)
       (;((X (F1 B1))   (X1 (F1 B1))   (X2 (F1 Y3))   (Y1 (BR-XOR1 B1 (F1 B1)))   (Y2 B1))
        ((X (F1 B1))   (X1 (F1 Y2))   (X2 (BR-XOR1 (F1 Y2) (F1 Y3) (F1 B1)))   (Y1 (BR-XOR1 B1 (F1 B1)))))
       tu.test-subst.test "Erste Loesung Instanz der Zweiten (y2 --> b1)")


(setf multi (list (list x1  (uds-create '(f1 a1)) (uds-create '(br-xor1 x2 y1 (f1 a1))))
		  (list y1  (uds-create '(f1 b1)) (uds-create '(br-xor1 y2 x1 (f1 b1))))))
(test= 17
       (tu.test-unifiers multi)
        (((X1 --> (F1 A1)) (X2 --> (F1 B1)) (Y1 --> (F1 B1)) (Y2 --> (F1 A1))))
       tu.test-subst.test "Beide Loesungen gleich")



;BR*.FREE

(setf multi (list (list x (uds-create '(br-and1 x1 a1))) (list x (uds-create '(br-and2 x2 a1)))))
(test= 18
       (tu.test-unifiers multi)
       (((X A1) (X1 (BR-XOR1 v_1 A1 (BR-AND1 v_1 A1))) (X2 (BR-XOR2 v_2 A1 (BR-AND2 v_2 A1)))))
       tu.test-subst.test)

(setf multi (list (list x (uds-create `(br-xor1 x1 a1))) (list x (uds-create `(br-xor2 y1 b1)))))
(test= 19
       (tu.test-unifiers multi)
       (((X (BR-XOR2 Y1 B1)) (X1 (BR-XOR1 A1 (BR-XOR2 Y1 B1))))
	((X (BR-XOR1 X1 A1)) (Y1 (BR-XOR2 B1 (BR-XOR1 X1 A1)))))
       tu.test-subst.test "Dritte Loesung ist Instanz der Ersten.")

(setf multi (list (list x (uds-create `(br-and1 x1 a1))) (list x (uds-create `(br-and2 y1 b1)))))
(test= 20
       (tu.test-unifiers multi)
       NIL
       tu.test-subst.test)

(setf multi (list (list x (uds-create `(br-and1 x1 a1)) (uds-create `(br-and2 y1 a1)))))
(test= 21
       (tu.test-unifiers multi)
       (((X A1) (Y1 (BR-XOR2 v_1 A1 (BR-AND2 v_1 A1))) (X1 (BR-XOR1 v_2 A1 (BR-AND1 v_2 A1)))))
       tu.test-subst.test)

(setf multi (list (list x1 (uds-create '(f1 (br-xor1 x2 x3))))
		  (list x3 (uds-create '(br-xor2 x4 a1 a2)))
		  (list x4 (uds-create '(f1 (br-xor1 x5 b1))))
		  (list x5 (uds-create '(br-xor2 x1)))))
(test= 22
       (tu.test-unifiers multi)
       (((X1 (F1 v_1))
	 (X2 (BR-XOR1 v_1 (BR-XOR2 A1 A2 (F1 (BR-XOR1 B1 (F1 v_1))))))
	 (X3 (BR-XOR2 A1 A2 (F1 (BR-XOR1 B1 (F1 v_1)))))
	 (X4 (F1 (BR-XOR1 B1 (F1 v_1))))
	 (X5 (F1 v_1))))
	#|((X1 (F1 NIL))
	 (X2 (BR-XOR1 NIL (BR-XOR2 A1 A2 (F1 (BR-XOR1 B1 (F1 NIL))))))
	 (X3 (BR-XOR2 A1 A2 (F1 (BR-XOR1 B1 (F1 NIL)))))
	 (X4 (F1 (BR-XOR1 B1 (F1 NIL))))
	 (X5 (F1 NIL))))|#
	tu.test-subst.test "Beide Loesungen aeqivalent: v_1 entspricht NIL !?!")


(setf multi (list (list (uds-create '(br-xor2 br-zero1 y4)) x3 (uds-create '(br-xor1 x1 x2)))
		  (list (uds-create '(f1 y3))               x2 (uds-create '(br-xor1 y2 b2)))
		  (list (uds-create '(f1 b1))               x1 (uds-create '(br-xor1 y1 b1)))
		  ))
(test= 23
       (tu.test-unifiers multi)
       (((X2 (F1 Y3)) (X1 (F1 B1)) (X3 (BR-XOR1 (F1 Y3) (F1 B1))) (Y4 (BR-XOR2 BR-ZERO1 (BR-XOR1 (F1 Y3) (F1 B1))))
	 (Y1 (BR-XOR1 B1 (F1 B1))) (Y2 (BR-XOR1 B2 (F1 Y3)))))
       ;(((X2 (F1 B1)) (X1 (F1 B1)) (Y3 B1) (Y2 (BR-XOR1 B2 (F1 B1))) (Y1 (BR-XOR1 B1 (F1 B1))) (x3 br-zero1) (y4 br-zero2)))
       tu.test-subst.test)


(setf multi (list (list (uds-create '(f2 a1 x2)) (uds-create '(f2 x1 a2)))
		  (list (uds-create '(f2 b1 y2)) x1)))
(test= 24
       (tu.test-unifiers multi)
       nil
       tu.test-subst.test)


;))
;)
#|
(with-open-file (file "br16.trace" :direction :output)
  (let ((trace au*trace))
    (setf au*trace file)
    (term-reset)
    (reset-grouped-array :memory)
    (term=cth.reset :loaded)
    (term=cth.configure)
    
    (do-new.environment
      
      
      (uds-instantiate 'th-boolean.ring '(br-xor1 br-not1 br-zero1 br-and1 br-one1)
		       :constants '(a1 a2 b1)
		       :variables '(x1 x2 x3 x4 x5))
      (uds-instantiate 'th-boolean.ring '(br-xor2 br-not2 br-zero2 br-and2 br-one2))
      (setf f1 (uds-function.create 'f1 1))
      (setf v_1 'v_1 v_2 'v_2 v_3 'v_3 v_4 'v_4)

      (setf term1 x1)
      (setf term2 (uds-create '(f1 (br-xor1 x2 x3))))
      (setf term11 x3)
      (setf term12 (uds-create '(br-xor2 x4 a1 a2)))
      (setf term21 x4)
      (setf term22 (uds-create '(f1 (br-xor1 x5 b1))))
      (setf term31 x5)
      (setf term32 (uds-create '(br-xor2 x1)))
      (setf multi (list (list term1 term2) (list term11 term12) (list term21 term22) (list term31 term32)))
      (test= 16
	     (tu.test-unifiers multi)
	     (((X1 (F1 v_1))
	       (X2 (BR-XOR1 v_1 (BR-XOR2 A1 A2 (F1 (BR-XOR1 B1 (F1 v_1))))))
	       (X3 (BR-XOR2 A1 A2 (F1 (BR-XOR1 B1 (F1 v_1)))))
	       (X4 (F1 (BR-XOR1 B1 (F1 v_1))))
	       (X5 (F1 v_1))))
	     #|((X1 (F1 NIL))
	 (X2 (BR-XOR1 NIL (BR-XOR2 A1 A2 (F1 (BR-XOR1 B1 (F1 NIL))))))
	 (X3 (BR-XOR2 A1 A2 (F1 (BR-XOR1 B1 (F1 NIL)))))
	 (X4 (F1 (BR-XOR1 B1 (F1 NIL))))
	 (X5 (F1 NIL)))|#
	     tu.test-subst.test "Beide Loesungen aeqivalent: v_1 entspricht NIL !?!")

      )
    (setf au*trace trace)))


(with-open-file (file "br20.trace" :direction :output)
  (let ((trace au*trace))
    (setf au*trace file)
    (tu.test-unifiers multi)
    (setf au*trace trace)))


(setf file (open "free.trace" :direction :output))
(setf au*trace file)
(tu.test-unifiers multi)

(close file)
(setf au*trace nil)
|#
