;;; -*- Package: HADES; Syntax: Common-lisp; Mode: LISP -*-


(in-package 'hades)

(term-reset)
(reset-grouped-array :memory)

(uds-instantiate 'th-abelian.semigroup
		 '(thas1)
		 :constants '(a1 a2 a3 a4 b1 b2 b3 b4)
		 :variables '(x x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 y1 y2 y3 y4))
(uds-instantiate 'th-abelian.semigroup '(thas2))
(uds-instantiate 'th-abelian.semigroup '(thas3))
(uds-instantiate 'th-abelian.monoid '(tham1 am-one1))
(uds-instantiate 'th-abelian.monoid '(tham2 am-one2))
(uds-instantiate 'th-abelian.group '(ag-plus1 ag-minus1 ag-zero1))
(uds-instantiate 'th-abelian.group '(ag-plus2 ag-minus2 ag-zero2))
(uds-instantiate 'th-boolean.ring '(br-xor1 br-not1 br-zero1 br-and1 br-one1))
(uds-instantiate 'th-boolean.ring '(br-xor2 br-not2 br-zero2 br-and2 br-one2))
(setf f1 (uds-function.create 'f1 1))
(setf f2 (uds-function.create 'f2 2))
(setf f3 (uds-function.create 'f3 3))


(setf term1 (uds-create '(f2 x1 (br-xor1 x4 a1 a2))))
(setf term2 (uds-create '(f2 (thas1 y2 y2) y1)))
(setf term3 (uds-create '(f2 (thas1 y3 a1) y4)))
(setf multi (list (list x term1) (list x term2 term3)))
(test= 1
       (au=unification.problem.substitutions
	 (au-unify.in.arbitrary.disjoint.equational.theories multi))
       (((Y1 (BR-XOR1 X4 A1 A2)) (Y2 (THAS1 v_1 A1))
	 (Y4 (BR-XOR1 X4 A1 A2)) (Y3 (THAS1 v_1 v_1 A1))
	 (X1 (THAS1 v_1 v_1 A1 A1)) (X (F2 (THAS1 v_1 v_1 A1 A1) (BR-XOR1 X4 A1 A2))))
	((Y1 (BR-XOR1 X4 A1 A2)) (Y2 A1)
	 (Y4 (BR-XOR1 X4 A1 A2)) (Y3 A1)
	 (X1 (THAS1 A1 A1)) (X (F2 (THAS1 A1 A1) (BR-XOR1 X4 A1 A2)))))
       tu.test=subst)
	
(setf term1 (uds-create '(br-xor1 x1 x2)))
(setf term2 (uds-create '(ag-plus1 x1 x2)))
(setf multi (list (list x term1) (list x term2)))
(test= 2
       (au=unification.problem.substitutions
	 (au-unify.in.arbitrary.disjoint.equational.theories multi))
       NIL
       tu.test=subst)


(setf term1 (uds-create '(f2 x3 x4)))
(setf term2 (uds-create '(tham1 x1 x2 x2)))
(setf term3 (uds-create '(tham2 x1 x4)))
(setf term4 (uds-create '(thas1 y1 y2)))
(setf term5 (uds-create '(tham1 y1 y3)))
(setf multi (list (list x term1 term2 term3) (list x3 term4 term5)))
(test= 3
       (au=unification.problem.substitutions
	 (au-unify.in.arbitrary.disjoint.equational.theories multi))
       (((X (F2 (THAS1 Y2 AM-ONE1) AM-ONE2))
	 (X4 AM-ONE2) (X3 (THAS1 Y2 AM-ONE1))
	 (X2 AM-ONE1) (X1 (F2 (THAS1 Y2 AM-ONE1) AM-ONE2))
	 (Y1 AM-ONE1) (Y3 (THAS1 Y2 AM-ONE1))))
       tu.test=subst)


(setf term1 (uds-create '(tham1 x1 x1 (thas1 x2 x2))))
(setf term2 (uds-create '(tham1 y1 y1 y2 y3)))
(setf multi (list (list x term1) (list x term2)))
(test= 4
       (au=unification.problem.substitutions
	 (au-unify.in.arbitrary.disjoint.equational.theories multi))
       2
       tu.test=subst)



(setf multi (list (list (uds-create '(tham1 br-zero1 y4)) x3 (uds-create '(br-xor1 x1 x2)))
		  (list (uds-create '(f1 y3))             x2 (uds-create '(br-xor1 y2 b2)))
		  (list (uds-create '(f1 b1))             x1 (uds-create '(br-xor1 y1 b1)))))
(test= 5
       (au=unification.problem.substitutions
	 (au-unify.in.arbitrary.disjoint.equational.theories multi))
       (((X2 (F1 B1)) (X1 (F1 B1)) (Y3 B1) (Y2 (BR-XOR1 B2 (F1 B1))) (Y1 (BR-XOR1 B1 (F1 B1))) (x3 br-zero1) (y4 am-one1)))
       tu.test=subst)
