;;; -*- Package: HADES; Syntax: Common-lisp; Mode: LISP -*-


(in-package 'hades)

(term-reset)
(reset-grouped-array :memory)

(uds-instantiate 'th-abelian.semigroup
		 '(thas1)
		 :constants '(a1 a2 a3 a4 b1 b2 b3 b4)
		 :variables '(x x1 x2 x3 x4 x5 x6 x7 x8 x9 x10 y1 y2 y3 y4))
(uds-instantiate 'th-abelian.semigroup '(thas2))
(uds-instantiate 'th-abelian.semigroup '(thas3))
(uds-instantiate 'th-abelian.monoid '(tham1 am-one1))
(uds-instantiate 'th-abelian.monoid '(tham2 am-one2))
;(uds-instantiate 'th-boolean.ring '(br-xor1 br-not1 br-zero1 br-and1 br-one1))
;(uds-instantiate 'th-boolean.ring '(br-xor2 br-not2 br-zero2 br-and2 br-one2))
(setf f1 (uds-function.create 'f1 1))
(setf f2 (uds-function.create 'f2 2))
(setf f3 (uds-function.create 'f3 3))

(setf term1 (uds-create '(thas1 x1 x2)))
(setf term2 (uds-create '(tham1 y1 y2)))
(setf term3 (uds-create '(thas2 x3 x4)))
(setf term4 (uds-create '(tham2 y3 y4)))


;Aufrufe ueber UNI-Modul

(test= 1 
       (do-type (uni-create.elementary.unification.problem term1 term2))
       au*unification-problem)

(setf multi (list (list term1 term2)))
(test= 2
       (uni-substitutions
	 (uni-create.elementary.unification.problem term1 term2))
       (((y1 am-one1) (y2 (thas1 x1 x2)))
	((y1 (thas1 x1 x2)) (y2 am-one1)))
       tu.test=subst)
(uni-create.unification.problem term2 x)
(test= 3
       (uni-substitutions
	 (uni-create.termlist.unification.problem (list term1 term2)))
       (((y1 am-one1) (y2 (thas1 x1 x2)))
	((y1 (thas1 x1 x2)) (y2 am-one1)))
       tu.test=subst)

(setf multi (list (list term1 term2) (list term3 term4)))
(test= 4
       (uni-substitutions
	 (uni-create.elementary.unification.problem (list term1 term3) (list term2 term4)))
       (((y1 am-one1) (y2 (thas1 x1 x2)) (y3 am-one2) (y4 (thas2 x3 x4)))
	((y1 am-one1) (y2 (thas1 x1 x2)) (y4 am-one2) (y3 (thas2 x3 x4)))
	((y2 am-one1) (y1 (thas1 x1 x2)) (y4 am-one2) (y3 (thas2 x3 x4)))
	((y2 am-one1) (y1 (thas1 x1 x2)) (y3 am-one2) (y4 (thas2 x3 x4))))
       tu.test=subst)

(test= 5
       (uni-substitutions
	 (uni-create.termlists.unification.problem multi))
       (((y1 am-one1) (y2 (thas1 x1 x2)) (y3 am-one2) (y4 (thas2 x3 x4)))
	((y1 am-one1) (y2 (thas1 x1 x2)) (y4 am-one2) (y3 (thas2 x3 x4)))
	((y2 am-one1) (y1 (thas1 x1 x2)) (y4 am-one2) (y3 (thas2 x3 x4)))
	((y2 am-one1) (y1 (thas1 x1 x2)) (y3 am-one2) (y4 (thas2 x3 x4))))
       tu.test=subst)


;Einbindung des neuen Unifikationsproblems
;Merge

(setf multi nil)


(setf subst (subst-create (list x1) (list a1)))
(test= 5
       (uni-substitutions (uni-merge subst (uni-create.termlist.unification.problem (list term1 term2))))
       (((y1 am-one1) (y2 (thas1 x2 a1)) (x1 a1))
	((y2 am-one1) (y1 (thas1 x2 a1)) (x1 a1)))
       tu.test=subst)

(test= 6
       (uni-substitutions (uni-merge (uni-create.termlist.unification.problem (list term1 term2)) subst))
       (((y1 am-one1) (y2 (thas1 x2 a1)) (x1 a1))
	((y2 am-one1) (y1 (thas1 x2 a1)) (x1 a1)))
       tu.test=subst)


(setf subst (subst-create (list y1) (list a1)))
(test= 7
       (uni-merge subst (uni-create.termlist.unification.problem (list term1 term2)))
       NIL
       tu.test=subst)


(setf subst (subst-create (list y1) (list a1)))
(test= 8
       (uni-substitutions (uni-merge subst (uni-create.termlist.unification.problem (list term1 term2)) (list y2)))
       (((y2 (thas1 x1 x2)))
	((y2 am-one1)))
       tu.test=subst)


(setf subst (subst-create (list y1) (list term4)))
(test= 9
       (uni-substitutions (uni-merge subst (uni-create.termlist.unification.problem (list term1 term2))))
       (((y1 am-one1) (y2 (thas1 x1 x2)) (y3 am-one2) (y4 am-one1))
	((y1 am-one1) (y2 (thas1 x1 x2)) (y4 am-one2) (y3 am-one1))
	((y2 am-one1) (y1 (thas1 x1 x2)) (y4 am-one2) (y3 (thas1 x1 x2)))
	((y2 am-one1) (y1 (thas1 x1 x2)) (y3 am-one2) (y4 (thas1 x1 x2))))
       tu.test=subst)


(setf substs (subst-l.create (list (subst-create (list y1) (list term4))
				   (subst-create (list y1) (list a1))
				   (subst-create (list x1) (list a1)))))
(test= 10
       (uni-substitutions (uni-merge substs (uni-create.termlist.unification.problem (list term1 term2))))
       (((y1 am-one1) (y2 (thas1 x1 x2)) (y3 am-one2) (y4 am-one1))
	((y1 am-one1) (y2 (thas1 x1 x2)) (y4 am-one2) (y3 am-one1))
	((y2 am-one1) (y1 (thas1 x1 x2)) (y4 am-one2) (y3 (thas1 x1 x2)))
	((y2 am-one1) (y1 (thas1 x1 x2)) (y3 am-one2) (y4 (thas1 x1 x2)))
	((y1 am-one1) (y2 (thas1 x2 a1)) (x1 a1))
	((y2 am-one1) (y1 (thas1 x2 a1)) (x1 a1)))
       tu.test=subst)

(setf up1 (uni-create.termlist.unification.problem (list term1 term2)))
(setf up2 (uni-create.termlist.unification.problem (list term1 term2)))
(test= 11
       (uni-substitutions (uni-merge up1 up2))
       (((y1 am-one1) (y2 (thas1 x1 x2)))
	((y2 am-one1) (y1 (thas1 x1 x2))))
       tu.test=subst)


;Insert

(setf multi nil)

(setf up1 (uni-create.termlist.unification.problem (list term1 term2)))
(setf up2 (uni-create.termlist.unification.problem (list term1 term2)))
(test= 12
       (uni-substitutions (uni-insert up1 up2))
       (((y1 am-one1) (y2 (thas1 x1 x2)))
	((y1 (thas1 x1 x2)) (y2 am-one1))
	((y1 am-one1) (y2 (thas1 x1 x2)))
	((y2 am-one1) (y1 (thas1 x1 x2))))
       tu.test=subst)

(setf up1 (uni-create.termlist.unification.problem (list term1 term2)))
(setf up2 (uni-create.termlist.unification.problem (list term1 term2)))
(test= 13
       (uni-substitutions (uni-insert up1 up2 t))
       (((y1 am-one1) (y2 (thas1 x1 x2)))
	((y2 am-one1) (y1 (thas1 x1 x2))))
       tu.test=subst)


(setf subst (subst-create (list y1) (list x5)))
(test= 14
       (uni-substitutions (uni-insert subst (uni-create.termlist.unification.problem (list term1 term2))))
       (((y1 am-one1) (y2 (thas1 x1 x2)))
	((y2 am-one1) (y1 (thas1 x1 x2)))
	((y1 x5)))
       tu.test=subst)

(test= 15
       (uni-substitutions (uni-insert subst (uni-create.termlist.unification.problem (list term1 term2)) t t))
       (((y1 x5)))
       tu.test=subst)

(setf up1 (uni-create.termlist.unification.problem (list term1 term2)))
(setf up2 (uni-create.termlist.unification.problem (list term3 term4)))
(test= 12
       (uni-substitutions (uni-insert up1 up2))
       (((y1 am-one1) (y2 (thas1 x1 x2)))
	((y2 am-one1) (y1 (thas1 x1 x2)))
	((y3 am-one2) (y4 (thas2 x3 x4)))
	((y4 am-one2) (y3 (thas2 x3 x4))))
       tu.test=subst)

