(in-package "KEIM")

(setf exblstn*env (env~create))

(post~read-object-list '((type-constants i)
			 (constants (a i) (b i)
				    (a0 i) (b0 i)
				    (a1 i) (b1 i)
				    (a_0 i) (a_1 i)
				    (fr (i i)))
			 (variables (x i) (y i) (z i) (u i) (v i) (w i)
				    (x1 i) (x2 i) (x3 i) (x4 i) (x5 i) (x6 i)
				    (y1 i) (y2 i) (y3 i) (y4 i) (y5 i) (y6 i))
			 (signatures (aci (f (i i i))) (aci (h (i i)))
				     (ac (+ (i i i))) (ac (* (i i i)))))
		       exblstn*env)

(defun cb==test (t1 t2 wwert)
  (let* ((stream *standard-output*)
	 (*standard-output* my-stream)
	 (term1 (term~copy (term~read t1 exblstn*env)))
	 (term2 (term~copy (term~read t2 exblstn*env)))
	 (result (mcb~decide-unify (list (list term1  term2)))
	   #+weg(cb~decide-unify (list (list term1 term2))
				   exblstn*env)))
    (declare (special *standard-output*))
    (get-output-stream-string my-stream)
    (format stream "~%~A: ~A ~A   " (incf counter) t1 t2)
    (cond #+weg((null wwert)
	   (format stream "### ~A must be ~A ###" result wwert))
	  ((eq (null result) (null wwert))
	   (format stream "OK"))
	  (t
	   (format stream "*** must be ~A ***" wwert)))))


(setf counter 0)
(setf my-stream (make-string-output-stream))


(time (progn
(cb==test (QUOTE (+ a_0 x1)) (QUOTE  (+ a_0 y1)) T ) 
(cb==test (QUOTE (* a_1 x1)) (QUOTE  (* a_1 y1)) T ) 
(cb==test (QUOTE (* a_1 x1)) (QUOTE  (* y1 y1)) T ) 
(cb==test (QUOTE (* x1 x1)) (QUOTE  (* y1 y1)) T ) 
(cb==test (QUOTE (* x1 x1)) (QUOTE  (* a_1 y1)) T ) 
(cb==test (QUOTE (* a_1 x1)) (QUOTE  (* a_0 y1)) T ) 
(cb==test (QUOTE (* a_1 x1)) (QUOTE  (* (* a_0 y1) y2)) T ) 
(cb==test (QUOTE (* x1 x1)) (QUOTE  (* a_0 y1)) T ) 
(cb==test (QUOTE (* x1 x1)) (QUOTE  (* (* a_0 y1) y2)) T ) 
(cb==test (QUOTE (* a_0 x1)) (QUOTE  (* a_0 y1)) T ) 
(cb==test (QUOTE (* (* a_0 x1) x2)) (QUOTE  (* a_0 y1)) T ) 
(cb==test (QUOTE (* a_0 x1)) (QUOTE  (* (* a_0 y1) y2)) T ) 
(cb==test (QUOTE (* (* a_0 x1) x2)) (QUOTE  (* (* a_0 y1) y2)) T ) 
(cb==test (QUOTE (* a_0 x1)) (QUOTE  (* a_1 y1)) T ) 
(cb==test (QUOTE (* (* a_0 x1) x2)) (QUOTE  (* a_1 y1)) T ) 
(cb==test (QUOTE (* a_0 x1)) (QUOTE  (* y1 y1)) T ) 
(cb==test (QUOTE (* (* a_0 x1) x2)) (QUOTE  (* y1 y1)) T ) 
(cb==test (QUOTE (+ a_0 x1)) (QUOTE  (+ y1 (fr y1))) T ) 
(cb==test (QUOTE (+ a_0 x1)) (QUOTE  (+ (+ y1 y2) (fr y1))) T ) 
(cb==test (QUOTE (+ x1 (fr x1))) (QUOTE  (+ y1 (fr y1))) T ) 
(cb==test (QUOTE (+ (+ x1 x2) (fr x1))) (QUOTE  (+ y1 (fr y1))) T ) 
(cb==test (QUOTE (+ x1 (fr x1))) (QUOTE  (+ (+ y1 y2) (fr y1))) T ) 
(cb==test (QUOTE (+ (+ x1 x2) (fr x1))) (QUOTE  (+ (+ y1 y2) (fr y1))) T ) 
(cb==test (QUOTE (+ x1 (fr x1))) (QUOTE  (+ a_0 y1)) T ) 
(cb==test (QUOTE (+ (+ x1 x2) (fr x1))) (QUOTE  (+ a_0 y1)) T ) 
(cb==test (QUOTE (* a_1 x1)) (QUOTE  (* y1 (+ y2 y3))) T ) 
(cb==test (QUOTE (* x1 x1)) (QUOTE  (* y1 (+ y2 y3))) T ) 
(cb==test (QUOTE (* a_0 x1)) (QUOTE  (* y1 (+ y2 y3))) T ) 
(cb==test (QUOTE (* (* a_0 x1) x2)) (QUOTE  (* y1 (+ y2 y3))) T ) 
(cb==test (QUOTE (* x1 (+ x2 x3))) (QUOTE  (* y1 (+ y2 y3))) T ) 
(cb==test (QUOTE (+ x2 x3)) (QUOTE  (+ a_0 y1)) T ) 
(cb==test (QUOTE (* x1 (+ x2 x3))) (QUOTE  (* a_1 y1)) T ) 
(cb==test (QUOTE (* x1 (+ x2 x3))) (QUOTE  (* y1 y1)) T ) 
(cb==test (QUOTE (* x1 (+ x2 x3))) (QUOTE  (* a_0 y1)) T ) 
(cb==test (QUOTE (* x1 (+ x2 x3))) (QUOTE  (* (* a_0 y1) y2)) T ) 
(cb==test (QUOTE (+ x2 x3)) (QUOTE  (+ y1 (fr y1))) T ) 
(cb==test (QUOTE (+ x2 x3)) (QUOTE  (+ (+ y1 y2) (fr y1))) T ) 
(cb==test (QUOTE (+ a_0 x1)) (QUOTE  (+ y2 (fr (+ y1 y2)))) T ) 
(cb==test (QUOTE (+ a_0 x1)) (QUOTE  (+ (+ y2 y3) (fr (+ y1 y2)))) T ) 
(cb==test (QUOTE (+ x1 (fr x1))) (QUOTE  (+ y2 (fr (+ y1 y2)))) NIL ) 
(cb==test (QUOTE (+ (+ x1 x2) (fr x1))) (QUOTE  (+ y2 (fr (+ y1 y2)))) T ) 
(cb==test (QUOTE (+ x1 (fr x1))) (QUOTE  (+ (+ y2 y3) (fr (+ y1 y2)))) T ) 
(cb==test (QUOTE (+ (+ x1 x2) (fr x1))) (QUOTE  (+ (+ y2 y3) (fr (+ y1 y2)))) T ) 
(cb==test (QUOTE (+ x2 x3)) (QUOTE  (+ y2 (fr (+ y1 y2)))) T ) 
(cb==test (QUOTE (+ x2 x3)) (QUOTE  (+ (+ y2 y3) (fr (+ y1 y2)))) T ) 
(cb==test (QUOTE (+ x2 (fr (+ x1 x2)))) (QUOTE  (+ y2 (fr (+ y1 y2)))) T ) 
(cb==test (QUOTE (+ x1 x2)) (QUOTE  (+ y2 (fr (+ y1 y2)))) T ) 
(cb==test (QUOTE (+ (+ x2 x3) (fr (+ x1 x2)))) (QUOTE  (+ y2 (fr (+ y1 y2)))) T ) 
(cb==test (QUOTE (+ x2 (fr (+ x1 x2)))) (QUOTE  (+ (+ y2 y3) (fr (+ y1 y2)))) T ) 
(cb==test (QUOTE (+ x1 x2)) (QUOTE  (+ (+ y2 y3) (fr (+ y1 y2)))) T ) 
(cb==test (QUOTE (+ (+ x2 x3) (fr (+ x1 x2)))) (QUOTE  (+ (+ y2 y3) (fr (+ y1 y2)))) T ) 
(cb==test (QUOTE (+ a_0 x1)) (QUOTE  (+ (* y1 y2) (* y1 (fr y2)))) NIL ) 
(cb==test (QUOTE (+ a_0 x1)) (QUOTE  (+ (+ y3 (* y1 y2)) (* y1 (fr y2)))) T ) 
(cb==test (QUOTE (+ x1 (fr x1))) (QUOTE  (+ (* y1 y2) (* y1 (fr y2)))) NIL ) 
(cb==test (QUOTE (+ (+ x1 x2) (fr x1))) (QUOTE  (+ (* y1 y2) (* y1 (fr y2)))) NIL ) 
(cb==test (QUOTE (+ x1 (fr x1))) (QUOTE  (+ (+ y3 (* y1 y2)) (* y1 (fr y2)))) T ) 
(cb==test (QUOTE (+ (+ x1 x2) (fr x1))) (QUOTE  (+ (+ y3 (* y1 y2)) (* y1 (fr y2)))) T ) 
(cb==test (QUOTE (+ x2 x3)) (QUOTE  (+ (* y1 y2) (* y1 (fr y2)))) T ) 
(cb==test (QUOTE (+ x2 x3)) (QUOTE  (+ (+ y3 (* y1 y2)) (* y1 (fr y2)))) T ) 
(cb==test (QUOTE (+ (* x1 x2) (* x1 (fr x2)))) (QUOTE  (+ (* y1 y2) (* y1 (fr y2)))) T ) 
(cb==test (QUOTE (+ (+ x3 (* x1 x2)) (* x1 (fr x2)))) (QUOTE  (+ (* y1 y2) (* y1 (fr y2)))) NIL ) 
(cb==test (QUOTE (+ (* x1 x2) (* x1 (fr x2)))) (QUOTE  (+ (+ y3 (* y1 y2)) (* y1 (fr y2)))) NIL ) 
(cb==test (QUOTE (+ (+ x3 (* x1 x2)) (* x1 (fr x2)))) (QUOTE  (+ (+ y3 (* y1 y2)) (* y1 (fr y2)))) T ) 
(cb==test (QUOTE (* a_1 x1)) (QUOTE  (* y1 (fr y2))) T ) 
(cb==test (QUOTE (* a_1 x1)) (QUOTE  (* (* y1 y3) (fr y2))) T ) 
(cb==test (QUOTE (* x1 x1)) (QUOTE  (* y1 (fr y2))) T ) 
(cb==test (QUOTE (* x1 x1)) (QUOTE  (* (* y1 y3) (fr y2))) T ) 
(cb==test (QUOTE (* a_0 x1)) (QUOTE  (* y1 (fr y2))) T ) 
(cb==test (QUOTE (* (* a_0 x1) x2)) (QUOTE  (* y1 (fr y2))) T ) 
(cb==test (QUOTE (* a_0 x1)) (QUOTE  (* (* y1 y3) (fr y2))) T ) 
(cb==test (QUOTE (* (* a_0 x1) x2)) (QUOTE  (* (* y1 y3) (fr y2))) T ) 
(cb==test (QUOTE (* x1 (+ x2 x3))) (QUOTE  (* y1 (fr y2))) T ) 
(cb==test (QUOTE (* x1 (+ x2 x3))) (QUOTE  (* (* y1 y3) (fr y2))) T ) 
(cb==test (QUOTE (* x1 (fr x2))) (QUOTE  (* y1 (fr y2))) T ) 
(cb==test (QUOTE (* (* x1 x3) (fr x2))) (QUOTE  (* y1 (fr y2))) T ) 
(cb==test (QUOTE (* x1 (fr x2))) (QUOTE  (* (* y1 y3) (fr y2))) T ) 
(cb==test (QUOTE (* (* x1 x3) (fr x2))) (QUOTE  (* (* y1 y3) (fr y2))) T ) 
(cb==test (QUOTE (+ a_0 x1)) (QUOTE  (+ y1 y1)) T ) 
(cb==test (QUOTE (+ a_0 x1)) (QUOTE  (+ (+ y1 y1) y2)) T ) 
(cb==test (QUOTE (+ x2 x3)) (QUOTE  (+ y1 y1)) T ) 
(cb==test (QUOTE (+ x2 x3)) (QUOTE  (+ (+ y1 y1) y2)) T ) 
(cb==test (QUOTE (+ x1 x1)) (QUOTE  (+ y1 y1)) T ) 
(cb==test (QUOTE (+ (+ x1 x1) x2)) (QUOTE  (+ y1 y1)) T ) 
(cb==test (QUOTE (+ x1 x1)) (QUOTE  (+ (+ y1 y1) y2)) T ) 
(cb==test (QUOTE (+ (+ x1 x1) x2)) (QUOTE  (+ (+ y1 y1) y2)) T ) 
(cb==test (QUOTE (+ x1 x1)) (QUOTE  (+ a_0 y1)) T ) 
(cb==test (QUOTE (+ (+ x1 x1) x2)) (QUOTE  (+ a_0 y1)) T ) 
))
