(in-package "KEIM")

(setf balgebra*env (env~create))

(setf cpcb*bcktrck-counter 0)

(post~read-object-list '((type-constants i)
			 (constants (a i) (b i) (a0 i) (b0 i) (a1 i) (b1 i)
			            (a_q i) (a_k i) (a_l i) (a_e i) (a_f i)
			            (a_A i) (a_B i) (a_0 i) (a_1 i) (a_2 i)
			            (a_3 i) (a_4 i) (a_5 i)
			            (f (i i)) (inv (i i)) (n (i i)) (p (i i))
			            (s (i i i)) (dot (i i i)))
			 (variables (x i) (y i) (z i) (u i) (v i) (w i)
				    (x1 i) (x2 i) (x3 i) (x4 i) (x5 i) (x6 i)
				    (x7 i) (x8 i)
				    (y1 i) (y2 i) (y3 i) (y4 i) (y5 i) (y6 i)
				    (y7 i) (y8 i)
				    (v_0 i) (v_1 i) (v_2 i) (v_3 i))
			 (signatures (ac (+ (i i i))) (ac (* (i i i)))
				     (ac (++ (i i i))) (ac (** (i i i)))))
		       balgebra*env)

(defun cb==test (&rest args)
  (let* ((stream *standard-output*)
	 ;(*standard-output* my-stream)
	 )
    (format stream "~%~A: ~A   " (incf counter) args)
    (let ((result
	   (do* ((arg-tail args (rest (rest arg-tail)))
		 (term1 (term~copy (term~read (first arg-tail) balgebra*env))
			(term~copy (term~read (first arg-tail) balgebra*env)))
		 (term2 (term~copy (term~read (second arg-tail) balgebra*env))
			(term~copy (term~read (second arg-tail) balgebra*env)))
		 (tl1 (list term1) (cons term1 tl1))
		 (tl2 (list term2) (cons term2 tl2)))
		((null (rest (rest (rest arg-tail))))
		 (#+weg mcb~decide-unify cpcb~decide-unify #+weg cb~decide-unify
				   tl1 tl2
				   ;(mapcar #'list tl1 tl2)
				   ))))
	  (wwert (first (last args))))
      (declare (special *standard-output*))
      ;(get-output-stream-string my-stream)
      (cond ((eq (null result) (null wwert))
	     (format stream "OK"))
	    (t (format stream "*** must be ~A ***" wwert))))))

(setf counter 0)
(setf my-stream (make-string-output-stream))

(time (progn
(cb==test  (QUOTE (+ (* x1 x1) (* x1 x2))) (QUOTE  (f (* y1 y2))) 
           (QUOTE x1) (QUOTE  (+ (f y1) (f y2)))  NIL ) 
(cb==test  (QUOTE (+ a_1 x1)) (QUOTE  (+ a_1 y1))  
	   (QUOTE (++ (++ a_1 x1) x2)) (QUOTE  (++ a_1 y1)) 
	   (QUOTE (* a_1 x1)) (QUOTE  (* (* a_1 y1) y2))  
	   (QUOTE (** (** a_1 x1) x2)) (QUOTE  (** (** a_1 y1) y2))  NIL ) 
(cb==test  (QUOTE (* y1 (+ x8 x1))) (QUOTE (* y3 (* x8 y1)))
	   (Quote (** x4 (++ x8 x7))) (QUOTE (** x5 (++ x8 a_1)))
	   (QUOTE x8) (QUOTE a_0) NIL)
(cb==test  (QUOTE (* (* a_0 x1) x2)) (QUOTE  (* a_0 y1))  T ) 
(cb==test  (QUOTE (* a_0 x1)) (QUOTE  (* (* a_0 y1) y2))  T ) 
(cb==test  (QUOTE (* (* a_0 x1) x2)) (QUOTE  (* (* a_0 y1) y2))  T ) 
(cb==test  (QUOTE (+ a_1 x1)) (QUOTE  (+ y1 (f y1)))  T ) 
(cb==test  (QUOTE (+ (+ a_1 x1) x2)) (QUOTE  (+ y1 (f y1)))  T ) 
(cb==test  (QUOTE (+ a_1 x1)) (QUOTE  (+ (+ y1 y2) (f y1)))  T ) 
(cb==test  (QUOTE (+ (+ a_1 x1) x2)) (QUOTE  (+ (+ y1 y2) (f y1)))  T ) 
(cb==test  (QUOTE (+ x1 (f x1))) (QUOTE  (+ y1 (f y1)))  T ) 
(cb==test  (QUOTE (+ (+ x1 x2) (f x1))) (QUOTE  (+ y1 (f y1)))  T ) 
(cb==test  (QUOTE (+ x1 (f x1))) (QUOTE  (+ (+ y1 y2) (f y1)))  T ) 
(cb==test  (QUOTE (+ (+ x1 x2) (f x1))) (QUOTE  (+ (+ y1 y2) (f y1)))  T ) 
(cb==test  (QUOTE (+ x1 (f x1))) (QUOTE  (+ a_1 y1))  T ) 
(cb==test  (QUOTE (+ (+ x1 x2) (f x1))) (QUOTE  (+ a_1 y1))  T ) 
(cb==test  (QUOTE (+ x1 (f x1))) (QUOTE  (+ (+ a_1 y1) y2))  T ) 
(cb==test  (QUOTE (+ (+ x1 x2) (f x1))) (QUOTE  (+ (+ a_1 y1) y2))  T ) 
(cb==test  (QUOTE (* a_0 x1)) (QUOTE  (* y1 (f y1)))  T ) 
(cb==test  (QUOTE (* (* a_0 x1) x2)) (QUOTE  (* y1 (f y1)))  T ) 
(cb==test  (QUOTE (* a_0 x1)) (QUOTE  (* (* y1 y2) (f y1)))  T ) 
(cb==test  (QUOTE (* (* a_0 x1) x2)) (QUOTE  (* (* y1 y2) (f y1)))  T ) 
(cb==test  (QUOTE (* x1 (f x1))) (QUOTE  (* y1 (f y1)))  T ) 
(cb==test  (QUOTE (* (* x1 x2) (f x1))) (QUOTE  (* y1 (f y1)))  T ) 
(cb==test  (QUOTE (* x1 (f x1))) (QUOTE  (* (* y1 y2) (f y1)))  T ) 
(cb==test  (QUOTE (* (* x1 x2) (f x1))) (QUOTE  (* (* y1 y2) (f y1)))  T ) 
(cb==test  (QUOTE (* x1 (f x1))) (QUOTE  (* a_0 y1))  T ) 
(cb==test  (QUOTE (* (* x1 x2) (f x1))) (QUOTE  (* a_0 y1))  T ) 
(cb==test  (QUOTE (* x1 (f x1))) (QUOTE  (* (* a_0 y1) y2))  T ) 
(cb==test  (QUOTE (* (* x1 x2) (f x1))) (QUOTE  (* (* a_0 y1) y2))  T ) 
(cb==test  (QUOTE (+ a_1 x1)) (QUOTE  (+ y1 (* y1 y2)))  T ) 
(cb==test  (QUOTE (+ (+ a_1 x1) x2)) (QUOTE  (+ y1 (* y1 y2)))  T ) 
(cb==test  (QUOTE (+ x1 (f x1))) (QUOTE  (+ y1 (* y1 y2)))  NIL ) 
(cb==test  (QUOTE (+ (+ x1 x2) (f x1))) (QUOTE  (+ y1 (* y1 y2)))  T ) 
(cb==test  (QUOTE (+ x1 (* x1 x2))) (QUOTE  (+ y1 (* y1 y2))) 
	   (QUOTE (++ x1 (** x1 x2))) (QUOTE  (++ y1 (** y1 y2)))  T ) 
(cb==test  (QUOTE (+ x1 (* x1 x2))) (QUOTE  (+ a_1 y1))  T ) 
(cb==test  (QUOTE (+ x1 (* x1 x2))) (QUOTE  (+ (+ a_1 y1) y2))  T ) 
(cb==test  (QUOTE (* x1 x2)) (QUOTE  (* a_0 y1))  T ) 
(cb==test  (QUOTE (* x1 x2)) (QUOTE  (* (* a_0 y1) y2))  T ) 
(cb==test  (QUOTE v_0) (QUOTE  a_0) 
           (QUOTE (+ v_0 v_0)) (QUOTE  (f (* y1 y2))) 
           (QUOTE a_0) (QUOTE  (+ (f y1) (f y2)))  NIL ) 
(cb==test  (QUOTE (+ a_0 x1)) (QUOTE  (f (* y1 y2))) 
           (QUOTE x1) (QUOTE  (+ (f y1) (f y2)))  NIL ) 
(cb==test  (QUOTE (+ x1 (* x1 x2))) (QUOTE  (+ y1 (f y1)))  NIL ) 
(cb==test  (QUOTE (+ x1 (* x1 x2))) (QUOTE  (+ (+ y1 y2) (f y1)))  T ) 
(cb==test  (QUOTE (* x1 x2)) (QUOTE  (* y1 (f y1)))  T ) 
(cb==test  (QUOTE (* x1 x2)) (QUOTE  (* (* y1 y2) (f y1)))  T ) 
(cb==test  (QUOTE (* x1 x2)) (QUOTE  (* a_0 y1))  T ) 
(cb==test  (QUOTE (* x1 x2)) (QUOTE  (* (* a_0 y1) y2))  T ) 
(cb==test  (QUOTE (* x1 x2)) (QUOTE  (* y1 (f y1)))  T ) 
(cb==test  (QUOTE (* x1 x2)) (QUOTE  (* (* y1 y2) (f y1)))  T ) 
(cb==test  (QUOTE (* a_0 x1)) (QUOTE  (* y1 (+ y2 y3)))  T ) 
(cb==test  (QUOTE (* (* a_0 x1) x2)) (QUOTE  (* y1 (+ y2 y3)))  T ) 
(cb==test  (QUOTE (* a_0 x1)) (QUOTE  (* (* y1 y4) (+ y2 y3)))  T ) 
(cb==test  (QUOTE (* (* a_0 x1) x2)) (QUOTE  (* (* y1 y4) (+ y2 y3)))  T ) 
(cb==test  (QUOTE (* x1 (f x1))) (QUOTE  (* y1 (+ y2 y3)))  T ) 
(cb==test  (QUOTE (* (* x1 x2) (f x1))) (QUOTE  (* y1 (+ y2 y3)))  T ) 
(cb==test  (QUOTE (* x1 (f x1))) (QUOTE  (* (* y1 y4) (+ y2 y3)))  T ) 
(cb==test  (QUOTE (* (* x1 x2) (f x1))) (QUOTE  (* (* y1 y4) (+ y2 y3)))  T ) 
(cb==test  (QUOTE (+ (* x1 (f (+ x1 x2))) (* x2 (f (+ x1 x2))))) (QUOTE  (+ (f (* y1 y2)) (f (* (* y3 y4) (f (* y2 y4)))))) 
           (QUOTE a_0) (QUOTE  (f a_0))  NIL ) 
(cb==test  (QUOTE (+ (* x1 (f (+ x1 x2))) (* x2 (f (+ x1 x2))))) (QUOTE  (+ (f (* y1 y2)) (f (* y3 (f (* y2 y3)))))) 
           (QUOTE a_0) (QUOTE  (f a_0))  NIL ) 
(cb==test  (QUOTE (+ (* x1 (f (+ x1 x2))) (* x2 (f (+ x1 x2))))) (QUOTE  (+ (f (* y1 y2)) (f (* y3 (f y2))))) 
           (QUOTE a_0) (QUOTE  (f a_0))  NIL ) 
(cb==test  (QUOTE (+ (* x1 (f (+ x1 x2))) (* x2 (f (+ x1 x2))))) (QUOTE  (+ (f y1) (f (* y2 (f (* y1 y2)))))) 
           (QUOTE a_0) (QUOTE  (f a_0))  NIL ) 
(cb==test  (QUOTE (+ (* x1 (f (+ x1 x2))) (* x2 (f (+ x1 x2))))) (QUOTE  (f a_0)) 
           (QUOTE a_0) (QUOTE  a_1)  NIL ) 
(cb==test  (QUOTE (+ (* x1 (f (+ x1 x2))) (* x2 (f (+ x1 x2))))) (QUOTE  (+ (f a_0) (f y1))) 
           (QUOTE a_0) (QUOTE  (f a_0))  NIL ) 
(cb==test  (QUOTE (+ (* x1 (f (+ x1 x2))) (* x2 (f (+ x1 x2))))) (QUOTE  (f (* y1 y2))) 
           (QUOTE a_0) (QUOTE  (+ (f y1) (f y2)))  NIL ) 
(cb==test  (QUOTE (+ (* (* x1 x2) (f (+ x1 x3))) (* (* x2 x3) (f (+ x1 x3))))) (QUOTE  (+ (f (* y1 y2)) (f (* (* y3 y4) (f (* y2 y4)))))) 
           (QUOTE a_0) (QUOTE  (f a_0))  NIL ) 
(cb==test  (QUOTE (+ (* (* x1 x2) (f (+ x1 x3))) (* (* x2 x3) (f (+ x1 x3))))) (QUOTE  (+ (f (* y1 y2)) (f (* y3 (f (* y2 y3)))))) 
           (QUOTE a_0) (QUOTE  (f a_0))  NIL ) 
(cb==test  (QUOTE (+ (* (* x1 x2) (f (+ x1 x3))) (* (* x2 x3) (f (+ x1 x3))))) (QUOTE  (+ (f (* y1 y2)) (f (* y3 (f y2))))) 
           (QUOTE a_0) (QUOTE  (f a_0))  NIL ) 
(cb==test  (QUOTE (+ (* (* x1 x2) (f (+ x1 x3))) (* (* x2 x3) (f (+ x1 x3))))) (QUOTE  (+ (f y1) (f (* y2 (f (* y1 y2)))))) 
           (QUOTE a_0) (QUOTE  (f a_0))  NIL ) 
(cb==test  (QUOTE (+ (* (* x1 x2) (f (+ x1 x3))) (* (* x2 x3) (f (+ x1 x3))))) (QUOTE  (f a_0)) 
           (QUOTE a_0) (QUOTE  a_1)  NIL ) 
(cb==test  (QUOTE (+ (* (* x1 x2) (f (+ x1 x3))) (* (* x2 x3) (f (+ x1 x3))))) (QUOTE  (+ (f a_0) (f y1))) 
           (QUOTE a_0) (QUOTE  (f a_0))  NIL ) 
(cb==test  (QUOTE (+ (* (* x1 x2) (f (+ x1 x3))) (* (* x2 x3) (f (+ x1 x3))))) (QUOTE  (f (* y1 y2))) 
           (QUOTE a_0) (QUOTE  (+ (f y1) (f y2)))  NIL ) 
(cb==test  (QUOTE (* x1 x2)) (QUOTE  (* y1 (+ y2 y3)))  T ) 
(cb==test  (QUOTE (* x1 x2)) (QUOTE  (* (* y1 y4) (+ y2 y3)))  T ) 
(cb==test  (QUOTE (* x1 (+ x2 x3))) (QUOTE  (* y1 (+ y2 y3)))  T ) 
(cb==test  (QUOTE (* (* x1 x4) (+ x2 x3))) (QUOTE  (* y1 (+ y2 y3)))  T ) 
(cb==test  (QUOTE (* x1 (+ x2 x3))) (QUOTE  (* (* y1 y4) (+ y2 y3)))  T ) 
(cb==test  (QUOTE (* (* x1 x4) (+ x2 x3))) (QUOTE  (* (* y1 y4) (+ y2 y3)))  T ) 
(cb==test  (QUOTE (+ x2 x3)) (QUOTE  (+ a_1 y1))  T ) 
(cb==test  (QUOTE (+ x2 x3)) (QUOTE  (+ a_1 y1))  T ) 
(cb==test  (QUOTE (+ x2 x3)) (QUOTE  (+ (+ a_1 y1) y2))  T ) 
(cb==test  (QUOTE (+ x2 x3)) (QUOTE  (+ (+ a_1 y1) y2))  T ) 
(cb==test  (QUOTE (+ (* a_1 x1) (* x1 x2))) (QUOTE  (+ (f (* y1 y2)) (f (* (* y3 y4) (f (* y2 y4)))))) 
           (QUOTE (* a_1 x1)) (QUOTE  (f a_0))  NIL ) 
(cb==test  (QUOTE (+ (* a_1 x1) (* x1 x2))) (QUOTE  (+ (f (* y1 y2)) (f (* y3 (f (* y2 y3)))))) 
           (QUOTE (* a_1 x1)) (QUOTE  (f a_0))  NIL ) 
(cb==test  (QUOTE (+ (* a_1 x1) (* x1 x2))) (QUOTE  (+ (f (* y1 y2)) (f (* y3 (f y2))))) 
           (QUOTE (* a_1 x1)) (QUOTE  (f a_0))  NIL ) 
(cb==test  (QUOTE (+ (* a_1 x1) (* x1 x2))) (QUOTE  (+ (f y1) (f (* y2 (f (* y1 y2)))))) 
           (QUOTE (* a_1 x1)) (QUOTE  (f a_0))  NIL ) 
(cb==test  (QUOTE (+ (* a_1 x1) (* x1 x2))) (QUOTE  (f a_0)) 
           (QUOTE (* a_1 x1)) (QUOTE  a_1)  NIL ) 
(cb==test  (QUOTE (+ (* a_1 x1) (* x1 x2))) (QUOTE  (+ (f a_0) (f y1))) 
           (QUOTE (* a_1 x1)) (QUOTE  (f a_0))  NIL ) 
(cb==test  (QUOTE (+ (* a_1 x1) (* x1 x2))) (QUOTE  (f (* y1 y2))) 
           (QUOTE (* a_1 x1)) (QUOTE  (+ (f y1) (f y2)))  NIL ) 
(cb==test  (QUOTE (* x1 (+ x2 x3))) (QUOTE  (* a_0 y1))  T ) 
(cb==test  (QUOTE (* (* x1 x4) (+ x2 x3))) (QUOTE  (* a_0 y1))  T ) 
(cb==test  (QUOTE (* x1 (+ x2 x3))) (QUOTE  (* (* a_0 y1) y2))  T ) 
(cb==test  (QUOTE (* (* x1 x4) (+ x2 x3))) (QUOTE  (* (* a_0 y1) y2))  T ) 
(cb==test  (QUOTE (+ x2 x3)) (QUOTE  (+ y1 (f y1)))  T ) 
(cb==test  (QUOTE (+ x2 x3)) (QUOTE  (+ y1 (f y1)))  T ) 
(cb==test  (QUOTE (+ x2 x3)) (QUOTE  (+ (+ y1 y2) (f y1)))  T ) 
(cb==test  (QUOTE (+ x2 x3)) (QUOTE  (+ (+ y1 y2) (f y1)))  T ) 
(cb==test  (QUOTE (+ (* x1 x2) (* x1 (f x2)))) (QUOTE  (+ (f (* y1 y2)) (f (* (* y3 y4) (f (* y2 y4)))))) 
           (QUOTE (* a_1 x1)) (QUOTE  (f a_0))  NIL ) 
(cb==test  (QUOTE (+ (* x1 x2) (* x1 (f x2)))) (QUOTE  (+ (f (* y1 y2)) (f (* y3 (f (* y2 y3)))))) 
           (QUOTE (* a_1 x1)) (QUOTE  (f a_0))  NIL ) 
(cb==test  (QUOTE (+ (* x1 x2) (* x1 (f x2)))) (QUOTE  (+ (f (* y1 y2)) (f (* y3 (f y2))))) 
           (QUOTE (* a_1 x1)) (QUOTE  (f a_0))  NIL ) 
(cb==test  (QUOTE (+ (* x1 x2) (* x1 (f x2)))) (QUOTE  (+ (f y1) (f (* y2 (f (* y1 y2)))))) 
           (QUOTE (* a_1 x1)) (QUOTE  (f a_0))  NIL ) 
(cb==test  (QUOTE (+ (* x1 x2) (* x1 (f x2)))) (QUOTE  (f a_0)) 
           (QUOTE (* a_1 x1)) (QUOTE  a_1)  NIL ) 
(cb==test  (QUOTE (+ (* x1 x2) (* x1 (f x2)))) (QUOTE  (+ (f a_0) (f y1))) 
           (QUOTE (* a_1 x1)) (QUOTE  (f a_0))  NIL ) 
(cb==test  (QUOTE (+ (* x1 x2) (* x1 (f x2)))) (QUOTE  (f (* y1 y2))) 
           (QUOTE (* a_1 x1)) (QUOTE  (+ (f y1) (f y2)))  NIL ) 
(cb==test  (QUOTE (+ (+ (* x1 x2) (* x1 x3)) (* x1 (f (+ x2 x3))))) (QUOTE  (+ (f (* y1 y2)) (f (* (* y3 y4) (f (* y2 y4)))))) 
           (QUOTE (* a_1 x1)) (QUOTE  (f a_0))  NIL ) 
(cb==test  (QUOTE (+ (+ (* x1 x2) (* x1 x3)) (* x1 (f (+ x2 x3))))) (QUOTE  (+ (f (* y1 y2)) (f (* y3 (f (* y2 y3)))))) 
           (QUOTE (* a_1 x1)) (QUOTE  (f a_0))  NIL ) 
(cb==test  (QUOTE (+ (+ (* x1 x2) (* x1 x3)) (* x1 (f (+ x2 x3))))) (QUOTE  (+ (f (* y1 y2)) (f (* y3 (f y2))))) 
           (QUOTE (* a_1 x1)) (QUOTE  (f a_0))  NIL ) 
(cb==test  (QUOTE (+ (+ (* x1 x2) (* x1 x3)) (* x1 (f (+ x2 x3))))) (QUOTE  (+ (f y1) (f (* y2 (f (* y1 y2)))))) 
           (QUOTE (* a_1 x1)) (QUOTE  (f a_0))  NIL ) 
(cb==test  (QUOTE (+ (+ (* x1 x2) (* x1 x3)) (* x1 (f (+ x2 x3))))) (QUOTE  (f a_0)) 
           (QUOTE (* a_1 x1)) (QUOTE  a_1)  NIL ) 
(cb==test  (QUOTE (+ (+ (* x1 x2) (* x1 x3)) (* x1 (f (+ x2 x3))))) (QUOTE  (+ (f a_0) (f y1))) 
           (QUOTE (* a_1 x1)) (QUOTE  (f a_0))  NIL ) 
(cb==test  (QUOTE (+ (+ (* x1 x2) (* x1 x3)) (* x1 (f (+ x2 x3))))) (QUOTE  (f (* y1 y2))) 
           (QUOTE (* a_1 x1)) (QUOTE  (+ (f y1) (f y2)))  NIL ) 
(cb==test  (QUOTE (* x1 (+ x2 x3))) (QUOTE  (* y1 (f y1)))  T ) 
(cb==test  (QUOTE (* (* x1 x4) (+ x2 x3))) (QUOTE  (* y1 (f y1)))  T ) 
(cb==test  (QUOTE (* x1 (+ x2 x3))) (QUOTE  (* (* y1 y2) (f y1)))  T ) 
(cb==test  (QUOTE (* (* x1 x4) (+ x2 x3))) (QUOTE  (* (* y1 y2) (f y1)))  T ) 
(cb==test  (QUOTE (+ x2 x3)) (QUOTE  (+ y1 (* y1 y2)))  T ) 
(cb==test  (QUOTE (+ a_1 x1)) (QUOTE  (+ a_0 y1))  T ) 
(cb==test  (QUOTE (+ (+ a_1 x1) x2)) (QUOTE  (+ a_0 y1))  T ) 
(cb==test  (QUOTE (+ x1 (f x1))) (QUOTE  (+ a_0 y1))  T ) 
(cb==test  (QUOTE (+ (+ x1 x2) (f x1))) (QUOTE  (+ a_0 y1))  T )
(cb==test  '(++ (** a_1 x1) (f (+ x3 x4)))
	   '(++ (** x2 a_0) (f (* a_2 a_3))) NIL)
(cb==test  '(++ (** x1 x2) x3) '(++ (** x4 x5) x6)
	   '(+ (* y1 y2) y3) '(+ (* a_0 x1) (* a_1 x4))
	   '(dot a_1 a_3) '(dot x1 x4)  T )

))

(format t "~%Number of Backtrackings: ~A" cpcb*bcktrck-counter)
