(in-package "KEIM")

;;; Umschalter zwischen
;;; AC - Spezialverfahren  und
;;; Verfahren fuer regulaere kollapsfreie Theorien


#|
;;; AC - Spezialverfahren
(defmethod unicp~theo-init ((cpac*theory th+ac) general-up equations
			    identified discriminated constants const-restr)
  (declare (edited  "13-DEC-1995")
	   (authors Neskakis)
	   (input   "cpac*theory: the theoryindex of the unification problem"
		    "general-up: "
		    "equations:  a list of pure equations (i.e. pairs of terms)"
		    "identified: list of pairs of variables which are identical"
		    "constants: a list of former variables which are now occupied by other theories"
		    "const-restr: a list of constant-restrictions")
	   (effect  "a unification problem [cpac+up] is created"
		    "+ effect as in unicp~new-constr")
	   (value   "value as in unicp~new-constr")
	   (special cpac*theory))
  (let ((up (make-instance 'cpac+up
			   :general-up general-up
			   :equations equations
			   :theory cpac*theory)))
    (cpac=new-equations! up)
    #+weg(cpac=new-solutions! up)
    #+weg(cpac=new-constr up
			  (cpac=check-identified identified)
			  (cpac=check-discriminated discriminated)
			  (cpac=check-constants constants)
			  (cpac=check-const-restr const-restr))))

|#


;;; Verfahren fuer regulaer & kollaps-frei
(defmethod unicp~theo-init ((cpac*theory th+ac) general-up equations
			    identified discriminated constants const-restr)
  (call-next-method))

(defmethod th~decide-unify ((th th+ac) tl1 tl2 restr const-vars)
      (ac~unify tl1 tl2 restr const-vars T))


(defmethod unicp~theo-init ((theory th+a) general-up equations
			    identified discriminated constants const-restr)
  (call-next-method))
