(in-package "KEIM")

(setf exgrobner*env (env~create))

(setf cpcb*bcktrck-counter 0)

(post~read-object-list '((type-constants i)
			 (constants (a i) (b i)
			            (q i) (k i) (l i) (e i) (f i)
			            (a0 i) (b0 i)
			            (a1 i) (b1 i)
			            (a_A i) (a_B i) (a_0 i) (a_1 i)
			            (a_Cx i) (a_Cy i) (a_Cz i) 
			            (inv (i i)) (n (i i)) (p (i i)) (g (i i)) (* (i i i))
			            (s (i i i)) (dot (i i i)))
			 (variables (x i) (y i) (z i) (u i) (v i) (w i)
				    (x1 i) (x2 i) (x3 i) (x4 i) (x5 i) (x6 i)
				    (y1 i) (y2 i) (y3 i) (y4 i) (y5 i) (y6 i)
				    (v_0 i) (v_1 i) (v_2 i) (v_3 i))
			 (signatures (ac (+ (i i i)))))
		       exgrobner*env)


(defun cb==test (&rest args)
  (let* ((stream *standard-output*)
	 ;(*standard-output* my-stream)
	 )
    (format stream "~%~A: ~A   " (incf counter) args)
    (let ((result
	   (do* ((arg-tail args (rest (rest arg-tail)))
		 (term1 (term~copy (term~read (first arg-tail) exgrobner*env))
			(term~copy (term~read (first arg-tail) exgrobner*env)))
		 (term2 (term~copy (term~read (second arg-tail) exgrobner*env))
			(term~copy (term~read (second arg-tail) exgrobner*env)))
		 (tl1 (list term1) (cons term1 tl1))
		 (tl2 (list term2) (cons term2 tl2)))
		((null (rest (rest (rest arg-tail))))
		 (cpcb~decide-unify #+weg cb~decide-unify
				    tl1 tl2))))
	  (wwert (first (last args))))
      (declare (special *standard-output*))
      ;(get-output-stream-string my-stream)
      (cond ((eq (null result) (null wwert))
	     (format stream "OK"))
	    (t
	     (format stream "*** must be ~A ***" wwert))))))


(setf counter 0)
(setf my-stream (make-string-output-stream))


(time (progn
(cb==test  (QUOTE (+ a_0 x1)) (QUOTE  (+ a_0 y1))  T ) 
(cb==test  (QUOTE (+ a_0 x1)) (QUOTE  (+ y1 (g y1)))  T ) 
(cb==test  (QUOTE (+ a_0 x1)) (QUOTE  (+ (+ y1 y2) (g y1)))  T ) 
(cb==test  (QUOTE (+ x1 (g x1))) (QUOTE  (+ y1 (g y1)))  T ) 
(cb==test  (QUOTE (+ (+ x1 x2) (g x1))) (QUOTE  (+ y1 (g y1)))  T ) 
(cb==test  (QUOTE (+ x1 (g x1))) (QUOTE  (+ (+ y1 y2) (g y1)))  T ) 
(cb==test  (QUOTE (+ (+ x1 x2) (g x1))) (QUOTE  (+ (+ y1 y2) (g y1)))  T ) 
(cb==test  (QUOTE (+ x1 (g x1))) (QUOTE  (+ a_0 y1))  T ) 
(cb==test  (QUOTE (+ (+ x1 x2) (g x1))) (QUOTE  (+ a_0 y1))  T ) 
(cb==test  (QUOTE (g x1)) (QUOTE  (g (+ y1 y2)))  T ) 
(cb==test  (QUOTE (g (+ x1 x2))) (QUOTE  (g (+ y1 y2)))  T ) 
(cb==test  (QUOTE (+ x1 x2)) (QUOTE  (+ a_0 y1))  T ) 
(cb==test  (QUOTE (+ x1 x2)) (QUOTE  (+ y1 (g y1)))  T ) 
(cb==test  (QUOTE (+ x1 x2)) (QUOTE  (+ (+ y1 y2) (g y1)))  T ) 
(cb==test  (QUOTE (g (g x1))) (QUOTE  (g (+ y1 y2)))  NIL ) 
(cb==test  (QUOTE (g x1)) (QUOTE  (g (+ y1 y2)))  T ) 
(cb==test  (QUOTE (* a_0 x1)) (QUOTE  (* y1 (+ y2 y3)))  T ) 
(cb==test  (QUOTE (* x1 a_0)) (QUOTE  (* y1 (+ y2 y3)))  NIL ) 
(cb==test  (QUOTE (* x1 (+ x2 x3))) (QUOTE  (* y1 (+ y2 y3)))  T ) 
(cb==test  (QUOTE (+ x2 x3)) (QUOTE  (+ a_0 y1))  T ) 
(cb==test  (QUOTE (+ x2 x3)) (QUOTE  (+ y1 (g y1)))  T ) 
(cb==test  (QUOTE (+ x2 x3)) (QUOTE  (+ (+ y1 y2) (g y1)))  T ) 
(cb==test  (QUOTE (* a_0 x1)) (QUOTE  (* (+ y1 y2) y3))  NIL ) 
(cb==test  (QUOTE (* x1 a_0)) (QUOTE  (* (+ y1 y2) y3))  T ) 
(cb==test  (QUOTE (* x1 (+ x2 x3))) (QUOTE  (* (+ y1 y2) y3))  T ) 
(cb==test  (QUOTE (* (+ x1 x2) x3)) (QUOTE  (* (+ y1 y2) y3))  T ) 
(cb==test  (QUOTE (+ x1 x2)) (QUOTE  (+ a_0 y1))  T ) 
(cb==test  (QUOTE (+ x1 x2)) (QUOTE  (+ y1 (g y1)))  T ) 
(cb==test  (QUOTE (+ x1 x2)) (QUOTE  (+ (+ y1 y2) (g y1)))  T ) 
(cb==test  (QUOTE (* (+ x1 x2) x3)) (QUOTE  (* y1 (+ y2 y3)))  T ) 
(cb==test  (QUOTE (g x1)) (QUOTE  (g (+ y1 y2)))  T ) 
(cb==test  (QUOTE (* (g x1) x2)) (QUOTE  (* y1 (+ y2 y3)))  T ) 
(cb==test  (QUOTE (* (g x1) x2)) (QUOTE  (* (+ y1 y2) y3))  NIL ) 
(cb==test  (QUOTE (g x2)) (QUOTE  (g (+ y1 y2)))  T ) 
(cb==test  (QUOTE (* x1 (g x2))) (QUOTE  (* y1 (+ y2 y3)))  NIL ) 
(cb==test  (QUOTE (* x1 (g x2))) (QUOTE  (* (+ y1 y2) y3))  T ) 
(cb==test  (QUOTE (+ (* (* x1 x2) x3) (* (* x1 x3) x2))) (QUOTE  (* (* a_a a_b) a_a)) 
           (QUOTE (+ (* x1 (* x2 x3)) (* x1 (* x3 x2)))) (QUOTE  (* a_a (* a_b a_a)))  NIL ) 
(cb==test  (QUOTE (* (* x1 x2) x2)) (QUOTE  (* y1 (+ y2 y3)))  T ) 
(cb==test  (QUOTE (* x1 x2)) (QUOTE  (* y1 (+ y2 y3)))  T ) 
(cb==test  (QUOTE (* (* x1 x2) x2)) (QUOTE  (* (+ y1 y2) y3))  NIL ) 
(cb==test  (QUOTE (* x1 x2)) (QUOTE  (* (+ y1 y2) y3))  T ) 
(cb==test  (QUOTE (* (* x1 x1) x2)) (QUOTE  (* y1 (+ y2 y3)))  T ) 
(cb==test  (QUOTE (* x1 x1)) (QUOTE  (* y1 (+ y2 y3)))  T ) 
(cb==test  (QUOTE (+ (* (* x1 x2) x3) (* (* x2 x1) x3))) (QUOTE  (* (* a_a a_b) a_a)) 
           (QUOTE (+ (* x1 (* x2 x3)) (* x2 (* x1 x3)))) (QUOTE  (* a_a (* a_b a_a)))  NIL ) 
(cb==test  (QUOTE (* (* x1 x1) x2)) (QUOTE  (* (+ y1 y2) y3))  NIL ) 
(cb==test  (QUOTE (* x1 x1)) (QUOTE  (* (+ y1 y2) y3))  T ) 
(cb==test  (QUOTE (* (* a_a a_b) a_a)) (QUOTE  (* y1 (+ y2 y3)))  NIL ) 
(cb==test  (QUOTE (* a_a a_b)) (QUOTE  (* y1 (+ y2 y3)))  NIL ) 
(cb==test  (QUOTE (* (* a_a a_b) a_a)) (QUOTE  (* (+ y1 y2) y3))  NIL ) 
(cb==test  (QUOTE (* a_a a_b)) (QUOTE  (* (+ y1 y2) y3))  NIL ) 
(cb==test  (QUOTE (g a_0)) (QUOTE  (g (+ y1 y2)))  NIL ) 
(cb==test  (QUOTE (+ a_0 x1)) (QUOTE  (+ (* (* y1 y2) y3) (* (* y1 y3) y2)))  NIL ) 
(cb==test  (QUOTE (+ a_0 x1)) (QUOTE  (+ (+ y4 (* (* y1 y2) y3)) (* (* y1 y3) y2)))  T ) 
(cb==test  (QUOTE (+ x1 (g x1))) (QUOTE  (+ (* (* y1 y2) y3) (* (* y1 y3) y2)))  NIL ) 
(cb==test  (QUOTE (+ (+ x1 x2) (g x1))) (QUOTE  (+ (* (* y1 y2) y3) (* (* y1 y3) y2)))  NIL ) 
(cb==test  (QUOTE (+ x1 (g x1))) (QUOTE  (+ (+ y4 (* (* y1 y2) y3)) (* (* y1 y3) y2)))  T ) 
(cb==test  (QUOTE (+ (+ x1 x2) (g x1))) (QUOTE  (+ (+ y4 (* (* y1 y2) y3)) (* (* y1 y3) y2)))  T ) 
(cb==test  (QUOTE (+ (+ (* x1 (* x2 x3)) (* x1 (* x3 x2))) (g (* (* x1 x2) x3)))) (QUOTE  (* (* a_a a_b) a_a)) 
           (QUOTE (* (* x1 x3) x2)) (QUOTE  (* a_a (* a_b a_a)))  NIL ) 
))

(format t "~%Number of Backtrackings: ~A" cpcb*bcktrck-counter)
