;;; AC-equations:
;;;
;;; z1 * z2 * a1 = z3 * z4
;;; z1 * z3      = z4 * z4
;;;
;;; constant restrictions:
;;;  + V(a1) = {z1}
;;;  + V(a1) = {z2}
;;;  - V(a1) = {z1,z2}
;;;  - V(a1) = {z3}
;;;  - V(a1) = {z4}
;;;

(setf lp "
min: x;

x10 + x20 - x30 -   x40 = 0;
x10       + x30 - 2 x40 = 0;

x11 + x21 - x31 -   x41 = -1;
x11       + x31 - 2 x41 = 0;

x10 + x11 >= 1;
x20 + x21 >= 1;
x30 + x31 >= 1;
x40 + x41 >= 1;

/*x11 = 0;*/
/*x21 = 0;*/
/*x31 = 0;*/
/*x41 = 0;*/

x21 = 0;

int x10 x20 x30 x40 x11 x21 x31 x41;
")

(defun foo ()
  (let ((lp-solve (run-program "/usr/local/keim/bin/lp_solve"
			       :input :stream
			       :output :stream
			       :error-output :output
			       :wait nil)))
    (unwind-protect
	(progn
	  (unwind-protect
	      (format lp-solve lp)
	    (close (underlying-stream lp-solve :output)))
	  (do ((line (read-line lp-solve nil lp-solve) (read-line lp-solve nil lp-solve))
	       (lines nil (cons line lines)))
	      ((eq line lp-solve) (nreverse lines))))
      (close (underlying-stream lp-solve :input)))))


	  
	       
