;;;****************************************************************************
;;;* Test                                                                     *
;;;****************************************************************************

(in-package :keim)

;;;+--------------------------------------------------------------------------+
;;;| universe                                                                 |
;;;+--------------------------------------------------------------------------+



(setf env (env~create))

(post~read-object-list '((type-constants i o)
			 (constants (and (o o o))
				    (f (i i)) (g (i i i)) (ac (i i i))
				    (a i) (a1 i) (a2 i) (a3 i)
				    (b i) (b1 i) (b2 i) (b3 i))
			 (signatures (ac (+ (i i i))) (ac (* (i i i))))
			 (variables (x i) (x1 i) (x2 i) (x3 i)
				    (y i) (y1 i) (y2 i) (y3 i)
				    (z i) (z1 i) (z2 i) (z3 i)))
		       env)
 
 (unicp~vars-label-initialize! (list (term~read 'x env)
				     (term~read 'x1 env)
				     (term~read 'x2 env)
				     (term~read 'x3 env)
				     (term~read 'y env)
				     (term~read 'y1 env)
				     (term~read 'y2 env)
				     (term~read 'y3 env)
				     (term~read 'z env)
				     (term~read 'z1 env)
				     (term~read 'z2 env)
				     (term~read 'z3 env)))













;;;+--------------------------------------------------------------------------+
;;;| tests                                                                    |
;;;+--------------------------------------------------------------------------+


(defun test~test (key)
  (let ((cpac*theory (th~term-theory (term~read '+ env))))
    (case key
      ((0.4) (test=test cpac*theory
		      NIL ;general-up
		      (list (list (term~read '(+ x1 z1) env) (term~read 'z2 env))
			    (list (term~read '(+ (+ y1 y2) z3) env) (term~read '(+ y2 y3) env)))
		      nil  ;identified
		      (list (unicp~id-create (term~read 'z1 env)
					     (term~read 'z2 env))
			    (unicp~id-create (term~read 'z1 env)
					     (term~read 'z3 env))
			    (unicp~id-create (term~read 'z2 env)
					     (term~read 'z3 env))) ;discriminated
		      (list (term~read 'z1 env) (term~read 'z3 env)) ;constants
		      (list (unicp~cr-create (term~read 'z3 env)
					     (term~read 'z2 env))) ;const-restr
		      ))
      ((0.3) (test=test cpac*theory
		      NIL ;general-up
		      (list (list (term~read '(+ x1 y1) env) (term~read 'x env))
			    (list (term~read '(+ x2 y2) env) (term~read '(+ x2 x3) env)))
		      (list (unicp~id-create (term~read 'y1 env)
					     (term~read 'y2 env))) ;identified
		      nil ;discriminated
		      (list (term~read 'y1 env) (term~read 'y2 env)) ;constants
		      NIL ;const-restr
		      ))
      ((0.2) (test=test cpac*theory
		      NIL ;general-up
		      (list (list (term~read '(+ x1 x2) env))
			    (list (term~read '(+ y1 y2) env)))
		      (list (unicp~id-create (term~read 'x1 env)
					     (term~read 'x2 env))) ;identified
		      nil ;discriminated
		      (list (term~read 'x1 env) (term~read 'x2 env)) ;constants
		      NIL ;const-restr
		      ))
      ((0.1) (test=test cpac*theory
		      NIL ;general-up
		      (list (list (term~read '(+ x x1) env))
			    (list (term~read '(+ x2 (+ y y)) env)))
		      NIL ;identified
		      (list (unicp~id-create (term~read 'x1 env)
					     (term~read 'x2 env))) ;discriminated
		      (list (term~read 'x1 env) (term~read 'x2 env)) ;constants
		      NIL ;const-restr
		      ))
      ((1) (test=test cpac*theory
		      NIL ;general-up
		      (list (list (term~read 'x1 env))  ;equations
			    (list (term~read 'y1 env)))
		      NIL ;identified
		      NIL ;discriminated
		      NIL ;constants
		      NIL ;const-restr
		      ))
      ((2) (test=test cpac*theory
		      NIL ;general-up
		      (list (list (term~read 'x1 env))  ;equations
			    (list (term~read 'y1 env)))
		      (list (list (term~read 'x1 env) (term~read 'y1 env))) ;identified
		      NIL ;discriminated
		      NIL ;constants
		      NIL ;const-restr
		      ))
      ((3) (test=test cpac*theory
		      NIL ;general-up
		      (list (list (term~read 'x1 env))  ;equations
			    (list (term~read 'y1 env)))
		      NIL ;identified
		      (list (list (term~read 'x1 env) (term~read 'y1 env))) ;discriminated
		      NIL ;constants
		      NIL ;const-restr
		      ))
      ((4) (test=test cpac*theory
		      NIL ;general-up
		      (list (list (term~read 'x1 env))  ;equations
			    (list (term~read 'y1 env)))
		      NIL ;identified
		      NIL ;discriminated
		      (list (term~read 'x1 env) (term~read 'y1 env)) ;constants
		      NIL ;const-restr
		      ))
      ((5) (test=test cpac*theory
		      NIL ;general-up
		      (list (list (term~read 'x1 env))  ;equations
			    (list (term~read 'y1 env)))
		      NIL ;identified
		      (list (list (term~read 'x1 env) (term~read 'y1 env))) ;discriminated
		      (list (term~read 'x1 env) (term~read 'y1 env)) ;constants
		      NIL ;const-restr
		      ))
      ((6) (test=test cpac*theory
		      NIL ;general-up
		      (list (list (term~read 'x1 env))  ;equations
			    (list (term~read 'y1 env)))
		      NIL ;identified
		      (list (list (term~read 'x1 env) (term~read 'y1 env))) ;discriminated
		      NIL ;constants
		      (list (list (term~read 'x1 env) (term~read 'y1 env))) ;const-restr
		      ))
      ((-) (test=test cpac*theory
		      NIL ;general-up
		      NIL ;equations
		      NIL ;identified
		      NIL ;discriminated
		      NIL ;constants
		      NIL ;const-restr
		      ))
      )))

      
      #|((1) (test=test cpac*theory
		      NIL
		      (list (list (term~read '(+ x1 x2) env))
			    (list (term~read '(+ y1 y2) env)))
		      NIL
		      NIL
		      NIL
		      NIL))
      ((2) (test=test cpac*theory
		      NIL
		      (list (list (term~read '(+ x1 x2) env))
			    (list (term~read '(+ y1 y2) env)))
		      NIL
		      NIL
		      (list (term~read 'x1 env))
		      NIL))
      ((3) (test=test cpac*theory
		      NIL
		      (list (list (term~read '(+ x1 x2) env))
			    (list (term~read '(+ y1 y2) env)))
		      NIL
		      (list (list (term~read 'x1 env) (term~read 'y1 env))
			    (list (term~read 'x2 env) (term~read 'y1 env)))
		      (list (term~read 'x1 env)
			    (term~read 'x2 env)
			    (term~read 'y1 env))
		      NIL))
      ((4) (test=test cpac*theory
		      NIL
		      (list (list (term~read '(+ x1 x2) env))
			    (list (term~read '(+ y1 y2) env)))
		      NIL
		      NIL
		      (list (term~read 'x1 env))
		      (list (list (term~read 'x1 env) (term~read 'y1 env)))))
      ((5) (test=test cpac*theory
		      NIL
		      (list (list (term~read '(+ x1 x2) env))
			    (list (term~read '(+ y1 y2) env)))
		      NIL
		      NIL
		      (list (term~read 'x1 env) (term~read 'y1 env))
		      (list (list (term~read 'y1 env) (term~read 'x2 env)))))
      ((6) (test=test cpac*theory
		      NIL
		      (list (list (term~read '(+ x y) env))
			    (list (term~read '(+ y1 (+ y2 y2)) env)))
		      NIL
		      NIL
		      (list (term~read 'y env) (term~read 'y1 env))
		      (list (list (term~read 'y env) (term~read 'x env)))))
      ((7) (test=test cpac*theory
		      NIL
		      (list (list (term~read '(+ x1 x2) env))
			    (list (term~read '(+ y1 y2) env)))
		      NIL
		      (list (list (term~read 'x1 env) (term~read 'y1 env)))
		      (list (term~read 'x1 env) (term~read 'x2 env))
		      (list (list (term~read 'x1 env) (term~read 'y1 env)))
		      )) 
      ((8) (test=test cpac*theory
		      NIL
		      (list (list (term~read '(+ x1 (+ x2 x3)) env))
			    (list (term~read '(+ y1 x1) env)))
		      NIL
		      NIL
		      (list (term~read 'x1 env) (term~read 'x2 env) (term~read 'x3 env))
		      NIL))
      ((9) (test=test cpac*theory
		      NIL
		      (list (list (term~read '(+ x1 x2) env))
			    (list (term~read '(+ y1 y1) env)))
		      NIL
		      NIL
		      NIL
		      NIL))
      ((10) (test=test cpac*theory
		       NIL
		       (list (list (term~read '(+ x1 x2) env))
			     (list (term~read '(+ y1 y1) env)))
		       NIL
		       NIL (list (term~read 'x1 env))
		       NIL))
      ((11) (test=test cpac*theory
		       NIL
		       (list (list (term~read '(+ x1 x2) env))
			     (list (term~read '(+ y1 y1) env)))
		       NIL
		       NIL
		       (list (term~read 'x1 env) (term~read 'x2 env))
		       NIL))
      ((12) (test=test cpac*theory
		       NIL
		      (list (list (term~read '(+ x1 x2) env))
			    (list (term~read 'y1 env)))
		      NIL
		      NIL
		      NIL
		      NIL))
      ((13) (test=test cpac*theory
		       NIL
		      (list (list (term~read 'x1 env))
			    (list (term~read 'y1 env)))
		      NIL
		      (list (list (term~read 'x1 env) (term~read 'y1 env)))
		      (list (term~read 'x1 env) (term~read 'y1 env))
		      NIL))
      ((14) (test=test cpac*theory
		       NIL
		      (list (list (term~read 'x1 env))
			    (list (term~read 'y1 env)))
		      NIL
		      (list (list (term~read 'x1 env) (term~read 'y1 env)))
		      NIL
		      (list (list (term~read 'x1 env) (term~read 'y1 env)))))
      ((15) (test=test cpac*theory
		       NIL
		      (list (list (term~read 'x1 env))
			    (list (term~read 'y1 env)))
		      NIL
		      (list (list (term~read 'x1 env) (term~read 'y1 env)))
		      NIL
		      (list (list (term~read 'x1 env) (term~read 'y1 env))
			    (list (term~read 'y1 env) (term~read 'x1 env)))))
      ))) |#



(defun test=test (cpac*theory general-up equations identified discriminated constants const-restr)
  (progn
    (unless general-up
      (setf general-up (unicp~general-up-create equations)))
    (unicp~vars-label-initialize! (unicp~variables general-up))
    (mapc #'(lambda(var) (setf (unicp~var-label-theories var) '(1 2 3))) (unicp~variables general-up))
    (mapc #'(lambda(c) (setf (unicp~var-label-theory c) 'weg)) constants)
    (if discriminated
	(mapc #'(lambda(pair)
		  (unicp~vars-discriminate! (first pair) (second pair)))
	      discriminated))
    (if identified
	(mapc #'(lambda(pair)
		  (unicp~vars-identify! (first pair) (second pair)))
	      identified))
    (unicp~theo-init cpac*theory general-up equations
		     identified discriminated constants const-restr)))

 




