(in-package "KEIM")

(defun cpac=add-to-permanents! (up)
  (declare (edited  "02-FEB-1996")
	   (authors Neskakis)
	   (input   "up: unification-problem [cpac+up]")
	   (effect  "vectors that must be in the set of solutions are moved"
		    "form SOLUTIONS to PERMANENT-SOLUTIONS of UP")
	   (Value   "True, iff some vector has been moved from SOLUTIONS to"
		    "PERMANENT-SOLUTIONS of UP. and problem is still solvable")
	   (special cpac*theory not*solvable))

  (let ((vecs (cpac=solutions up))
	(vecs-to-pervecs NIL)
	(new-pervecs NIL))

    (do ((args (cpac=arguments up) (cdr args)))
	((null args) vecs-to-pervecs)
	(do ((i (1- (length vecs)) (1- i))
	     (found1 NIL)
	     (found2 (some #'(lambda (vec)
			       (< 0 (elt vec (cpac=position (car args)))))
			   (cpac=permanent-solutions up))))
	    ((or (< i 0) found2)
	     (if (and found1 (not found2))
		 (push found1 vecs-to-pervecs)))
	    (if (< 0 (elt (elt vecs i) (cpac=position (car args))))
		(if found1
		    (setf found2 T)
		    (setf found1 i)))))

    (remove-duplicates vecs-to-pervecs)

    (setf (cpac=solutions up) NIL)

    (do ((i (1- (length vecs)) (1- i)) )
	((< i 0))
        (if (member i vecs-to-pervecs)
	    (progn
	      (push (elt vecs i) (cpac=permanent-solutions up))
	      (push (elt vecs i) new-pervecs))
	    (push (elt vecs i) (cpac=solutions up))))

    (if (> (length vecs-to-pervecs) 0)   ;werden Vektoren zu den permanent-solutions hinzugefuegt so
	(if (cpac=2vectors-oneconst-newpervecs! up new-pervecs) ; kann action5 nochmal greifen!
	    (cpac=add-to-permanents! up))) ;woraufhin add-to-permanents wieder greifen koennte

    (> (length vecs-to-pervecs) 0)))
