(in-package "KEIM")


(defun norm~alg (term)
  (declare (special bool*add))
  (declare (special bool*mul))
  (cond ((sym~constant-p Term) (list (list Term)))
	((sym~variable-p Term) (list (list Term)))
	((term~equal (term~top Term) bool*add)
	  (append (norm~alg (car (appl~arguments Term)))
		  (norm~alg (cadr (appl~arguments Term)))))
	((term~equal (term~top Term) bool*mul)
	  (norm=mult-new (norm~alg (car (appl~arguments Term)))
			 (norm~alg (cadr (appl~arguments Term)))))
	)
  )

(defun norm=mult-new (list-1 list-2)
  (if (null list-1) list-1
      (append (norm=mult-each-new (car list-1) list-2) (norm=mult-new (cdr list-1) list-2))))

(defun norm=mult-each-new (elem list)
  (if (null list) list
      (append (list (append elem (car list)))
	      (norm=mult-each-new elem (cdr list)))))












(defun norm~algold (term)
  (declare (edited  "11-JUL-1997")
	   (authors Hendrik Loehn)
	   (input   "a term+term.")
	   (effect  "none.")
	   (value   "the term in a normalized form, represented by a list of lists,"
		    "where the inner lists are conjunctions and the outer list"
		    "represents disjunctions."))
    (norm=alg2 (norm=alg1 term)))

(defun norm=alg1 (Term)
  (declare (special bool*add))
  (declare (special bool*mul))
  (cond ((sym~constant-p Term) (list Term))
	((sym~variable-p Term) (list Term))
	((term~equal (term~top Term) bool*add)
	  (append (norm=alg1 (car (appl~arguments Term)))
		  (norm=alg1 (cadr (appl~arguments Term)))))
	((term~equal (term~top Term) bool*mul)
	  (norm=mult (norm=alg1 (car (appl~arguments Term)))
		     (norm=alg1 (cadr (appl~arguments Term)))))
	)
  )

(defun norm=mult (List-1 List-2)
  (if (Null List-1) List-1
      (append (norm=multeach (car List-1) List-2) (norm=mult (cdr List-1) List-2))
      ))

(defun norm=multeach (element list)
  (declare (special bool*mul))
  (if (null (cdr list)) (list (appl~create bool*mul (append (list element) (list (car list)))))
      (append (list (appl~create bool*mul (append (list element) (list (car list)))))
              (norm=multeach element (cdr list)))))

(defun norm=alg2 (list)
  (if (null list) list
      (append (list (norm~term-to-list (car list))) (norm=alg2 (cdr list)))))

(defun norm~term-to-list (term)
  (cond ((sym~constant-p term) (list term))
	((sym~variable-p term) (list term))
	(t (append (norm~term-to-list (car (appl~arguments term)))
		   (norm~term-to-list (cadr (appl~arguments term)))))))


