(in-package "CLIM-USER")

(defun cpframe~up-frame-create-p (preds)
  (let* ((general-up (keim::cpcb=new-initial-gup preds))
	 (up-list (misc~queue-list (unicp~gup-up-queue general-up))))
    (mapcar #'(lambda (up color)
		(keim~put (unicp~theory up) :cpframe=color color))
	    up-list
	    (if cpframe*color-p
		(coerce (make-contrasting-inks (length up-list)) 'list)
		cpframe*gray-list))
    ;(cpframe==init-variables! (unicp~variables general-up))
    (make-application-frame 'cpframe+frame
			    :up general-up
			    :left 100 :top 50 :width 700 :height 800)))


(defun cpframe~decide-unify-pred (preds)
  (let (frame)
    (unwind-protect
	(progn
	  (setf frame (cpframe~up-frame-create-p preds))
	  (run-frame-top-level frame)
	  frame)
      (mapc #'(lambda (var)
		(sym~set-label! var nil))
	    (if (and frame
		     (cpframe~up frame)
		     (unicp~variables (cpframe~up frame)))
		(unicp~variables (cpframe~up frame))
		(top~free-variables preds))))))

