(in-package "KEIM")

(defun cpcb=select-choice-point (up)
  (declare (edited  "21-FEB-1996")
	   (authors Richts)
	   (input   "A general unification problem.")
	   (effect  "None.")
	   (value   "The next choice point is selected, i.e. the alternatives"
		    "are computed.  The result is a multiple value of four lists"
		    "of equal length.  Each list contains the alternatives for"
		    "one constraint type (identification, discrimination, theory"
		    "index and ordering).  So the first alternative consists of"
		    "the first elements of the four values, the second"
		    "alternative of the second elements, and so on.  Since only"
		    "one decision is made in this choice point, for each"
		    "alternative all but one value is empty and the non-empty"
		    "value contains only one object."))
  (let* ((variables (unicp~repres-list (unicp~shared-variables up)))
	 (unident1 (cpcb=some-var-pair #'(lambda (var1 var2)
					  (and (unicp~var-label-theory var1)
					       (eq (unicp~var-label-theory var1)
						   (unicp~var-label-theory var2))
					       (not (unicp~vars-identified-p var1 var2))
					       (not (unicp~vars-discriminated-p var1 var2))
					       (unicp~id-create var1 var2)))
				      variables))
	 (unident (or unident1
		      (cpcb=some-var-pair #'(lambda (var1 var2)
					      (and (not (unicp~vars-identified-p var1 var2))
						   (not (unicp~vars-discriminated-p var1 var2))
						   (unicp~id-create var1 var2)))
					  variables)))
	 (var (or unident
		  (find-if-not #'unicp~var-label-theory variables)))
	 (unorder (or var
		      (cpcb=some-var-pair #'(lambda (var1 var2)
					      (if (cpcb=order-not-ready-p
						   var1 var2 variables)
						  (cons var1 var2)))
					  variables))))
    (cond (unident
	   (values (list nil (list unident))
		   (list (list unident) nil)
		   (list nil nil)
		   (list nil nil)))
	  (var
	   (let* ((theories (mapcar #'unicp~theory
				    (misc~queue-list (unicp~gup-up-queue up))))
		  (var-indices (mapcar #'(lambda (th)
					   (list (unicp~vi-create var th)))
				       theories))
		  (nil-list (make-sequence 'list (length theories))))
	     (values nil-list nil-list var-indices nil-list)))
	  (unorder
	   (values (list nil nil) (list nil nil) (list nil nil)
		   (list (list (unicp~cr-create (car unorder) (cdr unorder)))
			 (list (unicp~cr-create (cdr unorder) (car unorder))))))
	  (t (error "CPCB:  Oh oh, found no more choice point, but was told there is some.")))))

(defun cpcb==trace-backtracking (up result)
  (format t "~%Backtracking(~A): " result)
  ;(pprint (cpcb=compute-result up))
  (incf cpcb*bcktrck-counter)
  )
