(in-package "KEIM")


; in sym.lisp

(defmethod post~read-object ((var symbol) (env env+environment) 
			    (indicator (eql :variable)))
  (sym~env-enter-variable var (type~individual) env nil))


(defmethod post~read-object ((var symbol) (env env+environment) 
			    (indicator (eql :variable-multiple)))
  (sym~env-enter-variable var (type~individual) env t))



(defmethod post~read-object ((functions list) (env env+environment) 
			    (indicator (eql :functions)))
  (dolist (function functions nil)
    (post~read-object function env :function)))
	    
(defmethod post~read-object ((function cons) (env env+environment) 
			    (indicator (eql :function)))
  (sym~env-enter-constant (car function) (type~function-create (cadr function)) env))


(defmethod post~read-object ((predicates list) (env env+environment) 
			    (indicator (eql :predicates)))
  (dolist (predicate predicates nil)
    (post~read-object predicate env :predicate)))
	    
(defmethod post~read-object ((predicate cons) (env env+environment) 
			    (indicator (eql :predicate)))
  (sym~env-enter-constant (car predicate) (type~predicate-create (cadr predicate)) env))


(defmethod post~read-object ((junctors list) (env env+environment) 
			    (indicator (eql :junctors)))
  (dolist (junctor junctors nil)
    (post~read-object junctor env :junctor)))
	    
(defmethod post~read-object ((junctor cons) (env env+environment) 
			    (indicator (eql :junctor)))
  (sym~env-enter-constant (car junctor) (type~junctor-create (cadr junctor)) env))


; in appl.lisp

(term~defgeneric appl~create ((function) arguments &key)
  (declare (edited  "15-AUG-1991 13:41")
	   (authors RICHTS)
	   (input   "A term with arity n and a list of terms 
with length <= n.")
	   (effect  "None.")
	   (value   "The term (function . arguments) if arguments is not nil,"
		    "function else.")
	   (example "Let QQ be a predicate of the type (i,i)->o"
		    "QQ (X) --> (QQ X)""(QQ X) (y) -->(QQ X Y)"))
  (:method ((function sym+const) arguments &key)
	   (if arguments
	       (make-instance 
		'appl+appl
		:function function
		:arguments arguments
		:type (type~apply (term~type function) 
				  (mapcar #'term~type arguments)))
	       function))
  (:method ((function appl+appl) (arguments t) &key)
	   (error "Typen sind geaendert."))
  (:method ((function term+term) (arguments t) &key)
	   (error "Typen sind geaendert.")))


(defun appl~poly-create (f a)
  (appl~create f a))
