
#{Each term has a unification class.  The unification class determines, which
unification algorithm must be used. It is computed from the theories in a
term. If the term contains only symbols of one theory (plus variables), the
theory itself is the unification class (i.e. {\tt th+general} is a subclass of
{\tt th+unification-class}).#}

(defclass th+unification-class (keim+name)
  (type :allocation :class)
  (:documentation "This is the superclass of all unification classes."))


(defclass th+uc-general (th+unification-class)
  (type :initform :infinitary :allocation :class)
  (:documentation "This is the unification class for general unification."))


(defgeneric th~combine-unif-classes (unif-class1 unif-class2)
  (declare (edited  "12-DEC-1994")
	   (authors Richts)
	   (input   "Two unification classes or two terms.")
	   (effect  "None.")
	   (value   "An object of the unification class, the resulting ")))

(defun th~combine-unif-class-list (unif-class-list)
  (declare (edited  "12-DEC-1994")
	   (authors Richts)
	   (input   "A list of unification classes or terms.")
	   (effect  "None.")
	   (value   "An objec")))
